/* Enums.c generated by valac 0.56.16, the Vala compiler
 * generated from Enums.vala, do not modify */

/* Enums.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_PATTERN_TYPE_CELL,
	GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT,
	GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED
} GnonogramsCellPatternType;

#define GNONOGRAMS_TYPE_CELL_PATTERN_TYPE (gnonograms_cell_pattern_type_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM,
	GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED
} GnonogramsGamePatternType;

#define GNONOGRAMS_TYPE_GAME_PATTERN_TYPE (gnonograms_game_pattern_type_get_type ())

VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* gnonograms_difficulty_to_string (GnonogramsDifficulty self);
VALA_EXTERN GnonogramsDifficulty* gnonograms_difficulty_all_human (gint* result_length1);
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_solver_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean gnonograms_solver_state_solved (GnonogramsSolverState self);
VALA_EXTERN GType gnonograms_cell_pattern_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_game_pattern_type_get_type (void) G_GNUC_CONST ;
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
gnonograms_difficulty_to_string (GnonogramsDifficulty self)
{
	gchar* result;
	switch (self) {
		case GNONOGRAMS_DIFFICULTY_TRIVIAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Trivial"));
			result = _tmp0_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_VERY_EASY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Very Easy"));
			result = _tmp1_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_EASY:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Easy"));
			result = _tmp2_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_MODERATE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Moderately difficult"));
			result = _tmp3_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_HARD:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Difficult"));
			result = _tmp4_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_CHALLENGING:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Very Difficult"));
			result = _tmp5_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_ADVANCED:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Advanced logic required"));
			result = _tmp6_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_MAXIMUM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Possibly ambiguous"));
			result = _tmp7_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_COMPUTER:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Super human"));
			result = _tmp8_;
			return result;
		}
		case GNONOGRAMS_DIFFICULTY_UNDEFINED:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("");
			result = _tmp9_;
			return result;
		}
		default:
		{
			g_critical ("Enums.vala:56: grade to string - unexpected grade");
			g_assert_not_reached ();
		}
	}
}

GnonogramsDifficulty*
gnonograms_difficulty_all_human (gint* result_length1)
{
	GnonogramsDifficulty* _tmp0_;
	GnonogramsDifficulty* _tmp1_;
	gint _tmp1__length1;
	GnonogramsDifficulty* result;
	_tmp0_ = g_new0 (GnonogramsDifficulty, 6);
	_tmp0_[0] = GNONOGRAMS_DIFFICULTY_EASY;
	_tmp0_[1] = GNONOGRAMS_DIFFICULTY_MODERATE;
	_tmp0_[2] = GNONOGRAMS_DIFFICULTY_HARD;
	_tmp0_[3] = GNONOGRAMS_DIFFICULTY_CHALLENGING;
	_tmp0_[4] = GNONOGRAMS_DIFFICULTY_ADVANCED;
	_tmp0_[5] = GNONOGRAMS_DIFFICULTY_MAXIMUM;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 6;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static GType
gnonograms_difficulty_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_DIFFICULTY_TRIVIAL, "GNONOGRAMS_DIFFICULTY_TRIVIAL", "trivial"}, {GNONOGRAMS_DIFFICULTY_VERY_EASY, "GNONOGRAMS_DIFFICULTY_VERY_EASY", "very-easy"}, {GNONOGRAMS_DIFFICULTY_EASY, "GNONOGRAMS_DIFFICULTY_EASY", "easy"}, {GNONOGRAMS_DIFFICULTY_MODERATE, "GNONOGRAMS_DIFFICULTY_MODERATE", "moderate"}, {GNONOGRAMS_DIFFICULTY_HARD, "GNONOGRAMS_DIFFICULTY_HARD", "hard"}, {GNONOGRAMS_DIFFICULTY_CHALLENGING, "GNONOGRAMS_DIFFICULTY_CHALLENGING", "challenging"}, {GNONOGRAMS_DIFFICULTY_ADVANCED, "GNONOGRAMS_DIFFICULTY_ADVANCED", "advanced"}, {GNONOGRAMS_DIFFICULTY_MAXIMUM, "GNONOGRAMS_DIFFICULTY_MAXIMUM", "maximum"}, {GNONOGRAMS_DIFFICULTY_COMPUTER, "GNONOGRAMS_DIFFICULTY_COMPUTER", "computer"}, {GNONOGRAMS_DIFFICULTY_UNDEFINED, "GNONOGRAMS_DIFFICULTY_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_difficulty_type_id;
	gnonograms_difficulty_type_id = g_enum_register_static ("GnonogramsDifficulty", values);
	return gnonograms_difficulty_type_id;
}

GType
gnonograms_difficulty_get_type (void)
{
	static volatile gsize gnonograms_difficulty_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_difficulty_type_id__once)) {
		GType gnonograms_difficulty_type_id;
		gnonograms_difficulty_type_id = gnonograms_difficulty_get_type_once ();
		g_once_init_leave (&gnonograms_difficulty_type_id__once, gnonograms_difficulty_type_id);
	}
	return gnonograms_difficulty_type_id__once;
}

static GType
gnonograms_game_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_GAME_STATE_SETTING, "GNONOGRAMS_GAME_STATE_SETTING", "setting"}, {GNONOGRAMS_GAME_STATE_SOLVING, "GNONOGRAMS_GAME_STATE_SOLVING", "solving"}, {GNONOGRAMS_GAME_STATE_GENERATING, "GNONOGRAMS_GAME_STATE_GENERATING", "generating"}, {GNONOGRAMS_GAME_STATE_UNDEFINED, "GNONOGRAMS_GAME_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_game_state_type_id;
	gnonograms_game_state_type_id = g_enum_register_static ("GnonogramsGameState", values);
	return gnonograms_game_state_type_id;
}

GType
gnonograms_game_state_get_type (void)
{
	static volatile gsize gnonograms_game_state_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_game_state_type_id__once)) {
		GType gnonograms_game_state_type_id;
		gnonograms_game_state_type_id = gnonograms_game_state_get_type_once ();
		g_once_init_leave (&gnonograms_game_state_type_id__once, gnonograms_game_state_type_id);
	}
	return gnonograms_game_state_type_id__once;
}

static GType
gnonograms_cell_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_CELL_STATE_UNKNOWN, "GNONOGRAMS_CELL_STATE_UNKNOWN", "unknown"}, {GNONOGRAMS_CELL_STATE_EMPTY, "GNONOGRAMS_CELL_STATE_EMPTY", "empty"}, {GNONOGRAMS_CELL_STATE_FILLED, "GNONOGRAMS_CELL_STATE_FILLED", "filled"}, {GNONOGRAMS_CELL_STATE_COMPLETED, "GNONOGRAMS_CELL_STATE_COMPLETED", "completed"}, {GNONOGRAMS_CELL_STATE_UNDEFINED, "GNONOGRAMS_CELL_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_cell_state_type_id;
	gnonograms_cell_state_type_id = g_enum_register_static ("GnonogramsCellState", values);
	return gnonograms_cell_state_type_id;
}

GType
gnonograms_cell_state_get_type (void)
{
	static volatile gsize gnonograms_cell_state_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_cell_state_type_id__once)) {
		GType gnonograms_cell_state_type_id;
		gnonograms_cell_state_type_id = gnonograms_cell_state_get_type_once ();
		g_once_init_leave (&gnonograms_cell_state_type_id__once, gnonograms_cell_state_type_id);
	}
	return gnonograms_cell_state_type_id__once;
}

gboolean
gnonograms_solver_state_solved (GnonogramsSolverState self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	if (self == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self == GNONOGRAMS_SOLVER_STATE_ADVANCED;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self == GNONOGRAMS_SOLVER_STATE_AMBIGUOUS;
	}
	result = _tmp0_;
	return result;
}

static GType
gnonograms_solver_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_SOLVER_STATE_ERROR, "GNONOGRAMS_SOLVER_STATE_ERROR", "error"}, {GNONOGRAMS_SOLVER_STATE_CANCELLED, "GNONOGRAMS_SOLVER_STATE_CANCELLED", "cancelled"}, {GNONOGRAMS_SOLVER_STATE_NO_SOLUTION, "GNONOGRAMS_SOLVER_STATE_NO_SOLUTION", "no-solution"}, {GNONOGRAMS_SOLVER_STATE_SIMPLE, "GNONOGRAMS_SOLVER_STATE_SIMPLE", "simple"}, {GNONOGRAMS_SOLVER_STATE_ADVANCED, "GNONOGRAMS_SOLVER_STATE_ADVANCED", "advanced"}, {GNONOGRAMS_SOLVER_STATE_AMBIGUOUS, "GNONOGRAMS_SOLVER_STATE_AMBIGUOUS", "ambiguous"}, {GNONOGRAMS_SOLVER_STATE_UNDEFINED, "GNONOGRAMS_SOLVER_STATE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_solver_state_type_id;
	gnonograms_solver_state_type_id = g_enum_register_static ("GnonogramsSolverState", values);
	return gnonograms_solver_state_type_id;
}

GType
gnonograms_solver_state_get_type (void)
{
	static volatile gsize gnonograms_solver_state_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_solver_state_type_id__once)) {
		GType gnonograms_solver_state_type_id;
		gnonograms_solver_state_type_id = gnonograms_solver_state_get_type_once ();
		g_once_init_leave (&gnonograms_solver_state_type_id__once, gnonograms_solver_state_type_id);
	}
	return gnonograms_solver_state_type_id__once;
}

static GType
gnonograms_cell_pattern_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_CELL_PATTERN_TYPE_CELL, "GNONOGRAMS_CELL_PATTERN_TYPE_CELL", "cell"}, {GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT, "GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT", "highlight"}, {GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED, "GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_cell_pattern_type_type_id;
	gnonograms_cell_pattern_type_type_id = g_enum_register_static ("GnonogramsCellPatternType", values);
	return gnonograms_cell_pattern_type_type_id;
}

GType
gnonograms_cell_pattern_type_get_type (void)
{
	static volatile gsize gnonograms_cell_pattern_type_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_cell_pattern_type_type_id__once)) {
		GType gnonograms_cell_pattern_type_type_id;
		gnonograms_cell_pattern_type_type_id = gnonograms_cell_pattern_type_get_type_once ();
		g_once_init_leave (&gnonograms_cell_pattern_type_type_id__once, gnonograms_cell_pattern_type_type_id);
	}
	return gnonograms_cell_pattern_type_type_id__once;
}

static GType
gnonograms_game_pattern_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM, "GNONOGRAMS_GAME_PATTERN_TYPE_SIMPLE_RANDOM", "simple-random"}, {GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED, "GNONOGRAMS_GAME_PATTERN_TYPE_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType gnonograms_game_pattern_type_type_id;
	gnonograms_game_pattern_type_type_id = g_enum_register_static ("GnonogramsGamePatternType", values);
	return gnonograms_game_pattern_type_type_id;
}

GType
gnonograms_game_pattern_type_get_type (void)
{
	static volatile gsize gnonograms_game_pattern_type_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_game_pattern_type_type_id__once)) {
		GType gnonograms_game_pattern_type_type_id;
		gnonograms_game_pattern_type_type_id = gnonograms_game_pattern_type_get_type_once ();
		g_once_init_leave (&gnonograms_game_pattern_type_type_id__once, gnonograms_game_pattern_type_type_id);
	}
	return gnonograms_game_pattern_type_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

