/* Filewriter.c generated by valac 0.56.16, the Vala compiler
 * generated from Filewriter.vala, do not modify */

/* Filewriter.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Author: Jeremy Wootten  < jeremwootten@gmail.com >
 */

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#define GNONOGRAMS_UNTITLED_NAME N_ ("Untitled")
#define GNONOGRAMS_GAMEFILEEXTENSION ".gno"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_FILEWRITER (gnonograms_filewriter_get_type ())
#define GNONOGRAMS_FILEWRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter))
#define GNONOGRAMS_FILEWRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriterClass))
#define GNONOGRAMS_IS_FILEWRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_FILEWRITER))
#define GNONOGRAMS_IS_FILEWRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_FILEWRITER))
#define GNONOGRAMS_FILEWRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriterClass))

typedef struct _GnonogramsFilewriter GnonogramsFilewriter;
typedef struct _GnonogramsFilewriterClass GnonogramsFilewriterClass;
typedef struct _GnonogramsFilewriterPrivate GnonogramsFilewriterPrivate;

#define GNONOGRAMS_TYPE_HISTORY (gnonograms_history_get_type ())
#define GNONOGRAMS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistory))
#define GNONOGRAMS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistoryClass))
#define GNONOGRAMS_IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_HISTORY))
#define GNONOGRAMS_IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_HISTORY))
#define GNONOGRAMS_HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistoryClass))

typedef struct _GnonogramsHistory GnonogramsHistory;
typedef struct _GnonogramsHistoryClass GnonogramsHistoryClass;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
enum  {
	GNONOGRAMS_FILEWRITER_0_PROPERTY,
	GNONOGRAMS_FILEWRITER_DATE_PROPERTY,
	GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY,
	GNONOGRAMS_FILEWRITER_PARENT_PROPERTY,
	GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY,
	GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY,
	GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY,
	GNONOGRAMS_FILEWRITER_WORKING_PROPERTY,
	GNONOGRAMS_FILEWRITER_ROWS_PROPERTY,
	GNONOGRAMS_FILEWRITER_COLS_PROPERTY,
	GNONOGRAMS_FILEWRITER_NAME_PROPERTY,
	GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY,
	GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY,
	GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY,
	GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY,
	GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY,
	GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY,
	GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY,
	GNONOGRAMS_FILEWRITER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

struct _GnonogramsFilewriter {
	GObject parent_instance;
	GnonogramsFilewriterPrivate * priv;
};

struct _GnonogramsFilewriterClass {
	GObjectClass parent_class;
};

struct _GnonogramsFilewriterPrivate {
	GDateTime* _date;
	GnonogramsHistory* _history;
	GtkWindow* _parent;
	GnonogramsDifficulty _difficulty;
	GnonogramsGameState _game_state;
	GnonogramsMy2DCellArray* _solution;
	GnonogramsMy2DCellArray* _working;
	guint _rows;
	guint _cols;
	gchar* _name;
	gchar** _row_clues;
	gint _row_clues_length1;
	gint __row_clues_size_;
	gchar** _col_clues;
	gint _col_clues_length1;
	gint __col_clues_size_;
	gboolean _save_solution;
	gchar* _game_path;
	gchar* _author;
	gchar* _license;
	gboolean _is_readonly;
	FILE* stream;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

static gint GnonogramsFilewriter_private_offset;
static gpointer gnonograms_filewriter_parent_class = NULL;

VALA_EXTERN GType gnonograms_filewriter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsFilewriter, g_object_unref)
VALA_EXTERN GType gnonograms_history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsHistory, g_object_unref)
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN GnonogramsFilewriter* gnonograms_filewriter_new (GtkWindow* parent,
                                                 GnonogramsDimensions* dimensions,
                                                 gchar** row_clues,
                                                 gint row_clues_length1,
                                                 gchar** col_clues,
                                                 gint col_clues_length1,
                                                 GnonogramsHistory* history,
                                                 gboolean save_solution,
                                                 GError** error);
VALA_EXTERN GnonogramsFilewriter* gnonograms_filewriter_construct (GType object_type,
                                                       GtkWindow* parent,
                                                       GnonogramsDimensions* dimensions,
                                                       gchar** row_clues,
                                                       gint row_clues_length1,
                                                       gchar** col_clues,
                                                       gint col_clues_length1,
                                                       GnonogramsHistory* history,
                                                       gboolean save_solution,
                                                       GError** error);
VALA_EXTERN void gnonograms_filewriter_write_game_file (GnonogramsFilewriter* self,
                                            const gchar* save_dir_path,
                                            const gchar* path,
                                            const gchar* _name,
                                            GError** error);
VALA_EXTERN void gnonograms_filewriter_set_name (GnonogramsFilewriter* self,
                                     const gchar* value);
VALA_EXTERN gchar* gnonograms_utils_get_open_save_path (GtkWindow* parent,
                                            const gchar* dialogname,
                                            gboolean save,
                                            const gchar* start_path,
                                            const gchar* basename);
VALA_EXTERN GtkWindow* gnonograms_filewriter_get_parent (GnonogramsFilewriter* self);
VALA_EXTERN const gchar* gnonograms_filewriter_get_name (GnonogramsFilewriter* self);
static void gnonograms_filewriter_set_game_path (GnonogramsFilewriter* self,
                                          const gchar* value);
VALA_EXTERN const gchar* gnonograms_filewriter_get_game_path (GnonogramsFilewriter* self);
VALA_EXTERN gboolean gnonograms_utils_show_confirm_dialog (const gchar* primary_text,
                                               const gchar* secondary_text,
                                               GtkWindow* parent);
VALA_EXTERN const gchar* gnonograms_filewriter_get_author (GnonogramsFilewriter* self);
VALA_EXTERN GDateTime* gnonograms_filewriter_get_date (GnonogramsFilewriter* self);
VALA_EXTERN GnonogramsDifficulty gnonograms_filewriter_get_difficulty (GnonogramsFilewriter* self);
VALA_EXTERN const gchar* gnonograms_filewriter_get_license (GnonogramsFilewriter* self);
VALA_EXTERN guint gnonograms_filewriter_get_rows (GnonogramsFilewriter* self);
VALA_EXTERN guint gnonograms_filewriter_get_cols (GnonogramsFilewriter* self);
VALA_EXTERN gchar** gnonograms_filewriter_get_row_clues (GnonogramsFilewriter* self,
                                             gint* result_length1);
VALA_EXTERN gchar** gnonograms_filewriter_get_col_clues (GnonogramsFilewriter* self,
                                             gint* result_length1);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_filewriter_get_solution (GnonogramsFilewriter* self);
VALA_EXTERN gboolean gnonograms_filewriter_get_save_solution (GnonogramsFilewriter* self);
VALA_EXTERN gchar* gnonograms_my2_dcell_array_to_string (GnonogramsMy2DCellArray* self);
VALA_EXTERN gboolean gnonograms_filewriter_get_is_readonly (GnonogramsFilewriter* self);
VALA_EXTERN void gnonograms_filewriter_write_position_file (GnonogramsFilewriter* self,
                                                const gchar* save_dir_path,
                                                const gchar* path,
                                                const gchar* name,
                                                GError** error);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_filewriter_get_working (GnonogramsFilewriter* self);
VALA_EXTERN GnonogramsGameState gnonograms_filewriter_get_game_state (GnonogramsFilewriter* self);
VALA_EXTERN GnonogramsHistory* gnonograms_filewriter_get_history (GnonogramsFilewriter* self);
VALA_EXTERN gchar* gnonograms_history_to_string (GnonogramsHistory* self);
static void gnonograms_filewriter_set_date (GnonogramsFilewriter* self,
                                     GDateTime* value);
static void gnonograms_filewriter_set_history (GnonogramsFilewriter* self,
                                        GnonogramsHistory* value);
static void gnonograms_filewriter_set_parent (GnonogramsFilewriter* self,
                                       GtkWindow* value);
VALA_EXTERN void gnonograms_filewriter_set_difficulty (GnonogramsFilewriter* self,
                                           GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_filewriter_set_game_state (GnonogramsFilewriter* self,
                                           GnonogramsGameState value);
VALA_EXTERN void gnonograms_filewriter_set_solution (GnonogramsFilewriter* self,
                                         GnonogramsMy2DCellArray* value);
VALA_EXTERN void gnonograms_filewriter_set_working (GnonogramsFilewriter* self,
                                        GnonogramsMy2DCellArray* value);
static void gnonograms_filewriter_set_rows (GnonogramsFilewriter* self,
                                     guint value);
static void gnonograms_filewriter_set_cols (GnonogramsFilewriter* self,
                                     guint value);
static void gnonograms_filewriter_set_row_clues (GnonogramsFilewriter* self,
                                          gchar** value,
                                          gint value_length1);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
static void gnonograms_filewriter_set_col_clues (GnonogramsFilewriter* self,
                                          gchar** value,
                                          gint value_length1);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
static void gnonograms_filewriter_set_save_solution (GnonogramsFilewriter* self,
                                              gboolean value);
VALA_EXTERN void gnonograms_filewriter_set_author (GnonogramsFilewriter* self,
                                       const gchar* value);
VALA_EXTERN void gnonograms_filewriter_set_license (GnonogramsFilewriter* self,
                                        const gchar* value);
VALA_EXTERN void gnonograms_filewriter_set_is_readonly (GnonogramsFilewriter* self,
                                            gboolean value);
static GObject * gnonograms_filewriter_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void gnonograms_filewriter_finalize (GObject * obj);
static GType gnonograms_filewriter_get_type_once (void);
static void _vala_gnonograms_filewriter_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gnonograms_filewriter_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gnonograms_filewriter_get_instance_private (GnonogramsFilewriter* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsFilewriter_private_offset);
}

GnonogramsFilewriter*
gnonograms_filewriter_construct (GType object_type,
                                 GtkWindow* parent,
                                 GnonogramsDimensions* dimensions,
                                 gchar** row_clues,
                                 gint row_clues_length1,
                                 gchar** col_clues,
                                 gint col_clues_length1,
                                 GnonogramsHistory* history,
                                 gboolean save_solution,
                                 GError** error)
{
	GnonogramsFilewriter * self = NULL;
	GnonogramsDimensions _tmp0_;
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (dimensions != NULL, NULL);
	_tmp0_ = *dimensions;
	_tmp1_ = *dimensions;
	self = (GnonogramsFilewriter*) g_object_new (object_type, "name", _ (GNONOGRAMS_UNTITLED_NAME), "parent", parent, "rows", _tmp0_.height, "cols", _tmp1_.width, "row-clues", row_clues, "col-clues", col_clues, "history", history, "save-solution", save_solution, NULL);
	return self;
}

GnonogramsFilewriter*
gnonograms_filewriter_new (GtkWindow* parent,
                           GnonogramsDimensions* dimensions,
                           gchar** row_clues,
                           gint row_clues_length1,
                           gchar** col_clues,
                           gint col_clues_length1,
                           GnonogramsHistory* history,
                           gboolean save_solution,
                           GError** error)
{
	return gnonograms_filewriter_construct (GNONOGRAMS_TYPE_FILEWRITER, parent, dimensions, row_clues, row_clues_length1, col_clues, col_clues_length1, history, save_solution, error);
}

/*** Writes minimum information required for valid game file ***/
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

void
gnonograms_filewriter_write_game_file (GnonogramsFilewriter* self,
                                       const gchar* save_dir_path,
                                       const gchar* path,
                                       const gchar* _name,
                                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp22_;
	GFile* file = NULL;
	const gchar* _tmp24_;
	GFile* _tmp25_;
	gboolean _tmp26_ = FALSE;
	GFile* _tmp27_;
	const gchar* _tmp32_;
	FILE* _tmp33_;
	FILE* _tmp34_;
	gboolean _tmp40_ = FALSE;
	const gchar* _tmp41_;
	FILE* _tmp46_;
	FILE* _tmp47_;
	const gchar* _tmp48_;
	FILE* _tmp49_;
	const gchar* _tmp50_;
	FILE* _tmp51_;
	GDateTime* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	FILE* _tmp55_;
	GnonogramsDifficulty _tmp56_;
	gboolean _tmp57_ = FALSE;
	const gchar* _tmp58_;
	gboolean _tmp65_ = FALSE;
	guint _tmp66_;
	FILE* _tmp69_;
	FILE* _tmp70_;
	guint _tmp71_;
	FILE* _tmp72_;
	guint _tmp73_;
	gboolean _tmp74_ = FALSE;
	gchar** _tmp75_;
	gint _tmp75__length1;
	gint _tmp76_ = 0;
	gchar** _tmp77_;
	gint _tmp77__length1;
	gboolean _tmp82_ = FALSE;
	gchar** _tmp83_;
	gint _tmp83__length1;
	gint _tmp84_ = 0;
	gchar** _tmp85_;
	gint _tmp85__length1;
	guint _tmp86_;
	FILE* _tmp92_;
	gchar** _tmp93_;
	gint _tmp93__length1;
	gint _tmp94_ = 0;
	gchar** _tmp95_;
	gint _tmp95__length1;
	FILE* _tmp99_;
	gchar** _tmp100_;
	gint _tmp100__length1;
	gint _tmp101_ = 0;
	gchar** _tmp102_;
	gint _tmp102__length1;
	FILE* _tmp106_;
	gboolean _tmp107_ = FALSE;
	GnonogramsMy2DCellArray* _tmp108_;
	FILE* _tmp115_;
	FILE* _tmp116_;
	gboolean _tmp117_;
	gchar* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (_name != NULL) {
		gnonograms_filewriter_set_name (self, _name);
	} else {
		gnonograms_filewriter_set_name (self, _ (GNONOGRAMS_UNTITLED_NAME));
	}
	if (path == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (path);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ <= 4;
	}
	if (_tmp0_) {
		GtkWindow* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = self->priv->_parent;
		_tmp4_ = self->priv->_name;
		_tmp5_ = gnonograms_utils_get_open_save_path (_tmp3_, _ ("Name and save this puzzle"), TRUE, save_dir_path, _tmp4_);
		_tmp6_ = _tmp5_;
		gnonograms_filewriter_set_game_path (self, _tmp6_);
		_g_free0 (_tmp6_);
	} else {
		gnonograms_filewriter_set_game_path (self, path);
	}
	_tmp8_ = self->priv->_game_path;
	if (_tmp8_ != NULL) {
		gboolean _tmp9_ = FALSE;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp10_ = self->priv->_game_path;
		_tmp11_ = strlen (_tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp12_ < 4) {
			_tmp9_ = TRUE;
		} else {
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp13_ = self->priv->_game_path;
			_tmp14_ = self->priv->_game_path;
			_tmp15_ = strlen (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = string_slice (_tmp13_, (glong) -4, (glong) _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp9_ = g_strcmp0 (_tmp18_, GNONOGRAMS_GAMEFILEEXTENSION) != 0;
			_g_free0 (_tmp18_);
		}
		_tmp7_ = _tmp9_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp19_ = self->priv->_game_path;
		_tmp20_ = g_strconcat (_tmp19_, GNONOGRAMS_GAMEFILEEXTENSION, NULL);
		_tmp21_ = _tmp20_;
		gnonograms_filewriter_set_game_path (self, _tmp21_);
		_g_free0 (_tmp21_);
	}
	_tmp22_ = self->priv->_game_path;
	if (_tmp22_ == NULL) {
		GError* _tmp23_;
		_tmp23_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "No path selected");
		_inner_error0_ = _tmp23_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp24_ = self->priv->_game_path;
	_tmp25_ = g_file_new_for_commandline_arg (_tmp24_);
	file = _tmp25_;
	_tmp27_ = file;
	if (g_file_query_exists (_tmp27_, NULL)) {
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp28_ = self->priv->_game_path;
		_tmp29_ = g_strdup_printf (_ ("Overwrite %s"), _tmp28_);
		_tmp30_ = _tmp29_;
		_tmp26_ = !gnonograms_utils_show_confirm_dialog (_tmp30_, _ ("This action will destroy contents of that file"), NULL);
		_g_free0 (_tmp30_);
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		GError* _tmp31_;
		_tmp31_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "File exists");
		_inner_error0_ = _tmp31_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp32_ = self->priv->_game_path;
	_tmp33_ = g_fopen (_tmp32_, "w");
	_fclose0 (self->priv->stream);
	self->priv->stream = _tmp33_;
	_tmp34_ = self->priv->stream;
	if (_tmp34_ == NULL) {
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GError* _tmp38_;
		GError* _tmp39_;
		_tmp35_ = self->priv->_game_path;
		_tmp36_ = g_strdup_printf ("Could not open filestream to %s", _tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp37_);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		_inner_error0_ = _tmp39_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp41_ = self->priv->_name;
	if (_tmp41_ == NULL) {
		_tmp40_ = TRUE;
	} else {
		const gchar* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		_tmp42_ = self->priv->_name;
		_tmp43_ = strlen (_tmp42_);
		_tmp44_ = _tmp43_;
		_tmp40_ = _tmp44_ == 0;
	}
	if (_tmp40_) {
		GError* _tmp45_;
		_tmp45_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "No name to save");
		_inner_error0_ = _tmp45_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp46_ = self->priv->stream;
	fprintf (_tmp46_, "[Description]\n");
	_tmp47_ = self->priv->stream;
	_tmp48_ = self->priv->_name;
	fprintf (_tmp47_, "%s\n", _tmp48_);
	_tmp49_ = self->priv->stream;
	_tmp50_ = self->priv->_author;
	fprintf (_tmp49_, "%s\n", _tmp50_);
	_tmp51_ = self->priv->stream;
	_tmp52_ = self->priv->_date;
	_tmp53_ = g_date_time_to_string (_tmp52_);
	_tmp54_ = _tmp53_;
	fprintf (_tmp51_, "%s\n", _tmp54_);
	_g_free0 (_tmp54_);
	_tmp55_ = self->priv->stream;
	_tmp56_ = self->priv->_difficulty;
	fprintf (_tmp55_, "%u\n", (guint) _tmp56_);
	_tmp58_ = self->priv->_license;
	if (_tmp58_ == NULL) {
		_tmp57_ = TRUE;
	} else {
		const gchar* _tmp59_;
		gint _tmp60_;
		gint _tmp61_;
		_tmp59_ = self->priv->_license;
		_tmp60_ = strlen (_tmp59_);
		_tmp61_ = _tmp60_;
		_tmp57_ = _tmp61_ > 0;
	}
	if (_tmp57_) {
		FILE* _tmp62_;
		FILE* _tmp63_;
		const gchar* _tmp64_;
		_tmp62_ = self->priv->stream;
		fprintf (_tmp62_, "[License]\n");
		_tmp63_ = self->priv->stream;
		_tmp64_ = self->priv->_license;
		fprintf (_tmp63_, "%s\n", _tmp64_);
	}
	_tmp66_ = self->priv->_rows;
	if (_tmp66_ == ((guint) 0)) {
		_tmp65_ = TRUE;
	} else {
		guint _tmp67_;
		_tmp67_ = self->priv->_cols;
		_tmp65_ = _tmp67_ == ((guint) 0);
	}
	if (_tmp65_) {
		GError* _tmp68_;
		_tmp68_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "No dimensions to save");
		_inner_error0_ = _tmp68_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp69_ = self->priv->stream;
	fprintf (_tmp69_, "[Dimensions]\n");
	_tmp70_ = self->priv->stream;
	_tmp71_ = self->priv->_rows;
	fprintf (_tmp70_, "%u\n", _tmp71_);
	_tmp72_ = self->priv->stream;
	_tmp73_ = self->priv->_cols;
	fprintf (_tmp72_, "%u\n", _tmp73_);
	_tmp75_ = gnonograms_filewriter_get_row_clues (self, &_tmp76_);
	_tmp75__length1 = _tmp76_;
	_tmp77_ = _tmp75_;
	_tmp77__length1 = _tmp75__length1;
	if (_tmp77__length1 == 0) {
		_tmp74_ = TRUE;
	} else {
		gchar** _tmp78_;
		gint _tmp78__length1;
		gint _tmp79_ = 0;
		gchar** _tmp80_;
		gint _tmp80__length1;
		_tmp78_ = gnonograms_filewriter_get_col_clues (self, &_tmp79_);
		_tmp78__length1 = _tmp79_;
		_tmp80_ = _tmp78_;
		_tmp80__length1 = _tmp78__length1;
		_tmp74_ = _tmp80__length1 == 0;
	}
	if (_tmp74_) {
		GError* _tmp81_;
		_tmp81_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "No clues to save");
		_inner_error0_ = _tmp81_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp83_ = gnonograms_filewriter_get_row_clues (self, &_tmp84_);
	_tmp83__length1 = _tmp84_;
	_tmp85_ = _tmp83_;
	_tmp85__length1 = _tmp83__length1;
	_tmp86_ = self->priv->_rows;
	if (((guint) _tmp85__length1) != _tmp86_) {
		_tmp82_ = TRUE;
	} else {
		gchar** _tmp87_;
		gint _tmp87__length1;
		gint _tmp88_ = 0;
		gchar** _tmp89_;
		gint _tmp89__length1;
		guint _tmp90_;
		_tmp87_ = gnonograms_filewriter_get_col_clues (self, &_tmp88_);
		_tmp87__length1 = _tmp88_;
		_tmp89_ = _tmp87_;
		_tmp89__length1 = _tmp87__length1;
		_tmp90_ = self->priv->_cols;
		_tmp82_ = ((guint) _tmp89__length1) != _tmp90_;
	}
	if (_tmp82_) {
		GError* _tmp91_;
		_tmp91_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "Clues do not match dimensions");
		_inner_error0_ = _tmp91_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (file);
			return;
		} else {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp92_ = self->priv->stream;
	fprintf (_tmp92_, "[Row clues]\n");
	_tmp93_ = gnonograms_filewriter_get_row_clues (self, &_tmp94_);
	_tmp93__length1 = _tmp94_;
	_tmp95_ = _tmp93_;
	_tmp95__length1 = _tmp93__length1;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp95_;
		s_collection_length1 = _tmp95__length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp96_;
			gchar* s = NULL;
			_tmp96_ = g_strdup (s_collection[s_it]);
			s = _tmp96_;
			{
				FILE* _tmp97_;
				const gchar* _tmp98_;
				_tmp97_ = self->priv->stream;
				_tmp98_ = s;
				fprintf (_tmp97_, "%s\n", _tmp98_);
				_g_free0 (s);
			}
		}
	}
	_tmp99_ = self->priv->stream;
	fprintf (_tmp99_, "[Column clues]\n");
	_tmp100_ = gnonograms_filewriter_get_col_clues (self, &_tmp101_);
	_tmp100__length1 = _tmp101_;
	_tmp102_ = _tmp100_;
	_tmp102__length1 = _tmp100__length1;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp102_;
		s_collection_length1 = _tmp102__length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp103_;
			gchar* s = NULL;
			_tmp103_ = g_strdup (s_collection[s_it]);
			s = _tmp103_;
			{
				FILE* _tmp104_;
				const gchar* _tmp105_;
				_tmp104_ = self->priv->stream;
				_tmp105_ = s;
				fprintf (_tmp104_, "%s\n", _tmp105_);
				_g_free0 (s);
			}
		}
	}
	_tmp106_ = self->priv->stream;
	fflush (_tmp106_);
	_tmp108_ = self->priv->_solution;
	if (_tmp108_ != NULL) {
		gboolean _tmp109_;
		_tmp109_ = self->priv->_save_solution;
		_tmp107_ = _tmp109_;
	} else {
		_tmp107_ = FALSE;
	}
	if (_tmp107_) {
		FILE* _tmp110_;
		FILE* _tmp111_;
		GnonogramsMy2DCellArray* _tmp112_;
		gchar* _tmp113_;
		gchar* _tmp114_;
		_tmp110_ = self->priv->stream;
		fprintf (_tmp110_, "[Solution grid]\n");
		_tmp111_ = self->priv->stream;
		_tmp112_ = self->priv->_solution;
		_tmp113_ = gnonograms_my2_dcell_array_to_string (_tmp112_);
		_tmp114_ = _tmp113_;
		fprintf (_tmp111_, "%s", _tmp114_);
		_g_free0 (_tmp114_);
	}
	_tmp115_ = self->priv->stream;
	fprintf (_tmp115_, "[Locked]\n");
	_tmp116_ = self->priv->stream;
	_tmp117_ = self->priv->_is_readonly;
	_tmp118_ = bool_to_string (_tmp117_);
	_tmp119_ = _tmp118_;
	_tmp120_ = g_strconcat (_tmp119_, "\n", NULL);
	_tmp121_ = _tmp120_;
	fprintf (_tmp116_, "%s", _tmp121_);
	_g_free0 (_tmp121_);
	_g_free0 (_tmp119_);
	_g_object_unref0 (file);
}

/*** Writes complete information to reload game state ***/
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

void
gnonograms_filewriter_write_position_file (GnonogramsFilewriter* self,
                                           const gchar* save_dir_path,
                                           const gchar* path,
                                           const gchar* name,
                                           GError** error)
{
	GnonogramsMy2DCellArray* _tmp0_;
	FILE* _tmp4_;
	FILE* _tmp5_;
	GnonogramsMy2DCellArray* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	FILE* _tmp9_;
	FILE* _tmp10_;
	GnonogramsGameState _tmp11_;
	GEnumValue* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GnonogramsHistory* _tmp21_;
	FILE* _tmp29_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_working;
	if (_tmp0_ == NULL) {
		GError* _tmp1_;
		_tmp1_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "No working grid to save");
		_inner_error0_ = _tmp1_;
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	} else {
		GnonogramsGameState _tmp2_;
		_tmp2_ = self->priv->_game_state;
		if (_tmp2_ == GNONOGRAMS_GAME_STATE_UNDEFINED) {
			GError* _tmp3_;
			_tmp3_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_INITIALIZED, "No game state to save");
			_inner_error0_ = _tmp3_;
			if (_inner_error0_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	gnonograms_filewriter_write_game_file (self, save_dir_path, path, name, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = self->priv->stream;
	fprintf (_tmp4_, "[Working grid]\n");
	_tmp5_ = self->priv->stream;
	_tmp6_ = self->priv->_working;
	_tmp7_ = gnonograms_my2_dcell_array_to_string (_tmp6_);
	_tmp8_ = _tmp7_;
	fprintf (_tmp5_, "%s", _tmp8_);
	_g_free0 (_tmp8_);
	_tmp9_ = self->priv->stream;
	fprintf (_tmp9_, "[State]\n");
	_tmp10_ = self->priv->stream;
	_tmp11_ = self->priv->_game_state;
	_tmp12_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_GAME_STATE), _tmp11_);
	_tmp13_ = g_strconcat ((_tmp12_ != NULL) ? _tmp12_->value_name : NULL, "\n", NULL);
	_tmp14_ = _tmp13_;
	fprintf (_tmp10_, "%s", _tmp14_);
	_g_free0 (_tmp14_);
	if (g_strcmp0 (name, _ (GNONOGRAMS_UNTITLED_NAME)) != 0) {
		FILE* _tmp15_;
		FILE* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp15_ = self->priv->stream;
		fprintf (_tmp15_, "[Original path]\n");
		_tmp16_ = self->priv->stream;
		_tmp17_ = self->priv->_game_path;
		_tmp18_ = string_to_string (_tmp17_);
		_tmp19_ = g_strconcat (_tmp18_, "\n", NULL);
		_tmp20_ = _tmp19_;
		fprintf (_tmp16_, "%s", _tmp20_);
		_g_free0 (_tmp20_);
	}
	_tmp21_ = self->priv->_history;
	if (_tmp21_ != NULL) {
		FILE* _tmp22_;
		FILE* _tmp23_;
		GnonogramsHistory* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp22_ = self->priv->stream;
		fprintf (_tmp22_, "[History]\n");
		_tmp23_ = self->priv->stream;
		_tmp24_ = self->priv->_history;
		_tmp25_ = gnonograms_history_to_string (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = g_strconcat (_tmp26_, "\n", NULL);
		_tmp28_ = _tmp27_;
		fprintf (_tmp23_, "%s", _tmp28_);
		_g_free0 (_tmp28_);
		_g_free0 (_tmp26_);
	}
	_tmp29_ = self->priv->stream;
	fflush (_tmp29_);
}

GDateTime*
gnonograms_filewriter_get_date (GnonogramsFilewriter* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
gnonograms_filewriter_set_date (GnonogramsFilewriter* self,
                                GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_date (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_DATE_PROPERTY]);
	}
}

GnonogramsHistory*
gnonograms_filewriter_get_history (GnonogramsFilewriter* self)
{
	GnonogramsHistory* result;
	GnonogramsHistory* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_history;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gnonograms_filewriter_set_history (GnonogramsFilewriter* self,
                                   GnonogramsHistory* value)
{
	GnonogramsHistory* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_history (self);
	if (old_value != value) {
		GnonogramsHistory* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_history);
		self->priv->_history = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY]);
	}
}

GtkWindow*
gnonograms_filewriter_get_parent (GnonogramsFilewriter* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filewriter_set_parent (GnonogramsFilewriter* self,
                                  GtkWindow* value)
{
	GtkWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_parent (self);
	if (old_value != value) {
		GtkWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_parent);
		self->priv->_parent = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_PARENT_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_filewriter_get_difficulty (GnonogramsFilewriter* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_difficulty;
	return result;
}

void
gnonograms_filewriter_set_difficulty (GnonogramsFilewriter* self,
                                      GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_difficulty (self);
	if (old_value != value) {
		self->priv->_difficulty = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY]);
	}
}

GnonogramsGameState
gnonograms_filewriter_get_game_state (GnonogramsFilewriter* self)
{
	GnonogramsGameState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_game_state;
	return result;
}

void
gnonograms_filewriter_set_game_state (GnonogramsFilewriter* self,
                                      GnonogramsGameState value)
{
	GnonogramsGameState old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_game_state (self);
	if (old_value != value) {
		self->priv->_game_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_filewriter_get_solution (GnonogramsFilewriter* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_solution;
	result = _tmp0_;
	return result;
}

void
gnonograms_filewriter_set_solution (GnonogramsFilewriter* self,
                                    GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_solution (self);
	if (old_value != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_solution);
		self->priv->_solution = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_filewriter_get_working (GnonogramsFilewriter* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_working;
	result = _tmp0_;
	return result;
}

void
gnonograms_filewriter_set_working (GnonogramsFilewriter* self,
                                   GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_working (self);
	if (old_value != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_working);
		self->priv->_working = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_WORKING_PROPERTY]);
	}
}

guint
gnonograms_filewriter_get_rows (GnonogramsFilewriter* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_rows;
	return result;
}

static void
gnonograms_filewriter_set_rows (GnonogramsFilewriter* self,
                                guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_rows (self);
	if (old_value != value) {
		self->priv->_rows = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_ROWS_PROPERTY]);
	}
}

guint
gnonograms_filewriter_get_cols (GnonogramsFilewriter* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_cols;
	return result;
}

static void
gnonograms_filewriter_set_cols (GnonogramsFilewriter* self,
                                guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_cols (self);
	if (old_value != value) {
		self->priv->_cols = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_COLS_PROPERTY]);
	}
}

const gchar*
gnonograms_filewriter_get_name (GnonogramsFilewriter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
gnonograms_filewriter_set_name (GnonogramsFilewriter* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_NAME_PROPERTY]);
	}
}

gchar**
gnonograms_filewriter_get_row_clues (GnonogramsFilewriter* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_row_clues;
	_tmp0__length1 = self->priv->_row_clues_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
gnonograms_filewriter_set_row_clues (GnonogramsFilewriter* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_row_clues (self, &old_value_length);
	if (old_value != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup6 (value, value_length1) : value;
		_tmp0__length1 = value_length1;
		self->priv->_row_clues = (_vala_array_free (self->priv->_row_clues, self->priv->_row_clues_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_row_clues = _tmp0_;
		self->priv->_row_clues_length1 = _tmp0__length1;
		self->priv->__row_clues_size_ = self->priv->_row_clues_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY]);
	}
}

gchar**
gnonograms_filewriter_get_col_clues (GnonogramsFilewriter* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_col_clues;
	_tmp0__length1 = self->priv->_col_clues_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
gnonograms_filewriter_set_col_clues (GnonogramsFilewriter* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_col_clues (self, &old_value_length);
	if (old_value != value) {
		gchar** _tmp0_;
		gint _tmp0__length1;
		_tmp0_ = (value != NULL) ? _vala_array_dup7 (value, value_length1) : value;
		_tmp0__length1 = value_length1;
		self->priv->_col_clues = (_vala_array_free (self->priv->_col_clues, self->priv->_col_clues_length1, (GDestroyNotify) g_free), NULL);
		self->priv->_col_clues = _tmp0_;
		self->priv->_col_clues_length1 = _tmp0__length1;
		self->priv->__col_clues_size_ = self->priv->_col_clues_length1;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY]);
	}
}

gboolean
gnonograms_filewriter_get_save_solution (GnonogramsFilewriter* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_save_solution;
	return result;
}

static void
gnonograms_filewriter_set_save_solution (GnonogramsFilewriter* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_save_solution (self);
	if (old_value != value) {
		self->priv->_save_solution = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY]);
	}
}

const gchar*
gnonograms_filewriter_get_game_path (GnonogramsFilewriter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_game_path;
	result = _tmp0_;
	return result;
}

static void
gnonograms_filewriter_set_game_path (GnonogramsFilewriter* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_game_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_game_path);
		self->priv->_game_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY]);
	}
}

const gchar*
gnonograms_filewriter_get_author (GnonogramsFilewriter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_author;
	result = _tmp0_;
	return result;
}

void
gnonograms_filewriter_set_author (GnonogramsFilewriter* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_author (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_author);
		self->priv->_author = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY]);
	}
}

const gchar*
gnonograms_filewriter_get_license (GnonogramsFilewriter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_license;
	result = _tmp0_;
	return result;
}

void
gnonograms_filewriter_set_license (GnonogramsFilewriter* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_license (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_license);
		self->priv->_license = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY]);
	}
}

gboolean
gnonograms_filewriter_get_is_readonly (GnonogramsFilewriter* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_readonly;
	return result;
}

void
gnonograms_filewriter_set_is_readonly (GnonogramsFilewriter* self,
                                       gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_filewriter_get_is_readonly (self);
	if (old_value != value) {
		self->priv->_is_readonly = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY]);
	}
}

static GObject *
gnonograms_filewriter_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsFilewriter * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	parent_class = G_OBJECT_CLASS (gnonograms_filewriter_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter);
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	gnonograms_filewriter_set_date (self, _tmp1_);
	_g_date_time_unref0 (_tmp1_);
	return obj;
}

static void
gnonograms_filewriter_class_init (GnonogramsFilewriterClass * klass,
                                  gpointer klass_data)
{
	gnonograms_filewriter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsFilewriter_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_filewriter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_filewriter_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_filewriter_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_filewriter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_DATE_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY] = g_param_spec_object ("history", "history", "history", GNONOGRAMS_TYPE_HISTORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_PARENT_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY] = g_param_spec_enum ("difficulty", "difficulty", "difficulty", GNONOGRAMS_TYPE_DIFFICULTY, GNONOGRAMS_DIFFICULTY_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY] = g_param_spec_enum ("game-state", "game-state", "game-state", GNONOGRAMS_TYPE_GAME_STATE, GNONOGRAMS_GAME_STATE_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY] = g_param_spec_object ("solution", "solution", "solution", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_WORKING_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_WORKING_PROPERTY] = g_param_spec_object ("working", "working", "working", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_ROWS_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_COLS_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_NAME_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY] = g_param_spec_boxed ("row-clues", "row-clues", "row-clues", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY] = g_param_spec_boxed ("col-clues", "col-clues", "col-clues", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY] = g_param_spec_boolean ("save-solution", "save-solution", "save-solution", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY] = g_param_spec_string ("game-path", "game-path", "game-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY] = g_param_spec_string ("author", "author", "author", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY] = g_param_spec_string ("license", "license", "license", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY, gnonograms_filewriter_properties[GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY] = g_param_spec_boolean ("is-readonly", "is-readonly", "is-readonly", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_filewriter_instance_init (GnonogramsFilewriter * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = gnonograms_filewriter_get_instance_private (self);
	self->priv->_difficulty = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	self->priv->_game_state = GNONOGRAMS_GAME_STATE_UNDEFINED;
	self->priv->_solution = NULL;
	self->priv->_working = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_author = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_license = _tmp1_;
	self->priv->_is_readonly = TRUE;
}

static void
gnonograms_filewriter_finalize (GObject * obj)
{
	GnonogramsFilewriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter);
	_g_date_time_unref0 (self->priv->_date);
	_g_object_unref0 (self->priv->_history);
	_g_object_unref0 (self->priv->_parent);
	_g_object_unref0 (self->priv->_solution);
	_g_object_unref0 (self->priv->_working);
	_g_free0 (self->priv->_name);
	self->priv->_row_clues = (_vala_array_free (self->priv->_row_clues, self->priv->_row_clues_length1, (GDestroyNotify) g_free), NULL);
	self->priv->_col_clues = (_vala_array_free (self->priv->_col_clues, self->priv->_col_clues_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_game_path);
	_g_free0 (self->priv->_author);
	_g_free0 (self->priv->_license);
	_fclose0 (self->priv->stream);
	G_OBJECT_CLASS (gnonograms_filewriter_parent_class)->finalize (obj);
}

static GType
gnonograms_filewriter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsFilewriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_filewriter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsFilewriter), 0, (GInstanceInitFunc) gnonograms_filewriter_instance_init, NULL };
	GType gnonograms_filewriter_type_id;
	gnonograms_filewriter_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsFilewriter", &g_define_type_info, 0);
	GnonogramsFilewriter_private_offset = g_type_add_instance_private (gnonograms_filewriter_type_id, sizeof (GnonogramsFilewriterPrivate));
	return gnonograms_filewriter_type_id;
}

GType
gnonograms_filewriter_get_type (void)
{
	static volatile gsize gnonograms_filewriter_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_filewriter_type_id__once)) {
		GType gnonograms_filewriter_type_id;
		gnonograms_filewriter_type_id = gnonograms_filewriter_get_type_once ();
		g_once_init_leave (&gnonograms_filewriter_type_id__once, gnonograms_filewriter_type_id);
	}
	return gnonograms_filewriter_type_id__once;
}

static void
_vala_gnonograms_filewriter_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsFilewriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter);
	switch (property_id) {
		case GNONOGRAMS_FILEWRITER_DATE_PROPERTY:
		g_value_set_boxed (value, gnonograms_filewriter_get_date (self));
		break;
		case GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY:
		g_value_set_object (value, gnonograms_filewriter_get_history (self));
		break;
		case GNONOGRAMS_FILEWRITER_PARENT_PROPERTY:
		g_value_set_object (value, gnonograms_filewriter_get_parent (self));
		break;
		case GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY:
		g_value_set_enum (value, gnonograms_filewriter_get_difficulty (self));
		break;
		case GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_filewriter_get_game_state (self));
		break;
		case GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY:
		g_value_set_object (value, gnonograms_filewriter_get_solution (self));
		break;
		case GNONOGRAMS_FILEWRITER_WORKING_PROPERTY:
		g_value_set_object (value, gnonograms_filewriter_get_working (self));
		break;
		case GNONOGRAMS_FILEWRITER_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_filewriter_get_rows (self));
		break;
		case GNONOGRAMS_FILEWRITER_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_filewriter_get_cols (self));
		break;
		case GNONOGRAMS_FILEWRITER_NAME_PROPERTY:
		g_value_set_string (value, gnonograms_filewriter_get_name (self));
		break;
		case GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filewriter_get_row_clues (self, &length));
		}
		break;
		case GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, gnonograms_filewriter_get_col_clues (self, &length));
		}
		break;
		case GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY:
		g_value_set_boolean (value, gnonograms_filewriter_get_save_solution (self));
		break;
		case GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY:
		g_value_set_string (value, gnonograms_filewriter_get_game_path (self));
		break;
		case GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY:
		g_value_set_string (value, gnonograms_filewriter_get_author (self));
		break;
		case GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY:
		g_value_set_string (value, gnonograms_filewriter_get_license (self));
		break;
		case GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_filewriter_get_is_readonly (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_filewriter_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsFilewriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter);
	switch (property_id) {
		case GNONOGRAMS_FILEWRITER_DATE_PROPERTY:
		gnonograms_filewriter_set_date (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_FILEWRITER_HISTORY_PROPERTY:
		gnonograms_filewriter_set_history (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_FILEWRITER_PARENT_PROPERTY:
		gnonograms_filewriter_set_parent (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_FILEWRITER_DIFFICULTY_PROPERTY:
		gnonograms_filewriter_set_difficulty (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_FILEWRITER_GAME_STATE_PROPERTY:
		gnonograms_filewriter_set_game_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_FILEWRITER_SOLUTION_PROPERTY:
		gnonograms_filewriter_set_solution (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_FILEWRITER_WORKING_PROPERTY:
		gnonograms_filewriter_set_working (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_FILEWRITER_ROWS_PROPERTY:
		gnonograms_filewriter_set_rows (self, g_value_get_uint (value));
		break;
		case GNONOGRAMS_FILEWRITER_COLS_PROPERTY:
		gnonograms_filewriter_set_cols (self, g_value_get_uint (value));
		break;
		case GNONOGRAMS_FILEWRITER_NAME_PROPERTY:
		gnonograms_filewriter_set_name (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEWRITER_ROW_CLUES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filewriter_set_row_clues (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEWRITER_COL_CLUES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			gnonograms_filewriter_set_col_clues (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case GNONOGRAMS_FILEWRITER_SAVE_SOLUTION_PROPERTY:
		gnonograms_filewriter_set_save_solution (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_FILEWRITER_GAME_PATH_PROPERTY:
		gnonograms_filewriter_set_game_path (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEWRITER_AUTHOR_PROPERTY:
		gnonograms_filewriter_set_author (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEWRITER_LICENSE_PROPERTY:
		gnonograms_filewriter_set_license (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_FILEWRITER_IS_READONLY_PROPERTY:
		gnonograms_filewriter_set_is_readonly (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

