/* Solver.c generated by valac 0.56.16, the Vala compiler
 * generated from Solver.vala, do not modify */

/* Solver.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define GNONOGRAMS_SOLVER_MODERATE_CPP ((gdouble) 5.0f)
#define GNONOGRAMS_SOLVER_HARD_CPP ((gdouble) 3.0f)
#define GNONOGRAMS_SOLVER_CHALLENGING_CPP ((gdouble) 1.5f)
#define GNONOGRAMS_SOLVER_MAX_PASSES ((guint) 200)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_SOLVER (gnonograms_solver_get_type ())
#define GNONOGRAMS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver))
#define GNONOGRAMS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))
#define GNONOGRAMS_IS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_IS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_SOLVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))

typedef struct _GnonogramsSolver GnonogramsSolver;
typedef struct _GnonogramsSolverClass GnonogramsSolverClass;
typedef struct _GnonogramsSolverPrivate GnonogramsSolverPrivate;
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_REGION (gnonograms_region_get_type ())
#define GNONOGRAMS_REGION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegion))
#define GNONOGRAMS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))
#define GNONOGRAMS_IS_REGION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_IS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_REGION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))

typedef struct _GnonogramsRegion GnonogramsRegion;
typedef struct _GnonogramsRegionClass GnonogramsRegionClass;
enum  {
	GNONOGRAMS_SOLVER_0_PROPERTY,
	GNONOGRAMS_SOLVER_STATE_PROPERTY,
	GNONOGRAMS_SOLVER_GRID_PROPERTY,
	GNONOGRAMS_SOLVER_SOLUTION_PROPERTY,
	GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY,
	GNONOGRAMS_SOLVER_CANCELLED_PROPERTY,
	GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY,
	GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY,
	GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY,
	GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY,
	GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY,
	GNONOGRAMS_SOLVER_ROWS_PROPERTY,
	GNONOGRAMS_SOLVER_COLS_PROPERTY,
	GNONOGRAMS_SOLVER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_solver_properties[GNONOGRAMS_SOLVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
typedef struct _GnonogramsSolverSolveCluesData GnonogramsSolverSolveCluesData;
#define _gnonograms_region_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_region_unref (var), NULL)))
typedef struct _GnonogramsSolverSolveItData GnonogramsSolverSolveItData;

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
#define _gnonograms_move_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_move_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _GnonogramsSolverSimpleSolverData GnonogramsSolverSimpleSolverData;

#define GNONOGRAMS_SOLVER_TYPE_GUESSER (gnonograms_solver_guesser_get_type ())
#define GNONOGRAMS_SOLVER_GUESSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesser))
#define GNONOGRAMS_SOLVER_GUESSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesserClass))
#define GNONOGRAMS_SOLVER_IS_GUESSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER))
#define GNONOGRAMS_SOLVER_IS_GUESSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_SOLVER_TYPE_GUESSER))
#define GNONOGRAMS_SOLVER_GUESSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesserClass))

typedef struct _GnonogramsSolverGuesser GnonogramsSolverGuesser;
typedef struct _GnonogramsSolverGuesserClass GnonogramsSolverGuesserClass;
#define _gnonograms_solver_guesser_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_solver_guesser_unref (var), NULL)))
typedef struct _GnonogramsSolverAdvancedSolverData GnonogramsSolverAdvancedSolverData;
typedef struct _GnonogramsSolverGuesserPrivate GnonogramsSolverGuesserPrivate;
typedef struct _GnonogramsSolverParamSpecGuesser GnonogramsSolverParamSpecGuesser;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsSolver {
	GObject parent_instance;
	GnonogramsSolverPrivate * priv;
};

struct _GnonogramsSolverClass {
	GObjectClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsSolverPrivate {
	GnonogramsSolverState _state;
	GnonogramsMy2DCellArray* _grid;
	GnonogramsMy2DCellArray* _solution;
	GCancellable* _cancellable;
	GnonogramsDimensions _dimensions;
	gboolean _unique_only;
	gboolean _use_advanced;
	gboolean _advanced_only;
	gboolean _human_only;
	GnonogramsRegion** regions;
	gint regions_length1;
	gint _regions_size_;
	gboolean should_check_solution;
	guint moderate_threshold;
	guint hard_threshold;
	guint challenging_threshold;
};

struct _GnonogramsSolverSolveCluesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsSolver* self;
	gchar** row_clues;
	gint row_clues_length1;
	gchar** col_clues;
	gint col_clues_length1;
	GnonogramsMy2DCellArray* start_grid;
	GnonogramsMy2DCellArray* solution_grid;
	GnonogramsDifficulty result;
};

struct _GnonogramsSolverSolveItData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsSolver* self;
	GnonogramsDifficulty result;
	gint _result_;
	gint i;
	gboolean _tmp0_;
	gint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsRegion** _tmp4_;
	gint _tmp4__length1;
	GnonogramsRegion* _tmp5_;
	GnonogramsSolverState _tmp6_;
	gboolean _tmp7_;
	GnonogramsSolverState _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GnonogramsSolverState _tmp11_;
	gboolean _tmp12_;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _Block8Data {
	int _ref_count_;
	GnonogramsSolver* self;
	gboolean changed;
	gint pass;
	gpointer _async_data_;
};

struct _GnonogramsSolverSimpleSolverData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsSolver* self;
	gint result;
	Block8Data* _data8_;
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
};

struct _GnonogramsSolverAdvancedSolverData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsSolver* self;
	gint result;
	GnonogramsSolverGuesser* guesser;
	GnonogramsMy2DCellArray* _tmp0_;
	gboolean _tmp1_;
	GnonogramsSolverGuesser* _tmp2_;
	GnonogramsSolverState initial_state;
	GnonogramsSolverState inverse_state;
	gint _result_;
	gint _tmp3_;
	gboolean _tmp4_;
	gint min_to_contradiction;
	gint contra;
	gint empty;
	gint min_empty_cells;
	gint changed_count;
	GnonogramsCell best_guess;
	GnonogramsSolverState _tmp5_;
	gint _tmp6_;
	GnonogramsSolverGuesser* _tmp7_;
	GnonogramsMy2DCellArray* _tmp8_;
	GnonogramsCell _tmp9_;
	GnonogramsMy2DCellArray* _tmp10_;
	GnonogramsSolverGuesser* _tmp11_;
	GnonogramsSolverGuesser* _tmp12_;
	GnonogramsSolverState _tmp13_;
	GnonogramsMy2DCellArray* _tmp14_;
	GnonogramsSolverGuesser* _tmp15_;
	GnonogramsCell _tmp16_;
	gboolean _tmp17_;
	GnonogramsSolverState _tmp18_;
	GnonogramsSolverGuesser* _tmp19_;
	GnonogramsSolverGuesser* _tmp20_;
	GnonogramsSolverState _tmp21_;
	GnonogramsMy2DCellArray* _tmp22_;
	GnonogramsSolverGuesser* _tmp23_;
	GnonogramsCell _tmp24_;
	gboolean _tmp25_;
	GnonogramsSolverGuesser* _tmp26_;
	GnonogramsSolverGuesser* _tmp27_;
	GnonogramsSolverGuesser* _tmp28_;
	GEnumValue* _tmp29_;
	gboolean _tmp30_;
	GnonogramsSolverGuesser* _tmp31_;
	GnonogramsSolverGuesser* _tmp32_;
	GnonogramsSolverGuesser* _tmp33_;
	GEnumValue* _tmp34_;
	gboolean _tmp35_;
	GEnumValue* _tmp36_;
	GCancellable* _tmp37_;
	GnonogramsSolverState _tmp38_;
	GnonogramsSolverState _tmp39_;
	GEnumValue* _tmp40_;
};

struct _GnonogramsSolverGuesser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsSolverGuesserPrivate * priv;
};

struct _GnonogramsSolverGuesserClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsSolverGuesser *self);
};

struct _GnonogramsSolverGuesserPrivate {
	GnonogramsCell trial_cell;
	gint rdir;
	gint cdir;
	gint rlim;
	gint clim;
	gint turn;
	guint max_turns;
	guint initial_max_turns;
	GnonogramsCellState initial_cell_state;
	gboolean human_only;
	GnonogramsCellState* gs;
	gint gs_length1;
	gint _gs_size_;
	GnonogramsMy2DCellArray* _grid;
};

struct _GnonogramsSolverParamSpecGuesser {
	GParamSpec parent_instance;
};

static gint GnonogramsSolver_private_offset;
static gpointer gnonograms_solver_parent_class = NULL;
static gint GnonogramsSolverGuesser_private_offset;
static gpointer gnonograms_solver_guesser_parent_class = NULL;

VALA_EXTERN GType gnonograms_solver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSolver, g_object_unref)
VALA_EXTERN GType gnonograms_solver_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN gpointer gnonograms_region_ref (gpointer instance);
VALA_EXTERN void gnonograms_region_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_region (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_region (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void gnonograms_value_take_region (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_region (const GValue* value);
VALA_EXTERN GType gnonograms_region_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRegion, gnonograms_region_unref)
VALA_EXTERN GnonogramsSolver* gnonograms_solver_new (GnonogramsDimensions* _dimensions);
VALA_EXTERN GnonogramsSolver* gnonograms_solver_construct (GType object_type,
                                               GnonogramsDimensions* _dimensions);
VALA_EXTERN void gnonograms_solver_get_dimensions (GnonogramsSolver* self,
                                       GnonogramsDimensions * result);
VALA_EXTERN guint gnonograms_dimensions_length (GnonogramsDimensions *self);
static gboolean gnonograms_solver_initialize (GnonogramsSolver* self,
                                       gchar** row_clues,
                                       gint row_clues_length1,
                                       gchar** col_clues,
                                       gint col_clues_length1,
                                       GnonogramsMy2DCellArray* start_grid,
                                       GnonogramsMy2DCellArray* solution_grid);
VALA_EXTERN guint gnonograms_solver_get_rows (GnonogramsSolver* self);
VALA_EXTERN guint gnonograms_solver_get_cols (GnonogramsSolver* self);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_solver_get_solution (GnonogramsSolver* self);
VALA_EXTERN void gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                      GnonogramsMy2DCellArray* ca);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_solver_get_grid (GnonogramsSolver* self);
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gnonograms_my2_dcell_array_set_all (GnonogramsMy2DCellArray* self,
                                         GnonogramsCellState s);
VALA_EXTERN void gnonograms_region_initialize (GnonogramsRegion* self,
                                   guint index,
                                   gboolean is_column,
                                   guint n_cells,
                                   const gchar* clue);
VALA_EXTERN void gnonograms_solver_set_state (GnonogramsSolver* self,
                                  GnonogramsSolverState value);
static gboolean gnonograms_solver_valid (GnonogramsSolver* self);
static void gnonograms_solver_solve_clues_data_free (gpointer _data);
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gnonograms_solver_solve_clues (GnonogramsSolver* self,
                                    gchar** row_clues,
                                    gint row_clues_length1,
                                    gchar** col_clues,
                                    gint col_clues_length1,
                                    GnonogramsMy2DCellArray* start_grid,
                                    GnonogramsMy2DCellArray* solution_grid,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN GnonogramsDifficulty gnonograms_solver_solve_clues_finish (GnonogramsSolver* self,
                                                           GAsyncResult* _res_);
static gboolean gnonograms_solver_solve_clues_co (GnonogramsSolverSolveCluesData* _data_);
static void gnonograms_solver_solve_it (GnonogramsSolver* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static GnonogramsDifficulty gnonograms_solver_solve_it_finish (GnonogramsSolver* self,
                                                        GAsyncResult* _res_);
static void gnonograms_solver_solve_clues_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
VALA_EXTERN void gnonograms_solver_cancel (GnonogramsSolver* self);
VALA_EXTERN GCancellable* gnonograms_solver_get_cancellable (GnonogramsSolver* self);
static void gnonograms_solver_reinitialize_regions (GnonogramsSolver* self);
VALA_EXTERN void gnonograms_region_set_to_initial_state (GnonogramsRegion* self);
VALA_EXTERN gboolean gnonograms_region_get_in_error (GnonogramsRegion* self);
VALA_EXTERN gint gnonograms_region_get_block_total (GnonogramsRegion* self);
VALA_EXTERN gboolean gnonograms_solver_solved (GnonogramsSolver* self);
VALA_EXTERN gboolean gnonograms_region_get_is_completed (GnonogramsRegion* self);
VALA_EXTERN void gnonograms_solver_configure_from_grade (GnonogramsSolver* self,
                                             GnonogramsDifficulty grade);
VALA_EXTERN void gnonograms_solver_set_use_advanced (GnonogramsSolver* self,
                                         gboolean value);
VALA_EXTERN void gnonograms_solver_set_unique_only (GnonogramsSolver* self,
                                        gboolean value);
VALA_EXTERN void gnonograms_solver_set_advanced_only (GnonogramsSolver* self,
                                          gboolean value);
VALA_EXTERN void gnonograms_solver_set_human_only (GnonogramsSolver* self,
                                       gboolean value);
static void gnonograms_solver_solve_it_data_free (gpointer _data);
static gboolean gnonograms_solver_solve_it_co (GnonogramsSolverSolveItData* _data_);
static guint gnonograms_solver_get_n_regions (GnonogramsSolver* self);
static void gnonograms_solver_simple_solver (GnonogramsSolver* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gint gnonograms_solver_simple_solver_finish (GnonogramsSolver* self,
                                             GAsyncResult* _res_);
static void gnonograms_solver_solve_it_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
VALA_EXTERN GnonogramsSolverState gnonograms_solver_get_state (GnonogramsSolver* self);
VALA_EXTERN gboolean gnonograms_solver_get_advanced_only (GnonogramsSolver* self);
VALA_EXTERN gboolean gnonograms_solver_get_use_advanced (GnonogramsSolver* self);
static void gnonograms_solver_advanced_solver (GnonogramsSolver* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gint gnonograms_solver_advanced_solver_finish (GnonogramsSolver* self,
                                               GAsyncResult* _res_);
static GnonogramsDifficulty gnonograms_solver_passes_to_grade (GnonogramsSolver* self,
                                                        guint passes);
VALA_EXTERN gpointer gnonograms_move_ref (gpointer instance);
VALA_EXTERN void gnonograms_move_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
VALA_EXTERN void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_move (const GValue* value);
VALA_EXTERN GType gnonograms_move_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
VALA_EXTERN GeeArrayQueue* gnonograms_solver_hint (GnonogramsSolver* self,
                                       gchar** row_clues,
                                       gint row_clues_length1,
                                       gchar** col_clues,
                                       gint col_clues_length1,
                                       GnonogramsMy2DCellArray* working);
VALA_EXTERN gboolean gnonograms_region_get_is_column (GnonogramsRegion* self);
VALA_EXTERN void gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState** sa,
                                           gint* sa_length1,
                                           guint start);
VALA_EXTERN guint gnonograms_region_get_index (GnonogramsRegion* self);
VALA_EXTERN GnonogramsCellState gnonograms_region_get_cell_state (GnonogramsRegion* self,
                                                      guint index);
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN GnonogramsMove* gnonograms_move_new (GnonogramsCell* _cell,
                                     GnonogramsCellState _previous_state);
VALA_EXTERN GnonogramsMove* gnonograms_move_construct (GType object_type,
                                           GnonogramsCell* _cell,
                                           GnonogramsCellState _previous_state);
VALA_EXTERN gboolean gnonograms_region_solve (GnonogramsRegion* self);
static void gnonograms_solver_simple_solver_data_free (gpointer _data);
static gboolean gnonograms_solver_simple_solver_co (GnonogramsSolverSimpleSolverData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean __lambda18_ (Block8Data* _data8_);
static gboolean ___lambda18__gsource_func (gpointer self);
static void gnonograms_solver_advanced_solver_data_free (gpointer _data);
static gboolean gnonograms_solver_advanced_solver_co (GnonogramsSolverAdvancedSolverData* _data_);
static gpointer gnonograms_solver_guesser_ref (gpointer instance);
static void gnonograms_solver_guesser_unref (gpointer instance);
static GParamSpec* gnonograms_solver_param_spec_guesser (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void gnonograms_solver_value_set_guesser (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED ;
static void gnonograms_solver_value_take_guesser (GValue* value,
                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer gnonograms_solver_value_get_guesser (const GValue* value) G_GNUC_UNUSED ;
static GType gnonograms_solver_guesser_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSolverGuesser, gnonograms_solver_guesser_unref)
VALA_EXTERN gboolean gnonograms_solver_get_human_only (GnonogramsSolver* self);
static GnonogramsSolverGuesser* gnonograms_solver_guesser_new (GnonogramsMy2DCellArray* _grid,
                                                        gboolean _human_only);
static GnonogramsSolverGuesser* gnonograms_solver_guesser_construct (GType object_type,
                                                              GnonogramsMy2DCellArray* _grid,
                                                              gboolean _human_only);
static gboolean gnonograms_solver_guesser_next_guess (GnonogramsSolverGuesser* self);
VALA_EXTERN gboolean gnonograms_cell_equal (GnonogramsCell *self,
                                GnonogramsCell* b);
VALA_EXTERN void gnonograms_my2_dcell_array_set_data_from_cell (GnonogramsMy2DCellArray* self,
                                                    GnonogramsCell* c);
static void gnonograms_solver_advanced_solver_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
VALA_EXTERN gint gnonograms_my2_dcell_array_count_state (GnonogramsMy2DCellArray* self,
                                             GnonogramsCellState cell_state);
static void gnonograms_solver_guesser_get_trial_cell_copy (GnonogramsSolverGuesser* self,
                                                    GnonogramsCell* result);
static void gnonograms_solver_guesser_cancel_previous_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_invert_previous_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_initialize (GnonogramsSolverGuesser* self);
VALA_EXTERN gboolean gnonograms_solver_get_unique_only (GnonogramsSolver* self);
VALA_EXTERN void gnonograms_solver_set_grid (GnonogramsSolver* self,
                                 GnonogramsMy2DCellArray* value);
VALA_EXTERN void gnonograms_solver_set_solution (GnonogramsSolver* self,
                                     GnonogramsMy2DCellArray* value);
VALA_EXTERN void gnonograms_solver_set_cancellable (GnonogramsSolver* self,
                                        GCancellable* value);
VALA_EXTERN gboolean gnonograms_solver_get_cancelled (GnonogramsSolver* self);
VALA_EXTERN void gnonograms_solver_set_dimensions (GnonogramsSolver* self,
                                       GnonogramsDimensions * value);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_new (GnonogramsDimensions* _dimensions,
                                                         GnonogramsCellState init);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_my2_dcell_array_construct (GType object_type,
                                                               GnonogramsDimensions* _dimensions,
                                                               GnonogramsCellState init);
VALA_EXTERN GnonogramsRegion* gnonograms_region_new (GnonogramsMy2DCellArray* grid);
VALA_EXTERN GnonogramsRegion* gnonograms_region_construct (GType object_type,
                                               GnonogramsMy2DCellArray* grid);
static void gnonograms_solver_guesser_set_grid (GnonogramsSolverGuesser* self,
                                         GnonogramsMy2DCellArray* value);
static guint gnonograms_solver_guesser_get_rows (GnonogramsSolverGuesser* self);
static guint gnonograms_solver_guesser_get_cols (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_save_position (GnonogramsSolverGuesser* self);
static gboolean gnonograms_solver_guesser_make_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_load_position (GnonogramsSolverGuesser* self);
VALA_EXTERN void gnonograms_cell_inverse (GnonogramsCell *self,
                              GnonogramsCell* result);
static GnonogramsMy2DCellArray* gnonograms_solver_guesser_get_grid (GnonogramsSolverGuesser* self);
VALA_EXTERN void gnonograms_my2_dcell_array_set_data_from_rc (GnonogramsMy2DCellArray* self,
                                                  guint r,
                                                  guint c,
                                                  GnonogramsCellState s);
VALA_EXTERN GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
VALA_EXTERN void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_area (GnonogramsMy2DCellArray* self);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
static void gnonograms_solver_guesser_finalize (GnonogramsSolverGuesser * obj);
static GType gnonograms_solver_guesser_get_type_once (void);
static void gnonograms_solver_finalize (GObject * obj);
static GType gnonograms_solver_get_type_once (void);
static void _vala_gnonograms_solver_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gnonograms_solver_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const GnonogramsCell GNONOGRAMS_NULL_CELL;

static inline gpointer
gnonograms_solver_get_instance_private (GnonogramsSolver* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsSolver_private_offset);
}

GnonogramsSolver*
gnonograms_solver_construct (GType object_type,
                             GnonogramsDimensions* _dimensions)
{
	GnonogramsSolver * self = NULL;
	GnonogramsDimensions _tmp0_;
	gdouble length = 0.0;
	GnonogramsDimensions _tmp1_ = {0};
	GnonogramsDimensions _tmp2_;
	g_return_val_if_fail (_dimensions != NULL, NULL);
	_tmp0_ = *_dimensions;
	self = (GnonogramsSolver*) g_object_new (object_type, "dimensions", &_tmp0_, NULL);
	gnonograms_solver_get_dimensions (self, &_tmp1_);
	_tmp2_ = _tmp1_;
	length = (gdouble) gnonograms_dimensions_length (&_tmp2_);
	self->priv->moderate_threshold = (guint) ((length / GNONOGRAMS_SOLVER_MODERATE_CPP) + 0.5);
	self->priv->hard_threshold = (guint) ((length / GNONOGRAMS_SOLVER_HARD_CPP) + 0.5);
	self->priv->challenging_threshold = (guint) ((length / GNONOGRAMS_SOLVER_CHALLENGING_CPP) - 0.5);
	return self;
}

GnonogramsSolver*
gnonograms_solver_new (GnonogramsDimensions* _dimensions)
{
	return gnonograms_solver_construct (GNONOGRAMS_TYPE_SOLVER, _dimensions);
}

/** Set up solver for a particular puzzle. In addition to the clues, a starting point
      * and/or the correct solution may be provided (useful for debugging).
    **/
static gboolean
gnonograms_solver_initialize (GnonogramsSolver* self,
                              gchar** row_clues,
                              gint row_clues_length1,
                              gchar** col_clues,
                              gint col_clues_length1,
                              GnonogramsMy2DCellArray* start_grid,
                              GnonogramsMy2DCellArray* solution_grid)
{
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	guint _tmp2_;
	gint index = 0;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = gnonograms_solver_get_rows (self);
	_tmp2_ = _tmp1_;
	if (((guint) row_clues_length1) == _tmp2_) {
		guint _tmp3_;
		guint _tmp4_;
		_tmp3_ = gnonograms_solver_get_cols (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = ((guint) col_clues_length1) == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_assert (_tmp0_, "row_clues.length == rows && col_clues.length == cols");
	self->priv->should_check_solution = solution_grid != NULL;
	if (self->priv->should_check_solution) {
		GnonogramsMy2DCellArray* _tmp5_;
		_tmp5_ = self->priv->_solution;
		gnonograms_my2_dcell_array_copy (_tmp5_, solution_grid);
	}
	if (start_grid != NULL) {
		GnonogramsMy2DCellArray* _tmp6_;
		_tmp6_ = self->priv->_grid;
		gnonograms_my2_dcell_array_copy (_tmp6_, start_grid);
	} else {
		GnonogramsMy2DCellArray* _tmp7_;
		_tmp7_ = self->priv->_grid;
		gnonograms_my2_dcell_array_set_all (_tmp7_, GNONOGRAMS_CELL_STATE_UNKNOWN);
	}
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				guint _tmp10_;
				guint _tmp11_;
				GnonogramsRegion** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				GnonogramsRegion* _tmp14_;
				gint _tmp15_;
				guint _tmp16_;
				guint _tmp17_;
				const gchar* _tmp18_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = r;
					r = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = gnonograms_solver_get_rows (self);
				_tmp11_ = _tmp10_;
				if (!(((guint) r) < _tmp11_)) {
					break;
				}
				_tmp12_ = self->priv->regions;
				_tmp12__length1 = self->priv->regions_length1;
				_tmp13_ = index;
				index = _tmp13_ + 1;
				_tmp14_ = _tmp12_[_tmp13_];
				_tmp15_ = r;
				_tmp16_ = gnonograms_solver_get_cols (self);
				_tmp17_ = _tmp16_;
				_tmp18_ = row_clues[r];
				gnonograms_region_initialize (_tmp14_, (guint) _tmp15_, FALSE, _tmp17_, _tmp18_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				guint _tmp21_;
				guint _tmp22_;
				GnonogramsRegion** _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				GnonogramsRegion* _tmp25_;
				gint _tmp26_;
				guint _tmp27_;
				guint _tmp28_;
				const gchar* _tmp29_;
				if (!_tmp19_) {
					gint _tmp20_;
					_tmp20_ = c;
					c = _tmp20_ + 1;
				}
				_tmp19_ = FALSE;
				_tmp21_ = gnonograms_solver_get_cols (self);
				_tmp22_ = _tmp21_;
				if (!(((guint) c) < _tmp22_)) {
					break;
				}
				_tmp23_ = self->priv->regions;
				_tmp23__length1 = self->priv->regions_length1;
				_tmp24_ = index;
				index = _tmp24_ + 1;
				_tmp25_ = _tmp23_[_tmp24_];
				_tmp26_ = c;
				_tmp27_ = gnonograms_solver_get_rows (self);
				_tmp28_ = _tmp27_;
				_tmp29_ = col_clues[c];
				gnonograms_region_initialize (_tmp25_, (guint) _tmp26_, TRUE, _tmp28_, _tmp29_);
			}
		}
	}
	gnonograms_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
	result = gnonograms_solver_valid (self);
	return result;
}

static void
gnonograms_solver_solve_clues_data_free (gpointer _data)
{
	GnonogramsSolverSolveCluesData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->start_grid);
	_g_object_unref0 (_data_->solution_grid);
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsSolverSolveCluesData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_solver_solve_clues (GnonogramsSolver* self,
                               gchar** row_clues,
                               gint row_clues_length1,
                               gchar** col_clues,
                               gint col_clues_length1,
                               GnonogramsMy2DCellArray* start_grid,
                               GnonogramsMy2DCellArray* solution_grid,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	GnonogramsSolverSolveCluesData* _data_;
	GnonogramsSolver* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsSolverSolveCluesData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_solver_solve_clues_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->row_clues = row_clues;
	_data_->row_clues_length1 = row_clues_length1;
	_data_->col_clues = col_clues;
	_data_->col_clues_length1 = col_clues_length1;
	_tmp1_ = _g_object_ref0 (start_grid);
	_g_object_unref0 (_data_->start_grid);
	_data_->start_grid = _tmp1_;
	_tmp2_ = _g_object_ref0 (solution_grid);
	_g_object_unref0 (_data_->solution_grid);
	_data_->solution_grid = _tmp2_;
	gnonograms_solver_solve_clues_co (_data_);
}

GnonogramsDifficulty
gnonograms_solver_solve_clues_finish (GnonogramsSolver* self,
                                      GAsyncResult* _res_)
{
	GnonogramsDifficulty result;
	GnonogramsSolverSolveCluesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

/** Initiate solving, specifying whether or not to use the advanced
      * procedures. Also specify whether in debugging mode and whether to solve one step
      * at a time (used for hinting if implemented).
    **/
static void
gnonograms_solver_solve_clues_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	GnonogramsSolverSolveCluesData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_solver_solve_clues_co (_data_);
}

static gboolean
gnonograms_solver_solve_clues_co (GnonogramsSolverSolveCluesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (gnonograms_solver_initialize (_data_->self, _data_->row_clues, (gint) _data_->row_clues_length1, _data_->col_clues, (gint) _data_->col_clues_length1, _data_->start_grid, _data_->solution_grid)) {
		_data_->_state_ = 1;
		gnonograms_solver_solve_it (_data_->self, gnonograms_solver_solve_clues_ready, _data_);
		return FALSE;
		_state_1:
		_data_->result = gnonograms_solver_solve_it_finish (_data_->self, _data_->_res_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_ERROR);
		_data_->result = GNONOGRAMS_DIFFICULTY_UNDEFINED;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
}

void
gnonograms_solver_cancel (GnonogramsSolver* self)
{
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_cancellable;
	g_cancellable_cancel (_tmp0_);
}

static void
gnonograms_solver_reinitialize_regions (GnonogramsSolver* self)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				GnonogramsRegion** _tmp4_;
				gint _tmp4__length1;
				gint _tmp5_;
				GnonogramsRegion* _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_solver_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->regions;
				_tmp4__length1 = self->priv->regions_length1;
				_tmp5_ = index;
				index = _tmp5_ + 1;
				_tmp6_ = _tmp4_[_tmp5_];
				gnonograms_region_set_to_initial_state (_tmp6_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				guint _tmp9_;
				guint _tmp10_;
				GnonogramsRegion** _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				GnonogramsRegion* _tmp13_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = c;
					c = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = gnonograms_solver_get_cols (self);
				_tmp10_ = _tmp9_;
				if (!(((guint) c) < _tmp10_)) {
					break;
				}
				_tmp11_ = self->priv->regions;
				_tmp11__length1 = self->priv->regions_length1;
				_tmp12_ = index;
				index = _tmp12_ + 1;
				_tmp13_ = _tmp11_[_tmp12_];
				gnonograms_region_set_to_initial_state (_tmp13_);
			}
		}
	}
}

static gpointer
_gnonograms_region_ref0 (gpointer self)
{
	return self ? gnonograms_region_ref (self) : NULL;
}

static gboolean
gnonograms_solver_valid (GnonogramsSolver* self)
{
	GnonogramsRegion** _tmp0_;
	gint _tmp0__length1;
	gint row_total = 0;
	gint col_total = 0;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->regions;
	_tmp0__length1 = self->priv->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp0_;
		r_collection_length1 = _tmp0__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp1_;
			GnonogramsRegion* r = NULL;
			_tmp1_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp1_;
			{
				GnonogramsRegion* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp2_ = r;
				_tmp3_ = gnonograms_region_get_in_error (_tmp2_);
				_tmp4_ = _tmp3_;
				if (_tmp4_) {
					result = FALSE;
					_gnonograms_region_unref0 (r);
					return result;
				}
				_gnonograms_region_unref0 (r);
			}
		}
	}
	row_total = 0;
	col_total = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				guint _tmp7_;
				guint _tmp8_;
				GnonogramsRegion** _tmp9_;
				gint _tmp9__length1;
				GnonogramsRegion* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = r;
					r = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = gnonograms_solver_get_rows (self);
				_tmp8_ = _tmp7_;
				if (!(((guint) r) < _tmp8_)) {
					break;
				}
				_tmp9_ = self->priv->regions;
				_tmp9__length1 = self->priv->regions_length1;
				_tmp10_ = _tmp9_[r];
				_tmp11_ = gnonograms_region_get_block_total (_tmp10_);
				_tmp12_ = _tmp11_;
				row_total += _tmp12_;
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				guint _tmp15_;
				guint _tmp16_;
				GnonogramsRegion** _tmp17_;
				gint _tmp17__length1;
				guint _tmp18_;
				guint _tmp19_;
				GnonogramsRegion* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = c;
					c = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp15_ = gnonograms_solver_get_cols (self);
				_tmp16_ = _tmp15_;
				if (!(((guint) c) < _tmp16_)) {
					break;
				}
				_tmp17_ = self->priv->regions;
				_tmp17__length1 = self->priv->regions_length1;
				_tmp18_ = gnonograms_solver_get_rows (self);
				_tmp19_ = _tmp18_;
				_tmp20_ = _tmp17_[_tmp19_ + c];
				_tmp21_ = gnonograms_region_get_block_total (_tmp20_);
				_tmp22_ = _tmp21_;
				col_total += _tmp22_;
			}
		}
	}
	result = row_total == col_total;
	return result;
}

gboolean
gnonograms_solver_solved (GnonogramsSolver* self)
{
	GnonogramsRegion** _tmp0_;
	gint _tmp0__length1;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->regions;
	_tmp0__length1 = self->priv->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp0_;
		r_collection_length1 = _tmp0__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp1_;
			GnonogramsRegion* r = NULL;
			_tmp1_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp1_;
			{
				GnonogramsRegion* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp2_ = r;
				_tmp3_ = gnonograms_region_get_is_completed (_tmp2_);
				_tmp4_ = _tmp3_;
				if (!_tmp4_) {
					result = FALSE;
					_gnonograms_region_unref0 (r);
					return result;
				}
				_gnonograms_region_unref0 (r);
			}
		}
	}
	result = TRUE;
	return result;
}

void
gnonograms_solver_configure_from_grade (GnonogramsSolver* self,
                                        GnonogramsDifficulty grade)
{
	g_return_if_fail (self != NULL);
	gnonograms_solver_set_use_advanced (self, FALSE);
	gnonograms_solver_set_unique_only (self, TRUE);
	gnonograms_solver_set_advanced_only (self, FALSE);
	gnonograms_solver_set_human_only (self, TRUE);
	switch (grade) {
		case GNONOGRAMS_DIFFICULTY_EASY:
		case GNONOGRAMS_DIFFICULTY_MODERATE:
		case GNONOGRAMS_DIFFICULTY_HARD:
		case GNONOGRAMS_DIFFICULTY_CHALLENGING:
		{
			break;
		}
		case GNONOGRAMS_DIFFICULTY_ADVANCED:
		{
			gnonograms_solver_set_use_advanced (self, TRUE);
			gnonograms_solver_set_advanced_only (self, TRUE);
			break;
		}
		case GNONOGRAMS_DIFFICULTY_MAXIMUM:
		{
			gnonograms_solver_set_use_advanced (self, TRUE);
			gnonograms_solver_set_unique_only (self, FALSE);
			gnonograms_solver_set_advanced_only (self, TRUE);
			break;
		}
		case GNONOGRAMS_DIFFICULTY_COMPUTER:
		{
			gnonograms_solver_set_use_advanced (self, TRUE);
			gnonograms_solver_set_unique_only (self, FALSE);
			gnonograms_solver_set_advanced_only (self, FALSE);
			gnonograms_solver_set_human_only (self, FALSE);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static void
gnonograms_solver_solve_it_data_free (gpointer _data)
{
	GnonogramsSolverSolveItData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsSolverSolveItData, _data_);
}

static void
gnonograms_solver_solve_it (GnonogramsSolver* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	GnonogramsSolverSolveItData* _data_;
	GnonogramsSolver* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsSolverSolveItData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_solver_solve_it_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	gnonograms_solver_solve_it_co (_data_);
}

static GnonogramsDifficulty
gnonograms_solver_solve_it_finish (GnonogramsSolver* self,
                                   GAsyncResult* _res_)
{
	GnonogramsDifficulty result;
	GnonogramsSolverSolveItData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
gnonograms_solver_solve_it_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	GnonogramsSolverSolveItData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_solver_solve_it_co (_data_);
}

static gboolean
gnonograms_solver_solve_it_co (GnonogramsSolverSolveItData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_result_ = -1;
	{
		_data_->i = 0;
		{
			_data_->_tmp0_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp0_) {
					_data_->_tmp1_ = _data_->i;
					_data_->i = _data_->_tmp1_ + 1;
				}
				_data_->_tmp0_ = FALSE;
				_data_->_tmp2_ = gnonograms_solver_get_n_regions (_data_->self);
				_data_->_tmp3_ = _data_->_tmp2_;
				if (!(((guint) _data_->i) < _data_->_tmp3_)) {
					break;
				}
				_data_->_tmp4_ = _data_->self->priv->regions;
				_data_->_tmp4__length1 = _data_->self->priv->regions_length1;
				_data_->_tmp5_ = _data_->_tmp4_[_data_->i];
				gnonograms_region_set_to_initial_state (_data_->_tmp5_);
			}
		}
	}
	_data_->_state_ = 1;
	gnonograms_solver_simple_solver (_data_->self, gnonograms_solver_solve_it_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_result_ = gnonograms_solver_simple_solver_finish (_data_->self, _data_->_res_);
	_data_->_tmp6_ = _data_->self->priv->_state;
	if (_data_->_tmp6_ == GNONOGRAMS_SOLVER_STATE_ERROR) {
		_data_->result = GNONOGRAMS_DIFFICULTY_UNDEFINED;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		_data_->_tmp8_ = _data_->self->priv->_state;
		if (_data_->_tmp8_ == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
			_data_->_tmp9_ = _data_->self->priv->_advanced_only;
			_data_->_tmp7_ = _data_->_tmp9_;
		} else {
			_data_->_tmp7_ = FALSE;
		}
		if (_data_->_tmp7_) {
			_data_->_result_ = 0;
		} else {
			_data_->_tmp11_ = _data_->self->priv->_state;
			if (_data_->_tmp11_ != GNONOGRAMS_SOLVER_STATE_SIMPLE) {
				_data_->_tmp12_ = _data_->self->priv->_use_advanced;
				_data_->_tmp10_ = _data_->_tmp12_;
			} else {
				_data_->_tmp10_ = FALSE;
			}
			if (_data_->_tmp10_) {
				_data_->_state_ = 2;
				gnonograms_solver_advanced_solver (_data_->self, gnonograms_solver_solve_it_ready, _data_);
				return FALSE;
				_state_2:
				_data_->_result_ = gnonograms_solver_advanced_solver_finish (_data_->self, _data_->_res_);
			}
		}
	}
	_data_->result = gnonograms_solver_passes_to_grade (_data_->self, (guint) _data_->_result_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

GeeArrayQueue*
gnonograms_solver_hint (GnonogramsSolver* self,
                        gchar** row_clues,
                        gint row_clues_length1,
                        gchar** col_clues,
                        gint col_clues_length1,
                        GnonogramsMy2DCellArray* working)
{
	gboolean changed = FALSE;
	guint count = 0U;
	GeeArrayQueue* moves = NULL;
	GeeArrayQueue* _tmp0_;
	GnonogramsRegion** _tmp1_;
	gint _tmp1__length1;
	GeeArrayQueue* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (working != NULL, NULL);
	gnonograms_solver_initialize (self, row_clues, (gint) row_clues_length1, col_clues, (gint) col_clues_length1, working, NULL);
	changed = FALSE;
	count = (guint) 0;
	_tmp0_ = gee_array_queue_new (GNONOGRAMS_TYPE_MOVE, (GBoxedCopyFunc) gnonograms_move_ref, (GDestroyNotify) gnonograms_move_unref, NULL, NULL, NULL);
	moves = _tmp0_;
	_tmp1_ = self->priv->regions;
	_tmp1__length1 = self->priv->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp1_;
		r_collection_length1 = _tmp1__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp2_;
			GnonogramsRegion* r = NULL;
			_tmp2_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp2_;
			{
				guint _tmp3_ = 0U;
				GnonogramsRegion* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
				guint size = 0U;
				GnonogramsCellState* csa = NULL;
				GnonogramsCellState* _tmp11_;
				gint csa_length1;
				gint _csa_size_;
				GnonogramsRegion* _tmp12_;
				guint _tmp13_;
				guint _tmp14_;
				GnonogramsRegion* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp4_ = r;
				_tmp5_ = gnonograms_region_get_is_column (_tmp4_);
				_tmp6_ = _tmp5_;
				if (_tmp6_) {
					guint _tmp7_;
					guint _tmp8_;
					_tmp7_ = gnonograms_solver_get_rows (self);
					_tmp8_ = _tmp7_;
					_tmp3_ = _tmp8_;
				} else {
					guint _tmp9_;
					guint _tmp10_;
					_tmp9_ = gnonograms_solver_get_cols (self);
					_tmp10_ = _tmp9_;
					_tmp3_ = _tmp10_;
				}
				size = _tmp3_;
				_tmp11_ = g_new0 (GnonogramsCellState, size);
				csa = _tmp11_;
				csa_length1 = size;
				_csa_size_ = csa_length1;
				_tmp12_ = r;
				_tmp13_ = gnonograms_region_get_index (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = r;
				_tmp16_ = gnonograms_region_get_is_column (_tmp15_);
				_tmp17_ = _tmp16_;
				gnonograms_my2_dcell_array_get_array (working, _tmp14_, _tmp17_, &csa, (gint*) (&csa_length1), (guint) 0);
				_csa_size_ = csa_length1;
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp18_ = FALSE;
						_tmp18_ = TRUE;
						while (TRUE) {
							GnonogramsCellState r_state = 0;
							GnonogramsRegion* _tmp20_;
							gboolean _tmp21_ = FALSE;
							if (!_tmp18_) {
								gint _tmp19_;
								_tmp19_ = i;
								i = _tmp19_ + 1;
							}
							_tmp18_ = FALSE;
							if (!(((guint) i) < size)) {
								break;
							}
							_tmp20_ = r;
							r_state = gnonograms_region_get_cell_state (_tmp20_, (guint) i);
							if (r_state != GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GnonogramsCellState* _tmp22_;
								gint _tmp22__length1;
								GnonogramsCellState _tmp23_;
								_tmp22_ = csa;
								_tmp22__length1 = csa_length1;
								_tmp23_ = _tmp22_[i];
								_tmp21_ = _tmp23_ != r_state;
							} else {
								_tmp21_ = FALSE;
							}
							if (_tmp21_) {
								guint _tmp24_ = 0U;
								GnonogramsRegion* _tmp25_;
								gboolean _tmp26_;
								gboolean _tmp27_;
								guint row = 0U;
								guint _tmp31_ = 0U;
								GnonogramsRegion* _tmp32_;
								gboolean _tmp33_;
								gboolean _tmp34_;
								guint col = 0U;
								GnonogramsCell c = {0};
								GnonogramsCell _tmp38_ = {0};
								GeeArrayQueue* _tmp39_;
								GnonogramsCell _tmp40_;
								GnonogramsCellState* _tmp41_;
								gint _tmp41__length1;
								GnonogramsCellState _tmp42_;
								GnonogramsMove* _tmp43_;
								GnonogramsMove* _tmp44_;
								_tmp25_ = r;
								_tmp26_ = gnonograms_region_get_is_column (_tmp25_);
								_tmp27_ = _tmp26_;
								if (_tmp27_) {
									_tmp24_ = (guint) i;
								} else {
									GnonogramsRegion* _tmp28_;
									guint _tmp29_;
									guint _tmp30_;
									_tmp28_ = r;
									_tmp29_ = gnonograms_region_get_index (_tmp28_);
									_tmp30_ = _tmp29_;
									_tmp24_ = _tmp30_;
								}
								row = _tmp24_;
								_tmp32_ = r;
								_tmp33_ = gnonograms_region_get_is_column (_tmp32_);
								_tmp34_ = _tmp33_;
								if (_tmp34_) {
									GnonogramsRegion* _tmp35_;
									guint _tmp36_;
									guint _tmp37_;
									_tmp35_ = r;
									_tmp36_ = gnonograms_region_get_index (_tmp35_);
									_tmp37_ = _tmp36_;
									_tmp31_ = _tmp37_;
								} else {
									_tmp31_ = (guint) i;
								}
								col = _tmp31_;
								_tmp38_.row = row;
								_tmp38_.col = col;
								_tmp38_.state = r_state;
								c = _tmp38_;
								_tmp39_ = moves;
								_tmp40_ = c;
								_tmp41_ = csa;
								_tmp41__length1 = csa_length1;
								_tmp42_ = _tmp41_[i];
								_tmp43_ = gnonograms_move_new (&_tmp40_, _tmp42_);
								_tmp44_ = _tmp43_;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp44_);
								_gnonograms_move_unref0 (_tmp44_);
								changed = TRUE;
							}
						}
					}
				}
				csa = (g_free (csa), NULL);
				_gnonograms_region_unref0 (r);
			}
		}
	}
	while (TRUE) {
		gboolean _tmp45_ = FALSE;
		gboolean _tmp46_ = FALSE;
		guint _tmp48_;
		GnonogramsRegion** _tmp49_;
		gint _tmp49__length1;
		if (!changed) {
			_tmp46_ = count < ((guint) 2);
		} else {
			_tmp46_ = FALSE;
		}
		if (_tmp46_) {
			GnonogramsSolverState _tmp47_;
			_tmp47_ = self->priv->_state;
			_tmp45_ = _tmp47_ != GNONOGRAMS_SOLVER_STATE_ERROR;
		} else {
			_tmp45_ = FALSE;
		}
		if (!_tmp45_) {
			break;
		}
		changed = FALSE;
		_tmp48_ = count;
		count = _tmp48_ + 1;
		_tmp49_ = self->priv->regions;
		_tmp49__length1 = self->priv->regions_length1;
		{
			GnonogramsRegion** r_collection = NULL;
			gint r_collection_length1 = 0;
			gint _r_collection_size_ = 0;
			gint r_it = 0;
			r_collection = _tmp49_;
			r_collection_length1 = _tmp49__length1;
			for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
				GnonogramsRegion* _tmp50_;
				GnonogramsRegion* r = NULL;
				_tmp50_ = _gnonograms_region_ref0 (r_collection[r_it]);
				r = _tmp50_;
				{
					GnonogramsRegion* _tmp51_;
					gboolean _tmp52_;
					gboolean _tmp53_;
					GnonogramsRegion* _tmp54_;
					GnonogramsRegion* _tmp55_;
					gboolean _tmp56_;
					gboolean _tmp57_;
					_tmp51_ = r;
					_tmp52_ = gnonograms_region_get_is_completed (_tmp51_);
					_tmp53_ = _tmp52_;
					if (_tmp53_) {
						_gnonograms_region_unref0 (r);
						continue;
					}
					_tmp54_ = r;
					changed = gnonograms_region_solve (_tmp54_);
					_tmp55_ = r;
					_tmp56_ = gnonograms_region_get_in_error (_tmp55_);
					_tmp57_ = _tmp56_;
					if (_tmp57_) {
						gnonograms_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_ERROR);
						_gnonograms_region_unref0 (r);
						break;
					}
					if (changed) {
						guint _tmp58_ = 0U;
						GnonogramsRegion* _tmp59_;
						gboolean _tmp60_;
						gboolean _tmp61_;
						guint size = 0U;
						GnonogramsCellState* csa = NULL;
						GnonogramsCellState* _tmp66_;
						gint csa_length1;
						gint _csa_size_;
						GnonogramsRegion* _tmp67_;
						guint _tmp68_;
						guint _tmp69_;
						GnonogramsRegion* _tmp70_;
						gboolean _tmp71_;
						gboolean _tmp72_;
						_tmp59_ = r;
						_tmp60_ = gnonograms_region_get_is_column (_tmp59_);
						_tmp61_ = _tmp60_;
						if (_tmp61_) {
							guint _tmp62_;
							guint _tmp63_;
							_tmp62_ = gnonograms_solver_get_rows (self);
							_tmp63_ = _tmp62_;
							_tmp58_ = _tmp63_;
						} else {
							guint _tmp64_;
							guint _tmp65_;
							_tmp64_ = gnonograms_solver_get_cols (self);
							_tmp65_ = _tmp64_;
							_tmp58_ = _tmp65_;
						}
						size = _tmp58_;
						_tmp66_ = g_new0 (GnonogramsCellState, size);
						csa = _tmp66_;
						csa_length1 = size;
						_csa_size_ = csa_length1;
						_tmp67_ = r;
						_tmp68_ = gnonograms_region_get_index (_tmp67_);
						_tmp69_ = _tmp68_;
						_tmp70_ = r;
						_tmp71_ = gnonograms_region_get_is_column (_tmp70_);
						_tmp72_ = _tmp71_;
						gnonograms_my2_dcell_array_get_array (working, _tmp69_, _tmp72_, &csa, (gint*) (&csa_length1), (guint) 0);
						_csa_size_ = csa_length1;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp73_ = FALSE;
								_tmp73_ = TRUE;
								while (TRUE) {
									GnonogramsCellState r_state = 0;
									GnonogramsRegion* _tmp75_;
									gboolean _tmp76_ = FALSE;
									if (!_tmp73_) {
										gint _tmp74_;
										_tmp74_ = i;
										i = _tmp74_ + 1;
									}
									_tmp73_ = FALSE;
									if (!(((guint) i) < size)) {
										break;
									}
									_tmp75_ = r;
									r_state = gnonograms_region_get_cell_state (_tmp75_, (guint) i);
									if (r_state != GNONOGRAMS_CELL_STATE_UNKNOWN) {
										GnonogramsCellState* _tmp77_;
										gint _tmp77__length1;
										GnonogramsCellState _tmp78_;
										_tmp77_ = csa;
										_tmp77__length1 = csa_length1;
										_tmp78_ = _tmp77_[i];
										_tmp76_ = _tmp78_ != r_state;
									} else {
										_tmp76_ = FALSE;
									}
									if (_tmp76_) {
										guint _tmp79_ = 0U;
										GnonogramsRegion* _tmp80_;
										gboolean _tmp81_;
										gboolean _tmp82_;
										guint row = 0U;
										guint _tmp86_ = 0U;
										GnonogramsRegion* _tmp87_;
										gboolean _tmp88_;
										gboolean _tmp89_;
										guint col = 0U;
										GnonogramsCell c = {0};
										GnonogramsCell _tmp93_ = {0};
										GeeArrayQueue* _tmp94_;
										GnonogramsCell _tmp95_;
										GnonogramsCellState* _tmp96_;
										gint _tmp96__length1;
										GnonogramsCellState _tmp97_;
										GnonogramsMove* _tmp98_;
										GnonogramsMove* _tmp99_;
										_tmp80_ = r;
										_tmp81_ = gnonograms_region_get_is_column (_tmp80_);
										_tmp82_ = _tmp81_;
										if (_tmp82_) {
											_tmp79_ = (guint) i;
										} else {
											GnonogramsRegion* _tmp83_;
											guint _tmp84_;
											guint _tmp85_;
											_tmp83_ = r;
											_tmp84_ = gnonograms_region_get_index (_tmp83_);
											_tmp85_ = _tmp84_;
											_tmp79_ = _tmp85_;
										}
										row = _tmp79_;
										_tmp87_ = r;
										_tmp88_ = gnonograms_region_get_is_column (_tmp87_);
										_tmp89_ = _tmp88_;
										if (_tmp89_) {
											GnonogramsRegion* _tmp90_;
											guint _tmp91_;
											guint _tmp92_;
											_tmp90_ = r;
											_tmp91_ = gnonograms_region_get_index (_tmp90_);
											_tmp92_ = _tmp91_;
											_tmp86_ = _tmp92_;
										} else {
											_tmp86_ = (guint) i;
										}
										col = _tmp86_;
										_tmp93_.row = row;
										_tmp93_.col = col;
										_tmp93_.state = r_state;
										c = _tmp93_;
										_tmp94_ = moves;
										_tmp95_ = c;
										_tmp96_ = csa;
										_tmp96__length1 = csa_length1;
										_tmp97_ = _tmp96_[i];
										_tmp98_ = gnonograms_move_new (&_tmp95_, _tmp97_);
										_tmp99_ = _tmp98_;
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp94_, _tmp99_);
										_gnonograms_move_unref0 (_tmp99_);
										break;
									}
								}
							}
						}
						csa = (g_free (csa), NULL);
						_gnonograms_region_unref0 (r);
						break;
					}
					_gnonograms_region_unref0 (r);
				}
			}
		}
	}
	result = moves;
	return result;
}

static void
gnonograms_solver_simple_solver_data_free (gpointer _data)
{
	GnonogramsSolverSimpleSolverData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsSolverSimpleSolverData, _data_);
}

static void
gnonograms_solver_simple_solver (GnonogramsSolver* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GnonogramsSolverSimpleSolverData* _data_;
	GnonogramsSolver* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsSolverSimpleSolverData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_solver_simple_solver_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	gnonograms_solver_simple_solver_co (_data_);
}

static gint
gnonograms_solver_simple_solver_finish (GnonogramsSolver* self,
                                        GAsyncResult* _res_)
{
	gint result;
	GnonogramsSolverSimpleSolverData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

/** Returns -1 to indicate an error **/
static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		GnonogramsSolver* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gboolean
__lambda18_ (Block8Data* _data8_)
{
	GnonogramsSolver* self;
	gboolean result;
	self = _data8_->self;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GnonogramsRegion** _tmp2_;
		gint _tmp2__length1;
		gint _tmp11_;
		GCancellable* _tmp12_;
		if (_data8_->changed) {
			_tmp1_ = _data8_->pass >= 0;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = ((guint) _data8_->pass) < GNONOGRAMS_SOLVER_MAX_PASSES;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_data8_->changed = FALSE;
		_tmp2_ = self->priv->regions;
		_tmp2__length1 = self->priv->regions_length1;
		{
			GnonogramsRegion** r_collection = NULL;
			gint r_collection_length1 = 0;
			gint _r_collection_size_ = 0;
			gint r_it = 0;
			r_collection = _tmp2_;
			r_collection_length1 = _tmp2__length1;
			for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
				GnonogramsRegion* _tmp3_;
				GnonogramsRegion* r = NULL;
				_tmp3_ = _gnonograms_region_ref0 (r_collection[r_it]);
				r = _tmp3_;
				{
					GnonogramsRegion* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					GnonogramsRegion* _tmp7_;
					GnonogramsRegion* _tmp8_;
					gboolean _tmp9_;
					gboolean _tmp10_;
					_tmp4_ = r;
					_tmp5_ = gnonograms_region_get_is_completed (_tmp4_);
					_tmp6_ = _tmp5_;
					if (_tmp6_) {
						_gnonograms_region_unref0 (r);
						continue;
					}
					_tmp7_ = r;
					_data8_->changed |= gnonograms_region_solve (_tmp7_);
					_tmp8_ = r;
					_tmp9_ = gnonograms_region_get_in_error (_tmp8_);
					_tmp10_ = _tmp9_;
					if (_tmp10_) {
						gnonograms_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_ERROR);
						_gnonograms_region_unref0 (r);
						break;
					}
					_gnonograms_region_unref0 (r);
				}
			}
		}
		_tmp11_ = _data8_->pass;
		_data8_->pass = _tmp11_ + 1;
		_tmp12_ = self->priv->_cancellable;
		if (g_cancellable_is_cancelled (_tmp12_)) {
			gnonograms_solver_set_state (self, GNONOGRAMS_SOLVER_STATE_CANCELLED);
			break;
		}
	}
	gnonograms_solver_simple_solver_co (_data8_->_async_data_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda18_ (self);
	return result;
}

static gboolean
gnonograms_solver_simple_solver_co (GnonogramsSolverSimpleSolverData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data8_ = g_slice_new0 (Block8Data);
	_data_->_data8_->_ref_count_ = 1;
	_data_->_data8_->self = g_object_ref (_data_->self);
	_data_->_data8_->_async_data_ = _data_;
	_data_->_data8_->changed = TRUE;
	_data_->_data8_->pass = 1;
	gnonograms_solver_reinitialize_regions (_data_->self);
	gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda18__gsource_func, block8_data_ref (_data_->_data8_), block8_data_unref);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp0_ = _data_->self->priv->_solution;
	_data_->_tmp1_ = _data_->self->priv->_grid;
	gnonograms_my2_dcell_array_copy (_data_->_tmp0_, _data_->_tmp1_);
	if (gnonograms_solver_solved (_data_->self)) {
		gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_SIMPLE);
	}
	_data_->result = _data_->_data8_->pass;
	block8_data_unref (_data_->_data8_);
	_data_->_data8_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
gnonograms_solver_advanced_solver_data_free (gpointer _data)
{
	GnonogramsSolverAdvancedSolverData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsSolverAdvancedSolverData, _data_);
}

static void
gnonograms_solver_advanced_solver (GnonogramsSolver* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	GnonogramsSolverAdvancedSolverData* _data_;
	GnonogramsSolver* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsSolverAdvancedSolverData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_solver_advanced_solver_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	gnonograms_solver_advanced_solver_co (_data_);
}

static gint
gnonograms_solver_advanced_solver_finish (GnonogramsSolver* self,
                                          GAsyncResult* _res_)
{
	gint result;
	GnonogramsSolverAdvancedSolverData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

/** Make single cell guesses, depth 1 (no recursion)
        Make a guess in each unknown cell in turn
        If it leads to contradiction mark opposite to guess,
        continue simple solve and if still no solution, continue with another guess.
        If first guess does not lead to solution leave unknown and choose another cell
    **/
static void
gnonograms_solver_advanced_solver_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	GnonogramsSolverAdvancedSolverData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_solver_advanced_solver_co (_data_);
}

static gboolean
gnonograms_solver_advanced_solver_co (GnonogramsSolverAdvancedSolverData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_grid;
	_data_->_tmp1_ = _data_->self->priv->_human_only;
	_data_->_tmp2_ = gnonograms_solver_guesser_new (_data_->_tmp0_, _data_->_tmp1_);
	_data_->guesser = _data_->_tmp2_;
	_data_->initial_state = GNONOGRAMS_SOLVER_STATE_UNDEFINED;
	_data_->inverse_state = GNONOGRAMS_SOLVER_STATE_UNDEFINED;
	_data_->_result_ = 0;
	_data_->_tmp4_ = _data_->self->priv->_human_only;
	if (_data_->_tmp4_) {
		_data_->_tmp3_ = 5;
	} else {
		_data_->_tmp3_ = (gint) GNONOGRAMS_SOLVER_MAX_PASSES;
	}
	_data_->min_to_contradiction = _data_->_tmp3_;
	_data_->contra = 0;
	_data_->empty = 0;
	_data_->min_empty_cells = G_MAXINT;
	_data_->changed_count = 0;
	_data_->best_guess = GNONOGRAMS_NULL_CELL;
	gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
	while (TRUE) {
		_data_->_tmp5_ = _data_->self->priv->_state;
		if (!(_data_->_tmp5_ == GNONOGRAMS_SOLVER_STATE_UNDEFINED)) {
			break;
		}
		_data_->_tmp6_ = _data_->changed_count;
		_data_->changed_count = _data_->_tmp6_ + 1;
		_data_->_tmp7_ = _data_->guesser;
		if (!gnonograms_solver_guesser_next_guess (_data_->_tmp7_)) {
			gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
			if (gnonograms_cell_equal (&_data_->best_guess, &GNONOGRAMS_NULL_CELL)) {
				break;
			} else {
				_data_->_tmp8_ = _data_->self->priv->_grid;
				_data_->_tmp9_ = _data_->best_guess;
				gnonograms_my2_dcell_array_set_data_from_cell (_data_->_tmp8_, &_data_->_tmp9_);
				_data_->_tmp10_ = _data_->self->priv->_grid;
				_data_->_tmp11_ = gnonograms_solver_guesser_new (_data_->_tmp10_, FALSE);
				_gnonograms_solver_guesser_unref0 (_data_->guesser);
				_data_->guesser = _data_->_tmp11_;
				_data_->best_guess = GNONOGRAMS_NULL_CELL;
				_data_->changed_count = 0;
				_data_->_tmp12_ = _data_->guesser;
				if (!gnonograms_solver_guesser_next_guess (_data_->_tmp12_)) {
					g_warning ("Solver.vala:404: No next guess");
					break;
				}
			}
		}
		_data_->_state_ = 1;
		gnonograms_solver_simple_solver (_data_->self, gnonograms_solver_advanced_solver_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_result_ = gnonograms_solver_simple_solver_finish (_data_->self, _data_->_res_);
		_data_->_tmp13_ = _data_->self->priv->_state;
		_data_->initial_state = _data_->_tmp13_;
		if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
			_data_->_tmp14_ = _data_->self->priv->_solution;
			_data_->empty = gnonograms_my2_dcell_array_count_state (_data_->_tmp14_, GNONOGRAMS_CELL_STATE_EMPTY);
			if (_data_->empty < _data_->min_empty_cells) {
				_data_->min_empty_cells = _data_->empty;
				_data_->_tmp15_ = _data_->guesser;
				memset (&_data_->_tmp16_, 0, sizeof (GnonogramsCell));
				gnonograms_solver_guesser_get_trial_cell_copy (_data_->_tmp15_, &_data_->_tmp16_);
				_data_->best_guess = _data_->_tmp16_;
			}
		}
		_data_->_tmp18_ = _data_->self->priv->_state;
		if (_data_->_tmp18_ == GNONOGRAMS_SOLVER_STATE_ERROR) {
			_data_->_tmp17_ = _data_->_result_ > _data_->min_to_contradiction;
		} else {
			_data_->_tmp17_ = FALSE;
		}
		if (_data_->_tmp17_) {
			gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
			_data_->_tmp19_ = _data_->guesser;
			gnonograms_solver_guesser_cancel_previous_guess (_data_->_tmp19_);
			continue;
		}
		_data_->contra = _data_->_result_;
		_data_->_tmp20_ = _data_->guesser;
		gnonograms_solver_guesser_invert_previous_guess (_data_->_tmp20_);
		_data_->_state_ = 2;
		gnonograms_solver_simple_solver (_data_->self, gnonograms_solver_advanced_solver_ready, _data_);
		return FALSE;
		_state_2:
		_data_->_result_ = gnonograms_solver_simple_solver_finish (_data_->self, _data_->_res_);
		_data_->_tmp21_ = _data_->self->priv->_state;
		_data_->inverse_state = _data_->_tmp21_;
		if (_data_->inverse_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
			_data_->_tmp22_ = _data_->self->priv->_grid;
			_data_->empty = gnonograms_my2_dcell_array_count_state (_data_->_tmp22_, GNONOGRAMS_CELL_STATE_EMPTY);
			if (_data_->empty < _data_->min_empty_cells) {
				_data_->min_empty_cells = _data_->empty;
				_data_->_tmp23_ = _data_->guesser;
				memset (&_data_->_tmp24_, 0, sizeof (GnonogramsCell));
				gnonograms_solver_guesser_get_trial_cell_copy (_data_->_tmp23_, &_data_->_tmp24_);
				_data_->best_guess = _data_->_tmp24_;
			}
		}
		if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
			_data_->_tmp25_ = _data_->inverse_state == GNONOGRAMS_SOLVER_STATE_ERROR;
		} else {
			_data_->_tmp25_ = FALSE;
		}
		if (_data_->_tmp25_) {
			gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
			break;
		}
		switch (_data_->inverse_state) {
			case GNONOGRAMS_SOLVER_STATE_ERROR:
			{
				if (_data_->_result_ > _data_->min_to_contradiction) {
					_data_->_tmp26_ = _data_->guesser;
					gnonograms_solver_guesser_cancel_previous_guess (_data_->_tmp26_);
					gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					break;
				}
				_data_->contra = _data_->_result_;
				_data_->_tmp27_ = _data_->guesser;
				gnonograms_solver_guesser_invert_previous_guess (_data_->_tmp27_);
				_data_->_state_ = 3;
				gnonograms_solver_simple_solver (_data_->self, gnonograms_solver_advanced_solver_ready, _data_);
				return FALSE;
				_state_3:
				_data_->_result_ = gnonograms_solver_simple_solver_finish (_data_->self, _data_->_res_);
				if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
					gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_ADVANCED);
				} else {
					if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
						_data_->_tmp28_ = _data_->guesser;
						gnonograms_solver_guesser_initialize (_data_->_tmp28_);
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					} else {
						_data_->_tmp29_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), _data_->initial_state);
						g_critical ("Solver.vala:468: unexpected initial tate %s", (_data_->_tmp29_ != NULL) ? _data_->_tmp29_->value_name : NULL);
						g_assert_not_reached ();
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_NO_SOLUTION:
			{
				if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
					_data_->_tmp30_ = _data_->self->priv->_unique_only;
					if (_data_->_tmp30_) {
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
					} else {
						_data_->_tmp31_ = _data_->guesser;
						gnonograms_solver_guesser_invert_previous_guess (_data_->_tmp31_);
						_data_->_state_ = 4;
						gnonograms_solver_simple_solver (_data_->self, gnonograms_solver_advanced_solver_ready, _data_);
						return FALSE;
						_state_4:
						_data_->_result_ = gnonograms_solver_simple_solver_finish (_data_->self, _data_->_res_);
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_AMBIGUOUS);
					}
				} else {
					if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
						_data_->_tmp32_ = _data_->guesser;
						gnonograms_solver_guesser_initialize (_data_->_tmp32_);
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					} else {
						if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
							_data_->_tmp33_ = _data_->guesser;
							gnonograms_solver_guesser_cancel_previous_guess (_data_->_tmp33_);
							gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
						} else {
							_data_->_tmp34_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), _data_->initial_state);
							g_critical ("Solver.vala:492: unexpected initial state %s", (_data_->_tmp34_ != NULL) ? _data_->_tmp34_->value_name : NULL);
							g_assert_not_reached ();
						}
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_SIMPLE:
			{
				if (_data_->initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
					gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_ADVANCED);
				} else {
					_data_->_tmp35_ = _data_->self->priv->_unique_only;
					if (_data_->_tmp35_) {
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
					} else {
						gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_AMBIGUOUS);
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_CANCELLED:
			{
				break;
			}
			default:
			{
				_data_->_tmp36_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), _data_->inverse_state);
				g_critical ("Solver.vala:513: unexpected state %s", (_data_->_tmp36_ != NULL) ? _data_->_tmp36_->value_name : NULL);
				g_assert_not_reached ();
			}
		}
		_data_->_tmp37_ = _data_->self->priv->_cancellable;
		if (g_cancellable_is_cancelled (_data_->_tmp37_)) {
			gnonograms_solver_set_state (_data_->self, GNONOGRAMS_SOLVER_STATE_CANCELLED);
			break;
		}
	}
	_data_->_tmp38_ = _data_->self->priv->_state;
	switch (_data_->_tmp38_) {
		case GNONOGRAMS_SOLVER_STATE_CANCELLED:
		case GNONOGRAMS_SOLVER_STATE_NO_SOLUTION:
		{
			_data_->result = 0;
			_gnonograms_solver_guesser_unref0 (_data_->guesser);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		case GNONOGRAMS_SOLVER_STATE_ADVANCED:
		case GNONOGRAMS_SOLVER_STATE_AMBIGUOUS:
		{
			_data_->result = _data_->_result_;
			_gnonograms_solver_guesser_unref0 (_data_->guesser);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		default:
		{
			_data_->_tmp39_ = _data_->self->priv->_state;
			_data_->_tmp40_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), _data_->_tmp39_);
			g_critical ("Solver.vala:534: unexpected state %s", (_data_->_tmp40_ != NULL) ? _data_->_tmp40_->value_name : NULL);
			g_assert_not_reached ();
		}
	}
}

/** Only call if simple solver used **/
static GnonogramsDifficulty
gnonograms_solver_passes_to_grade (GnonogramsSolver* self,
                                   guint passes)
{
	GnonogramsDifficulty _result_ = 0;
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	if (passes == ((guint) 0)) {
		_result_ = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	} else {
		GnonogramsSolverState _tmp0_;
		_tmp0_ = self->priv->_state;
		if (_tmp0_ == GNONOGRAMS_SOLVER_STATE_ADVANCED) {
			_result_ = GNONOGRAMS_DIFFICULTY_ADVANCED;
		} else {
			GnonogramsSolverState _tmp1_;
			_tmp1_ = self->priv->_state;
			if (_tmp1_ == GNONOGRAMS_SOLVER_STATE_AMBIGUOUS) {
				_result_ = GNONOGRAMS_DIFFICULTY_MAXIMUM;
			} else {
				if (passes >= self->priv->challenging_threshold) {
					_result_ = GNONOGRAMS_DIFFICULTY_CHALLENGING;
				} else {
					if (passes >= self->priv->hard_threshold) {
						_result_ = GNONOGRAMS_DIFFICULTY_HARD;
					} else {
						if (passes >= self->priv->moderate_threshold) {
							_result_ = GNONOGRAMS_DIFFICULTY_MODERATE;
						} else {
							_result_ = GNONOGRAMS_DIFFICULTY_EASY;
						}
					}
				}
			}
		}
	}
	result = _result_;
	return result;
}

GnonogramsSolverState
gnonograms_solver_get_state (GnonogramsSolver* self)
{
	GnonogramsSolverState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}

void
gnonograms_solver_set_state (GnonogramsSolver* self,
                             GnonogramsSolverState value)
{
	GnonogramsSolverState old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_state (self);
	if (old_value != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_STATE_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_solver_get_grid (GnonogramsSolver* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid;
	result = _tmp0_;
	return result;
}

void
gnonograms_solver_set_grid (GnonogramsSolver* self,
                            GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_grid (self);
	if (old_value != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_grid);
		self->priv->_grid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_GRID_PROPERTY]);
	}
}

GnonogramsMy2DCellArray*
gnonograms_solver_get_solution (GnonogramsSolver* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_solution;
	result = _tmp0_;
	return result;
}

void
gnonograms_solver_set_solution (GnonogramsSolver* self,
                                GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_solution (self);
	if (old_value != value) {
		GnonogramsMy2DCellArray* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_solution);
		self->priv->_solution = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_SOLUTION_PROPERTY]);
	}
}

GCancellable*
gnonograms_solver_get_cancellable (GnonogramsSolver* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cancellable;
	result = _tmp0_;
	return result;
}

void
gnonograms_solver_set_cancellable (GnonogramsSolver* self,
                                   GCancellable* value)
{
	GCancellable* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_cancellable (self);
	if (old_value != value) {
		GCancellable* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_cancellable);
		self->priv->_cancellable = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY]);
	}
}

gboolean
gnonograms_solver_get_cancelled (GnonogramsSolver* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_cancellable;
	if (_tmp1_ != NULL) {
		GCancellable* _tmp2_;
		_tmp2_ = self->priv->_cancellable;
		_tmp0_ = g_cancellable_is_cancelled (_tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
gnonograms_solver_get_dimensions (GnonogramsSolver* self,
                                  GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

void
gnonograms_solver_set_dimensions (GnonogramsSolver* self,
                                  GnonogramsDimensions * value)
{
	GnonogramsDimensions _tmp0_;
	GnonogramsDimensions _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsMy2DCellArray* _tmp3_;
	GnonogramsDimensions _tmp4_;
	GnonogramsMy2DCellArray* _tmp5_;
	GnonogramsMy2DCellArray* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	GnonogramsRegion** _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->priv->_dimensions = _tmp0_;
	_tmp1_ = self->priv->_dimensions;
	_tmp2_ = gnonograms_my2_dcell_array_new (&_tmp1_, GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp3_ = _tmp2_;
	gnonograms_solver_set_grid (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->_dimensions;
	_tmp5_ = gnonograms_my2_dcell_array_new (&_tmp4_, GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp6_ = _tmp5_;
	gnonograms_solver_set_solution (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = gnonograms_solver_get_n_regions (self);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_new0 (GnonogramsRegion*, _tmp8_ + 1);
	self->priv->regions = (_vala_array_free (self->priv->regions, self->priv->regions_length1, (GDestroyNotify) gnonograms_region_unref), NULL);
	self->priv->regions = _tmp9_;
	self->priv->regions_length1 = _tmp8_;
	self->priv->_regions_size_ = self->priv->regions_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				guint _tmp12_;
				guint _tmp13_;
				GnonogramsRegion** _tmp14_;
				gint _tmp14__length1;
				GnonogramsMy2DCellArray* _tmp15_;
				GnonogramsRegion* _tmp16_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = i;
					i = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				_tmp12_ = gnonograms_solver_get_n_regions (self);
				_tmp13_ = _tmp12_;
				if (!(((guint) i) < _tmp13_)) {
					break;
				}
				_tmp14_ = self->priv->regions;
				_tmp14__length1 = self->priv->regions_length1;
				_tmp15_ = self->priv->_grid;
				_tmp16_ = gnonograms_region_new (_tmp15_);
				_gnonograms_region_unref0 (_tmp14_[i]);
				_tmp14_[i] = _tmp16_;
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY]);
}

gboolean
gnonograms_solver_get_unique_only (GnonogramsSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_unique_only;
	return result;
}

void
gnonograms_solver_set_unique_only (GnonogramsSolver* self,
                                   gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_unique_only (self);
	if (old_value != value) {
		self->priv->_unique_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY]);
	}
}

gboolean
gnonograms_solver_get_use_advanced (GnonogramsSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_use_advanced;
	return result;
}

void
gnonograms_solver_set_use_advanced (GnonogramsSolver* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_use_advanced (self);
	if (old_value != value) {
		self->priv->_use_advanced = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY]);
	}
}

gboolean
gnonograms_solver_get_advanced_only (GnonogramsSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_advanced_only;
	return result;
}

void
gnonograms_solver_set_advanced_only (GnonogramsSolver* self,
                                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_advanced_only (self);
	if (old_value != value) {
		self->priv->_advanced_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY]);
	}
}

gboolean
gnonograms_solver_get_human_only (GnonogramsSolver* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_human_only;
	return result;
}

void
gnonograms_solver_set_human_only (GnonogramsSolver* self,
                                  gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_solver_get_human_only (self);
	if (old_value != value) {
		self->priv->_human_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_solver_properties[GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY]);
	}
}

guint
gnonograms_solver_get_rows (GnonogramsSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.height;
	return result;
}

guint
gnonograms_solver_get_cols (GnonogramsSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.width;
	return result;
}

static guint
gnonograms_solver_get_n_regions (GnonogramsSolver* self)
{
	guint result;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	gnonograms_solver_get_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = gnonograms_dimensions_length (&_tmp1_);
	return result;
}

static inline gpointer
gnonograms_solver_guesser_get_instance_private (GnonogramsSolverGuesser* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsSolverGuesser_private_offset);
}

static GnonogramsSolverGuesser*
gnonograms_solver_guesser_construct (GType object_type,
                                     GnonogramsMy2DCellArray* _grid,
                                     gboolean _human_only)
{
	GnonogramsSolverGuesser* self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_val_if_fail (_grid != NULL, NULL);
	self = (GnonogramsSolverGuesser*) g_type_create_instance (object_type);
	gnonograms_solver_guesser_set_grid (self, _grid);
	_tmp0_ = gnonograms_solver_guesser_get_rows (self);
	_tmp1_ = _tmp0_;
	self->priv->rlim = (gint) _tmp1_;
	_tmp2_ = gnonograms_solver_guesser_get_cols (self);
	_tmp3_ = _tmp2_;
	self->priv->clim = (gint) _tmp3_;
	self->priv->human_only = _human_only;
	gnonograms_solver_guesser_initialize (self);
	return self;
}

static GnonogramsSolverGuesser*
gnonograms_solver_guesser_new (GnonogramsMy2DCellArray* _grid,
                               gboolean _human_only)
{
	return gnonograms_solver_guesser_construct (GNONOGRAMS_SOLVER_TYPE_GUESSER, _grid, _human_only);
}

static void
gnonograms_solver_guesser_initialize (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	self->priv->rdir = 0;
	self->priv->cdir = 1;
	self->priv->turn = 0;
	if (self->priv->human_only) {
		self->priv->max_turns = self->priv->initial_max_turns;
	} else {
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		_tmp0_ = gnonograms_solver_guesser_get_rows (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gnonograms_solver_guesser_get_cols (self);
		_tmp3_ = _tmp2_;
		self->priv->max_turns = MIN (_tmp1_, _tmp3_) / 2;
	}
	_tmp4_.row = (guint) 0;
	_tmp4_.col = (guint) -1;
	_tmp4_.state = self->priv->initial_cell_state;
	self->priv->trial_cell = _tmp4_;
}

static gboolean
gnonograms_solver_guesser_next_guess (GnonogramsSolverGuesser* self)
{
	gboolean guessed = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_solver_guesser_save_position (self);
	guessed = gnonograms_solver_guesser_make_guess (self);
	result = guessed;
	return result;
}

static void
gnonograms_solver_guesser_invert_previous_guess (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp0_ = {0};
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsCell _tmp3_;
	g_return_if_fail (self != NULL);
	gnonograms_solver_guesser_load_position (self);
	gnonograms_cell_inverse (&self->priv->trial_cell, &_tmp0_);
	self->priv->trial_cell = _tmp0_;
	_tmp1_ = gnonograms_solver_guesser_get_grid (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->trial_cell;
	gnonograms_my2_dcell_array_set_data_from_cell (_tmp2_, &_tmp3_);
}

static void
gnonograms_solver_guesser_cancel_previous_guess (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp0_ = {0};
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsCell _tmp3_;
	GnonogramsCell _tmp4_;
	g_return_if_fail (self != NULL);
	gnonograms_solver_guesser_load_position (self);
	gnonograms_cell_inverse (&self->priv->trial_cell, &_tmp0_);
	self->priv->trial_cell = _tmp0_;
	_tmp1_ = gnonograms_solver_guesser_get_grid (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->trial_cell;
	_tmp4_ = self->priv->trial_cell;
	gnonograms_my2_dcell_array_set_data_from_rc (_tmp2_, _tmp3_.row, _tmp4_.col, GNONOGRAMS_CELL_STATE_UNKNOWN);
}

static void
gnonograms_solver_guesser_save_position (GnonogramsSolverGuesser* self)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_solver_guesser_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsCellState* _tmp8_;
							gint _tmp8__length1;
							gint _tmp9_;
							GnonogramsMy2DCellArray* _tmp10_;
							GnonogramsMy2DCellArray* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_solver_guesser_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->gs;
							_tmp8__length1 = self->priv->gs_length1;
							_tmp9_ = index;
							index = _tmp9_ + 1;
							_tmp10_ = gnonograms_solver_guesser_get_grid (self);
							_tmp11_ = _tmp10_;
							_tmp8_[_tmp9_] = gnonograms_my2_dcell_array_get_data_from_rc (_tmp11_, (guint) r, (guint) c);
						}
					}
				}
			}
		}
	}
}

static void
gnonograms_solver_guesser_load_position (GnonogramsSolverGuesser* self)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_solver_guesser_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsMy2DCellArray* _tmp8_;
							GnonogramsMy2DCellArray* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							GnonogramsCellState* _tmp12_;
							gint _tmp12__length1;
							gint _tmp13_;
							GnonogramsCellState _tmp14_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_solver_guesser_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = gnonograms_solver_guesser_get_grid (self);
							_tmp9_ = _tmp8_;
							_tmp10_ = r;
							_tmp11_ = c;
							_tmp12_ = self->priv->gs;
							_tmp12__length1 = self->priv->gs_length1;
							_tmp13_ = index;
							index = _tmp13_ + 1;
							_tmp14_ = _tmp12_[_tmp13_];
							gnonograms_my2_dcell_array_set_data_from_rc (_tmp9_, (guint) _tmp10_, (guint) _tmp11_, _tmp14_);
						}
					}
				}
			}
		}
	}
}

/** Used by advanced solver. Scans in a spiral pattern from edges
          * as critical cells most likely in this region.
        **/
static gboolean
gnonograms_solver_guesser_make_guess (GnonogramsSolverGuesser* self)
{
	gint r = 0;
	GnonogramsCell _tmp0_;
	gint c = 0;
	GnonogramsCell _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->trial_cell;
	r = (gint) _tmp0_.row;
	_tmp1_ = self->priv->trial_cell;
	c = (gint) _tmp1_.col;
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		GnonogramsMy2DCellArray* _tmp16_;
		GnonogramsMy2DCellArray* _tmp17_;
		r += self->priv->rdir;
		c += self->priv->cdir;
		if (self->priv->cdir == 1) {
			_tmp2_ = c >= self->priv->clim;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			gint _tmp3_;
			gint _tmp4_;
			_tmp3_ = c;
			c = _tmp3_ - 1;
			self->priv->cdir = 0;
			self->priv->rdir = 1;
			_tmp4_ = r;
			r = _tmp4_ + 1;
		} else {
			gboolean _tmp5_ = FALSE;
			if (self->priv->rdir == 1) {
				_tmp5_ = r >= self->priv->rlim;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				gint _tmp6_;
				gint _tmp7_;
				_tmp6_ = r;
				r = _tmp6_ - 1;
				self->priv->rdir = 0;
				self->priv->cdir = -1;
				_tmp7_ = c;
				c = _tmp7_ - 1;
			} else {
				gboolean _tmp8_ = FALSE;
				if (self->priv->cdir == -1) {
					_tmp8_ = c < self->priv->turn;
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					gint _tmp9_;
					gint _tmp10_;
					_tmp9_ = c;
					c = _tmp9_ + 1;
					self->priv->cdir = 0;
					self->priv->rdir = -1;
					_tmp10_ = r;
					r = _tmp10_ - 1;
				} else {
					gboolean _tmp11_ = FALSE;
					if (self->priv->rdir == -1) {
						_tmp11_ = r <= self->priv->turn;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						gint _tmp12_;
						gint _tmp13_;
						gint _tmp14_;
						gint _tmp15_;
						_tmp12_ = r;
						r = _tmp12_ + 1;
						_tmp13_ = self->priv->turn;
						self->priv->turn = _tmp13_ + 1;
						_tmp14_ = self->priv->rlim;
						self->priv->rlim = _tmp14_ - 1;
						_tmp15_ = self->priv->clim;
						self->priv->clim = _tmp15_ - 1;
						self->priv->rdir = 0;
						self->priv->cdir = 1;
					}
				}
			}
		}
		if (((guint) self->priv->turn) > self->priv->max_turns) {
			self->priv->trial_cell.row = (guint) 0;
			self->priv->trial_cell.col = G_MAXUINT;
			result = FALSE;
			return result;
		}
		_tmp16_ = gnonograms_solver_guesser_get_grid (self);
		_tmp17_ = _tmp16_;
		if (gnonograms_my2_dcell_array_get_data_from_rc (_tmp17_, (guint) r, (guint) c) == GNONOGRAMS_CELL_STATE_UNKNOWN) {
			GnonogramsMy2DCellArray* _tmp18_;
			GnonogramsMy2DCellArray* _tmp19_;
			GnonogramsCell _tmp20_;
			self->priv->trial_cell.row = (guint) r;
			self->priv->trial_cell.col = (guint) c;
			_tmp18_ = gnonograms_solver_guesser_get_grid (self);
			_tmp19_ = _tmp18_;
			_tmp20_ = self->priv->trial_cell;
			gnonograms_my2_dcell_array_set_data_from_cell (_tmp19_, &_tmp20_);
			break;
		}
	}
	result = TRUE;
	return result;
}

static void
gnonograms_solver_guesser_get_trial_cell_copy (GnonogramsSolverGuesser* self,
                                               GnonogramsCell* result)
{
	GnonogramsCell _tmp0_ = {0};
	g_return_if_fail (self != NULL);
	gnonograms_cell_clone (&self->priv->trial_cell, &_tmp0_);
	*result = _tmp0_;
	return;
}

static GnonogramsMy2DCellArray*
gnonograms_solver_guesser_get_grid (GnonogramsSolverGuesser* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid;
	result = _tmp0_;
	return result;
}

static void
gnonograms_solver_guesser_set_grid (GnonogramsSolverGuesser* self,
                                    GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsCellState* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_grid);
	self->priv->_grid = _tmp0_;
	_tmp1_ = self->priv->_grid;
	_tmp2_ = gnonograms_my2_dcell_array_get_area (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_new0 (GnonogramsCellState, _tmp3_);
	self->priv->gs = (g_free (self->priv->gs), NULL);
	self->priv->gs = _tmp4_;
	self->priv->gs_length1 = _tmp3_;
	self->priv->_gs_size_ = self->priv->gs_length1;
}

static guint
gnonograms_solver_guesser_get_rows (GnonogramsSolverGuesser* self)
{
	guint result;
	GnonogramsMy2DCellArray* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = gnonograms_my2_dcell_array_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static guint
gnonograms_solver_guesser_get_cols (GnonogramsSolverGuesser* self)
{
	guint result;
	GnonogramsMy2DCellArray* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = gnonograms_my2_dcell_array_get_cols (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static void
gnonograms_solver_value_guesser_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_solver_value_guesser_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_solver_guesser_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_solver_value_guesser_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_solver_guesser_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_solver_value_guesser_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_solver_value_guesser_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsSolverGuesser * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_solver_guesser_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_solver_value_guesser_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	GnonogramsSolverGuesser ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_solver_guesser_ref (value->data[0].v_pointer);
	}
	return NULL;
}

static GParamSpec*
gnonograms_solver_param_spec_guesser (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	GnonogramsSolverParamSpecGuesser* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_SOLVER_TYPE_GUESSER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

static gpointer
gnonograms_solver_value_get_guesser (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER), NULL);
	return value->data[0].v_pointer;
}

static void
gnonograms_solver_value_set_guesser (GValue* value,
                                     gpointer v_object)
{
	GnonogramsSolverGuesser * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_SOLVER_TYPE_GUESSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_solver_guesser_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_solver_guesser_unref (old);
	}
}

static void
gnonograms_solver_value_take_guesser (GValue* value,
                                      gpointer v_object)
{
	GnonogramsSolverGuesser * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_SOLVER_TYPE_GUESSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_solver_guesser_unref (old);
	}
}

static void
gnonograms_solver_guesser_class_init (GnonogramsSolverGuesserClass * klass,
                                      gpointer klass_data)
{
	gnonograms_solver_guesser_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsSolverGuesserClass *) klass)->finalize = gnonograms_solver_guesser_finalize;
	g_type_class_adjust_private_offset (klass, &GnonogramsSolverGuesser_private_offset);
}

static void
gnonograms_solver_guesser_instance_init (GnonogramsSolverGuesser * self,
                                         gpointer klass)
{
	self->priv = gnonograms_solver_guesser_get_instance_private (self);
	self->priv->initial_max_turns = (guint) 3;
	self->priv->initial_cell_state = GNONOGRAMS_CELL_STATE_EMPTY;
	self->ref_count = 1;
}

static void
gnonograms_solver_guesser_finalize (GnonogramsSolverGuesser * obj)
{
	GnonogramsSolverGuesser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesser);
	g_signal_handlers_destroy (self);
	self->priv->gs = (g_free (self->priv->gs), NULL);
	_g_object_unref0 (self->priv->_grid);
}

static GType
gnonograms_solver_guesser_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gnonograms_solver_value_guesser_init, gnonograms_solver_value_guesser_free_value, gnonograms_solver_value_guesser_copy_value, gnonograms_solver_value_guesser_peek_pointer, "p", gnonograms_solver_value_guesser_collect_value, "p", gnonograms_solver_value_guesser_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsSolverGuesserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_solver_guesser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsSolverGuesser), 0, (GInstanceInitFunc) gnonograms_solver_guesser_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gnonograms_solver_guesser_type_id;
	gnonograms_solver_guesser_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsSolverGuesser", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GnonogramsSolverGuesser_private_offset = g_type_add_instance_private (gnonograms_solver_guesser_type_id, sizeof (GnonogramsSolverGuesserPrivate));
	return gnonograms_solver_guesser_type_id;
}

static GType
gnonograms_solver_guesser_get_type (void)
{
	static volatile gsize gnonograms_solver_guesser_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_solver_guesser_type_id__once)) {
		GType gnonograms_solver_guesser_type_id;
		gnonograms_solver_guesser_type_id = gnonograms_solver_guesser_get_type_once ();
		g_once_init_leave (&gnonograms_solver_guesser_type_id__once, gnonograms_solver_guesser_type_id);
	}
	return gnonograms_solver_guesser_type_id__once;
}

static gpointer
gnonograms_solver_guesser_ref (gpointer instance)
{
	GnonogramsSolverGuesser * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

static void
gnonograms_solver_guesser_unref (gpointer instance)
{
	GnonogramsSolverGuesser * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_SOLVER_GUESSER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
gnonograms_solver_class_init (GnonogramsSolverClass * klass,
                              gpointer klass_data)
{
	gnonograms_solver_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsSolver_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_solver_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_solver_set_property;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_solver_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_STATE_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", GNONOGRAMS_TYPE_SOLVER_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_GRID_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_GRID_PROPERTY] = g_param_spec_object ("grid", "grid", "grid", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_SOLUTION_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_SOLUTION_PROPERTY] = g_param_spec_object ("solution", "solution", "solution", GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_CANCELLED_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY] = g_param_spec_boolean ("unique-only", "unique-only", "unique-only", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY] = g_param_spec_boolean ("use-advanced", "use-advanced", "use-advanced", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY] = g_param_spec_boolean ("advanced-only", "advanced-only", "advanced-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY] = g_param_spec_boolean ("human-only", "human-only", "human-only", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_ROWS_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_ROWS_PROPERTY] = g_param_spec_uint ("rows", "rows", "rows", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_SOLVER_COLS_PROPERTY, gnonograms_solver_properties[GNONOGRAMS_SOLVER_COLS_PROPERTY] = g_param_spec_uint ("cols", "cols", "cols", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
gnonograms_solver_instance_init (GnonogramsSolver * self,
                                 gpointer klass)
{
	self->priv = gnonograms_solver_get_instance_private (self);
	self->priv->_unique_only = TRUE;
	self->priv->_use_advanced = FALSE;
	self->priv->_advanced_only = FALSE;
	self->priv->_human_only = TRUE;
}

static void
gnonograms_solver_finalize (GObject * obj)
{
	GnonogramsSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver);
	_g_object_unref0 (self->priv->_grid);
	_g_object_unref0 (self->priv->_solution);
	_g_object_unref0 (self->priv->_cancellable);
	self->priv->regions = (_vala_array_free (self->priv->regions, self->priv->regions_length1, (GDestroyNotify) gnonograms_region_unref), NULL);
	G_OBJECT_CLASS (gnonograms_solver_parent_class)->finalize (obj);
}

static GType
gnonograms_solver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsSolverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_solver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsSolver), 0, (GInstanceInitFunc) gnonograms_solver_instance_init, NULL };
	GType gnonograms_solver_type_id;
	gnonograms_solver_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsSolver", &g_define_type_info, 0);
	GnonogramsSolver_private_offset = g_type_add_instance_private (gnonograms_solver_type_id, sizeof (GnonogramsSolverPrivate));
	return gnonograms_solver_type_id;
}

GType
gnonograms_solver_get_type (void)
{
	static volatile gsize gnonograms_solver_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_solver_type_id__once)) {
		GType gnonograms_solver_type_id;
		gnonograms_solver_type_id = gnonograms_solver_get_type_once ();
		g_once_init_leave (&gnonograms_solver_type_id__once, gnonograms_solver_type_id);
	}
	return gnonograms_solver_type_id__once;
}

static void
_vala_gnonograms_solver_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GnonogramsSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver);
	switch (property_id) {
		case GNONOGRAMS_SOLVER_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_solver_get_state (self));
		break;
		case GNONOGRAMS_SOLVER_GRID_PROPERTY:
		g_value_set_object (value, gnonograms_solver_get_grid (self));
		break;
		case GNONOGRAMS_SOLVER_SOLUTION_PROPERTY:
		g_value_set_object (value, gnonograms_solver_get_solution (self));
		break;
		case GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY:
		g_value_set_object (value, gnonograms_solver_get_cancellable (self));
		break;
		case GNONOGRAMS_SOLVER_CANCELLED_PROPERTY:
		g_value_set_boolean (value, gnonograms_solver_get_cancelled (self));
		break;
		case GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_solver_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_solver_get_unique_only (self));
		break;
		case GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY:
		g_value_set_boolean (value, gnonograms_solver_get_use_advanced (self));
		break;
		case GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_solver_get_advanced_only (self));
		break;
		case GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_solver_get_human_only (self));
		break;
		case GNONOGRAMS_SOLVER_ROWS_PROPERTY:
		g_value_set_uint (value, gnonograms_solver_get_rows (self));
		break;
		case GNONOGRAMS_SOLVER_COLS_PROPERTY:
		g_value_set_uint (value, gnonograms_solver_get_cols (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_solver_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GnonogramsSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver);
	switch (property_id) {
		case GNONOGRAMS_SOLVER_STATE_PROPERTY:
		gnonograms_solver_set_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_SOLVER_GRID_PROPERTY:
		gnonograms_solver_set_grid (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_SOLVER_SOLUTION_PROPERTY:
		gnonograms_solver_set_solution (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_SOLVER_CANCELLABLE_PROPERTY:
		gnonograms_solver_set_cancellable (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_SOLVER_DIMENSIONS_PROPERTY:
		gnonograms_solver_set_dimensions (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_SOLVER_UNIQUE_ONLY_PROPERTY:
		gnonograms_solver_set_unique_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_SOLVER_USE_ADVANCED_PROPERTY:
		gnonograms_solver_set_use_advanced (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_SOLVER_ADVANCED_ONLY_PROPERTY:
		gnonograms_solver_set_advanced_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_SOLVER_HUMAN_ONLY_PROPERTY:
		gnonograms_solver_set_human_only (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

