/* Cellgrid.c generated by valac 0.56.16, the Vala compiler
 * generated from Cellgrid.vala, do not modify */

/* CellGrid.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <gobject/gvaluecollector.h>

#define GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH 3.0
#define GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH 1.0
#define GNONOGRAMS_UNKNOWN_COLOR "#d4d4d4"
#define GNONOGRAMS_SETTING_EMPTY_COLOR "#fafafa"
#define GNONOGRAMS_SETTING_FILLED_COLOR "#000000"
#define GNONOGRAMS_SOLVING_EMPTY_COLOR "#ffff00"
#define GNONOGRAMS_SOLVING_FILLED_COLOR "#180297"
#define GNONOGRAMS_GRID_COLOR "#000000"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_CELL_GRID (gnonograms_cell_grid_get_type ())
#define GNONOGRAMS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid))
#define GNONOGRAMS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))
#define GNONOGRAMS_IS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_IS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_CELL_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))

typedef struct _GnonogramsCellGrid GnonogramsCellGrid;
typedef struct _GnonogramsCellGridClass GnonogramsCellGridClass;
typedef struct _GnonogramsCellGridPrivate GnonogramsCellGridPrivate;

#define GNONOGRAMS_TYPE_VIEW (gnonograms_view_get_type ())
#define GNONOGRAMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsView))
#define GNONOGRAMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))
#define GNONOGRAMS_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))

typedef struct _GnonogramsView GnonogramsView;
typedef struct _GnonogramsViewClass GnonogramsViewClass;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_PATTERN_TYPE_CELL,
	GNONOGRAMS_CELL_PATTERN_TYPE_HIGHLIGHT,
	GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED
} GnonogramsCellPatternType;

#define GNONOGRAMS_TYPE_CELL_PATTERN_TYPE (gnonograms_cell_pattern_type_get_type ())

#define GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN (gnonograms_cell_grid_cell_pattern_get_type ())
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern))
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPatternClass))
#define GNONOGRAMS_CELL_GRID_IS_CELL_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN))
#define GNONOGRAMS_CELL_GRID_IS_CELL_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN))
#define GNONOGRAMS_CELL_GRID_CELL_PATTERN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPatternClass))

typedef struct _GnonogramsCellGridCellPattern GnonogramsCellGridCellPattern;
typedef struct _GnonogramsCellGridCellPatternClass GnonogramsCellGridCellPatternClass;
enum  {
	GNONOGRAMS_CELL_GRID_0_PROPERTY,
	GNONOGRAMS_CELL_GRID_VIEW_PROPERTY,
	GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY,
	GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY,
	GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY,
	GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY,
	GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY,
	GNONOGRAMS_CELL_GRID_NUM_PROPERTIES
};
static GParamSpec* gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gnonograms_cell_grid_cell_pattern_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_cell_grid_cell_pattern_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_CONTROLLER (gnonograms_controller_get_type ())
#define GNONOGRAMS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController))
#define GNONOGRAMS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))
#define GNONOGRAMS_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))

typedef struct _GnonogramsController GnonogramsController;
typedef struct _GnonogramsControllerClass GnonogramsControllerClass;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR (gnonograms_my2_dcell_array_iterator_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIterator))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR))
#define GNONOGRAMS_MY2_DCELL_ARRAY_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_MY2_DCELL_ARRAY_TYPE_ITERATOR, GnonogramsMy2DCellArrayIteratorClass))

typedef struct _GnonogramsMy2DCellArrayIterator GnonogramsMy2DCellArrayIterator;
typedef struct _GnonogramsMy2DCellArrayIteratorClass GnonogramsMy2DCellArrayIteratorClass;
#define _gnonograms_my2_dcell_array_iterator_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_my2_dcell_array_iterator_unref (var), NULL)))
typedef struct _GnonogramsCellGridCellPatternPrivate GnonogramsCellGridCellPatternPrivate;

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _GnonogramsCellGridParamSpecCellPattern GnonogramsCellGridParamSpecCellPattern;
enum  {
	GNONOGRAMS_CELL_GRID_CURSOR_MOVED_SIGNAL,
	GNONOGRAMS_CELL_GRID_NUM_SIGNALS
};
static guint gnonograms_cell_grid_signals[GNONOGRAMS_CELL_GRID_NUM_SIGNALS] = {0};

struct _GnonogramsCellGrid {
	GtkDrawingArea parent_instance;
	GnonogramsCellGridPrivate * priv;
};

struct _GnonogramsCellGridClass {
	GtkDrawingAreaClass parent_class;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsCellGridPrivate {
	GnonogramsView* _view;
	GnonogramsCell _current_cell;
	GnonogramsCell _previous_cell;
	gboolean _frozen;
	gboolean _draw_only;
	GnonogramsCellPatternType _cell_pattern_type;
	GdkRGBA* colors;
	gint colors_length1;
	gint colors_length2;
	gint rows;
	gint cols;
	gboolean dirty;
	gdouble cell_width;
	gdouble cell_height;
	GdkRGBA grid_color;
	GdkRGBA fill_color;
	GdkRGBA empty_color;
	GdkRGBA unknown_color;
	GnonogramsCellGridCellPattern* filled_cell_pattern;
	GnonogramsCellGridCellPattern* empty_cell_pattern;
	GnonogramsCellGridCellPattern* unknown_cell_pattern;
	GnonogramsCellGridCellPattern* highlight_pattern;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsCellGridCellPattern {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsCellGridCellPatternPrivate * priv;
	cairo_pattern_t* pattern;
};

struct _GnonogramsCellGridCellPatternClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsCellGridCellPattern *self);
};

struct _GnonogramsCellGridCellPatternPrivate {
	gdouble _size;
	gdouble red;
	gdouble green;
	gdouble blue;
	gdouble x0;
	gdouble y0;
	cairo_matrix_t matrix;
};

struct _Block7Data {
	int _ref_count_;
	GnonogramsCellGridCellPattern* self;
	GraniteSettings* granite_settings;
};

struct _GnonogramsCellGridParamSpecCellPattern {
	GParamSpec parent_instance;
};

static gint GnonogramsCellGrid_private_offset;
static gpointer gnonograms_cell_grid_parent_class = NULL;
static gint GnonogramsCellGridCellPattern_private_offset;
static gpointer gnonograms_cell_grid_cell_pattern_parent_class = NULL;

VALA_EXTERN GType gnonograms_cell_grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGrid, g_object_unref)
VALA_EXTERN GType gnonograms_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsView, g_object_unref)
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN GType gnonograms_cell_pattern_type_get_type (void) G_GNUC_CONST ;
static gpointer gnonograms_cell_grid_cell_pattern_ref (gpointer instance);
static void gnonograms_cell_grid_cell_pattern_unref (gpointer instance);
static GParamSpec* gnonograms_cell_grid_param_spec_cell_pattern (const gchar* name,
                                                          const gchar* nick,
                                                          const gchar* blurb,
                                                          GType object_type,
                                                          GParamFlags flags) G_GNUC_UNUSED ;
static void gnonograms_cell_grid_value_set_cell_pattern (GValue* value,
                                                  gpointer v_object) G_GNUC_UNUSED ;
static void gnonograms_cell_grid_value_take_cell_pattern (GValue* value,
                                                   gpointer v_object) G_GNUC_UNUSED ;
static gpointer gnonograms_cell_grid_value_get_cell_pattern (const GValue* value) G_GNUC_UNUSED ;
static GType gnonograms_cell_grid_cell_pattern_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGridCellPattern, gnonograms_cell_grid_cell_pattern_unref)
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_new (GnonogramsView* view);
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_construct (GType object_type,
                                                    GnonogramsView* view);
static void gnonograms_cell_grid_set_colors (GnonogramsCellGrid* self);
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
static void gnonograms_cell_grid_dimensions_updated (GnonogramsCellGrid* self);
VALA_EXTERN GnonogramsView* gnonograms_cell_grid_get_view (GnonogramsCellGrid* self);
VALA_EXTERN GType gnonograms_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsController, g_object_unref)
VALA_EXTERN GnonogramsController* gnonograms_view_get_controller (GnonogramsView* self);
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_controller_get_dimensions (GnonogramsController* self,
                                           GnonogramsDimensions * result);
VALA_EXTERN gint gnonograms_view_get_cell_size (GnonogramsView* self);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new_highlight (gdouble wd,
                                                                                gdouble ht);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct_highlight (GType object_type,
                                                                                      gdouble wd,
                                                                                      gdouble ht);
static gboolean gnonograms_cell_grid_on_draw_event (GnonogramsCellGrid* self,
                                             cairo_t* cr);
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
static GnonogramsMy2DCellArray* gnonograms_cell_grid_get_array (GnonogramsCellGrid* self);
VALA_EXTERN gpointer gnonograms_my2_dcell_array_iterator_ref (gpointer instance);
VALA_EXTERN void gnonograms_my2_dcell_array_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_my2_dcell_array_param_spec_iterator (const gchar* name,
                                                            const gchar* nick,
                                                            const gchar* blurb,
                                                            GType object_type,
                                                            GParamFlags flags);
VALA_EXTERN void gnonograms_my2_dcell_array_value_set_iterator (GValue* value,
                                                    gpointer v_object);
VALA_EXTERN void gnonograms_my2_dcell_array_value_take_iterator (GValue* value,
                                                     gpointer v_object);
VALA_EXTERN gpointer gnonograms_my2_dcell_array_value_get_iterator (const GValue* value);
VALA_EXTERN GType gnonograms_my2_dcell_array_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArrayIterator, gnonograms_my2_dcell_array_iterator_unref)
VALA_EXTERN GnonogramsMy2DCellArrayIterator* gnonograms_my2_dcell_array_iterator (GnonogramsMy2DCellArray* self);
VALA_EXTERN gboolean gnonograms_my2_dcell_array_iterator_next (GnonogramsMy2DCellArrayIterator* self);
VALA_EXTERN void gnonograms_my2_dcell_array_iterator_get (GnonogramsMy2DCellArrayIterator* self,
                                              GnonogramsCell* result);
VALA_EXTERN void gnonograms_cell_grid_get_current_cell (GnonogramsCellGrid* self,
                                            GnonogramsCell * result);
static void gnonograms_cell_grid_draw_cell (GnonogramsCellGrid* self,
                                     cairo_t* cr,
                                     GnonogramsCell* cell,
                                     gboolean highlight,
                                     gboolean mark);
static void gnonograms_cell_grid_draw_grid (GnonogramsCellGrid* self,
                                     cairo_t* cr);
static gboolean gnonograms_cell_grid_on_pointer_moved (GnonogramsCellGrid* self,
                                                GdkEventMotion* e);
VALA_EXTERN gboolean gnonograms_cell_grid_get_draw_only (GnonogramsCellGrid* self);
VALA_EXTERN GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
VALA_EXTERN gboolean gnonograms_cell_equal (GnonogramsCell *self,
                                GnonogramsCell* b);
static void gnonograms_cell_grid_update_current_cell (GnonogramsCellGrid* self,
                                               GnonogramsCell* target);
VALA_EXTERN void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
VALA_EXTERN void gnonograms_cell_grid_set_previous_cell (GnonogramsCellGrid* self,
                                             GnonogramsCell * value);
VALA_EXTERN void gnonograms_cell_grid_set_current_cell (GnonogramsCellGrid* self,
                                            GnonogramsCell * value);
VALA_EXTERN gboolean gnonograms_cell_grid_get_frozen (GnonogramsCellGrid* self);
static void gnonograms_cell_grid_cell_pattern_move_to (GnonogramsCellGridCellPattern* self,
                                                gdouble x,
                                                gdouble y);
static gboolean gnonograms_cell_grid_on_leave_notify (GnonogramsCellGrid* self);
static void gnonograms_cell_grid_set_view (GnonogramsCellGrid* self,
                                    GnonogramsView* value);
static gboolean _gnonograms_cell_equal (const GnonogramsCell * s1,
                                 const GnonogramsCell * s2);
VALA_EXTERN void gnonograms_cell_grid_get_previous_cell (GnonogramsCellGrid* self,
                                             GnonogramsCell * result);
VALA_EXTERN void gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                      gboolean value);
VALA_EXTERN void gnonograms_cell_grid_set_draw_only (GnonogramsCellGrid* self,
                                         gboolean value);
VALA_EXTERN GnonogramsCellPatternType gnonograms_cell_grid_get_cell_pattern_type (GnonogramsCellGrid* self);
VALA_EXTERN void gnonograms_cell_grid_set_cell_pattern_type (GnonogramsCellGrid* self,
                                                 GnonogramsCellPatternType value);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new_cell (GdkRGBA* color);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct_cell (GType object_type,
                                                                                 GdkRGBA* color);
VALA_EXTERN GType gnonograms_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
VALA_EXTERN GnonogramsModel* gnonograms_view_get_model (GnonogramsView* self);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_model_get_display_data (GnonogramsModel* self);
static void g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void gnonograms_cell_grid_cell_pattern_set_pattern (GnonogramsCellGridCellPattern* self,
                                                    gboolean is_dark);
static void __lambda14_ (Block7Data* _data7_);
static void ___lambda14__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void gnonograms_cell_grid_cell_pattern_set_size (GnonogramsCellGridCellPattern* self,
                                                 gdouble value);
static gdouble gnonograms_cell_grid_cell_pattern_get_size (GnonogramsCellGridCellPattern* self);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_new (void);
static GnonogramsCellGridCellPattern* gnonograms_cell_grid_cell_pattern_construct (GType object_type);
static void gnonograms_cell_grid_cell_pattern_finalize (GnonogramsCellGridCellPattern * obj);
static GType gnonograms_cell_grid_cell_pattern_get_type_once (void);
static GObject * gnonograms_cell_grid_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static gboolean _gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                GdkEventMotion* event,
                                                                                gpointer self);
static gboolean _gnonograms_cell_grid_on_draw_event_gtk_widget_draw (GtkWidget* _sender,
                                                              cairo_t* cr,
                                                              gpointer self);
static gboolean _gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                              GdkEventCrossing* event,
                                                                              gpointer self);
static void _gnonograms_cell_grid___lambda15_ (GnonogramsCellGrid* self);
static void __gnonograms_cell_grid___lambda15__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gnonograms_cell_grid_dimensions_updated_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void _gnonograms_cell_grid___lambda16_ (GnonogramsCellGrid* self);
VALA_EXTERN GnonogramsGameState gnonograms_controller_get_game_state (GnonogramsController* self);
static void __gnonograms_cell_grid___lambda16__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gnonograms_cell_grid___lambda17_ (GnonogramsCellGrid* self);
static void __gnonograms_cell_grid___lambda17__gnonograms_model_changed (GnonogramsModel* _sender,
                                                                  gpointer self);
static void gnonograms_cell_grid_finalize (GObject * obj);
static GType gnonograms_cell_grid_get_type_once (void);
static void _vala_gnonograms_cell_grid_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gnonograms_cell_grid_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

VALA_EXTERN const GnonogramsCell GNONOGRAMS_NULL_CELL;

static inline gpointer
gnonograms_cell_grid_get_instance_private (GnonogramsCellGrid* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsCellGrid_private_offset);
}

GnonogramsCellGrid*
gnonograms_cell_grid_construct (GType object_type,
                                GnonogramsView* view)
{
	GnonogramsCellGrid * self = NULL;
	g_return_val_if_fail (view != NULL, NULL);
	self = (GnonogramsCellGrid*) g_object_new (object_type, "view", view, NULL);
	return self;
}

GnonogramsCellGrid*
gnonograms_cell_grid_new (GnonogramsView* view)
{
	return gnonograms_cell_grid_construct (GNONOGRAMS_TYPE_CELL_GRID, view);
}

static void
gnonograms_cell_grid_set_colors (GnonogramsCellGrid* self)
{
	gint setting = 0;
	GdkRGBA* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GdkRGBA* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	GdkRGBA* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint solving = 0;
	GdkRGBA* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GdkRGBA* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GdkRGBA* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	g_return_if_fail (self != NULL);
	setting = (gint) GNONOGRAMS_GAME_STATE_SETTING;
	_tmp0_ = self->priv->colors;
	_tmp0__length1 = self->priv->colors_length1;
	_tmp0__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp0_[(setting * _tmp0__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)], GNONOGRAMS_UNKNOWN_COLOR);
	_tmp1_ = self->priv->colors;
	_tmp1__length1 = self->priv->colors_length1;
	_tmp1__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp1_[(setting * _tmp1__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)], GNONOGRAMS_SETTING_EMPTY_COLOR);
	_tmp2_ = self->priv->colors;
	_tmp2__length1 = self->priv->colors_length1;
	_tmp2__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp2_[(setting * _tmp2__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)], GNONOGRAMS_SETTING_FILLED_COLOR);
	solving = (gint) GNONOGRAMS_GAME_STATE_SOLVING;
	_tmp3_ = self->priv->colors;
	_tmp3__length1 = self->priv->colors_length1;
	_tmp3__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp3_[(solving * _tmp3__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)], GNONOGRAMS_UNKNOWN_COLOR);
	_tmp4_ = self->priv->colors;
	_tmp4__length1 = self->priv->colors_length1;
	_tmp4__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp4_[(solving * _tmp4__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)], GNONOGRAMS_SOLVING_EMPTY_COLOR);
	_tmp5_ = self->priv->colors;
	_tmp5__length1 = self->priv->colors_length1;
	_tmp5__length2 = self->priv->colors_length2;
	gdk_rgba_parse (&_tmp5_[(solving * _tmp5__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)], GNONOGRAMS_SOLVING_FILLED_COLOR);
}

static void
gnonograms_cell_grid_dimensions_updated (GnonogramsCellGrid* self)
{
	GnonogramsView* _tmp0_;
	GnonogramsController* _tmp1_;
	GnonogramsController* _tmp2_;
	GnonogramsDimensions _tmp3_ = {0};
	GnonogramsDimensions _tmp4_;
	GnonogramsView* _tmp5_;
	GnonogramsController* _tmp6_;
	GnonogramsController* _tmp7_;
	GnonogramsDimensions _tmp8_ = {0};
	GnonogramsDimensions _tmp9_;
	GnonogramsView* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GnonogramsView* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GnonogramsCellGridCellPattern* _tmp16_;
	GnonogramsView* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	GnonogramsView* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view;
	_tmp1_ = gnonograms_view_get_controller (_tmp0_);
	_tmp2_ = _tmp1_;
	gnonograms_controller_get_dimensions (_tmp2_, &_tmp3_);
	_tmp4_ = _tmp3_;
	self->priv->rows = (gint) _tmp4_.height;
	_tmp5_ = self->priv->_view;
	_tmp6_ = gnonograms_view_get_controller (_tmp5_);
	_tmp7_ = _tmp6_;
	gnonograms_controller_get_dimensions (_tmp7_, &_tmp8_);
	_tmp9_ = _tmp8_;
	self->priv->cols = (gint) _tmp9_.width;
	_tmp10_ = self->priv->_view;
	_tmp11_ = gnonograms_view_get_cell_size (_tmp10_);
	_tmp12_ = _tmp11_;
	self->priv->cell_width = (gdouble) _tmp12_;
	_tmp13_ = self->priv->_view;
	_tmp14_ = gnonograms_view_get_cell_size (_tmp13_);
	_tmp15_ = _tmp14_;
	self->priv->cell_height = (gdouble) _tmp15_;
	_tmp16_ = gnonograms_cell_grid_cell_pattern_new_highlight (self->priv->cell_width, self->priv->cell_height);
	_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->highlight_pattern);
	self->priv->highlight_pattern = _tmp16_;
	_tmp17_ = self->priv->_view;
	_tmp18_ = gnonograms_view_get_cell_size (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = self->priv->_view;
	_tmp21_ = gnonograms_view_get_cell_size (_tmp20_);
	_tmp22_ = _tmp21_;
	gtk_widget_set_size_request ((GtkWidget*) self, (self->priv->cols * _tmp19_) + ((gint) GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH), (self->priv->rows * _tmp22_) + ((gint) GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH));
}

static gboolean
gnonograms_cell_grid_on_draw_event (GnonogramsCellGrid* self,
                                    cairo_t* cr)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	self->priv->dirty = FALSE;
	_tmp0_ = gnonograms_cell_grid_get_array (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		{
			GnonogramsMy2DCellArrayIterator* _c_it = NULL;
			GnonogramsMy2DCellArray* _tmp2_;
			GnonogramsMy2DCellArray* _tmp3_;
			GnonogramsMy2DCellArrayIterator* _tmp4_;
			_tmp2_ = gnonograms_cell_grid_get_array (self);
			_tmp3_ = _tmp2_;
			_tmp4_ = gnonograms_my2_dcell_array_iterator (_tmp3_);
			_c_it = _tmp4_;
			while (TRUE) {
				GnonogramsMy2DCellArrayIterator* _tmp5_;
				GnonogramsCell c = {0};
				GnonogramsMy2DCellArrayIterator* _tmp6_;
				GnonogramsCell _tmp7_ = {0};
				gboolean _tmp8_ = FALSE;
				GnonogramsCell _tmp9_;
				GnonogramsCell _tmp10_;
				gboolean highlight = FALSE;
				GnonogramsCell _tmp13_;
				_tmp5_ = _c_it;
				if (!gnonograms_my2_dcell_array_iterator_next (_tmp5_)) {
					break;
				}
				_tmp6_ = _c_it;
				gnonograms_my2_dcell_array_iterator_get (_tmp6_, &_tmp7_);
				c = _tmp7_;
				_tmp9_ = c;
				_tmp10_ = self->priv->_current_cell;
				if (_tmp9_.row == _tmp10_.row) {
					GnonogramsCell _tmp11_;
					GnonogramsCell _tmp12_;
					_tmp11_ = c;
					_tmp12_ = self->priv->_current_cell;
					_tmp8_ = _tmp11_.col == _tmp12_.col;
				} else {
					_tmp8_ = FALSE;
				}
				highlight = _tmp8_;
				_tmp13_ = c;
				gnonograms_cell_grid_draw_cell (self, cr, &_tmp13_, highlight, FALSE);
			}
			_gnonograms_my2_dcell_array_iterator_unref0 (_c_it);
		}
	}
	gnonograms_cell_grid_draw_grid (self, cr);
	result = TRUE;
	return result;
}

static gboolean
gnonograms_cell_grid_on_pointer_moved (GnonogramsCellGrid* self,
                                       GdkEventMotion* e)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	guint r = 0U;
	guint c = 0U;
	gboolean _tmp3_ = FALSE;
	GnonogramsCell cell = {0};
	GnonogramsMy2DCellArray* _tmp4_;
	GnonogramsMy2DCellArray* _tmp5_;
	GnonogramsCell _tmp6_ = {0};
	GnonogramsCell _tmp7_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp2_ = self->priv->_draw_only;
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = e->x < ((gdouble) 0);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = e->y < ((gdouble) 0);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	r = (guint) (e->y / self->priv->cell_height);
	c = (guint) (e->x / self->priv->cell_width);
	if (r >= ((guint) self->priv->rows)) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = c >= ((guint) self->priv->cols);
	}
	if (_tmp3_) {
		result = TRUE;
		return result;
	}
	_tmp4_ = gnonograms_cell_grid_get_array (self);
	_tmp5_ = _tmp4_;
	_tmp6_.row = r;
	_tmp6_.col = c;
	_tmp6_.state = gnonograms_my2_dcell_array_get_data_from_rc (_tmp5_, r, c);
	cell = _tmp6_;
	_tmp7_ = self->priv->_current_cell;
	if (!gnonograms_cell_equal (&cell, &_tmp7_)) {
		GnonogramsCell _tmp8_;
		_tmp8_ = cell;
		gnonograms_cell_grid_update_current_cell (self, &_tmp8_);
	}
	result = TRUE;
	return result;
}

static void
gnonograms_cell_grid_update_current_cell (GnonogramsCellGrid* self,
                                          GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_ = {0};
	GnonogramsCell _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = self->priv->_current_cell;
	gnonograms_cell_clone (&_tmp0_, &_tmp1_);
	gnonograms_cell_grid_set_previous_cell (self, &_tmp1_);
	gnonograms_cell_clone (target, &_tmp2_);
	gnonograms_cell_grid_set_current_cell (self, &_tmp2_);
}

static void
gnonograms_cell_grid_draw_grid (GnonogramsCellGrid* self,
                                cairo_t* cr)
{
	GdkRGBA _tmp0_;
	gdouble y1 = 0.0;
	gdouble x1 = 0.0;
	gdouble x2 = 0.0;
	GnonogramsView* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble y2 = 0.0;
	GnonogramsView* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->grid_color;
	gdk_cairo_set_source_rgba (cr, &_tmp0_);
	cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE);
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH);
	y1 = GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH;
	x1 = GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH;
	_tmp1_ = self->priv->_view;
	_tmp2_ = gnonograms_view_get_cell_size (_tmp1_);
	_tmp3_ = _tmp2_;
	x2 = x1 + (self->priv->cols * _tmp3_);
	_tmp4_ = self->priv->_view;
	_tmp5_ = gnonograms_view_get_cell_size (_tmp4_);
	_tmp6_ = _tmp5_;
	y2 = y1 + (self->priv->rows * _tmp6_);
	while (TRUE) {
		GnonogramsView* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		if (!(y1 < y2)) {
			break;
		}
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x2, y1);
		cairo_stroke (cr);
		_tmp7_ = self->priv->_view;
		_tmp8_ = gnonograms_view_get_cell_size (_tmp7_);
		_tmp9_ = _tmp8_;
		y1 += (gdouble) _tmp9_;
	}
	y1 = GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH;
	while (TRUE) {
		GnonogramsView* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		if (!(x1 < x2)) {
			break;
		}
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x1, y2);
		cairo_stroke (cr);
		_tmp10_ = self->priv->_view;
		_tmp11_ = gnonograms_view_get_cell_size (_tmp10_);
		_tmp12_ = _tmp11_;
		x1 += (gdouble) _tmp12_;
	}
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MAJOR_GRID_LINE_WIDTH);
	x1 = GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH;
	while (TRUE) {
		GnonogramsView* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		if (!(y1 < y2)) {
			break;
		}
		_tmp13_ = self->priv->_view;
		_tmp14_ = gnonograms_view_get_cell_size (_tmp13_);
		_tmp15_ = _tmp14_;
		y1 += 5.0 * _tmp15_;
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x2, y1);
		cairo_stroke (cr);
	}
	y1 = GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH;
	while (TRUE) {
		GnonogramsView* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		if (!(x1 < x2)) {
			break;
		}
		_tmp16_ = self->priv->_view;
		_tmp17_ = gnonograms_view_get_cell_size (_tmp16_);
		_tmp18_ = _tmp17_;
		x1 += 5.0 * _tmp18_;
		cairo_move_to (cr, x1, y1);
		cairo_line_to (cr, x1, y2);
		cairo_stroke (cr);
	}
	cairo_set_line_width (cr, GNONOGRAMS_CELL_GRID_MINOR_GRID_LINE_WIDTH);
	y1 = (gdouble) 0;
	x1 = (gdouble) 0;
	cairo_move_to (cr, x1, y1);
	cairo_line_to (cr, x2, y1);
	cairo_stroke (cr);
	cairo_line_to (cr, x2, y2);
	cairo_stroke (cr);
	cairo_line_to (cr, x1, y2);
	cairo_stroke (cr);
	cairo_line_to (cr, x1, y1);
	cairo_stroke (cr);
}

static gpointer
_gnonograms_cell_grid_cell_pattern_ref0 (gpointer self)
{
	return self ? gnonograms_cell_grid_cell_pattern_ref (self) : NULL;
}

static void
gnonograms_cell_grid_draw_cell (GnonogramsCellGrid* self,
                                cairo_t* cr,
                                GnonogramsCell* cell,
                                gboolean highlight,
                                gboolean mark)
{
	gboolean _tmp0_;
	gdouble x = 0.0;
	GnonogramsCell _tmp1_;
	gdouble y = 0.0;
	GnonogramsCell _tmp2_;
	GnonogramsCellGridCellPattern* cell_pattern = NULL;
	GnonogramsCell _tmp3_;
	GnonogramsCellGridCellPattern* _tmp10_;
	GnonogramsCellGridCellPattern* _tmp11_;
	cairo_pattern_t* _tmp12_;
	gboolean _tmp13_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	g_return_if_fail (cell != NULL);
	_tmp0_ = self->priv->_frozen;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = *cell;
	x = _tmp1_.col * self->priv->cell_width;
	_tmp2_ = *cell;
	y = _tmp2_.row * self->priv->cell_height;
	_tmp3_ = *cell;
	switch (_tmp3_.state) {
		case GNONOGRAMS_CELL_STATE_EMPTY:
		{
			GnonogramsCellGridCellPattern* _tmp4_;
			GnonogramsCellGridCellPattern* _tmp5_;
			_tmp4_ = self->priv->empty_cell_pattern;
			_tmp5_ = _gnonograms_cell_grid_cell_pattern_ref0 (_tmp4_);
			_gnonograms_cell_grid_cell_pattern_unref0 (cell_pattern);
			cell_pattern = _tmp5_;
			break;
		}
		case GNONOGRAMS_CELL_STATE_FILLED:
		{
			GnonogramsCellGridCellPattern* _tmp6_;
			GnonogramsCellGridCellPattern* _tmp7_;
			_tmp6_ = self->priv->filled_cell_pattern;
			_tmp7_ = _gnonograms_cell_grid_cell_pattern_ref0 (_tmp6_);
			_gnonograms_cell_grid_cell_pattern_unref0 (cell_pattern);
			cell_pattern = _tmp7_;
			break;
		}
		default:
		{
			GnonogramsCellGridCellPattern* _tmp8_;
			GnonogramsCellGridCellPattern* _tmp9_;
			_tmp8_ = self->priv->unknown_cell_pattern;
			_tmp9_ = _gnonograms_cell_grid_cell_pattern_ref0 (_tmp8_);
			_gnonograms_cell_grid_cell_pattern_unref0 (cell_pattern);
			cell_pattern = _tmp9_;
			break;
		}
	}
	cairo_save (cr);
	_tmp10_ = cell_pattern;
	gnonograms_cell_grid_cell_pattern_move_to (_tmp10_, x, y);
	cairo_set_line_width (cr, 0.0);
	cairo_rectangle (cr, x, y, self->priv->cell_width, self->priv->cell_height);
	_tmp11_ = cell_pattern;
	_tmp12_ = _tmp11_->pattern;
	cairo_set_source (cr, _tmp12_);
	cairo_fill (cr);
	cairo_restore (cr);
	if (highlight) {
		gboolean _tmp14_;
		_tmp14_ = self->priv->_draw_only;
		_tmp13_ = !_tmp14_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		GnonogramsCellGridCellPattern* _tmp15_;
		GnonogramsCellGridCellPattern* _tmp16_;
		cairo_pattern_t* _tmp17_;
		cairo_save (cr);
		_tmp15_ = self->priv->highlight_pattern;
		gnonograms_cell_grid_cell_pattern_move_to (_tmp15_, x, y);
		cairo_rectangle (cr, x, y, self->priv->cell_width, self->priv->cell_width);
		cairo_clip (cr);
		_tmp16_ = self->priv->highlight_pattern;
		_tmp17_ = _tmp16_->pattern;
		cairo_set_source (cr, _tmp17_);
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
		cairo_paint (cr);
		cairo_restore (cr);
	}
	_gnonograms_cell_grid_cell_pattern_unref0 (cell_pattern);
}

static gboolean
gnonograms_cell_grid_on_leave_notify (GnonogramsCellGrid* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_cell_grid_set_previous_cell (self, &GNONOGRAMS_NULL_CELL);
	gnonograms_cell_grid_set_current_cell (self, &GNONOGRAMS_NULL_CELL);
	result = FALSE;
	return result;
}

GnonogramsView*
gnonograms_cell_grid_get_view (GnonogramsCellGrid* self)
{
	GnonogramsView* result;
	GnonogramsView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gnonograms_cell_grid_set_view (GnonogramsCellGrid* self,
                               GnonogramsView* value)
{
	GnonogramsView* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_cell_grid_get_view (self);
	if (old_value != value) {
		GnonogramsView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_VIEW_PROPERTY]);
	}
}

void
gnonograms_cell_grid_get_current_cell (GnonogramsCellGrid* self,
                                       GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_cell_equal (const GnonogramsCell * s1,
                        const GnonogramsCell * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->row != s2->row) {
		return FALSE;
	}
	if (s1->col != s2->col) {
		return FALSE;
	}
	if (s1->state != s2->state) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_cell_grid_set_current_cell (GnonogramsCellGrid* self,
                                       GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_cell_grid_get_current_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_current_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY]);
	}
}

void
gnonograms_cell_grid_get_previous_cell (GnonogramsCellGrid* self,
                                        GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_previous_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_cell_grid_set_previous_cell (GnonogramsCellGrid* self,
                                        GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_cell_grid_get_previous_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_previous_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY]);
	}
}

gboolean
gnonograms_cell_grid_get_frozen (GnonogramsCellGrid* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_frozen;
	return result;
}

void
gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_cell_grid_get_frozen (self);
	if (old_value != value) {
		self->priv->_frozen = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY]);
	}
}

gboolean
gnonograms_cell_grid_get_draw_only (GnonogramsCellGrid* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_draw_only;
	return result;
}

void
gnonograms_cell_grid_set_draw_only (GnonogramsCellGrid* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_cell_grid_get_draw_only (self);
	if (old_value != value) {
		self->priv->_draw_only = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY]);
	}
}

GnonogramsCellPatternType
gnonograms_cell_grid_get_cell_pattern_type (GnonogramsCellGrid* self)
{
	GnonogramsCellPatternType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_cell_pattern_type;
	return result;
}

void
gnonograms_cell_grid_set_cell_pattern_type (GnonogramsCellGrid* self,
                                            GnonogramsCellPatternType value)
{
	g_return_if_fail (self != NULL);
	switch (value) {
		case GNONOGRAMS_CELL_PATTERN_TYPE_CELL:
		{
			GdkRGBA _tmp0_;
			GnonogramsCellGridCellPattern* _tmp1_;
			GdkRGBA _tmp2_;
			GnonogramsCellGridCellPattern* _tmp3_;
			GdkRGBA _tmp4_;
			GnonogramsCellGridCellPattern* _tmp5_;
			_tmp0_ = self->priv->fill_color;
			_tmp1_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp0_);
			_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->filled_cell_pattern);
			self->priv->filled_cell_pattern = _tmp1_;
			_tmp2_ = self->priv->empty_color;
			_tmp3_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp2_);
			_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->empty_cell_pattern);
			self->priv->empty_cell_pattern = _tmp3_;
			_tmp4_ = self->priv->unknown_color;
			_tmp5_ = gnonograms_cell_grid_cell_pattern_new_cell (&_tmp4_);
			_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->unknown_cell_pattern);
			self->priv->unknown_cell_pattern = _tmp5_;
			self->priv->_cell_pattern_type = value;
			break;
		}
		default:
		{
			if (self->priv->_cell_pattern_type != GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED) {
				gnonograms_cell_grid_set_cell_pattern_type (self, self->priv->_cell_pattern_type);
			}
			break;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY]);
}

static GnonogramsMy2DCellArray*
gnonograms_cell_grid_get_array (GnonogramsCellGrid* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsView* _tmp0_;
	GnonogramsModel* _tmp1_;
	GnonogramsModel* _tmp2_;
	GnonogramsMy2DCellArray* _tmp3_;
	GnonogramsMy2DCellArray* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	_tmp1_ = gnonograms_view_get_model (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gnonograms_model_get_display_data (_tmp2_);
	_tmp4_ = _tmp3_;
	result = _tmp4_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), data2);
}

static inline gpointer
gnonograms_cell_grid_cell_pattern_get_instance_private (GnonogramsCellGridCellPattern* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsCellGridCellPattern_private_offset);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		GnonogramsCellGridCellPattern* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->granite_settings);
		_gnonograms_cell_grid_cell_pattern_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda14_ (Block7Data* _data7_)
{
	GnonogramsCellGridCellPattern* self;
	GraniteSettingsColorScheme _tmp0_;
	GraniteSettingsColorScheme _tmp1_;
	self = _data7_->self;
	_tmp0_ = granite_settings_get_prefers_color_scheme (_data7_->granite_settings);
	_tmp1_ = _tmp0_;
	gnonograms_cell_grid_cell_pattern_set_pattern (self, _tmp1_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK);
}

static void
___lambda14__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda14_ (self);
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct_cell (GType object_type,
                                                  GdkRGBA* color)
{
	GnonogramsCellGridCellPattern* self = NULL;
	Block7Data* _data7_;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GraniteSettings* _tmp3_;
	GraniteSettings* _tmp4_;
	GraniteSettingsColorScheme _tmp5_;
	GraniteSettingsColorScheme _tmp6_;
	g_return_val_if_fail (color != NULL, NULL);
	self = (GnonogramsCellGridCellPattern*) g_type_create_instance (object_type);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = gnonograms_cell_grid_cell_pattern_ref (self);
	_tmp0_ = *color;
	self->priv->red = _tmp0_.red;
	_tmp1_ = *color;
	self->priv->green = _tmp1_.green;
	_tmp2_ = *color;
	self->priv->blue = _tmp2_.blue;
	cairo_matrix_init_identity (&self->priv->matrix);
	_tmp3_ = granite_settings_get_default ();
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_data7_->granite_settings = _tmp4_;
	_tmp5_ = granite_settings_get_prefers_color_scheme (_data7_->granite_settings);
	_tmp6_ = _tmp5_;
	gnonograms_cell_grid_cell_pattern_set_pattern (self, _tmp6_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK);
	g_signal_connect_data ((GObject*) _data7_->granite_settings, "notify::prefers-color-scheme", (GCallback) ___lambda14__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new_cell (GdkRGBA* color)
{
	return gnonograms_cell_grid_cell_pattern_construct_cell (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, color);
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct_highlight (GType object_type,
                                                       gdouble wd,
                                                       gdouble ht)
{
	GnonogramsCellGridCellPattern* self = NULL;
	gdouble r = 0.0;
	cairo_surface_t* surface = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* context = NULL;
	cairo_t* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	self = (GnonogramsCellGridCellPattern*) g_type_create_instance (object_type);
	r = (wd + ht) / 4.0;
	gnonograms_cell_grid_cell_pattern_set_size (self, 2 * r);
	_tmp0_ = self->priv->_size;
	_tmp1_ = self->priv->_size;
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (gint) _tmp0_, (gint) _tmp1_);
	surface = _tmp2_;
	_tmp3_ = cairo_create (surface);
	context = _tmp3_;
	cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
	_tmp4_ = self->priv->_size;
	_tmp5_ = self->priv->_size;
	cairo_rectangle (context, (gdouble) 0, (gdouble) 0, _tmp4_, _tmp5_);
	cairo_fill (context);
	cairo_arc (context, r, r, r - 2.0, (gdouble) 0, 2 * G_PI);
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, 0.5);
	cairo_set_operator (context, CAIRO_OPERATOR_SOURCE);
	cairo_fill (context);
	_tmp6_ = cairo_pattern_create_for_surface (surface);
	_cairo_pattern_destroy0 (self->pattern);
	self->pattern = _tmp6_;
	_tmp7_ = self->pattern;
	cairo_pattern_set_extend (_tmp7_, CAIRO_EXTEND_NONE);
	cairo_matrix_init_identity (&self->priv->matrix);
	_tmp8_ = self->pattern;
	_tmp9_ = self->priv->matrix;
	cairo_pattern_set_matrix (_tmp8_, &_tmp9_);
	_cairo_destroy0 (context);
	_cairo_surface_destroy0 (surface);
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new_highlight (gdouble wd,
                                                 gdouble ht)
{
	return gnonograms_cell_grid_cell_pattern_construct_highlight (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, wd, ht);
}

static void
gnonograms_cell_grid_cell_pattern_move_to (GnonogramsCellGridCellPattern* self,
                                           gdouble x,
                                           gdouble y)
{
	gdouble xx = 0.0;
	gdouble yy = 0.0;
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	g_return_if_fail (self != NULL);
	xx = x - self->priv->x0;
	yy = y - self->priv->y0;
	cairo_matrix_translate (&self->priv->matrix, -xx, -yy);
	_tmp0_ = self->pattern;
	_tmp1_ = self->priv->matrix;
	cairo_pattern_set_matrix (_tmp0_, &_tmp1_);
	self->priv->x0 = x;
	self->priv->y0 = y;
}

static void
gnonograms_cell_grid_cell_pattern_set_pattern (GnonogramsCellGridCellPattern* self,
                                               gboolean is_dark)
{
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	cairo_pattern_t* _tmp3_;
	g_return_if_fail (self != NULL);
	if (is_dark) {
		_tmp0_ = self->priv->red / 2;
	} else {
		_tmp0_ = self->priv->red;
	}
	if (is_dark) {
		_tmp1_ = self->priv->green / 2;
	} else {
		_tmp1_ = self->priv->green;
	}
	if (is_dark) {
		_tmp2_ = self->priv->blue / 2;
	} else {
		_tmp2_ = self->priv->blue;
	}
	_tmp3_ = cairo_pattern_create_rgba (_tmp0_, _tmp1_, _tmp2_, 1.0);
	_cairo_pattern_destroy0 (self->pattern);
	self->pattern = _tmp3_;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_construct (GType object_type)
{
	GnonogramsCellGridCellPattern* self = NULL;
	self = (GnonogramsCellGridCellPattern*) g_type_create_instance (object_type);
	return self;
}

static GnonogramsCellGridCellPattern*
gnonograms_cell_grid_cell_pattern_new (void)
{
	return gnonograms_cell_grid_cell_pattern_construct (GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN);
}

static gdouble
gnonograms_cell_grid_cell_pattern_get_size (GnonogramsCellGridCellPattern* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_size;
	return result;
}

static void
gnonograms_cell_grid_cell_pattern_set_size (GnonogramsCellGridCellPattern* self,
                                            gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_size = value;
}

static void
gnonograms_cell_grid_value_cell_pattern_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_cell_grid_value_cell_pattern_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_cell_grid_cell_pattern_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_cell_grid_value_cell_pattern_copy_value (const GValue* src_value,
                                                    GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_cell_grid_cell_pattern_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_cell_grid_value_cell_pattern_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_cell_grid_value_cell_pattern_collect_value (GValue* value,
                                                       guint n_collect_values,
                                                       GTypeCValue* collect_values,
                                                       guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsCellGridCellPattern * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_cell_grid_cell_pattern_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_cell_grid_value_cell_pattern_lcopy_value (const GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
	GnonogramsCellGridCellPattern ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_cell_grid_cell_pattern_ref (value->data[0].v_pointer);
	}
	return NULL;
}

static GParamSpec*
gnonograms_cell_grid_param_spec_cell_pattern (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags)
{
	GnonogramsCellGridParamSpecCellPattern* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

static gpointer
gnonograms_cell_grid_value_get_cell_pattern (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN), NULL);
	return value->data[0].v_pointer;
}

static void
gnonograms_cell_grid_value_set_cell_pattern (GValue* value,
                                             gpointer v_object)
{
	GnonogramsCellGridCellPattern * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_cell_grid_cell_pattern_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_cell_grid_cell_pattern_unref (old);
	}
}

static void
gnonograms_cell_grid_value_take_cell_pattern (GValue* value,
                                              gpointer v_object)
{
	GnonogramsCellGridCellPattern * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_cell_grid_cell_pattern_unref (old);
	}
}

static void
gnonograms_cell_grid_cell_pattern_class_init (GnonogramsCellGridCellPatternClass * klass,
                                              gpointer klass_data)
{
	gnonograms_cell_grid_cell_pattern_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsCellGridCellPatternClass *) klass)->finalize = gnonograms_cell_grid_cell_pattern_finalize;
	g_type_class_adjust_private_offset (klass, &GnonogramsCellGridCellPattern_private_offset);
}

static void
gnonograms_cell_grid_cell_pattern_instance_init (GnonogramsCellGridCellPattern * self,
                                                 gpointer klass)
{
	self->priv = gnonograms_cell_grid_cell_pattern_get_instance_private (self);
	self->priv->x0 = (gdouble) 0;
	self->priv->y0 = (gdouble) 0;
	self->ref_count = 1;
}

static void
gnonograms_cell_grid_cell_pattern_finalize (GnonogramsCellGridCellPattern * obj)
{
	GnonogramsCellGridCellPattern * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_CELL_GRID_TYPE_CELL_PATTERN, GnonogramsCellGridCellPattern);
	g_signal_handlers_destroy (self);
	_cairo_pattern_destroy0 (self->pattern);
}

static GType
gnonograms_cell_grid_cell_pattern_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gnonograms_cell_grid_value_cell_pattern_init, gnonograms_cell_grid_value_cell_pattern_free_value, gnonograms_cell_grid_value_cell_pattern_copy_value, gnonograms_cell_grid_value_cell_pattern_peek_pointer, "p", gnonograms_cell_grid_value_cell_pattern_collect_value, "p", gnonograms_cell_grid_value_cell_pattern_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsCellGridCellPatternClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_cell_grid_cell_pattern_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsCellGridCellPattern), 0, (GInstanceInitFunc) gnonograms_cell_grid_cell_pattern_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gnonograms_cell_grid_cell_pattern_type_id;
	gnonograms_cell_grid_cell_pattern_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsCellGridCellPattern", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GnonogramsCellGridCellPattern_private_offset = g_type_add_instance_private (gnonograms_cell_grid_cell_pattern_type_id, sizeof (GnonogramsCellGridCellPatternPrivate));
	return gnonograms_cell_grid_cell_pattern_type_id;
}

static GType
gnonograms_cell_grid_cell_pattern_get_type (void)
{
	static volatile gsize gnonograms_cell_grid_cell_pattern_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_cell_grid_cell_pattern_type_id__once)) {
		GType gnonograms_cell_grid_cell_pattern_type_id;
		gnonograms_cell_grid_cell_pattern_type_id = gnonograms_cell_grid_cell_pattern_get_type_once ();
		g_once_init_leave (&gnonograms_cell_grid_cell_pattern_type_id__once, gnonograms_cell_grid_cell_pattern_type_id);
	}
	return gnonograms_cell_grid_cell_pattern_type_id__once;
}

static gpointer
gnonograms_cell_grid_cell_pattern_ref (gpointer instance)
{
	GnonogramsCellGridCellPattern * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

static void
gnonograms_cell_grid_cell_pattern_unref (gpointer instance)
{
	GnonogramsCellGridCellPattern * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_CELL_GRID_CELL_PATTERN_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static gboolean
_gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                       GdkEventMotion* event,
                                                                       gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_pointer_moved ((GnonogramsCellGrid*) self, event);
	return result;
}

static gboolean
_gnonograms_cell_grid_on_draw_event_gtk_widget_draw (GtkWidget* _sender,
                                                     cairo_t* cr,
                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_draw_event ((GnonogramsCellGrid*) self, cr);
	return result;
}

static gboolean
_gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                     GdkEventCrossing* event,
                                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_cell_grid_on_leave_notify ((GnonogramsCellGrid*) self);
	return result;
}

static void
_gnonograms_cell_grid___lambda15_ (GnonogramsCellGrid* self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
__gnonograms_cell_grid___lambda15__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_gnonograms_cell_grid___lambda15_ ((GnonogramsCellGrid*) self);
}

static void
_gnonograms_cell_grid_dimensions_updated_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
	gnonograms_cell_grid_dimensions_updated ((GnonogramsCellGrid*) self);
}

static void
_gnonograms_cell_grid___lambda16_ (GnonogramsCellGrid* self)
{
	GnonogramsGameState gs = 0;
	GnonogramsView* _tmp0_;
	GnonogramsController* _tmp1_;
	GnonogramsController* _tmp2_;
	GnonogramsGameState _tmp3_;
	GnonogramsGameState _tmp4_;
	GdkRGBA* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	GdkRGBA _tmp6_;
	GdkRGBA* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	GdkRGBA _tmp8_;
	GdkRGBA* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	GdkRGBA _tmp10_;
	_tmp0_ = self->priv->_view;
	_tmp1_ = gnonograms_view_get_controller (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gnonograms_controller_get_game_state (_tmp2_);
	_tmp4_ = _tmp3_;
	gs = _tmp4_;
	_tmp5_ = self->priv->colors;
	_tmp5__length1 = self->priv->colors_length1;
	_tmp5__length2 = self->priv->colors_length2;
	_tmp6_ = _tmp5_[(((gint) gs) * _tmp5__length2) + ((gint) GNONOGRAMS_CELL_STATE_UNKNOWN)];
	self->priv->unknown_color = _tmp6_;
	_tmp7_ = self->priv->colors;
	_tmp7__length1 = self->priv->colors_length1;
	_tmp7__length2 = self->priv->colors_length2;
	_tmp8_ = _tmp7_[(((gint) gs) * _tmp7__length2) + ((gint) GNONOGRAMS_CELL_STATE_FILLED)];
	self->priv->fill_color = _tmp8_;
	_tmp9_ = self->priv->colors;
	_tmp9__length1 = self->priv->colors_length1;
	_tmp9__length2 = self->priv->colors_length2;
	_tmp10_ = _tmp9_[(((gint) gs) * _tmp9__length2) + ((gint) GNONOGRAMS_CELL_STATE_EMPTY)];
	self->priv->empty_color = _tmp10_;
	gnonograms_cell_grid_set_cell_pattern_type (self, GNONOGRAMS_CELL_PATTERN_TYPE_UNDEFINED);
}

static void
__gnonograms_cell_grid___lambda16__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_gnonograms_cell_grid___lambda16_ ((GnonogramsCellGrid*) self);
}

static void
_gnonograms_cell_grid___lambda17_ (GnonogramsCellGrid* self)
{
	if (!self->priv->dirty) {
		self->priv->dirty = TRUE;
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
}

static void
__gnonograms_cell_grid___lambda17__gnonograms_model_changed (GnonogramsModel* _sender,
                                                             gpointer self)
{
	_gnonograms_cell_grid___lambda17_ ((GnonogramsCellGrid*) self);
}

static GObject *
gnonograms_cell_grid_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsCellGrid * self;
	GdkRGBA* _tmp0_;
	GnonogramsView* _tmp1_;
	GnonogramsView* _tmp2_;
	GnonogramsController* _tmp3_;
	GnonogramsController* _tmp4_;
	GnonogramsView* _tmp5_;
	GnonogramsController* _tmp6_;
	GnonogramsController* _tmp7_;
	GnonogramsView* _tmp8_;
	GnonogramsModel* _tmp9_;
	GnonogramsModel* _tmp10_;
	parent_class = G_OBJECT_CLASS (gnonograms_cell_grid_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	self->priv->_current_cell = GNONOGRAMS_NULL_CELL;
	_tmp0_ = g_new0 (GdkRGBA, 2 * 3);
	self->priv->colors = (g_free (self->priv->colors), NULL);
	self->priv->colors = _tmp0_;
	self->priv->colors_length1 = 2;
	self->priv->colors_length2 = 3;
	gdk_rgba_parse (&self->priv->grid_color, GNONOGRAMS_GRID_COLOR);
	gnonograms_cell_grid_set_cell_pattern_type (self, GNONOGRAMS_CELL_PATTERN_TYPE_CELL);
	gnonograms_cell_grid_set_colors (self);
	gtk_widget_add_events ((GtkWidget*) self, (gint) (((((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_KEY_PRESS_MASK) | GDK_KEY_RELEASE_MASK) | GDK_LEAVE_NOTIFY_MASK));
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _gnonograms_cell_grid_on_pointer_moved_gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _gnonograms_cell_grid_on_draw_event_gtk_widget_draw, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) _gnonograms_cell_grid_on_leave_notify_gtk_widget_leave_notify_event, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::current-cell", (GCallback) __gnonograms_cell_grid___lambda15__g_object_notify, self, 0);
	_tmp1_ = self->priv->_view;
	g_signal_connect_object ((GObject*) _tmp1_, "notify::cell-size", (GCallback) _gnonograms_cell_grid_dimensions_updated_g_object_notify, self, 0);
	_tmp2_ = self->priv->_view;
	_tmp3_ = gnonograms_view_get_controller (_tmp2_);
	_tmp4_ = _tmp3_;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::dimensions", (GCallback) _gnonograms_cell_grid_dimensions_updated_g_object_notify, self, 0);
	_tmp5_ = self->priv->_view;
	_tmp6_ = gnonograms_view_get_controller (_tmp5_);
	_tmp7_ = _tmp6_;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::game-state", (GCallback) __gnonograms_cell_grid___lambda16__g_object_notify, self, 0);
	_tmp8_ = self->priv->_view;
	_tmp9_ = gnonograms_view_get_model (_tmp8_);
	_tmp10_ = _tmp9_;
	g_signal_connect_object (_tmp10_, "changed", (GCallback) __gnonograms_cell_grid___lambda17__gnonograms_model_changed, self, 0);
	gnonograms_cell_grid_dimensions_updated (self);
	return obj;
}

static void
gnonograms_cell_grid_class_init (GnonogramsCellGridClass * klass,
                                 gpointer klass_data)
{
	gnonograms_cell_grid_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsCellGrid_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_cell_grid_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_cell_grid_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_cell_grid_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_cell_grid_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_VIEW_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", GNONOGRAMS_TYPE_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY] = g_param_spec_boxed ("current-cell", "current-cell", "current-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY] = g_param_spec_boxed ("previous-cell", "previous-cell", "previous-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY] = g_param_spec_boolean ("frozen", "frozen", "frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY] = g_param_spec_boolean ("draw-only", "draw-only", "draw-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY, gnonograms_cell_grid_properties[GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY] = g_param_spec_enum ("cell-pattern-type", "cell-pattern-type", "cell-pattern-type", GNONOGRAMS_TYPE_CELL_PATTERN_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gnonograms_cell_grid_signals[GNONOGRAMS_CELL_GRID_CURSOR_MOVED_SIGNAL] = g_signal_new ("cursor-moved", GNONOGRAMS_TYPE_CELL_GRID, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED, G_TYPE_NONE, 2, GNONOGRAMS_TYPE_CELL, GNONOGRAMS_TYPE_CELL);
}

static void
gnonograms_cell_grid_instance_init (GnonogramsCellGrid * self,
                                    gpointer klass)
{
	self->priv = gnonograms_cell_grid_get_instance_private (self);
	self->priv->_draw_only = FALSE;
	self->priv->rows = 0;
	self->priv->cols = 0;
	self->priv->dirty = FALSE;
}

static void
gnonograms_cell_grid_finalize (GObject * obj)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	_g_object_unref0 (self->priv->_view);
	self->priv->colors = (g_free (self->priv->colors), NULL);
	_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->filled_cell_pattern);
	_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->empty_cell_pattern);
	_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->unknown_cell_pattern);
	_gnonograms_cell_grid_cell_pattern_unref0 (self->priv->highlight_pattern);
	G_OBJECT_CLASS (gnonograms_cell_grid_parent_class)->finalize (obj);
}

static GType
gnonograms_cell_grid_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsCellGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_cell_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsCellGrid), 0, (GInstanceInitFunc) gnonograms_cell_grid_instance_init, NULL };
	GType gnonograms_cell_grid_type_id;
	gnonograms_cell_grid_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GnonogramsCellGrid", &g_define_type_info, 0);
	GnonogramsCellGrid_private_offset = g_type_add_instance_private (gnonograms_cell_grid_type_id, sizeof (GnonogramsCellGridPrivate));
	return gnonograms_cell_grid_type_id;
}

GType
gnonograms_cell_grid_get_type (void)
{
	static volatile gsize gnonograms_cell_grid_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_cell_grid_type_id__once)) {
		GType gnonograms_cell_grid_type_id;
		gnonograms_cell_grid_type_id = gnonograms_cell_grid_get_type_once ();
		g_once_init_leave (&gnonograms_cell_grid_type_id__once, gnonograms_cell_grid_type_id);
	}
	return gnonograms_cell_grid_type_id__once;
}

static void
_vala_gnonograms_cell_grid_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_VIEW_PROPERTY:
		g_value_set_object (value, gnonograms_cell_grid_get_view (self));
		break;
		case GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_cell_grid_get_current_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_cell_grid_get_previous_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY:
		g_value_set_boolean (value, gnonograms_cell_grid_get_frozen (self));
		break;
		case GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_cell_grid_get_draw_only (self));
		break;
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY:
		g_value_set_enum (value, gnonograms_cell_grid_get_cell_pattern_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_cell_grid_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsCellGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid);
	switch (property_id) {
		case GNONOGRAMS_CELL_GRID_VIEW_PROPERTY:
		gnonograms_cell_grid_set_view (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_CELL_GRID_CURRENT_CELL_PROPERTY:
		gnonograms_cell_grid_set_current_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_CELL_GRID_PREVIOUS_CELL_PROPERTY:
		gnonograms_cell_grid_set_previous_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_CELL_GRID_FROZEN_PROPERTY:
		gnonograms_cell_grid_set_frozen (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_CELL_GRID_DRAW_ONLY_PROPERTY:
		gnonograms_cell_grid_set_draw_only (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_CELL_GRID_CELL_PATTERN_TYPE_PROPERTY:
		gnonograms_cell_grid_set_cell_pattern_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

