/* Controller.c generated by valac 0.56.16, the Vala compiler
 * generated from Controller.vala, do not modify */

/* Controller.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <handy.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gdk/gdk.h>

#define GNONOGRAMS_CONTROLLER_SETTINGS_SCHEMA_ID "com.github.jeremypw.gnonograms.settings"
#define GNONOGRAMS_CONTROLLER_SAVED_STATE_SCHEMA_ID "com.github.jeremypw.gnonograms.saved-state"
#define GNONOGRAMS_UNTITLED_NAME N_ ("Untitled")
#define GNONOGRAMS_GAMEFILEEXTENSION ".gno"
#define GNONOGRAMS_UNSAVED_FILENAME "Unsaved Game" GNONOGRAMS_GAMEFILEEXTENSION
#define GNONOGRAMS_MAXSIZE ((guint) 54)
#define GNONOGRAMS_MINSIZE ((guint) 5)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_CONTROLLER (gnonograms_controller_get_type ())
#define GNONOGRAMS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController))
#define GNONOGRAMS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))
#define GNONOGRAMS_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))

typedef struct _GnonogramsController GnonogramsController;
typedef struct _GnonogramsControllerClass GnonogramsControllerClass;
typedef struct _GnonogramsControllerPrivate GnonogramsControllerPrivate;
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())

#define GNONOGRAMS_TYPE_VIEW (gnonograms_view_get_type ())
#define GNONOGRAMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsView))
#define GNONOGRAMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))
#define GNONOGRAMS_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))

typedef struct _GnonogramsView GnonogramsView;
typedef struct _GnonogramsViewClass GnonogramsViewClass;

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;

#define GNONOGRAMS_TYPE_SOLVER (gnonograms_solver_get_type ())
#define GNONOGRAMS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver))
#define GNONOGRAMS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))
#define GNONOGRAMS_IS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_IS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_SOLVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))

typedef struct _GnonogramsSolver GnonogramsSolver;
typedef struct _GnonogramsSolverClass GnonogramsSolverClass;

#define GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR (gnonograms_simple_random_game_generator_get_type ())
#define GNONOGRAMS_SIMPLE_RANDOM_GAME_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR, GnonogramsSimpleRandomGameGenerator))
#define GNONOGRAMS_SIMPLE_RANDOM_GAME_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR, GnonogramsSimpleRandomGameGeneratorClass))
#define GNONOGRAMS_IS_SIMPLE_RANDOM_GAME_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR))
#define GNONOGRAMS_IS_SIMPLE_RANDOM_GAME_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR))
#define GNONOGRAMS_SIMPLE_RANDOM_GAME_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_SIMPLE_RANDOM_GAME_GENERATOR, GnonogramsSimpleRandomGameGeneratorClass))

typedef struct _GnonogramsSimpleRandomGameGenerator GnonogramsSimpleRandomGameGenerator;
typedef struct _GnonogramsSimpleRandomGameGeneratorClass GnonogramsSimpleRandomGameGeneratorClass;

#define GNONOGRAMS_TYPE_HISTORY (gnonograms_history_get_type ())
#define GNONOGRAMS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistory))
#define GNONOGRAMS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistoryClass))
#define GNONOGRAMS_IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_HISTORY))
#define GNONOGRAMS_IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_HISTORY))
#define GNONOGRAMS_HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_HISTORY, GnonogramsHistoryClass))

typedef struct _GnonogramsHistory GnonogramsHistory;
typedef struct _GnonogramsHistoryClass GnonogramsHistoryClass;
enum  {
	GNONOGRAMS_CONTROLLER_0_PROPERTY,
	GNONOGRAMS_CONTROLLER_WINDOW_PROPERTY,
	GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY,
	GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY,
	GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY,
	GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY,
	GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY,
	GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY,
	GNONOGRAMS_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GnonogramsControllerRestoreGameData GnonogramsControllerRestoreGameData;

#define GNONOGRAMS_TYPE_FILEWRITER (gnonograms_filewriter_get_type ())
#define GNONOGRAMS_FILEWRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriter))
#define GNONOGRAMS_FILEWRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriterClass))
#define GNONOGRAMS_IS_FILEWRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_FILEWRITER))
#define GNONOGRAMS_IS_FILEWRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_FILEWRITER))
#define GNONOGRAMS_FILEWRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_FILEWRITER, GnonogramsFilewriterClass))

typedef struct _GnonogramsFilewriter GnonogramsFilewriter;
typedef struct _GnonogramsFilewriterClass GnonogramsFilewriterClass;

#define GNONOGRAMS_TYPE_FILEREADER (gnonograms_filereader_get_type ())
#define GNONOGRAMS_FILEREADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereader))
#define GNONOGRAMS_FILEREADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereaderClass))
#define GNONOGRAMS_IS_FILEREADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_FILEREADER))
#define GNONOGRAMS_IS_FILEREADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_FILEREADER))
#define GNONOGRAMS_FILEREADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_FILEREADER, GnonogramsFilereaderClass))

typedef struct _GnonogramsFilereader GnonogramsFilereader;
typedef struct _GnonogramsFilereaderClass GnonogramsFilereaderClass;

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;
#define _gnonograms_move_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_move_unref (var), NULL)))
typedef struct _GnonogramsFilereaderPrivate GnonogramsFilereaderPrivate;
typedef struct _GnonogramsControllerLoadGameAsyncData GnonogramsControllerLoadGameAsyncData;
typedef struct _Block3Data Block3Data;
typedef struct _GnonogramsControllerLoadCommonData GnonogramsControllerLoadCommonData;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef struct _GnonogramsMovePrivate GnonogramsMovePrivate;
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())
typedef struct _GnonogramsControllerStartSolvingData GnonogramsControllerStartSolvingData;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
enum  {
	GNONOGRAMS_CONTROLLER_QUIT_APP_SIGNAL,
	GNONOGRAMS_CONTROLLER_NUM_SIGNALS
};
static guint gnonograms_controller_signals[GNONOGRAMS_CONTROLLER_NUM_SIGNALS] = {0};

struct _GnonogramsController {
	GObject parent_instance;
	GnonogramsControllerPrivate * priv;
};

struct _GnonogramsControllerClass {
	GObjectClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsControllerPrivate {
	GnonogramsGameState _game_state;
	GnonogramsDimensions _dimensions;
	GnonogramsDifficulty _generator_grade;
	gchar* _game_name;
	gboolean _is_readonly;
	GnonogramsView* view;
	GnonogramsModel* model;
	GnonogramsSolver* solver;
	GnonogramsSimpleRandomGameGenerator* generator;
	GSettings* settings;
	GSettings* saved_state;
	GnonogramsHistory* history;
	gchar* _current_game_path;
	gchar* saved_games_folder;
	gchar* temporary_game_path;
	guint configure_id;
};

struct _Block2Data {
	int _ref_count_;
	GnonogramsController* self;
	GCancellable* cancellable;
};

struct _GnonogramsControllerRestoreGameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsController* self;
	gboolean result;
	const gchar* _tmp0_;
	GFile* current_game_file;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
};

struct _GnonogramsFilereader {
	GObject parent_instance;
	GnonogramsFilereaderPrivate * priv;
	gchar* err_msg;
};

struct _GnonogramsFilereaderClass {
	GObjectClass parent_class;
};

struct _GnonogramsControllerLoadGameAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsController* self;
	GFile* game;
	gboolean result;
	GnonogramsFilereader* reader;
	GnonogramsGameState gs;
	GnonogramsGameState _tmp0_;
	GnonogramsFilereader* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	const gchar* _tmp4_;
	GnonogramsFilereader* _tmp5_;
	GnonogramsFilereader* _tmp6_;
	GError* e;
	GError* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* basename;
	gchar* _tmp11_;
	gchar* game_path;
	gchar* _tmp12_;
	gboolean _tmp13_;
	GnonogramsFilereader* _tmp14_;
	GnonogramsFilereader* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GnonogramsFilereader* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gchar* _tmp21_;
	GnonogramsFilereader* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	GnonogramsView* _tmp31_;
	GError* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GError* _inner_error1_;
	gboolean _tmp36_;
	GnonogramsFilereader* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GnonogramsFilereader* _tmp40_;
	GnonogramsFilereader* _tmp41_;
	GnonogramsGameState _tmp42_;
	GnonogramsGameState _tmp43_;
	GnonogramsFilereader* _tmp44_;
	GnonogramsGameState _tmp45_;
	GnonogramsGameState _tmp46_;
	GnonogramsHistory* _tmp47_;
	GnonogramsFilereader* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	GnonogramsHistory* _tmp51_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	GnonogramsHistory* _tmp54_;
	GnonogramsMove* _tmp55_;
	GnonogramsMove* _tmp56_;
	GnonogramsView* _tmp57_;
	GnonogramsFilereader* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	GnonogramsController* self;
	GnonogramsFilereader* reader;
	gpointer _async_data_;
};

struct _GnonogramsControllerLoadCommonData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsController* self;
	GnonogramsFilereader* reader;
	gboolean result;
	Block3Data* _data3_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GnonogramsDimensions _tmp18_;
	GnonogramsDimensions _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsMove {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsMovePrivate * priv;
	GnonogramsCell cell;
	GnonogramsCellState previous_state;
};

struct _GnonogramsMoveClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsMove *self);
};

struct _GnonogramsControllerStartSolvingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnonogramsController* self;
	gboolean copy_to_working;
	gboolean copy_to_solution;
	GnonogramsSolverState result;
	GnonogramsSolverState state;
	GCancellable* cancellable;
	GCancellable* _tmp0_;
	GnonogramsDifficulty diff;
	gchar* msg;
	gchar* _tmp1_;
	GnonogramsSolver* _tmp2_;
	GnonogramsSolver* _tmp3_;
	GCancellable* _tmp4_;
	GnonogramsView* _tmp5_;
	GCancellable* _tmp6_;
	GnonogramsSolver* _tmp7_;
	GnonogramsSolver* _tmp8_;
	GnonogramsView* _tmp9_;
	gint _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GnonogramsView* _tmp13_;
	gint _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gboolean _tmp17_;
	GCancellable* _tmp18_;
	GCancellable* _tmp19_;
	gchar* _tmp20_;
	GnonogramsSolver* _tmp21_;
	GnonogramsSolverState _tmp22_;
	GnonogramsSolverState _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	GnonogramsView* _tmp29_;
	const gchar* _tmp30_;
	GnonogramsView* _tmp31_;
	GnonogramsSolver* _tmp32_;
	GnonogramsSolverState _tmp33_;
	GnonogramsSolverState _tmp34_;
	GnonogramsModel* _tmp35_;
	GnonogramsSolver* _tmp36_;
	GnonogramsMy2DCellArray* _tmp37_;
	GnonogramsMy2DCellArray* _tmp38_;
	GnonogramsModel* _tmp39_;
	GnonogramsSolver* _tmp40_;
	GnonogramsMy2DCellArray* _tmp41_;
	GnonogramsMy2DCellArray* _tmp42_;
	GnonogramsView* _tmp43_;
};

static gint GnonogramsController_private_offset;
static gpointer gnonograms_controller_parent_class = NULL;

VALA_EXTERN GType gnonograms_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsController, g_object_unref)
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsView, g_object_unref)
VALA_EXTERN GType gnonograms_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
VALA_EXTERN GType gnonograms_solver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSolver, g_object_unref)
VALA_EXTERN GType gnonograms_simple_random_game_generator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSimpleRandomGameGenerator, g_object_unref)
VALA_EXTERN GType gnonograms_history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsHistory, g_object_unref)
static void gnonograms_controller_new_or_random_game (GnonogramsController* self);
VALA_EXTERN GnonogramsGameState gnonograms_controller_get_game_state (GnonogramsController* self);
VALA_EXTERN const gchar* gnonograms_controller_get_game_name (GnonogramsController* self);
static void gnonograms_controller_on_new_random_request (GnonogramsController* self);
static void gnonograms_controller_new_game (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_quit (GnonogramsController* self);
VALA_EXTERN void gnonograms_solver_cancel (GnonogramsSolver* self);
static void gnonograms_controller_save_game_state (GnonogramsController* self);
VALA_EXTERN void gnonograms_simple_random_game_generator_cancel (GnonogramsSimpleRandomGameGenerator* self);
static void gnonograms_controller_clear (GnonogramsController* self);
VALA_EXTERN void gnonograms_model_clear (GnonogramsModel* self);
VALA_EXTERN void gnonograms_view_update_labels_from_solution (GnonogramsView* self);
static void gnonograms_controller_clear_history (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_set_is_readonly (GnonogramsController* self,
                                            gboolean value);
VALA_EXTERN void gnonograms_controller_set_game_state (GnonogramsController* self,
                                           GnonogramsGameState value);
VALA_EXTERN void gnonograms_controller_set_game_name (GnonogramsController* self,
                                          const gchar* value);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN void gnonograms_solver_set_cancellable (GnonogramsSolver* self,
                                        GCancellable* value);
VALA_EXTERN void gnonograms_controller_get_dimensions (GnonogramsController* self,
                                           GnonogramsDimensions * result);
VALA_EXTERN GnonogramsDifficulty gnonograms_controller_get_generator_grade (GnonogramsController* self);
VALA_EXTERN GnonogramsSimpleRandomGameGenerator* gnonograms_simple_random_game_generator_new (GnonogramsDimensions* _dimensions,
                                                                                  GnonogramsSolver* _solver);
VALA_EXTERN GnonogramsSimpleRandomGameGenerator* gnonograms_simple_random_game_generator_construct (GType object_type,
                                                                                        GnonogramsDimensions* _dimensions,
                                                                                        GnonogramsSolver* _solver);
VALA_EXTERN void gnonograms_simple_random_game_generator_set_grade (GnonogramsSimpleRandomGameGenerator* self,
                                                        GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_view_set_game_grade (GnonogramsView* self,
                                     GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_view_show_working (GnonogramsView* self,
                                   GCancellable* cancellable,
                                   const gchar* text);
VALA_EXTERN void gnonograms_simple_random_game_generator_generate (GnonogramsSimpleRandomGameGenerator* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
VALA_EXTERN gboolean gnonograms_simple_random_game_generator_generate_finish (GnonogramsSimpleRandomGameGenerator* self,
                                                                  GAsyncResult* _res_);
static void __lambda43_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
VALA_EXTERN void gnonograms_model_set_solution_from_array (GnonogramsModel* self,
                                               GnonogramsMy2DCellArray* array);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_simple_random_game_generator_get_solution (GnonogramsSimpleRandomGameGenerator* self);
VALA_EXTERN GnonogramsDifficulty gnonograms_simple_random_game_generator_get_solution_grade (GnonogramsSimpleRandomGameGenerator* self);
VALA_EXTERN void gnonograms_view_send_notification (GnonogramsView* self,
                                        const gchar* text);
VALA_EXTERN void gnonograms_view_end_working (GnonogramsView* self);
static void ___lambda43__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gchar* gnonograms_controller_write_game (GnonogramsController* self,
                                         const gchar* path,
                                         gboolean save_state);
static void gnonograms_controller_restore_settings (GnonogramsController* self);
static void gnonograms_controller_set_current_game_path (GnonogramsController* self,
                                                  const gchar* value);
VALA_EXTERN void gnonograms_view_set_cell_size (GnonogramsView* self,
                                    gint value);
VALA_EXTERN GtkWindow* gnonograms_controller_get_window (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_set_generator_grade (GnonogramsController* self,
                                                GnonogramsDifficulty value);
static void gnonograms_controller_restore_dimensions (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_set_dimensions (GnonogramsController* self,
                                           GnonogramsDimensions * value);
static void gnonograms_controller_restore_game_data_free (gpointer _data);
static void gnonograms_controller_restore_game (GnonogramsController* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean gnonograms_controller_restore_game_finish (GnonogramsController* self,
                                                    GAsyncResult* _res_);
static gboolean gnonograms_controller_restore_game_co (GnonogramsControllerRestoreGameData* _data_);
static void gnonograms_controller_load_game_async (GnonogramsController* self,
                                            GFile* game,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gboolean gnonograms_controller_load_game_finish (GnonogramsController* self,
                                                 GAsyncResult* _res_);
static void gnonograms_controller_restore_game_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN GType gnonograms_filewriter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsFilewriter, g_object_unref)
VALA_EXTERN gchar** gnonograms_view_get_clues (GnonogramsView* self,
                                   gboolean is_column,
                                   gint* result_length1);
VALA_EXTERN gboolean gnonograms_model_solution_is_blank (GnonogramsModel* self);
VALA_EXTERN GnonogramsFilewriter* gnonograms_filewriter_new (GtkWindow* parent,
                                                 GnonogramsDimensions* dimensions,
                                                 gchar** row_clues,
                                                 gint row_clues_length1,
                                                 gchar** col_clues,
                                                 gint col_clues_length1,
                                                 GnonogramsHistory* history,
                                                 gboolean save_solution,
                                                 GError** error);
VALA_EXTERN GnonogramsFilewriter* gnonograms_filewriter_construct (GType object_type,
                                                       GtkWindow* parent,
                                                       GnonogramsDimensions* dimensions,
                                                       gchar** row_clues,
                                                       gint row_clues_length1,
                                                       gchar** col_clues,
                                                       gint col_clues_length1,
                                                       GnonogramsHistory* history,
                                                       gboolean save_solution,
                                                       GError** error);
VALA_EXTERN GnonogramsDifficulty gnonograms_view_get_game_grade (GnonogramsView* self);
VALA_EXTERN void gnonograms_filewriter_set_difficulty (GnonogramsFilewriter* self,
                                           GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_filewriter_set_game_state (GnonogramsFilewriter* self,
                                           GnonogramsGameState value);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_model_copy_working_data (GnonogramsModel* self);
VALA_EXTERN void gnonograms_filewriter_set_working (GnonogramsFilewriter* self,
                                        GnonogramsMy2DCellArray* value);
VALA_EXTERN gboolean gnonograms_filewriter_get_save_solution (GnonogramsFilewriter* self);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_model_copy_solution_data (GnonogramsModel* self);
VALA_EXTERN void gnonograms_filewriter_set_solution (GnonogramsFilewriter* self,
                                         GnonogramsMy2DCellArray* value);
VALA_EXTERN gboolean gnonograms_controller_get_is_readonly (GnonogramsController* self);
VALA_EXTERN void gnonograms_filewriter_set_is_readonly (GnonogramsFilewriter* self,
                                            gboolean value);
VALA_EXTERN void gnonograms_filewriter_write_position_file (GnonogramsFilewriter* self,
                                                const gchar* save_dir_path,
                                                const gchar* path,
                                                const gchar* name,
                                                GError** error);
VALA_EXTERN void gnonograms_filewriter_write_game_file (GnonogramsFilewriter* self,
                                            const gchar* save_dir_path,
                                            const gchar* path,
                                            const gchar* _name,
                                            GError** error);
VALA_EXTERN const gchar* gnonograms_filewriter_get_game_path (GnonogramsFilewriter* self);
VALA_EXTERN void gnonograms_utils_show_error_dialog (const gchar* primary_text,
                                         const gchar* secondary_text,
                                         GtkWindow* parent);
VALA_EXTERN void gnonograms_controller_load_game (GnonogramsController* self,
                                      GFile* game);
static void __lambda44_ (GnonogramsController* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda44__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void gnonograms_controller_load_game_async_data_free (gpointer _data);
static gboolean gnonograms_controller_load_game_async_co (GnonogramsControllerLoadGameAsyncData* _data_);
VALA_EXTERN GType gnonograms_filereader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsFilereader, g_object_unref)
VALA_EXTERN GnonogramsFilereader* gnonograms_filereader_new (GtkWindow* parent,
                                                 const gchar* load_dir_path,
                                                 GFile* game,
                                                 GError** error);
VALA_EXTERN GnonogramsFilereader* gnonograms_filereader_construct (GType object_type,
                                                       GtkWindow* parent,
                                                       const gchar* load_dir_path,
                                                       GFile* game,
                                                       GError** error);
VALA_EXTERN GFile* gnonograms_filereader_get_game_file (GnonogramsFilereader* self);
VALA_EXTERN gboolean gnonograms_filereader_get_valid (GnonogramsFilereader* self);
static void gnonograms_controller_load_common (GnonogramsController* self,
                                        GnonogramsFilereader* reader,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean gnonograms_controller_load_common_finish (GnonogramsController* self,
                                                   GAsyncResult* _res_);
static void gnonograms_controller_load_game_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN GnonogramsGameState gnonograms_filereader_get_state (GnonogramsFilereader* self);
VALA_EXTERN void gnonograms_history_from_string (GnonogramsHistory* self,
                                     const gchar* s);
VALA_EXTERN const gchar* gnonograms_filereader_get_moves (GnonogramsFilereader* self);
VALA_EXTERN gboolean gnonograms_history_get_can_go_back (GnonogramsHistory* self);
VALA_EXTERN gpointer gnonograms_move_ref (gpointer instance);
VALA_EXTERN void gnonograms_move_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
VALA_EXTERN void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_move (const GValue* value);
VALA_EXTERN GType gnonograms_move_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
static void gnonograms_controller_make_move (GnonogramsController* self,
                                      GnonogramsMove* mv);
VALA_EXTERN GnonogramsMove* gnonograms_history_get_current_move (GnonogramsHistory* self);
static void gnonograms_controller_load_common_data_free (gpointer _data);
static gboolean gnonograms_controller_load_common_co (GnonogramsControllerLoadCommonData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gboolean gnonograms_filereader_get_has_dimensions (GnonogramsFilereader* self);
VALA_EXTERN gint gnonograms_filereader_get_rows (GnonogramsFilereader* self);
VALA_EXTERN gint gnonograms_filereader_get_cols (GnonogramsFilereader* self);
static gboolean __lambda13_ (Block3Data* _data3_);
VALA_EXTERN void gnonograms_model_blank_working (GnonogramsModel* self);
VALA_EXTERN gboolean gnonograms_filereader_get_has_solution (GnonogramsFilereader* self);
VALA_EXTERN GnonogramsDifficulty gnonograms_filereader_get_difficulty (GnonogramsFilereader* self);
VALA_EXTERN gboolean gnonograms_filereader_get_has_row_clues (GnonogramsFilereader* self);
VALA_EXTERN gboolean gnonograms_filereader_get_has_col_clues (GnonogramsFilereader* self);
VALA_EXTERN void gnonograms_view_update_labels_from_string_array (GnonogramsView* self,
                                                      gchar** clues,
                                                      gint clues_length1,
                                                      gboolean is_column);
VALA_EXTERN gchar** gnonograms_filereader_get_row_clues (GnonogramsFilereader* self,
                                             gint* result_length1);
VALA_EXTERN gchar** gnonograms_filereader_get_col_clues (GnonogramsFilereader* self,
                                             gint* result_length1);
VALA_EXTERN void gnonograms_model_set_solution_data_from_string_array (GnonogramsModel* self,
                                                           gchar** row_data_strings,
                                                           gint row_data_strings_length1);
VALA_EXTERN gchar** gnonograms_filereader_get_solution (GnonogramsFilereader* self,
                                            gint* result_length1);
VALA_EXTERN const gchar* gnonograms_filereader_get_name (GnonogramsFilereader* self);
VALA_EXTERN gboolean gnonograms_filereader_get_has_working (GnonogramsFilereader* self);
VALA_EXTERN void gnonograms_model_set_working_data_from_string_array (GnonogramsModel* self,
                                                          gchar** row_data_strings,
                                                          gint row_data_strings_length1);
VALA_EXTERN gchar** gnonograms_filereader_get_working (GnonogramsFilereader* self,
                                           gint* result_length1);
static gboolean ___lambda13__gsource_func (gpointer self);
VALA_EXTERN gboolean gnonograms_filereader_get_is_readonly (GnonogramsFilereader* self);
VALA_EXTERN const gchar* gnonograms_filereader_get_original_path (GnonogramsFilereader* self);
VALA_EXTERN gint gnonograms_controller_rewind_until_correct (GnonogramsController* self);
VALA_EXTERN gint gnonograms_model_count_errors (GnonogramsModel* self);
VALA_EXTERN gboolean gnonograms_controller_previous_move (GnonogramsController* self);
VALA_EXTERN void gnonograms_view_make_move (GnonogramsView* self,
                                GnonogramsMove* m);
VALA_EXTERN void gnonograms_history_clear_all (GnonogramsHistory* self);
static gboolean gnonograms_controller_computer_hint (GnonogramsController* self);
VALA_EXTERN void gnonograms_solver_configure_from_grade (GnonogramsSolver* self,
                                             GnonogramsDifficulty grade);
VALA_EXTERN GeeArrayQueue* gnonograms_solver_hint (GnonogramsSolver* self,
                                       gchar** row_clues,
                                       gint row_clues_length1,
                                       gchar** col_clues,
                                       gint col_clues_length1,
                                       GnonogramsMy2DCellArray* working);
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN void gnonograms_history_record_move (GnonogramsHistory* self,
                                     GnonogramsCell* cell,
                                     GnonogramsCellState previous_state);
VALA_EXTERN void gnonograms_controller_after_cell_changed (GnonogramsController* self,
                                               GnonogramsCell* cell,
                                               GnonogramsCellState previous_state);
VALA_EXTERN gboolean gnonograms_model_get_is_finished (GnonogramsModel* self);
VALA_EXTERN gboolean gnonograms_model_working_matches_clues (GnonogramsModel* self);
VALA_EXTERN GType gnonograms_solver_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gnonograms_solver_set_state (GnonogramsSolver* self,
                                  GnonogramsSolverState value);
VALA_EXTERN gboolean gnonograms_controller_next_move (GnonogramsController* self);
VALA_EXTERN gboolean gnonograms_history_get_can_go_forward (GnonogramsHistory* self);
VALA_EXTERN GnonogramsMove* gnonograms_history_pop_next_move (GnonogramsHistory* self);
VALA_EXTERN GnonogramsMove* gnonograms_history_pop_previous_move (GnonogramsHistory* self);
static gboolean gnonograms_controller_on_view_deleted (GnonogramsController* self);
static gboolean gnonograms_controller_on_view_configure (GnonogramsController* self);
static gboolean __lambda45_ (GnonogramsController* self);
VALA_EXTERN gint gnonograms_view_get_cell_size (GnonogramsView* self);
static gboolean ___lambda45__gsource_func (gpointer self);
VALA_EXTERN void gnonograms_controller_save_game (GnonogramsController* self);
VALA_EXTERN const gchar* gnonograms_controller_get_current_game_path (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_save_game_as (GnonogramsController* self);
static void gnonograms_controller_notify_saved (GnonogramsController* self,
                                         const gchar* path);
VALA_EXTERN void gnonograms_controller_open_game (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_computer_solve (GnonogramsController* self);
static void gnonograms_controller_start_solving (GnonogramsController* self,
                                          gboolean copy_to_working,
                                          gboolean copy_to_solution,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static GnonogramsSolverState gnonograms_controller_start_solving_finish (GnonogramsController* self,
                                                                  GAsyncResult* _res_);
VALA_EXTERN void gnonograms_controller_hint (GnonogramsController* self);
VALA_EXTERN gboolean gnonograms_solver_solved (GnonogramsSolver* self);
static void gnonograms_controller_start_solving_data_free (gpointer _data);
static gboolean gnonograms_controller_start_solving_co (GnonogramsControllerStartSolvingData* _data_);
VALA_EXTERN void gnonograms_solver_solve_clues (GnonogramsSolver* self,
                                    gchar** row_clues,
                                    gint row_clues_length1,
                                    gchar** col_clues,
                                    gint col_clues_length1,
                                    GnonogramsMy2DCellArray* start_grid,
                                    GnonogramsMy2DCellArray* solution_grid,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN GnonogramsDifficulty gnonograms_solver_solve_clues_finish (GnonogramsSolver* self,
                                                           GAsyncResult* _res_);
static void gnonograms_controller_start_solving_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
VALA_EXTERN GnonogramsSolverState gnonograms_solver_get_state (GnonogramsSolver* self);
VALA_EXTERN gboolean gnonograms_solver_state_solved (GnonogramsSolverState self);
VALA_EXTERN gchar* gnonograms_difficulty_to_string (GnonogramsDifficulty self);
VALA_EXTERN void gnonograms_model_copy_to_solution_data (GnonogramsModel* self,
                                             GnonogramsMy2DCellArray* grid);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_solver_get_grid (GnonogramsSolver* self);
VALA_EXTERN void gnonograms_model_copy_to_working_data (GnonogramsModel* self,
                                            GnonogramsMy2DCellArray* grid);
VALA_EXTERN void gnonograms_controller_restart (GnonogramsController* self);
VALA_EXTERN GnonogramsController* gnonograms_controller_new (void);
VALA_EXTERN GnonogramsController* gnonograms_controller_construct (GType object_type);
static gboolean _gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                                       const GnonogramsDimensions * s2);
static GObject * gnonograms_controller_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
VALA_EXTERN GnonogramsModel* gnonograms_model_new (GnonogramsController* controller);
VALA_EXTERN GnonogramsModel* gnonograms_model_construct (GType object_type,
                                             GnonogramsController* controller);
VALA_EXTERN GnonogramsView* gnonograms_view_new (GnonogramsModel* _model,
                                     GnonogramsController* controller);
VALA_EXTERN GnonogramsView* gnonograms_view_construct (GType object_type,
                                           GnonogramsModel* _model,
                                           GnonogramsController* controller);
VALA_EXTERN GnonogramsHistory* gnonograms_history_new (void);
VALA_EXTERN GnonogramsHistory* gnonograms_history_construct (GType object_type);
static gboolean _gnonograms_controller_on_view_deleted_gtk_widget_delete_event (GtkWidget* _sender,
                                                                         GdkEventAny* event,
                                                                         gpointer self);
static gboolean _gnonograms_controller_on_view_configure_gtk_widget_configure_event (GtkWidget* _sender,
                                                                              GdkEventConfigure* event,
                                                                              gpointer self);
static void _gnonograms_controller___lambda46_ (GnonogramsController* self);
static void __gnonograms_controller___lambda46__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _gnonograms_controller___lambda47_ (GnonogramsController* self);
VALA_EXTERN GnonogramsSolver* gnonograms_solver_new (GnonogramsDimensions* _dimensions);
VALA_EXTERN GnonogramsSolver* gnonograms_solver_construct (GType object_type,
                                               GnonogramsDimensions* _dimensions);
static void __gnonograms_controller___lambda47__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _gnonograms_controller___lambda48_ (GnonogramsController* self);
VALA_EXTERN void gnonograms_view_update_title (GnonogramsView* self);
static void __gnonograms_controller___lambda48__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _gnonograms_controller___lambda49_ (GnonogramsController* self,
                                         GObject* obj,
                                         GAsyncResult* res);
static void __gnonograms_controller___lambda49__gasync_ready_callback (GObject* source_object,
                                                                GAsyncResult* res,
                                                                gpointer self);
static void gnonograms_controller_finalize (GObject * obj);
static GType gnonograms_controller_get_type_once (void);
static void _vala_gnonograms_controller_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_gnonograms_controller_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gnonograms_controller_get_instance_private (GnonogramsController* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsController_private_offset);
}

static void
gnonograms_controller_new_or_random_game (GnonogramsController* self)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsGameState _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_game_state;
	if (_tmp1_ == GNONOGRAMS_GAME_STATE_SOLVING) {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_game_name;
		_tmp0_ = _tmp2_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gnonograms_controller_on_new_random_request (self);
	} else {
		gnonograms_controller_new_game (self);
	}
}

void
gnonograms_controller_quit (GnonogramsController* self)
{
	GnonogramsSolver* _tmp0_;
	GnonogramsSimpleRandomGameGenerator* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->solver;
	if (_tmp0_ != NULL) {
		GnonogramsSolver* _tmp1_;
		_tmp1_ = self->priv->solver;
		gnonograms_solver_cancel (_tmp1_);
	}
	_tmp2_ = self->priv->generator;
	if (_tmp2_ == NULL) {
		gnonograms_controller_save_game_state (self);
	} else {
		GnonogramsSimpleRandomGameGenerator* _tmp3_;
		_tmp3_ = self->priv->generator;
		gnonograms_simple_random_game_generator_cancel (_tmp3_);
	}
	g_signal_emit (self, gnonograms_controller_signals[GNONOGRAMS_CONTROLLER_QUIT_APP_SIGNAL], 0);
}

static void
gnonograms_controller_clear (GnonogramsController* self)
{
	GnonogramsModel* _tmp0_;
	GnonogramsView* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->model;
	gnonograms_model_clear (_tmp0_);
	_tmp1_ = self->priv->view;
	gnonograms_view_update_labels_from_solution (_tmp1_);
	gnonograms_controller_clear_history (self);
	gnonograms_controller_set_is_readonly (self, TRUE);
}

static void
gnonograms_controller_new_game (GnonogramsController* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_controller_clear (self);
	gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_SETTING);
	gnonograms_controller_set_game_name (self, _ (GNONOGRAMS_UNTITLED_NAME));
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		GnonogramsController* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda43_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* res)
{
	GnonogramsController* self;
	gboolean success = FALSE;
	GnonogramsSimpleRandomGameGenerator* _tmp0_;
	GnonogramsView* _tmp12_;
	self = _data2_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = self->priv->generator;
	success = gnonograms_simple_random_game_generator_generate_finish (_tmp0_, res);
	if (success) {
		GnonogramsModel* _tmp1_;
		GnonogramsSimpleRandomGameGenerator* _tmp2_;
		GnonogramsMy2DCellArray* _tmp3_;
		GnonogramsMy2DCellArray* _tmp4_;
		GnonogramsView* _tmp5_;
		GnonogramsView* _tmp6_;
		GnonogramsSimpleRandomGameGenerator* _tmp7_;
		GnonogramsDifficulty _tmp8_;
		GnonogramsDifficulty _tmp9_;
		_tmp1_ = self->priv->model;
		_tmp2_ = self->priv->generator;
		_tmp3_ = gnonograms_simple_random_game_generator_get_solution (_tmp2_);
		_tmp4_ = _tmp3_;
		gnonograms_model_set_solution_from_array (_tmp1_, _tmp4_);
		_g_object_unref0 (_tmp4_);
		gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_SOLVING);
		_tmp5_ = self->priv->view;
		gnonograms_view_update_labels_from_solution (_tmp5_);
		_tmp6_ = self->priv->view;
		_tmp7_ = self->priv->generator;
		_tmp8_ = gnonograms_simple_random_game_generator_get_solution_grade (_tmp7_);
		_tmp9_ = _tmp8_;
		gnonograms_view_set_game_grade (_tmp6_, _tmp9_);
	} else {
		gnonograms_controller_clear (self);
		gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_SETTING);
		if (g_cancellable_is_cancelled (_data2_->cancellable)) {
			GnonogramsView* _tmp10_;
			_tmp10_ = self->priv->view;
			gnonograms_view_send_notification (_tmp10_, _ ("Game generation was cancelled"));
		} else {
			GnonogramsView* _tmp11_;
			_tmp11_ = self->priv->view;
			gnonograms_view_send_notification (_tmp11_, _ ("Failed to generate game of required grade"));
		}
	}
	_tmp12_ = self->priv->view;
	gnonograms_view_end_working (_tmp12_);
	_g_object_unref0 (self->priv->generator);
	self->priv->generator = NULL;
}

static void
___lambda43__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda43_ (self, source_object, res);
	block2_data_unref (self);
}

static void
gnonograms_controller_on_new_random_request (GnonogramsController* self)
{
	Block2Data* _data2_;
	GnonogramsSolver* _tmp0_;
	GCancellable* _tmp1_;
	GnonogramsSolver* _tmp2_;
	GnonogramsDimensions _tmp3_;
	GnonogramsSolver* _tmp4_;
	GnonogramsDifficulty _tmp5_;
	GnonogramsSimpleRandomGameGenerator* _tmp6_ = NULL;
	GnonogramsView* _tmp7_;
	GnonogramsView* _tmp8_;
	GnonogramsSimpleRandomGameGenerator* _tmp9_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	gnonograms_controller_clear (self);
	_tmp0_ = self->priv->solver;
	gnonograms_solver_cancel (_tmp0_);
	_tmp1_ = g_cancellable_new ();
	_data2_->cancellable = _tmp1_;
	_tmp2_ = self->priv->solver;
	gnonograms_solver_set_cancellable (_tmp2_, _data2_->cancellable);
	_tmp3_ = self->priv->_dimensions;
	_tmp4_ = self->priv->solver;
	_tmp5_ = self->priv->_generator_grade;
	_tmp6_ = gnonograms_simple_random_game_generator_new (&_tmp3_, _tmp4_);
	gnonograms_simple_random_game_generator_set_grade (_tmp6_, _tmp5_);
	_g_object_unref0 (self->priv->generator);
	self->priv->generator = _tmp6_;
	gnonograms_controller_set_game_name (self, _ ("Random pattern"));
	_tmp7_ = self->priv->view;
	gnonograms_view_set_game_grade (_tmp7_, GNONOGRAMS_DIFFICULTY_UNDEFINED);
	_tmp8_ = self->priv->view;
	gnonograms_view_show_working (_tmp8_, _data2_->cancellable, _ ("Generating"));
	_tmp9_ = self->priv->generator;
	gnonograms_simple_random_game_generator_generate (_tmp9_, ___lambda43__gasync_ready_callback, block2_data_ref (_data2_));
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
gnonograms_controller_save_game_state (GnonogramsController* self)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->temporary_game_path;
	if (_tmp0_ != NULL) {
		{
			GFile* current_game_file = NULL;
			const gchar* _tmp1_;
			GFile* _tmp2_;
			GFile* _tmp3_;
			_tmp1_ = self->priv->temporary_game_path;
			_tmp2_ = g_file_new_for_path (_tmp1_);
			current_game_file = _tmp2_;
			_tmp3_ = current_game_file;
			g_file_delete (_tmp3_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (current_game_file);
				goto __catch0_g_error;
			}
			_g_object_unref0 (current_game_file);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp4_ = self->priv->temporary_game_path;
			_tmp5_ = e;
			_tmp6_ = _tmp5_->message;
			g_debug ("Controller.vala:214: Error deleting temporary game file %s - %s", _tmp4_, _tmp6_);
			_g_error_free0 (e);
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp7_ = self->priv->temporary_game_path;
			g_warning ("Controller.vala:216: writing unsaved game to %s", _tmp7_);
			_tmp8_ = self->priv->temporary_game_path;
			_tmp9_ = gnonograms_controller_write_game (self, _tmp8_, TRUE);
			_tmp10_ = _tmp9_;
			_g_free0 (_tmp10_);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	} else {
		g_warning ("Controller.vala:221: No temporary game path");
	}
}

static void
gnonograms_controller_restore_settings (GnonogramsController* self)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->saved_state;
	if (_tmp0_ != NULL) {
		gint x = 0;
		gint y = 0;
		gint cell_size = 0;
		GSettings* _tmp1_;
		gint _tmp2_ = 0;
		GSettings* _tmp3_;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		GSettings* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GnonogramsView* _tmp9_;
		GtkWindow* _tmp10_;
		GtkWindow* _tmp11_;
		_tmp1_ = self->priv->saved_state;
		g_settings_get (_tmp1_, "cell-size", "i", &_tmp2_);
		cell_size = _tmp2_;
		_tmp3_ = self->priv->saved_state;
		g_settings_get (_tmp3_, "window-position", "(ii)", &_tmp4_, &_tmp5_);
		x = _tmp4_;
		y = _tmp5_;
		_tmp6_ = self->priv->saved_state;
		_tmp7_ = g_settings_get_string (_tmp6_, "current-game-path");
		_tmp8_ = _tmp7_;
		gnonograms_controller_set_current_game_path (self, _tmp8_);
		_g_free0 (_tmp8_);
		_tmp9_ = self->priv->view;
		gnonograms_view_set_cell_size (_tmp9_, cell_size);
		_tmp10_ = gnonograms_controller_get_window (self);
		_tmp11_ = _tmp10_;
		gtk_window_move (_tmp11_, x, y);
	} else {
		g_critical ("Controller.vala:235: Unable to restore settings - using defaults");
		gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_SOLVING);
		gnonograms_controller_set_generator_grade (self, GNONOGRAMS_DIFFICULTY_MODERATE);
		gnonograms_controller_set_current_game_path (self, "");
	}
	gnonograms_controller_restore_dimensions (self);
}

static void
gnonograms_controller_restore_dimensions (GnonogramsController* self)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	if (_tmp0_ != NULL) {
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GnonogramsDimensions _tmp3_ = {0};
		_tmp1_ = self->priv->settings;
		_tmp2_ = self->priv->settings;
		_tmp3_.width = CLAMP (g_settings_get_uint (_tmp1_, "columns"), (guint) 10, (guint) 50);
		_tmp3_.height = CLAMP (g_settings_get_uint (_tmp2_, "rows"), (guint) 10, (guint) 50);
		gnonograms_controller_set_dimensions (self, &_tmp3_);
	} else {
		GnonogramsDimensions _tmp4_ = {0};
		_tmp4_.width = (guint) 15;
		_tmp4_.height = (guint) 10;
		gnonograms_controller_set_dimensions (self, &_tmp4_);
	}
}

static void
gnonograms_controller_restore_game_data_free (gpointer _data)
{
	GnonogramsControllerRestoreGameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsControllerRestoreGameData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gnonograms_controller_restore_game (GnonogramsController* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GnonogramsControllerRestoreGameData* _data_;
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsControllerRestoreGameData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_controller_restore_game_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	gnonograms_controller_restore_game_co (_data_);
}

static gboolean
gnonograms_controller_restore_game_finish (GnonogramsController* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	GnonogramsControllerRestoreGameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
gnonograms_controller_restore_game_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GnonogramsControllerRestoreGameData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_controller_restore_game_co (_data_);
}

static gboolean
gnonograms_controller_restore_game_co (GnonogramsControllerRestoreGameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->temporary_game_path;
	if (_data_->_tmp0_ != NULL) {
		_data_->_tmp1_ = _data_->self->priv->temporary_game_path;
		_data_->_tmp2_ = g_file_new_for_path (_data_->_tmp1_);
		_data_->current_game_file = _data_->_tmp2_;
		_data_->_tmp3_ = _data_->current_game_file;
		_data_->_state_ = 1;
		gnonograms_controller_load_game_async (_data_->self, _data_->_tmp3_, gnonograms_controller_restore_game_ready, _data_);
		return FALSE;
		_state_1:
		_data_->result = gnonograms_controller_load_game_finish (_data_->self, _data_->_res_);
		_g_object_unref0 (_data_->current_game_file);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	} else {
		_data_->result = FALSE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
}

static gchar*
gnonograms_controller_write_game (GnonogramsController* self,
                                  const gchar* path,
                                  gboolean save_state)
{
	GnonogramsFilewriter* file_writer = NULL;
	GnonogramsGameState gs = 0;
	GnonogramsGameState _tmp0_;
	GnonogramsFilewriter* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	file_writer = NULL;
	_tmp0_ = self->priv->_game_state;
	gs = _tmp0_;
	gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_UNDEFINED);
	{
		GnonogramsFilewriter* _tmp1_ = NULL;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
		GnonogramsDimensions _tmp4_;
		GnonogramsView* _tmp5_;
		gint _tmp6_ = 0;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		GnonogramsView* _tmp9_;
		gint _tmp10_ = 0;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		GnonogramsHistory* _tmp13_;
		GnonogramsModel* _tmp14_;
		GnonogramsFilewriter* _tmp15_;
		GnonogramsFilewriter* _tmp16_;
		GnonogramsFilewriter* _tmp17_;
		GnonogramsFilewriter* _tmp18_;
		GnonogramsView* _tmp19_;
		GnonogramsDifficulty _tmp20_;
		GnonogramsDifficulty _tmp21_;
		GnonogramsFilewriter* _tmp22_;
		GnonogramsFilewriter* _tmp23_;
		GnonogramsModel* _tmp24_;
		GnonogramsMy2DCellArray* _tmp25_;
		GnonogramsMy2DCellArray* _tmp26_;
		GnonogramsFilewriter* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
		GnonogramsFilewriter* _tmp34_;
		gboolean _tmp35_;
		_tmp2_ = gnonograms_controller_get_window (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->_dimensions;
		_tmp5_ = self->priv->view;
		_tmp7_ = gnonograms_view_get_clues (_tmp5_, FALSE, &_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp8__length1 = _tmp6_;
		_tmp9_ = self->priv->view;
		_tmp11_ = gnonograms_view_get_clues (_tmp9_, TRUE, &_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp12__length1 = _tmp10_;
		_tmp13_ = self->priv->history;
		_tmp14_ = self->priv->model;
		_tmp15_ = gnonograms_filewriter_new (_tmp3_, &_tmp4_, _tmp8_, _tmp6_, _tmp12_, _tmp10_, _tmp13_, !gnonograms_model_solution_is_blank (_tmp14_), &_inner_error0_);
		_tmp16_ = _tmp15_;
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
		_tmp1_ = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			_g_object_unref0 (file_writer);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp17_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (file_writer);
		file_writer = _tmp17_;
		_tmp18_ = file_writer;
		_tmp19_ = self->priv->view;
		_tmp20_ = gnonograms_view_get_game_grade (_tmp19_);
		_tmp21_ = _tmp20_;
		gnonograms_filewriter_set_difficulty (_tmp18_, _tmp21_);
		_tmp22_ = file_writer;
		gnonograms_filewriter_set_game_state (_tmp22_, gs);
		_tmp23_ = file_writer;
		_tmp24_ = self->priv->model;
		_tmp25_ = gnonograms_model_copy_working_data (_tmp24_);
		_tmp26_ = _tmp25_;
		gnonograms_filewriter_set_working (_tmp23_, _tmp26_);
		_g_object_unref0 (_tmp26_);
		_tmp27_ = file_writer;
		_tmp28_ = gnonograms_filewriter_get_save_solution (_tmp27_);
		_tmp29_ = _tmp28_;
		if (_tmp29_) {
			GnonogramsFilewriter* _tmp30_;
			GnonogramsModel* _tmp31_;
			GnonogramsMy2DCellArray* _tmp32_;
			GnonogramsMy2DCellArray* _tmp33_;
			_tmp30_ = file_writer;
			_tmp31_ = self->priv->model;
			_tmp32_ = gnonograms_model_copy_solution_data (_tmp31_);
			_tmp33_ = _tmp32_;
			gnonograms_filewriter_set_solution (_tmp30_, _tmp33_);
			_g_object_unref0 (_tmp33_);
		}
		_tmp34_ = file_writer;
		_tmp35_ = self->priv->_is_readonly;
		gnonograms_filewriter_set_is_readonly (_tmp34_, _tmp35_);
		if (save_state) {
			GnonogramsFilewriter* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			_tmp36_ = file_writer;
			_tmp37_ = self->priv->saved_games_folder;
			_tmp38_ = self->priv->_game_name;
			gnonograms_filewriter_write_position_file (_tmp36_, _tmp37_, path, _tmp38_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_object_unref0 (file_writer);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		} else {
			GnonogramsFilewriter* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			_tmp39_ = file_writer;
			_tmp40_ = self->priv->saved_games_folder;
			_tmp41_ = self->priv->_game_name;
			gnonograms_filewriter_write_game_file (_tmp39_, _tmp40_, path, _tmp41_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_object_unref0 (file_writer);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp42_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp42_ = e;
		if (!g_error_matches (_tmp42_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
			gchar* basename = NULL;
			GnonogramsFilewriter* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			GError* _tmp50_;
			const gchar* _tmp51_;
			_tmp43_ = file_writer;
			_tmp44_ = gnonograms_filewriter_get_game_path (_tmp43_);
			_tmp45_ = _tmp44_;
			_tmp46_ = g_path_get_basename (_tmp45_);
			basename = _tmp46_;
			_tmp47_ = basename;
			_tmp48_ = g_strdup_printf (_ ("Unable to save %s"), _tmp47_);
			_tmp49_ = _tmp48_;
			_tmp50_ = e;
			_tmp51_ = _tmp50_->message;
			gnonograms_utils_show_error_dialog (_tmp49_, _tmp51_, NULL);
			_g_free0 (_tmp49_);
			_g_free0 (basename);
		}
		result = NULL;
		_g_error_free0 (e);
		{
			GError* _inner_error0_ = NULL;
			gnonograms_controller_set_game_state (self, gs);
		}
		_g_object_unref0 (file_writer);
		return result;
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		gnonograms_controller_set_game_state (self, gs);
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file_writer);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp52_ = file_writer;
	_tmp53_ = gnonograms_filewriter_get_game_path (_tmp52_);
	_tmp54_ = _tmp53_;
	_tmp55_ = g_strdup (_tmp54_);
	result = _tmp55_;
	_g_object_unref0 (file_writer);
	return result;
}

static void
__lambda44_ (GnonogramsController* self,
             GObject* obj,
             GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	if (!gnonograms_controller_load_game_finish (self, res)) {
		g_warning ("Controller.vala:311: Load game failed");
		gnonograms_controller_set_current_game_path (self, "");
		gnonograms_controller_restore_dimensions (self);
		gnonograms_controller_new_or_random_game (self);
	}
}

static void
___lambda44__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda44_ ((GnonogramsController*) self, source_object, res);
	g_object_unref (self);
}

void
gnonograms_controller_load_game (GnonogramsController* self,
                                 GFile* game)
{
	g_return_if_fail (self != NULL);
	gnonograms_controller_load_game_async (self, game, ___lambda44__gasync_ready_callback, g_object_ref (self));
}

static void
gnonograms_controller_load_game_async_data_free (gpointer _data)
{
	GnonogramsControllerLoadGameAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->game);
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsControllerLoadGameAsyncData, _data_);
}

static void
gnonograms_controller_load_game_async (GnonogramsController* self,
                                       GFile* game,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	GnonogramsControllerLoadGameAsyncData* _data_;
	GnonogramsController* _tmp0_;
	GFile* _tmp1_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsControllerLoadGameAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_controller_load_game_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (game);
	_g_object_unref0 (_data_->game);
	_data_->game = _tmp1_;
	gnonograms_controller_load_game_async_co (_data_);
}

static gboolean
gnonograms_controller_load_game_finish (GnonogramsController* self,
                                        GAsyncResult* _res_)
{
	gboolean result;
	GnonogramsControllerLoadGameAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
gnonograms_controller_load_game_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	GnonogramsControllerLoadGameAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_controller_load_game_async_co (_data_);
}

static gboolean
gnonograms_controller_load_game_async_co (GnonogramsControllerLoadGameAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->reader = NULL;
	_data_->_tmp0_ = _data_->self->priv->_game_state;
	_data_->gs = _data_->_tmp0_;
	gnonograms_controller_set_game_state (_data_->self, GNONOGRAMS_GAME_STATE_UNDEFINED);
	gnonograms_controller_clear_history (_data_->self);
	{
		_data_->_tmp2_ = gnonograms_controller_get_window (_data_->self);
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp4_ = g_get_user_special_dir (G_USER_DIRECTORY_DOCUMENTS);
		_data_->_tmp5_ = gnonograms_filereader_new (_data_->_tmp3_, _data_->_tmp4_, _data_->game, &_data_->_inner_error0_);
		_data_->_tmp1_ = _data_->_tmp5_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp6_ = _data_->_tmp1_;
		_data_->_tmp1_ = NULL;
		_g_object_unref0 (_data_->reader);
		_data_->reader = _data_->_tmp6_;
		_g_object_unref0 (_data_->_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp7_ = _data_->e;
		if (!g_error_matches (_data_->_tmp7_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
			if (_data_->game != NULL) {
				_data_->_tmp9_ = g_file_get_basename (_data_->game);
				_g_free0 (_data_->_tmp8_);
				_data_->_tmp8_ = _data_->_tmp9_;
			} else {
				_data_->_tmp10_ = g_strdup (_ ("game"));
				_g_free0 (_data_->_tmp8_);
				_data_->_tmp8_ = _data_->_tmp10_;
			}
			_data_->_tmp11_ = g_strdup (_data_->_tmp8_);
			_data_->basename = _data_->_tmp11_;
			_data_->_tmp12_ = g_strdup ("");
			_data_->game_path = _data_->_tmp12_;
			_data_->_tmp14_ = _data_->reader;
			if (_data_->_tmp14_ != NULL) {
				_data_->_tmp15_ = _data_->reader;
				_data_->_tmp16_ = gnonograms_filereader_get_game_file (_data_->_tmp15_);
				_data_->_tmp17_ = _data_->_tmp16_;
				_data_->_tmp13_ = _data_->_tmp17_ != NULL;
			} else {
				_data_->_tmp13_ = FALSE;
			}
			if (_data_->_tmp13_) {
				_data_->_tmp18_ = _data_->reader;
				_data_->_tmp19_ = gnonograms_filereader_get_game_file (_data_->_tmp18_);
				_data_->_tmp20_ = _data_->_tmp19_;
				_data_->_tmp21_ = g_file_get_basename (_data_->_tmp20_);
				_g_free0 (_data_->basename);
				_data_->basename = _data_->_tmp21_;
				_data_->_tmp22_ = _data_->reader;
				_data_->_tmp23_ = gnonograms_filereader_get_game_file (_data_->_tmp22_);
				_data_->_tmp24_ = _data_->_tmp23_;
				_data_->_tmp25_ = g_file_get_uri (_data_->_tmp24_);
				_g_free0 (_data_->game_path);
				_data_->game_path = _data_->_tmp25_;
			}
			_data_->_tmp26_ = _data_->basename;
			if (g_strcmp0 (_data_->_tmp26_, GNONOGRAMS_UNSAVED_FILENAME) != 0) {
				_data_->_tmp28_ = _data_->game_path;
				if (_data_->_tmp28_ != NULL) {
					_data_->_tmp29_ = _data_->game_path;
					_data_->_tmp27_ = _data_->_tmp29_;
				} else {
					_data_->_tmp30_ = _data_->basename;
					_data_->_tmp27_ = _data_->_tmp30_;
				}
				_data_->_tmp31_ = _data_->self->priv->view;
				_data_->_tmp32_ = _data_->e;
				_data_->_tmp33_ = _data_->_tmp32_->message;
				_data_->_tmp34_ = g_strdup_printf (_ ("Error when loading game %s: %s"), _data_->_tmp27_, _data_->_tmp33_);
				_data_->_tmp35_ = _data_->_tmp34_;
				gnonograms_view_send_notification (_data_->_tmp31_, _data_->_tmp35_);
				_g_free0 (_data_->_tmp35_);
			}
			_g_free0 (_data_->game_path);
			_g_free0 (_data_->basename);
			_g_free0 (_data_->_tmp8_);
		}
		_data_->result = FALSE;
		_g_error_free0 (_data_->e);
		{
			gnonograms_controller_set_game_state (_data_->self, _data_->gs);
		}
		_g_object_unref0 (_data_->reader);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	{
		gnonograms_controller_set_game_state (_data_->self, _data_->gs);
	}
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->reader);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp37_ = _data_->reader;
	_data_->_tmp38_ = gnonograms_filereader_get_valid (_data_->_tmp37_);
	_data_->_tmp39_ = _data_->_tmp38_;
	if (_data_->_tmp39_) {
		_data_->_tmp40_ = _data_->reader;
		_data_->_state_ = 1;
		gnonograms_controller_load_common (_data_->self, _data_->_tmp40_, gnonograms_controller_load_game_async_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp36_ = gnonograms_controller_load_common_finish (_data_->self, _data_->_res_);
	} else {
		_data_->_tmp36_ = FALSE;
	}
	if (_data_->_tmp36_) {
		_data_->_tmp41_ = _data_->reader;
		_data_->_tmp42_ = gnonograms_filereader_get_state (_data_->_tmp41_);
		_data_->_tmp43_ = _data_->_tmp42_;
		if (_data_->_tmp43_ != GNONOGRAMS_GAME_STATE_UNDEFINED) {
			_data_->_tmp44_ = _data_->reader;
			_data_->_tmp45_ = gnonograms_filereader_get_state (_data_->_tmp44_);
			_data_->_tmp46_ = _data_->_tmp45_;
			gnonograms_controller_set_game_state (_data_->self, _data_->_tmp46_);
		} else {
			gnonograms_controller_set_game_state (_data_->self, GNONOGRAMS_GAME_STATE_SOLVING);
		}
		_data_->_tmp47_ = _data_->self->priv->history;
		_data_->_tmp48_ = _data_->reader;
		_data_->_tmp49_ = gnonograms_filereader_get_moves (_data_->_tmp48_);
		_data_->_tmp50_ = _data_->_tmp49_;
		gnonograms_history_from_string (_data_->_tmp47_, _data_->_tmp50_);
		_data_->_tmp51_ = _data_->self->priv->history;
		_data_->_tmp52_ = gnonograms_history_get_can_go_back (_data_->_tmp51_);
		_data_->_tmp53_ = _data_->_tmp52_;
		if (_data_->_tmp53_) {
			_data_->_tmp54_ = _data_->self->priv->history;
			_data_->_tmp55_ = gnonograms_history_get_current_move (_data_->_tmp54_);
			_data_->_tmp56_ = _data_->_tmp55_;
			gnonograms_controller_make_move (_data_->self, _data_->_tmp56_);
			_gnonograms_move_unref0 (_data_->_tmp56_);
		}
	} else {
		_data_->_tmp57_ = _data_->self->priv->view;
		_data_->_tmp58_ = _data_->reader;
		_data_->_tmp59_ = _data_->_tmp58_->err_msg;
		_data_->_tmp60_ = g_strdup_printf (_ ("Unable to load game. %s"), _data_->_tmp59_);
		_data_->_tmp61_ = _data_->_tmp60_;
		gnonograms_view_send_notification (_data_->_tmp57_, _data_->_tmp61_);
		_g_free0 (_data_->_tmp61_);
		_data_->result = FALSE;
		_g_object_unref0 (_data_->reader);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = TRUE;
	_g_object_unref0 (_data_->reader);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
gnonograms_controller_load_common_data_free (gpointer _data)
{
	GnonogramsControllerLoadCommonData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsControllerLoadCommonData, _data_);
}

static void
gnonograms_controller_load_common (GnonogramsController* self,
                                   GnonogramsFilereader* reader,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	GnonogramsControllerLoadCommonData* _data_;
	GnonogramsController* _tmp0_;
	GnonogramsFilereader* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (reader != NULL);
	_data_ = g_slice_new0 (GnonogramsControllerLoadCommonData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_controller_load_common_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (reader);
	_g_object_unref0 (_data_->reader);
	_data_->reader = _tmp1_;
	gnonograms_controller_load_common_co (_data_);
}

static gboolean
gnonograms_controller_load_common_finish (GnonogramsController* self,
                                          GAsyncResult* _res_)
{
	gboolean result;
	GnonogramsControllerLoadCommonData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		GnonogramsController* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->reader);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gboolean
__lambda13_ (Block3Data* _data3_)
{
	GnonogramsController* self;
	GnonogramsModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp28_ = FALSE;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean result;
	self = _data3_->self;
	_tmp0_ = self->priv->model;
	gnonograms_model_blank_working (_tmp0_);
	_tmp1_ = gnonograms_filereader_get_has_solution (_data3_->reader);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GnonogramsView* _tmp3_;
		GnonogramsDifficulty _tmp4_;
		GnonogramsDifficulty _tmp5_;
		_tmp3_ = self->priv->view;
		_tmp4_ = gnonograms_filereader_get_difficulty (_data3_->reader);
		_tmp5_ = _tmp4_;
		gnonograms_view_set_game_grade (_tmp3_, _tmp5_);
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = gnonograms_filereader_get_has_row_clues (_data3_->reader);
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp9_ = gnonograms_filereader_get_has_col_clues (_data3_->reader);
			_tmp10_ = _tmp9_;
			_tmp6_ = _tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			GnonogramsView* _tmp11_;
			gchar** _tmp12_;
			gint _tmp12__length1;
			gint _tmp13_ = 0;
			gchar** _tmp14_;
			gint _tmp14__length1;
			GnonogramsView* _tmp15_;
			gchar** _tmp16_;
			gint _tmp16__length1;
			gint _tmp17_ = 0;
			gchar** _tmp18_;
			gint _tmp18__length1;
			_tmp11_ = self->priv->view;
			_tmp12_ = gnonograms_filereader_get_row_clues (_data3_->reader, &_tmp13_);
			_tmp12__length1 = _tmp13_;
			_tmp14_ = _tmp12_;
			_tmp14__length1 = _tmp12__length1;
			gnonograms_view_update_labels_from_string_array (_tmp11_, _tmp14_, (gint) _tmp14__length1, FALSE);
			_tmp15_ = self->priv->view;
			_tmp16_ = gnonograms_filereader_get_col_clues (_data3_->reader, &_tmp17_);
			_tmp16__length1 = _tmp17_;
			_tmp18_ = _tmp16_;
			_tmp18__length1 = _tmp16__length1;
			gnonograms_view_update_labels_from_string_array (_tmp15_, _tmp18_, (gint) _tmp18__length1, TRUE);
		} else {
			gchar* _tmp19_;
			_tmp19_ = g_strdup (_ ("Clues missing"));
			_g_free0 (_data3_->reader->err_msg);
			_data3_->reader->err_msg = _tmp19_;
			result = FALSE;
			return result;
		}
	}
	_tmp20_ = gnonograms_filereader_get_has_solution (_data3_->reader);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		GnonogramsModel* _tmp22_;
		gchar** _tmp23_;
		gint _tmp23__length1;
		gint _tmp24_ = 0;
		gchar** _tmp25_;
		gint _tmp25__length1;
		GnonogramsDimensions _tmp26_;
		GnonogramsView* _tmp27_;
		_tmp22_ = self->priv->model;
		_tmp23_ = gnonograms_filereader_get_solution (_data3_->reader, &_tmp24_);
		_tmp23__length1 = _tmp24_;
		_tmp25_ = _tmp23_;
		_tmp25__length1 = _tmp23__length1;
		_tmp26_ = self->priv->_dimensions;
		gnonograms_model_set_solution_data_from_string_array (_tmp22_, _tmp25_ + 0, (gint) (((gint) _tmp26_.height) - 0));
		_tmp27_ = self->priv->view;
		gnonograms_view_update_labels_from_solution (_tmp27_);
	}
	_tmp29_ = gnonograms_filereader_get_name (_data3_->reader);
	_tmp30_ = _tmp29_;
	_tmp31_ = strlen (_tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_ > 1) {
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		_tmp33_ = gnonograms_filereader_get_name (_data3_->reader);
		_tmp34_ = _tmp33_;
		_tmp28_ = g_strcmp0 (_tmp34_, "") != 0;
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		_tmp35_ = gnonograms_filereader_get_name (_data3_->reader);
		_tmp36_ = _tmp35_;
		gnonograms_controller_set_game_name (self, _tmp36_);
	}
	_tmp37_ = gnonograms_filereader_get_has_working (_data3_->reader);
	_tmp38_ = _tmp37_;
	if (_tmp38_) {
		GnonogramsModel* _tmp39_;
		gchar** _tmp40_;
		gint _tmp40__length1;
		gint _tmp41_ = 0;
		gchar** _tmp42_;
		gint _tmp42__length1;
		GnonogramsDimensions _tmp43_;
		_tmp39_ = self->priv->model;
		_tmp40_ = gnonograms_filereader_get_working (_data3_->reader, &_tmp41_);
		_tmp40__length1 = _tmp41_;
		_tmp42_ = _tmp40_;
		_tmp42__length1 = _tmp40__length1;
		_tmp43_ = self->priv->_dimensions;
		gnonograms_model_set_working_data_from_string_array (_tmp39_, _tmp42_ + 0, (gint) (((gint) _tmp43_.height) - 0));
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ (self);
	return result;
}

static gboolean
gnonograms_controller_load_common_co (GnonogramsControllerLoadCommonData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data3_ = g_slice_new0 (Block3Data);
	_data_->_data3_->_ref_count_ = 1;
	_data_->_data3_->self = g_object_ref (_data_->self);
	_g_object_unref0 (_data_->_data3_->reader);
	_data_->_data3_->reader = _data_->reader;
	_data_->_data3_->_async_data_ = _data_;
	_data_->_tmp0_ = gnonograms_filereader_get_has_dimensions (_data_->_data3_->reader);
	_data_->_tmp1_ = _data_->_tmp0_;
	if (_data_->_tmp1_) {
		_data_->_tmp3_ = gnonograms_filereader_get_rows (_data_->_data3_->reader);
		_data_->_tmp4_ = _data_->_tmp3_;
		if (((guint) _data_->_tmp4_) > GNONOGRAMS_MAXSIZE) {
			_data_->_tmp2_ = TRUE;
		} else {
			_data_->_tmp5_ = gnonograms_filereader_get_cols (_data_->_data3_->reader);
			_data_->_tmp6_ = _data_->_tmp5_;
			_data_->_tmp2_ = ((guint) _data_->_tmp6_) > GNONOGRAMS_MAXSIZE;
		}
		if (_data_->_tmp2_) {
			_data_->_tmp7_ = g_strdup (_ ("Dimensions too large"));
			_g_free0 (_data_->_data3_->reader->err_msg);
			_data_->_data3_->reader->err_msg = _data_->_tmp7_;
			_data_->result = FALSE;
			block3_data_unref (_data_->_data3_);
			_data_->_data3_ = NULL;
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_data_->_tmp9_ = gnonograms_filereader_get_rows (_data_->_data3_->reader);
			_data_->_tmp10_ = _data_->_tmp9_;
			if (((guint) _data_->_tmp10_) < GNONOGRAMS_MINSIZE) {
				_data_->_tmp8_ = TRUE;
			} else {
				_data_->_tmp11_ = gnonograms_filereader_get_cols (_data_->_data3_->reader);
				_data_->_tmp12_ = _data_->_tmp11_;
				_data_->_tmp8_ = ((guint) _data_->_tmp12_) < GNONOGRAMS_MINSIZE;
			}
			if (_data_->_tmp8_) {
				_data_->_tmp13_ = g_strdup (_ ("Dimensions too small"));
				_g_free0 (_data_->_data3_->reader->err_msg);
				_data_->_data3_->reader->err_msg = _data_->_tmp13_;
				_data_->result = FALSE;
				block3_data_unref (_data_->_data3_);
				_data_->_data3_ = NULL;
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
				if (_data_->_state_ != 0) {
					while (!g_task_get_completed (_data_->_async_result)) {
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
					}
				}
				g_object_unref (_data_->_async_result);
				return FALSE;
			} else {
				_data_->_tmp14_ = gnonograms_filereader_get_cols (_data_->_data3_->reader);
				_data_->_tmp15_ = _data_->_tmp14_;
				_data_->_tmp16_ = gnonograms_filereader_get_rows (_data_->_data3_->reader);
				_data_->_tmp17_ = _data_->_tmp16_;
				memset (&_data_->_tmp18_, 0, sizeof (GnonogramsDimensions));
				_data_->_tmp18_.width = (guint) _data_->_tmp15_;
				_data_->_tmp18_.height = (guint) _data_->_tmp17_;
				_data_->_tmp19_ = _data_->_tmp18_;
				gnonograms_controller_set_dimensions (_data_->self, &_data_->_tmp19_);
			}
		}
	} else {
		_data_->_tmp20_ = g_strdup (_ ("Dimensions missing"));
		_g_free0 (_data_->_data3_->reader->err_msg);
		_data_->_data3_->reader->err_msg = _data_->_tmp20_;
		_data_->result = FALSE;
		block3_data_unref (_data_->_data3_);
		_data_->_data3_ = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda13__gsource_func, block3_data_ref (_data_->_data3_), block3_data_unref);
	_data_->_tmp21_ = gnonograms_filereader_get_is_readonly (_data_->_data3_->reader);
	_data_->_tmp22_ = _data_->_tmp21_;
	gnonograms_controller_set_is_readonly (_data_->self, _data_->_tmp22_);
	_data_->_tmp24_ = gnonograms_filereader_get_original_path (_data_->_data3_->reader);
	_data_->_tmp25_ = _data_->_tmp24_;
	if (_data_->_tmp25_ != NULL) {
		_data_->_tmp26_ = gnonograms_filereader_get_original_path (_data_->_data3_->reader);
		_data_->_tmp27_ = _data_->_tmp26_;
		_data_->_tmp23_ = g_strcmp0 (_data_->_tmp27_, "") != 0;
	} else {
		_data_->_tmp23_ = FALSE;
	}
	if (_data_->_tmp23_) {
		_data_->_tmp28_ = gnonograms_filereader_get_original_path (_data_->_data3_->reader);
		_data_->_tmp29_ = _data_->_tmp28_;
		gnonograms_controller_set_current_game_path (_data_->self, _data_->_tmp29_);
	} else {
		_data_->_tmp30_ = gnonograms_filereader_get_game_file (_data_->_data3_->reader);
		_data_->_tmp31_ = _data_->_tmp30_;
		_data_->_tmp32_ = g_file_get_path (_data_->_tmp31_);
		_data_->_tmp33_ = _data_->_tmp32_;
		gnonograms_controller_set_current_game_path (_data_->self, _data_->_tmp33_);
		_g_free0 (_data_->_tmp33_);
	}
	_data_->result = TRUE;
	block3_data_unref (_data_->_data3_);
	_data_->_data3_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gint
gnonograms_controller_rewind_until_correct (GnonogramsController* self)
{
	GnonogramsModel* _tmp0_;
	gint errors = 0;
	GnonogramsModel* _tmp2_;
	GnonogramsModel* _tmp5_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->model;
	if (gnonograms_model_solution_is_blank (_tmp0_)) {
		GnonogramsView* _tmp1_;
		_tmp1_ = self->priv->view;
		gnonograms_view_send_notification (_tmp1_, _ ("Cannot check for errors.  Solution unknown"));
		result = -1;
		return result;
	}
	_tmp2_ = self->priv->model;
	errors = gnonograms_model_count_errors (_tmp2_);
	while (TRUE) {
		gboolean _tmp3_ = FALSE;
		GnonogramsModel* _tmp4_;
		_tmp4_ = self->priv->model;
		if (gnonograms_model_count_errors (_tmp4_) > 0) {
			_tmp3_ = gnonograms_controller_previous_move (self);
		} else {
			_tmp3_ = FALSE;
		}
		if (!_tmp3_) {
			break;
		}
		continue;
	}
	_tmp5_ = self->priv->model;
	if (gnonograms_model_count_errors (_tmp5_) > 0) {
		GnonogramsModel* _tmp6_;
		_tmp6_ = self->priv->model;
		gnonograms_model_blank_working (_tmp6_);
		gnonograms_controller_clear_history (self);
	}
	if (errors > 0) {
		GnonogramsView* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = self->priv->view;
		_tmp8_ = g_strdup_printf (ngettext (_ ("%u error found"), _ ("%u errors found"), (gulong) errors), (guint) errors);
		_tmp9_ = _tmp8_;
		gnonograms_view_send_notification (_tmp7_, _tmp9_);
		_g_free0 (_tmp9_);
	}
	result = errors;
	return result;
}

static void
gnonograms_controller_make_move (GnonogramsController* self,
                                 GnonogramsMove* mv)
{
	GnonogramsView* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mv != NULL);
	_tmp0_ = self->priv->view;
	gnonograms_view_make_move (_tmp0_, mv);
}

static void
gnonograms_controller_clear_history (GnonogramsController* self)
{
	GnonogramsHistory* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->history;
	gnonograms_history_clear_all (_tmp0_);
}

static gboolean
gnonograms_controller_computer_hint (GnonogramsController* self)
{
	gchar** row_clues = NULL;
	gint row_clues_length1 = 0;
	gint _row_clues_size_ = 0;
	gchar** col_clues = NULL;
	gint col_clues_length1 = 0;
	gint _col_clues_size_ = 0;
	GnonogramsView* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GnonogramsView* _tmp3_;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	GnonogramsSolver* _tmp6_;
	GeeArrayQueue* moves = NULL;
	GnonogramsSolver* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	GnonogramsModel* _tmp10_;
	GnonogramsMy2DCellArray* _tmp11_;
	GnonogramsMy2DCellArray* _tmp12_;
	GeeArrayQueue* _tmp13_;
	GeeArrayQueue* _tmp14_;
	GeeArrayQueue* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->view;
	_tmp2_ = gnonograms_view_get_clues (_tmp0_, FALSE, &_tmp1_);
	row_clues = (_vala_array_free (row_clues, row_clues_length1, (GDestroyNotify) g_free), NULL);
	row_clues = _tmp2_;
	row_clues_length1 = _tmp1_;
	_row_clues_size_ = row_clues_length1;
	_tmp3_ = self->priv->view;
	_tmp5_ = gnonograms_view_get_clues (_tmp3_, TRUE, &_tmp4_);
	col_clues = (_vala_array_free (col_clues, col_clues_length1, (GDestroyNotify) g_free), NULL);
	col_clues = _tmp5_;
	col_clues_length1 = _tmp4_;
	_col_clues_size_ = col_clues_length1;
	_tmp6_ = self->priv->solver;
	gnonograms_solver_configure_from_grade (_tmp6_, GNONOGRAMS_DIFFICULTY_CHALLENGING);
	_tmp7_ = self->priv->solver;
	_tmp8_ = row_clues;
	_tmp8__length1 = row_clues_length1;
	_tmp9_ = col_clues;
	_tmp9__length1 = col_clues_length1;
	_tmp10_ = self->priv->model;
	_tmp11_ = gnonograms_model_copy_working_data (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = gnonograms_solver_hint (_tmp7_, _tmp8_, (gint) _tmp8__length1, _tmp9_, (gint) _tmp9__length1, _tmp12_);
	_tmp14_ = _tmp13_;
	_g_object_unref0 (_tmp12_);
	moves = _tmp14_;
	{
		GeeIterator* _mv_it = NULL;
		GeeArrayQueue* _tmp15_;
		GeeIterator* _tmp16_;
		_tmp15_ = moves;
		_tmp16_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp15_);
		_mv_it = _tmp16_;
		while (TRUE) {
			GeeIterator* _tmp17_;
			GnonogramsMove* mv = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			GnonogramsMove* _tmp20_;
			GnonogramsHistory* _tmp21_;
			GnonogramsMove* _tmp22_;
			GnonogramsCell _tmp23_;
			GnonogramsMove* _tmp24_;
			_tmp17_ = _mv_it;
			if (!gee_iterator_next (_tmp17_)) {
				break;
			}
			_tmp18_ = _mv_it;
			_tmp19_ = gee_iterator_get (_tmp18_);
			mv = (GnonogramsMove*) _tmp19_;
			_tmp20_ = mv;
			gnonograms_controller_make_move (self, _tmp20_);
			_tmp21_ = self->priv->history;
			_tmp22_ = mv;
			_tmp23_ = _tmp22_->cell;
			_tmp24_ = mv;
			gnonograms_history_record_move (_tmp21_, &_tmp23_, _tmp24_->previous_state);
			_gnonograms_move_unref0 (mv);
		}
		_g_object_unref0 (_mv_it);
	}
	_tmp25_ = moves;
	_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
	_tmp27_ = _tmp26_;
	result = _tmp27_ > 0;
	_g_object_unref0 (moves);
	col_clues = (_vala_array_free (col_clues, col_clues_length1, (GDestroyNotify) g_free), NULL);
	row_clues = (_vala_array_free (row_clues, row_clues_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

void
gnonograms_controller_after_cell_changed (GnonogramsController* self,
                                          GnonogramsCell* cell,
                                          GnonogramsCellState previous_state)
{
	GnonogramsHistory* _tmp0_;
	GnonogramsCell _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GnonogramsGameState _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	_tmp0_ = self->priv->history;
	_tmp1_ = *cell;
	gnonograms_history_record_move (_tmp0_, &_tmp1_, previous_state);
	_tmp4_ = self->priv->_game_state;
	if (_tmp4_ == GNONOGRAMS_GAME_STATE_SOLVING) {
		GnonogramsModel* _tmp5_;
		_tmp5_ = self->priv->model;
		_tmp3_ = !gnonograms_model_solution_is_blank (_tmp5_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GnonogramsModel* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->priv->model;
		_tmp7_ = gnonograms_model_get_is_finished (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = _tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GnonogramsModel* _tmp9_;
		GnonogramsView* _tmp14_;
		_tmp9_ = self->priv->model;
		if (gnonograms_model_count_errors (_tmp9_) == 0) {
			GnonogramsView* _tmp10_;
			_tmp10_ = self->priv->view;
			gnonograms_view_send_notification (_tmp10_, _ ("Correct solution"));
		} else {
			GnonogramsModel* _tmp11_;
			_tmp11_ = self->priv->model;
			if (gnonograms_model_working_matches_clues (_tmp11_)) {
				GnonogramsView* _tmp12_;
				_tmp12_ = self->priv->view;
				gnonograms_view_send_notification (_tmp12_, _ ("Alternative solution found"));
			} else {
				GnonogramsView* _tmp13_;
				_tmp13_ = self->priv->view;
				gnonograms_view_send_notification (_tmp13_, _ ("There are errors"));
			}
		}
		_tmp14_ = self->priv->view;
		gnonograms_view_end_working (_tmp14_);
	} else {
		GnonogramsGameState _tmp15_;
		_tmp15_ = self->priv->_game_state;
		if (_tmp15_ != GNONOGRAMS_GAME_STATE_SOLVING) {
			GnonogramsSolver* _tmp16_;
			_tmp16_ = self->priv->solver;
			gnonograms_solver_set_state (_tmp16_, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
		}
	}
}

gboolean
gnonograms_controller_next_move (GnonogramsController* self)
{
	GnonogramsHistory* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->history;
	_tmp1_ = gnonograms_history_get_can_go_forward (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GnonogramsHistory* _tmp3_;
		GnonogramsMove* _tmp4_;
		GnonogramsMove* _tmp5_;
		_tmp3_ = self->priv->history;
		_tmp4_ = gnonograms_history_pop_next_move (_tmp3_);
		_tmp5_ = _tmp4_;
		gnonograms_controller_make_move (self, _tmp5_);
		_gnonograms_move_unref0 (_tmp5_);
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

gboolean
gnonograms_controller_previous_move (GnonogramsController* self)
{
	GnonogramsHistory* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->history;
	_tmp1_ = gnonograms_history_get_can_go_back (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GnonogramsHistory* _tmp3_;
		GnonogramsMove* _tmp4_;
		GnonogramsMove* _tmp5_;
		_tmp3_ = self->priv->history;
		_tmp4_ = gnonograms_history_pop_previous_move (_tmp3_);
		_tmp5_ = _tmp4_;
		gnonograms_controller_make_move (self, _tmp5_);
		_gnonograms_move_unref0 (_tmp5_);
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static gboolean
gnonograms_controller_on_view_deleted (GnonogramsController* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_controller_quit (self);
	result = FALSE;
	return result;
}

static gboolean
__lambda45_ (GnonogramsController* self)
{
	gint x_pos = 0;
	gint y_pos = 0;
	GnonogramsView* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GnonogramsView* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result;
	self->priv->configure_id = (guint) 0;
	_tmp0_ = self->priv->view;
	gtk_window_get_position ((GtkWindow*) _tmp0_, &_tmp1_, &_tmp2_);
	x_pos = _tmp1_;
	y_pos = _tmp2_;
	_tmp3_ = self->priv->saved_state;
	g_settings_set (_tmp3_, "window-position", "(ii)", x_pos, y_pos);
	_tmp4_ = self->priv->saved_state;
	_tmp5_ = self->priv->view;
	_tmp6_ = gnonograms_view_get_cell_size (_tmp5_);
	_tmp7_ = _tmp6_;
	g_settings_set (_tmp4_, "cell-size", "i", _tmp7_);
	result = FALSE;
	return result;
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((GnonogramsController*) self);
	return result;
}

static gboolean
gnonograms_controller_on_view_configure (GnonogramsController* self)
{
	GSettings* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->saved_state;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	if (self->priv->configure_id != ((guint) 0)) {
		g_source_remove (self->priv->configure_id);
	}
	self->priv->configure_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda45__gsource_func, g_object_ref (self), g_object_unref);
	result = FALSE;
	return result;
}

void
gnonograms_controller_save_game (GnonogramsController* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_is_readonly;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_current_game_path;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		gnonograms_controller_save_game_as (self);
	} else {
		gchar* path = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		_tmp3_ = self->priv->_current_game_path;
		_tmp4_ = gnonograms_controller_write_game (self, _tmp3_, FALSE);
		path = _tmp4_;
		_tmp6_ = path;
		if (_tmp6_ != NULL) {
			const gchar* _tmp7_;
			_tmp7_ = path;
			_tmp5_ = g_strcmp0 (_tmp7_, "") != 0;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = path;
			gnonograms_controller_set_current_game_path (self, _tmp8_);
			_tmp9_ = path;
			gnonograms_controller_notify_saved (self, _tmp9_);
		}
		_g_free0 (path);
	}
}

void
gnonograms_controller_save_game_as (GnonogramsController* self)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gnonograms_controller_write_game (self, NULL, FALSE);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = path;
		gnonograms_controller_set_current_game_path (self, _tmp2_);
		_tmp3_ = path;
		gnonograms_controller_notify_saved (self, _tmp3_);
		gnonograms_controller_set_is_readonly (self, FALSE);
	}
	_g_free0 (path);
}

static void
gnonograms_controller_notify_saved (GnonogramsController* self,
                                    const gchar* path)
{
	GnonogramsView* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->view;
	_tmp1_ = g_strdup_printf (_ ("Saved to %s"), path);
	_tmp2_ = _tmp1_;
	gnonograms_view_send_notification (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
}

void
gnonograms_controller_open_game (GnonogramsController* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_controller_load_game_async (self, NULL, NULL, NULL);
}

void
gnonograms_controller_computer_solve (GnonogramsController* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_controller_set_game_state (self, GNONOGRAMS_GAME_STATE_SOLVING);
	gnonograms_controller_start_solving (self, TRUE, FALSE, NULL, NULL);
}

void
gnonograms_controller_hint (GnonogramsController* self)
{
	GnonogramsGameState _tmp0_;
	gboolean _tmp1_ = FALSE;
	GnonogramsModel* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_game_state;
	if (_tmp0_ != GNONOGRAMS_GAME_STATE_SOLVING) {
		return;
	}
	_tmp2_ = self->priv->model;
	if (!gnonograms_model_solution_is_blank (_tmp2_)) {
		GnonogramsModel* _tmp3_;
		_tmp3_ = self->priv->model;
		_tmp1_ = gnonograms_model_count_errors (_tmp3_) > 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gnonograms_controller_rewind_until_correct (self);
	} else {
		gboolean _tmp4_ = FALSE;
		if (!gnonograms_controller_computer_hint (self)) {
			GnonogramsSolver* _tmp5_;
			_tmp5_ = self->priv->solver;
			_tmp4_ = !gnonograms_solver_solved (_tmp5_);
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			GnonogramsView* _tmp6_;
			_tmp6_ = self->priv->view;
			gnonograms_view_send_notification (_tmp6_, _ ("Failed to find a hint using simple logic - multi-line logic (trial and" \
" error) required"));
		}
	}
}

static void
gnonograms_controller_start_solving_data_free (gpointer _data)
{
	GnonogramsControllerStartSolvingData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (GnonogramsControllerStartSolvingData, _data_);
}

static void
gnonograms_controller_start_solving (GnonogramsController* self,
                                     gboolean copy_to_working,
                                     gboolean copy_to_solution,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GnonogramsControllerStartSolvingData* _data_;
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (GnonogramsControllerStartSolvingData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gnonograms_controller_start_solving_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->copy_to_working = copy_to_working;
	_data_->copy_to_solution = copy_to_solution;
	gnonograms_controller_start_solving_co (_data_);
}

static GnonogramsSolverState
gnonograms_controller_start_solving_finish (GnonogramsController* self,
                                            GAsyncResult* _res_)
{
	GnonogramsSolverState result;
	GnonogramsControllerStartSolvingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
gnonograms_controller_start_solving_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	GnonogramsControllerStartSolvingData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	gnonograms_controller_start_solving_co (_data_);
}

static gboolean
gnonograms_controller_start_solving_co (GnonogramsControllerStartSolvingData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->state = GNONOGRAMS_SOLVER_STATE_UNDEFINED;
	_data_->_tmp0_ = g_cancellable_new ();
	_data_->cancellable = _data_->_tmp0_;
	_data_->diff = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	_data_->_tmp1_ = g_strdup ("");
	_data_->msg = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->self->priv->solver;
	gnonograms_solver_cancel (_data_->_tmp2_);
	_data_->_tmp3_ = _data_->self->priv->solver;
	_data_->_tmp4_ = _data_->cancellable;
	gnonograms_solver_set_cancellable (_data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = _data_->self->priv->view;
	_data_->_tmp6_ = _data_->cancellable;
	gnonograms_view_show_working (_data_->_tmp5_, _data_->_tmp6_, _ ("Solving"));
	_data_->_tmp7_ = _data_->self->priv->solver;
	gnonograms_solver_configure_from_grade (_data_->_tmp7_, GNONOGRAMS_DIFFICULTY_COMPUTER);
	_data_->_tmp8_ = _data_->self->priv->solver;
	_data_->_tmp9_ = _data_->self->priv->view;
	_data_->_tmp10_ = 0;
	_data_->_tmp11_ = gnonograms_view_get_clues (_data_->_tmp9_, FALSE, &_data_->_tmp10_);
	_data_->_tmp12_ = _data_->_tmp11_;
	_data_->_tmp12__length1 = _data_->_tmp10_;
	_data_->_tmp13_ = _data_->self->priv->view;
	_data_->_tmp14_ = 0;
	_data_->_tmp15_ = gnonograms_view_get_clues (_data_->_tmp13_, TRUE, &_data_->_tmp14_);
	_data_->_tmp16_ = _data_->_tmp15_;
	_data_->_tmp16__length1 = _data_->_tmp14_;
	_data_->_state_ = 1;
	gnonograms_solver_solve_clues (_data_->_tmp8_, _data_->_tmp12_, (gint) _data_->_tmp10_, _data_->_tmp16_, (gint) _data_->_tmp14_, NULL, NULL, gnonograms_controller_start_solving_ready, _data_);
	return FALSE;
	_state_1:
	_data_->diff = gnonograms_solver_solve_clues_finish (_data_->_tmp8_, _data_->_res_);
	_data_->_tmp16_ = (_vala_array_free (_data_->_tmp16_, _data_->_tmp16__length1, (GDestroyNotify) g_free), NULL);
	_data_->_tmp12_ = (_vala_array_free (_data_->_tmp12_, _data_->_tmp12__length1, (GDestroyNotify) g_free), NULL);
	_data_->_tmp18_ = _data_->cancellable;
	if (_data_->_tmp18_ != NULL) {
		_data_->_tmp19_ = _data_->cancellable;
		_data_->_tmp17_ = g_cancellable_is_cancelled (_data_->_tmp19_);
	} else {
		_data_->_tmp17_ = FALSE;
	}
	if (_data_->_tmp17_) {
		_data_->_tmp20_ = g_strdup (_ ("Solving was cancelled"));
		_g_free0 (_data_->msg);
		_data_->msg = _data_->_tmp20_;
	} else {
		_data_->_tmp21_ = _data_->self->priv->solver;
		_data_->_tmp22_ = gnonograms_solver_get_state (_data_->_tmp21_);
		_data_->_tmp23_ = _data_->_tmp22_;
		if (gnonograms_solver_state_solved (_data_->_tmp23_)) {
			_data_->_tmp24_ = gnonograms_difficulty_to_string (_data_->diff);
			_data_->_tmp25_ = _data_->_tmp24_;
			_data_->_tmp26_ = g_strdup_printf (_ ("Solution found. %s"), _data_->_tmp25_);
			_g_free0 (_data_->msg);
			_data_->msg = _data_->_tmp26_;
			_g_free0 (_data_->_tmp25_);
		} else {
			_data_->_tmp27_ = g_strdup (_ ("No solution found"));
			_g_free0 (_data_->msg);
			_data_->msg = _data_->_tmp27_;
		}
	}
	_data_->_tmp28_ = _data_->msg;
	if (g_strcmp0 (_data_->_tmp28_, "") != 0) {
		_data_->_tmp29_ = _data_->self->priv->view;
		_data_->_tmp30_ = _data_->msg;
		gnonograms_view_send_notification (_data_->_tmp29_, _data_->_tmp30_);
	}
	_data_->_tmp31_ = _data_->self->priv->view;
	gnonograms_view_set_game_grade (_data_->_tmp31_, _data_->diff);
	_data_->_tmp32_ = _data_->self->priv->solver;
	_data_->_tmp33_ = gnonograms_solver_get_state (_data_->_tmp32_);
	_data_->_tmp34_ = _data_->_tmp33_;
	if (gnonograms_solver_state_solved (_data_->_tmp34_)) {
		gnonograms_controller_set_game_state (_data_->self, GNONOGRAMS_GAME_STATE_SOLVING);
		if (_data_->copy_to_solution) {
			_data_->_tmp35_ = _data_->self->priv->model;
			_data_->_tmp36_ = _data_->self->priv->solver;
			_data_->_tmp37_ = gnonograms_solver_get_grid (_data_->_tmp36_);
			_data_->_tmp38_ = _data_->_tmp37_;
			gnonograms_model_copy_to_solution_data (_data_->_tmp35_, _data_->_tmp38_);
		}
	}
	if (_data_->copy_to_working) {
		_data_->_tmp39_ = _data_->self->priv->model;
		_data_->_tmp40_ = _data_->self->priv->solver;
		_data_->_tmp41_ = gnonograms_solver_get_grid (_data_->_tmp40_);
		_data_->_tmp42_ = _data_->_tmp41_;
		gnonograms_model_copy_to_working_data (_data_->_tmp39_, _data_->_tmp42_);
	}
	_data_->_tmp43_ = _data_->self->priv->view;
	gnonograms_view_end_working (_data_->_tmp43_);
	_data_->result = _data_->state;
	_g_free0 (_data_->msg);
	_g_object_unref0 (_data_->cancellable);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
gnonograms_controller_restart (GnonogramsController* self)
{
	GnonogramsGameState _tmp0_;
	GnonogramsView* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_game_state;
	if (_tmp0_ == GNONOGRAMS_GAME_STATE_SETTING) {
		gnonograms_controller_new_game (self);
	} else {
		GnonogramsModel* _tmp1_;
		_tmp1_ = self->priv->model;
		gnonograms_model_blank_working (_tmp1_);
		gnonograms_controller_clear_history (self);
	}
	_tmp2_ = self->priv->view;
	gnonograms_view_end_working (_tmp2_);
}

GnonogramsController*
gnonograms_controller_construct (GType object_type)
{
	GnonogramsController * self = NULL;
	self = (GnonogramsController*) g_object_new (object_type, NULL);
	return self;
}

GnonogramsController*
gnonograms_controller_new (void)
{
	return gnonograms_controller_construct (GNONOGRAMS_TYPE_CONTROLLER);
}

GtkWindow*
gnonograms_controller_get_window (GnonogramsController* self)
{
	GtkWindow* result;
	GnonogramsView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->view;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow);
	return result;
}

GnonogramsGameState
gnonograms_controller_get_game_state (GnonogramsController* self)
{
	GnonogramsGameState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_game_state;
	return result;
}

void
gnonograms_controller_set_game_state (GnonogramsController* self,
                                      GnonogramsGameState value)
{
	GnonogramsGameState old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_controller_get_game_state (self);
	if (old_value != value) {
		self->priv->_game_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY]);
	}
}

void
gnonograms_controller_get_dimensions (GnonogramsController* self,
                                      GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                              const GnonogramsDimensions * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_controller_set_dimensions (GnonogramsController* self,
                                      GnonogramsDimensions * value)
{
	GnonogramsDimensions old_value;
	g_return_if_fail (self != NULL);
	gnonograms_controller_get_dimensions (self, &old_value);
	if (_gnonograms_dimensions_equal (value, &old_value) != TRUE) {
		GnonogramsDimensions _tmp0_;
		_tmp0_ = *value;
		self->priv->_dimensions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_controller_get_generator_grade (GnonogramsController* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_generator_grade;
	return result;
}

void
gnonograms_controller_set_generator_grade (GnonogramsController* self,
                                           GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_controller_get_generator_grade (self);
	if (old_value != value) {
		self->priv->_generator_grade = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY]);
	}
}

const gchar*
gnonograms_controller_get_game_name (GnonogramsController* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_game_name;
	result = _tmp0_;
	return result;
}

void
gnonograms_controller_set_game_name (GnonogramsController* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_controller_get_game_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_game_name);
		self->priv->_game_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY]);
	}
}

gboolean
gnonograms_controller_get_is_readonly (GnonogramsController* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_readonly;
	return result;
}

void
gnonograms_controller_set_is_readonly (GnonogramsController* self,
                                       gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_controller_get_is_readonly (self);
	if (old_value != value) {
		self->priv->_is_readonly = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY]);
	}
}

const gchar*
gnonograms_controller_get_current_game_path (GnonogramsController* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_game_path;
	result = _tmp0_;
	return result;
}

static void
gnonograms_controller_set_current_game_path (GnonogramsController* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_controller_get_current_game_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_current_game_path);
		self->priv->_current_game_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY]);
	}
}

static gboolean
_gnonograms_controller_on_view_deleted_gtk_widget_delete_event (GtkWidget* _sender,
                                                                GdkEventAny* event,
                                                                gpointer self)
{
	gboolean result;
	result = gnonograms_controller_on_view_deleted ((GnonogramsController*) self);
	return result;
}

static gboolean
_gnonograms_controller_on_view_configure_gtk_widget_configure_event (GtkWidget* _sender,
                                                                     GdkEventConfigure* event,
                                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_controller_on_view_configure ((GnonogramsController*) self);
	return result;
}

static void
_gnonograms_controller___lambda46_ (GnonogramsController* self)
{
	GnonogramsGameState _tmp0_;
	GnonogramsGameState _tmp1_;
	_tmp0_ = self->priv->_game_state;
	if (_tmp0_ != GNONOGRAMS_GAME_STATE_UNDEFINED) {
		gnonograms_controller_clear_history (self);
	}
	_tmp1_ = self->priv->_game_state;
	if (_tmp1_ == GNONOGRAMS_GAME_STATE_GENERATING) {
		gnonograms_controller_on_new_random_request (self);
	}
}

static void
__gnonograms_controller___lambda46__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_gnonograms_controller___lambda46_ ((GnonogramsController*) self);
}

static void
_gnonograms_controller___lambda47_ (GnonogramsController* self)
{
	GnonogramsDimensions _tmp0_;
	GnonogramsSolver* _tmp1_;
	_tmp0_ = self->priv->_dimensions;
	_tmp1_ = gnonograms_solver_new (&_tmp0_);
	_g_object_unref0 (self->priv->solver);
	self->priv->solver = _tmp1_;
	gnonograms_controller_set_game_name (self, _ (GNONOGRAMS_UNTITLED_NAME));
}

static void
__gnonograms_controller___lambda47__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_gnonograms_controller___lambda47_ ((GnonogramsController*) self);
}

static void
_gnonograms_controller___lambda48_ (GnonogramsController* self)
{
	GnonogramsView* _tmp0_;
	_tmp0_ = self->priv->view;
	gnonograms_view_update_title (_tmp0_);
}

static void
__gnonograms_controller___lambda48__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_gnonograms_controller___lambda48_ ((GnonogramsController*) self);
}

static void
_gnonograms_controller___lambda49_ (GnonogramsController* self,
                                    GObject* obj,
                                    GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	if (!gnonograms_controller_restore_game_finish (self, res)) {
		g_warning ("Controller.vala:130: Restoring game failed");
		gnonograms_controller_restore_dimensions (self);
		gnonograms_controller_new_game (self);
	}
}

static void
__gnonograms_controller___lambda49__gasync_ready_callback (GObject* source_object,
                                                           GAsyncResult* res,
                                                           gpointer self)
{
	_gnonograms_controller___lambda49_ ((GnonogramsController*) self, source_object, res);
	g_object_unref (self);
}

static GObject *
gnonograms_controller_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsController * self;
	GnonogramsModel* _tmp0_;
	GnonogramsModel* _tmp1_;
	GnonogramsView* _tmp2_;
	GnonogramsHistory* _tmp3_;
	GnonogramsView* _tmp4_;
	GnonogramsView* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GSettingsSchemaSource* _tmp7_;
	GSettingsSchema* _tmp8_;
	GSettingsSchema* _tmp9_;
	gboolean _tmp10_;
	gchar* data_home_folder_current = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gboolean _tmp29_ = FALSE;
	GSettings* _tmp30_;
	GnonogramsView* _tmp36_;
	GnonogramsView* _tmp37_;
	GnonogramsView* _tmp38_;
	GnonogramsView* _tmp39_;
	GnonogramsHistory* _tmp40_;
	GnonogramsView* _tmp41_;
	GnonogramsHistory* _tmp42_;
	GnonogramsView* _tmp43_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (gnonograms_controller_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController);
	gnonograms_controller_set_game_name (self, _ (GNONOGRAMS_UNTITLED_NAME));
	_tmp0_ = gnonograms_model_new (self);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp0_;
	_tmp1_ = self->priv->model;
	_tmp2_ = gnonograms_view_new (_tmp1_, self);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp2_;
	_tmp3_ = gnonograms_history_new ();
	_g_object_unref0 (self->priv->history);
	self->priv->history = _tmp3_;
	_tmp4_ = self->priv->view;
	g_signal_connect_object ((GtkWidget*) _tmp4_, "delete-event", (GCallback) _gnonograms_controller_on_view_deleted_gtk_widget_delete_event, self, 0);
	_tmp5_ = self->priv->view;
	g_signal_connect_object ((GtkWidget*) _tmp5_, "configure-event", (GCallback) _gnonograms_controller_on_view_configure_gtk_widget_configure_event, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::game-state", (GCallback) __gnonograms_controller___lambda46__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::dimensions", (GCallback) __gnonograms_controller___lambda47__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::current_game_path", (GCallback) __gnonograms_controller___lambda48__g_object_notify, self, 0);
	_tmp7_ = g_settings_schema_source_get_default ();
	_tmp8_ = g_settings_schema_source_lookup (_tmp7_, GNONOGRAMS_CONTROLLER_SETTINGS_SCHEMA_ID, TRUE);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_ != NULL;
	_g_settings_schema_unref0 (_tmp9_);
	if (_tmp10_) {
		GSettingsSchemaSource* _tmp11_;
		GSettingsSchema* _tmp12_;
		GSettingsSchema* _tmp13_;
		_tmp11_ = g_settings_schema_source_get_default ();
		_tmp12_ = g_settings_schema_source_lookup (_tmp11_, GNONOGRAMS_CONTROLLER_SAVED_STATE_SCHEMA_ID, TRUE);
		_tmp13_ = _tmp12_;
		_tmp6_ = _tmp13_ != NULL;
		_g_settings_schema_unref0 (_tmp13_);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		_tmp14_ = g_settings_new (GNONOGRAMS_CONTROLLER_SETTINGS_SCHEMA_ID);
		_g_object_unref0 (self->priv->settings);
		self->priv->settings = _tmp14_;
		_tmp15_ = g_settings_new (GNONOGRAMS_CONTROLLER_SAVED_STATE_SCHEMA_ID);
		_g_object_unref0 (self->priv->saved_state);
		self->priv->saved_state = _tmp15_;
	} else {
		g_warning ("Controller.vala:84: not found one of the schemas");
	}
	_tmp16_ = g_get_user_config_dir ();
	_tmp17_ = g_build_path (G_DIR_SEPARATOR_S, _tmp16_, "unsaved", NULL);
	data_home_folder_current = _tmp17_;
	{
		GFile* file = NULL;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		_tmp18_ = data_home_folder_current;
		_tmp19_ = g_file_new_for_path (_tmp18_);
		file = _tmp19_;
		_tmp20_ = file;
		g_file_make_directory_with_parents (_tmp20_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			goto __catch0_g_error;
		}
		_g_object_unref0 (file);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp21_ = e;
		if (!g_error_matches (_tmp21_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			const gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
			_tmp22_ = data_home_folder_current;
			_tmp23_ = e;
			_tmp24_ = _tmp23_->message;
			g_warning ("Controller.vala:98: Error making %s: %s", _tmp22_, _tmp24_);
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (data_home_folder_current);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp25_ = g_get_user_special_dir (G_USER_DIRECTORY_DOCUMENTS);
	_tmp26_ = g_strdup (_tmp25_);
	_g_free0 (self->priv->saved_games_folder);
	self->priv->saved_games_folder = _tmp26_;
	gnonograms_controller_set_current_game_path (self, "");
	_tmp27_ = data_home_folder_current;
	_tmp28_ = g_build_path (G_DIR_SEPARATOR_S, _tmp27_, GNONOGRAMS_UNSAVED_FILENAME, NULL);
	_g_free0 (self->priv->temporary_game_path);
	self->priv->temporary_game_path = _tmp28_;
	_tmp30_ = self->priv->saved_state;
	if (_tmp30_ != NULL) {
		GSettings* _tmp31_;
		_tmp31_ = self->priv->settings;
		_tmp29_ = _tmp31_ != NULL;
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		GSettings* _tmp32_;
		GSettings* _tmp33_;
		GSettings* _tmp34_;
		GnonogramsView* _tmp35_;
		_tmp32_ = self->priv->saved_state;
		g_settings_bind (_tmp32_, "mode", (GObject*) self, "game_state", G_SETTINGS_BIND_DEFAULT);
		_tmp33_ = self->priv->settings;
		g_settings_bind (_tmp33_, "grade", (GObject*) self, "generator_grade", G_SETTINGS_BIND_DEFAULT);
		_tmp34_ = self->priv->settings;
		_tmp35_ = self->priv->view;
		g_settings_bind (_tmp34_, "clue-help", (GObject*) _tmp35_, "strikeout-complete", G_SETTINGS_BIND_DEFAULT);
	}
	_tmp36_ = self->priv->view;
	gtk_widget_show_all ((GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->view;
	gtk_window_present ((GtkWindow*) _tmp37_);
	gnonograms_controller_restore_settings (self);
	_tmp38_ = self->priv->view;
	g_object_bind_property_with_closures ((GObject*) self, "generator-grade", (GObject*) _tmp38_, "generator-grade", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp39_ = self->priv->view;
	g_object_bind_property_with_closures ((GObject*) self, "is-readonly", (GObject*) _tmp39_, "readonly", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp40_ = self->priv->history;
	_tmp41_ = self->priv->view;
	g_object_bind_property_with_closures ((GObject*) _tmp40_, "can-go-back", (GObject*) _tmp41_, "can-go-back", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp42_ = self->priv->history;
	_tmp43_ = self->priv->view;
	g_object_bind_property_with_closures ((GObject*) _tmp42_, "can-go-forward", (GObject*) _tmp43_, "can-go-forward", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	gnonograms_controller_restore_game (self, __gnonograms_controller___lambda49__gasync_ready_callback, g_object_ref (self));
	_g_free0 (data_home_folder_current);
	return obj;
}

static void
gnonograms_controller_class_init (GnonogramsControllerClass * klass,
                                  gpointer klass_data)
{
	gnonograms_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsController_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_controller_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_controller_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_controller_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_controller_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_WINDOW_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY] = g_param_spec_enum ("game-state", "game-state", "game-state", GNONOGRAMS_TYPE_GAME_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY] = g_param_spec_enum ("generator-grade", "generator-grade", "generator-grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY] = g_param_spec_string ("game-name", "game-name", "game-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY] = g_param_spec_boolean ("is-readonly", "is-readonly", "is-readonly", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY, gnonograms_controller_properties[GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY] = g_param_spec_string ("current-game-path", "current-game-path", "current-game-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	gnonograms_controller_signals[GNONOGRAMS_CONTROLLER_QUIT_APP_SIGNAL] = g_signal_new ("quit-app", GNONOGRAMS_TYPE_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
gnonograms_controller_instance_init (GnonogramsController * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
	self->priv = gnonograms_controller_get_instance_private (self);
	self->priv->_is_readonly = FALSE;
	self->priv->settings = NULL;
	self->priv->saved_state = NULL;
	_tmp0_ = g_strdup ("");
	self->priv->_current_game_path = _tmp0_;
	self->priv->temporary_game_path = NULL;
	self->priv->configure_id = (guint) 0;
}

static void
gnonograms_controller_finalize (GObject * obj)
{
	GnonogramsController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController);
	_g_free0 (self->priv->_game_name);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->solver);
	_g_object_unref0 (self->priv->generator);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->saved_state);
	_g_object_unref0 (self->priv->history);
	_g_free0 (self->priv->_current_game_path);
	_g_free0 (self->priv->saved_games_folder);
	_g_free0 (self->priv->temporary_game_path);
	G_OBJECT_CLASS (gnonograms_controller_parent_class)->finalize (obj);
}

static GType
gnonograms_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsController), 0, (GInstanceInitFunc) gnonograms_controller_instance_init, NULL };
	GType gnonograms_controller_type_id;
	gnonograms_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "GnonogramsController", &g_define_type_info, 0);
	GnonogramsController_private_offset = g_type_add_instance_private (gnonograms_controller_type_id, sizeof (GnonogramsControllerPrivate));
	return gnonograms_controller_type_id;
}

GType
gnonograms_controller_get_type (void)
{
	static volatile gsize gnonograms_controller_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_controller_type_id__once)) {
		GType gnonograms_controller_type_id;
		gnonograms_controller_type_id = gnonograms_controller_get_type_once ();
		g_once_init_leave (&gnonograms_controller_type_id__once, gnonograms_controller_type_id);
	}
	return gnonograms_controller_type_id__once;
}

static void
_vala_gnonograms_controller_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController);
	switch (property_id) {
		case GNONOGRAMS_CONTROLLER_WINDOW_PROPERTY:
		g_value_set_object (value, gnonograms_controller_get_window (self));
		break;
		case GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_controller_get_game_state (self));
		break;
		case GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_controller_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_controller_get_generator_grade (self));
		break;
		case GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY:
		g_value_set_string (value, gnonograms_controller_get_game_name (self));
		break;
		case GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_controller_get_is_readonly (self));
		break;
		case GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY:
		g_value_set_string (value, gnonograms_controller_get_current_game_path (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_controller_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	GnonogramsController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController);
	switch (property_id) {
		case GNONOGRAMS_CONTROLLER_GAME_STATE_PROPERTY:
		gnonograms_controller_set_game_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_CONTROLLER_DIMENSIONS_PROPERTY:
		gnonograms_controller_set_dimensions (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_CONTROLLER_GENERATOR_GRADE_PROPERTY:
		gnonograms_controller_set_generator_grade (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_CONTROLLER_GAME_NAME_PROPERTY:
		gnonograms_controller_set_game_name (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_CONTROLLER_IS_READONLY_PROPERTY:
		gnonograms_controller_set_is_readonly (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_CONTROLLER_CURRENT_GAME_PATH_PROPERTY:
		gnonograms_controller_set_current_game_path (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

