/* View.c generated by valac 0.56.16, the Vala compiler
 * generated from View.vala, do not modify */

/* View.vala
 * Copyright (C) 2010-2021  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <handy.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>

#define GNONOGRAMS_VIEW_USABLE_MONITOR_HEIGHT 0.85
#define GNONOGRAMS_VIEW_USABLE_MONITOR_WIDTH 0.95
#define GNONOGRAMS_VIEW_GRID_BORDER 6
#define GNONOGRAMS_VIEW_GRID_COLUMN_SPACING 6
#define GNONOGRAMS_VIEW_TYPICAL_MAX_BLOCKS_RATIO 0.3
#define GNONOGRAMS_VIEW_ZOOM_RATIO 0.05
#define GNONOGRAMS_VIEW_PROGRESS_DELAY_MSEC ((guint) 500)
#define GNONOGRAMS_VIEW_ACTION_GROUP "win"
#define GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_GROUP "."
#define GNONOGRAMS_VIEW_ACTION_UNDO "action-undo"
#define GNONOGRAMS_VIEW_ACTION_REDO "action-redo"
#define GNONOGRAMS_VIEW_ACTION_ZOOM_IN "action-zoom-in"
#define GNONOGRAMS_VIEW_ACTION_ZOOM_OUT "action-zoom-out"
#define GNONOGRAMS_VIEW_ACTION_CURSOR_UP "action-cursor_up"
#define GNONOGRAMS_VIEW_ACTION_CURSOR_DOWN "action-cursor_down"
#define GNONOGRAMS_VIEW_ACTION_CURSOR_LEFT "action-cursor_left"
#define GNONOGRAMS_VIEW_ACTION_CURSOR_RIGHT "action-cursor_right"
#define GNONOGRAMS_VIEW_ACTION_SETTING_MODE "action-setting-mode"
#define GNONOGRAMS_VIEW_ACTION_SOLVING_MODE "action-solving-mode"
#define GNONOGRAMS_VIEW_ACTION_GENERATING_MODE "action-generating-mode"
#define GNONOGRAMS_VIEW_ACTION_OPEN "action-open"
#define GNONOGRAMS_VIEW_ACTION_SAVE "action-save"
#define GNONOGRAMS_VIEW_ACTION_SAVE_AS "action-save-as"
#define GNONOGRAMS_VIEW_ACTION_PAINT_FILLED "action-paint-filled"
#define GNONOGRAMS_VIEW_ACTION_PAINT_EMPTY "action-paint-empty"
#define GNONOGRAMS_VIEW_ACTION_PAINT_UNKNOWN "action-paint-unknown"
#define GNONOGRAMS_VIEW_ACTION_CHECK_ERRORS "action-check-errors"
#define GNONOGRAMS_VIEW_ACTION_RESTART "action-restart"
#define GNONOGRAMS_VIEW_ACTION_SOLVE "action-solve"
#define GNONOGRAMS_VIEW_ACTION_HINT "action-hint"
#define GNONOGRAMS_VIEW_ACTION_OPTIONS "action-options"
#define GNONOGRAMS_MIN_GRADE GNONOGRAMS_DIFFICULTY_EASY
#define GNONOGRAMS_GRID_LABELBOX_RATIO 0.3
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_VIEW (gnonograms_view_get_type ())
#define GNONOGRAMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsView))
#define GNONOGRAMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))
#define GNONOGRAMS_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))

typedef struct _GnonogramsView GnonogramsView;
typedef struct _GnonogramsViewClass GnonogramsViewClass;
typedef struct _GnonogramsViewPrivate GnonogramsViewPrivate;

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;

#define GNONOGRAMS_TYPE_CONTROLLER (gnonograms_controller_get_type ())
#define GNONOGRAMS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController))
#define GNONOGRAMS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))
#define GNONOGRAMS_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))

typedef struct _GnonogramsController GnonogramsController;
typedef struct _GnonogramsControllerClass GnonogramsControllerClass;

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())

#define GNONOGRAMS_TYPE_LABEL_BOX (gnonograms_label_box_get_type ())
#define GNONOGRAMS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox))
#define GNONOGRAMS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))
#define GNONOGRAMS_IS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_IS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_LABEL_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))

typedef struct _GnonogramsLabelBox GnonogramsLabelBox;
typedef struct _GnonogramsLabelBoxClass GnonogramsLabelBoxClass;

#define GNONOGRAMS_TYPE_CELL_GRID (gnonograms_cell_grid_get_type ())
#define GNONOGRAMS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid))
#define GNONOGRAMS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))
#define GNONOGRAMS_IS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_IS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_CELL_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))

typedef struct _GnonogramsCellGrid GnonogramsCellGrid;
typedef struct _GnonogramsCellGridClass GnonogramsCellGridClass;

#define GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR (gnonograms_view_progress_indicator_get_type ())
#define GNONOGRAMS_VIEW_PROGRESS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicator))
#define GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicatorClass))
#define GNONOGRAMS_VIEW_IS_PROGRESS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR))
#define GNONOGRAMS_VIEW_IS_PROGRESS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR))
#define GNONOGRAMS_VIEW_PROGRESS_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicatorClass))

typedef struct _GnonogramsViewProgressIndicator GnonogramsViewProgressIndicator;
typedef struct _GnonogramsViewProgressIndicatorClass GnonogramsViewProgressIndicatorClass;

#define GNONOGRAMS_VIEW_TYPE_APP_MENU (gnonograms_view_app_menu_get_type ())
#define GNONOGRAMS_VIEW_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenu))
#define GNONOGRAMS_VIEW_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenuClass))
#define GNONOGRAMS_VIEW_IS_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_TYPE_APP_MENU))
#define GNONOGRAMS_VIEW_IS_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_TYPE_APP_MENU))
#define GNONOGRAMS_VIEW_APP_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenuClass))

typedef struct _GnonogramsViewAppMenu GnonogramsViewAppMenu;
typedef struct _GnonogramsViewAppMenuClass GnonogramsViewAppMenuClass;
enum  {
	GNONOGRAMS_VIEW_0_PROPERTY,
	GNONOGRAMS_VIEW_MODEL_PROPERTY,
	GNONOGRAMS_VIEW_CONTROLLER_PROPERTY,
	GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY,
	GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY,
	GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY,
	GNONOGRAMS_VIEW_GAME_NAME_PROPERTY,
	GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY,
	GNONOGRAMS_VIEW_READONLY_PROPERTY,
	GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY,
	GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY,
	GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY,
	GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY,
	GNONOGRAMS_VIEW_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_properties[GNONOGRAMS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;
typedef struct _GnonogramsMovePrivate GnonogramsMovePrivate;
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
typedef struct _Block4Data Block4Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
typedef struct _GnonogramsViewProgressIndicatorPrivate GnonogramsViewProgressIndicatorPrivate;
enum  {
	GNONOGRAMS_VIEW_PROGRESS_INDICATOR_0_PROPERTY,
	GNONOGRAMS_VIEW_PROGRESS_INDICATOR_TEXT_PROPERTY,
	GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY,
	GNONOGRAMS_VIEW_PROGRESS_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_progress_indicator_properties[GNONOGRAMS_VIEW_PROGRESS_INDICATOR_NUM_PROPERTIES];

#define GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON (gnonograms_view_header_button_get_type ())
#define GNONOGRAMS_VIEW_HEADER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, GnonogramsViewHeaderButton))
#define GNONOGRAMS_VIEW_HEADER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, GnonogramsViewHeaderButtonClass))
#define GNONOGRAMS_VIEW_IS_HEADER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON))
#define GNONOGRAMS_VIEW_IS_HEADER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON))
#define GNONOGRAMS_VIEW_HEADER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, GnonogramsViewHeaderButtonClass))

typedef struct _GnonogramsViewHeaderButton GnonogramsViewHeaderButton;
typedef struct _GnonogramsViewHeaderButtonClass GnonogramsViewHeaderButtonClass;
typedef struct _GnonogramsViewHeaderButtonPrivate GnonogramsViewHeaderButtonPrivate;
enum  {
	GNONOGRAMS_VIEW_HEADER_BUTTON_0_PROPERTY,
	GNONOGRAMS_VIEW_HEADER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_header_button_properties[GNONOGRAMS_VIEW_HEADER_BUTTON_NUM_PROPERTIES];

#define GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON (gnonograms_view_restart_button_get_type ())
#define GNONOGRAMS_VIEW_RESTART_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButton))
#define GNONOGRAMS_VIEW_RESTART_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButtonClass))
#define GNONOGRAMS_VIEW_IS_RESTART_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON))
#define GNONOGRAMS_VIEW_IS_RESTART_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON))
#define GNONOGRAMS_VIEW_RESTART_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButtonClass))

typedef struct _GnonogramsViewRestartButton GnonogramsViewRestartButton;
typedef struct _GnonogramsViewRestartButtonClass GnonogramsViewRestartButtonClass;
typedef struct _GnonogramsViewRestartButtonPrivate GnonogramsViewRestartButtonPrivate;
enum  {
	GNONOGRAMS_VIEW_RESTART_BUTTON_0_PROPERTY,
	GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY,
	GNONOGRAMS_VIEW_RESTART_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_restart_button_properties[GNONOGRAMS_VIEW_RESTART_BUTTON_NUM_PROPERTIES];
typedef struct _GnonogramsViewAppMenuPrivate GnonogramsViewAppMenuPrivate;
enum  {
	GNONOGRAMS_VIEW_APP_MENU_0_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_app_menu_properties[GNONOGRAMS_VIEW_APP_MENU_NUM_PROPERTIES];

#define GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER (gnonograms_view_app_menu_grade_chooser_get_type ())
#define GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER, GnonogramsViewAppMenuGradeChooser))
#define GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER, GnonogramsViewAppMenuGradeChooserClass))
#define GNONOGRAMS_VIEW_APP_MENU_IS_GRADE_CHOOSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER))
#define GNONOGRAMS_VIEW_APP_MENU_IS_GRADE_CHOOSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER))
#define GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER, GnonogramsViewAppMenuGradeChooserClass))

typedef struct _GnonogramsViewAppMenuGradeChooser GnonogramsViewAppMenuGradeChooser;
typedef struct _GnonogramsViewAppMenuGradeChooserClass GnonogramsViewAppMenuGradeChooserClass;
typedef struct _GnonogramsViewAppMenuGradeChooserPrivate GnonogramsViewAppMenuGradeChooserPrivate;
enum  {
	GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_0_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_app_menu_grade_chooser_properties[GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_NUM_PROPERTIES];

#define GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON (gnonograms_view_app_menu_dimension_spin_button_get_type ())
#define GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON, GnonogramsViewAppMenuDimensionSpinButton))
#define GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON, GnonogramsViewAppMenuDimensionSpinButtonClass))
#define GNONOGRAMS_VIEW_APP_MENU_IS_DIMENSION_SPIN_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON))
#define GNONOGRAMS_VIEW_APP_MENU_IS_DIMENSION_SPIN_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON))
#define GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON, GnonogramsViewAppMenuDimensionSpinButtonClass))

typedef struct _GnonogramsViewAppMenuDimensionSpinButton GnonogramsViewAppMenuDimensionSpinButton;
typedef struct _GnonogramsViewAppMenuDimensionSpinButtonClass GnonogramsViewAppMenuDimensionSpinButtonClass;
typedef struct _GnonogramsViewAppMenuDimensionSpinButtonPrivate GnonogramsViewAppMenuDimensionSpinButtonPrivate;
enum  {
	GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON_0_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_app_menu_dimension_spin_button_properties[GNONOGRAMS_VIEW_APP_MENU_DIMENSION_SPIN_BUTTON_NUM_PROPERTIES];

#define GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER (gnonograms_view_app_menu_app_popover_get_type ())
#define GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, GnonogramsViewAppMenuAppPopover))
#define GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, GnonogramsViewAppMenuAppPopoverClass))
#define GNONOGRAMS_VIEW_APP_MENU_IS_APP_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER))
#define GNONOGRAMS_VIEW_APP_MENU_IS_APP_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER))
#define GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, GnonogramsViewAppMenuAppPopoverClass))

typedef struct _GnonogramsViewAppMenuAppPopover GnonogramsViewAppMenuAppPopover;
typedef struct _GnonogramsViewAppMenuAppPopoverClass GnonogramsViewAppMenuAppPopoverClass;
typedef struct _GnonogramsViewAppMenuAppPopoverPrivate GnonogramsViewAppMenuAppPopoverPrivate;
enum  {
	GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_0_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_app_menu_app_popover_properties[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_NUM_PROPERTIES];
enum  {
	GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_APPLY_SETTINGS_SIGNAL,
	GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_CANCEL_SIGNAL,
	GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_NUM_SIGNALS
};
static guint gnonograms_view_app_menu_app_popover_signals[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_NUM_SIGNALS] = {0};

#define GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL (gnonograms_view_app_menu_setting_label_get_type ())
#define GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL, GnonogramsViewAppMenuSettingLabel))
#define GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL, GnonogramsViewAppMenuSettingLabelClass))
#define GNONOGRAMS_VIEW_APP_MENU_IS_SETTING_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL))
#define GNONOGRAMS_VIEW_APP_MENU_IS_SETTING_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL))
#define GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL, GnonogramsViewAppMenuSettingLabelClass))

typedef struct _GnonogramsViewAppMenuSettingLabel GnonogramsViewAppMenuSettingLabel;
typedef struct _GnonogramsViewAppMenuSettingLabelClass GnonogramsViewAppMenuSettingLabelClass;
typedef struct _GnonogramsViewAppMenuSettingLabelPrivate GnonogramsViewAppMenuSettingLabelPrivate;
enum  {
	GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL_0_PROPERTY,
	GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_app_menu_setting_label_properties[GNONOGRAMS_VIEW_APP_MENU_SETTING_LABEL_NUM_PROPERTIES];
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GnonogramsView {
	HdyApplicationWindow parent_instance;
	GnonogramsViewPrivate * priv;
};

struct _GnonogramsViewClass {
	HdyApplicationWindowClass parent_class;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsViewPrivate {
	GnonogramsModel* _model;
	GnonogramsController* _controller;
	GnonogramsCell _current_cell;
	GnonogramsCell _previous_cell;
	GnonogramsDifficulty _generator_grade;
	GnonogramsDifficulty _game_grade;
	gint _cell_size;
	gboolean _strikeout_complete;
	gboolean _readonly;
	gboolean _can_go_back;
	gboolean _can_go_forward;
	gboolean _restart_destructive;
	GSimpleActionGroup* _view_actions;
	GnonogramsLabelBox* row_clue_box;
	GnonogramsLabelBox* column_clue_box;
	GnonogramsCellGrid* cell_grid;
	GnonogramsViewProgressIndicator* progress_indicator;
	GnonogramsViewAppMenu* app_menu;
	GnonogramsCellState drawing_with_state;
	HdyHeaderBar* header_bar;
	GraniteWidgetsToast* toast;
	GraniteModeSwitch* mode_switch;
	GtkGrid* main_grid;
	GtkOverlay* overlay;
	GtkStack* progress_stack;
	GtkLabel* title_label;
	GtkLabel* grade_label;
	GtkButton* generate_button;
	GtkButton* load_game_button;
	GtkButton* save_game_button;
	GtkButton* save_game_as_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* check_correct_button;
	GtkButton* hint_button;
	GtkButton* auto_solve_button;
	GtkButton* restart_button;
	guint drawing_with_key;
	guint progress_timeout_id;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsMove {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsMovePrivate * priv;
	GnonogramsCell cell;
	GnonogramsCellState previous_state;
};

struct _GnonogramsMoveClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsMove *self);
};

struct _Block4Data {
	int _ref_count_;
	GnonogramsView* self;
	GCancellable* cancellable;
};

struct _GnonogramsViewProgressIndicator {
	GtkGrid parent_instance;
	GnonogramsViewProgressIndicatorPrivate * priv;
};

struct _GnonogramsViewProgressIndicatorClass {
	GtkGridClass parent_class;
};

struct _GnonogramsViewProgressIndicatorPrivate {
	GtkSpinner* spinner;
	GtkButton* cancel_button;
	GtkLabel* label;
	GCancellable* _cancellable;
};

struct _GnonogramsViewHeaderButton {
	GtkButton parent_instance;
	GnonogramsViewHeaderButtonPrivate * priv;
};

struct _GnonogramsViewHeaderButtonClass {
	GtkButtonClass parent_class;
};

struct _GnonogramsViewRestartButton {
	GnonogramsViewHeaderButton parent_instance;
	GnonogramsViewRestartButtonPrivate * priv;
};

struct _GnonogramsViewRestartButtonClass {
	GnonogramsViewHeaderButtonClass parent_class;
};

struct _GnonogramsViewRestartButtonPrivate {
	gboolean _restart_destructive;
};

struct _GnonogramsViewAppMenu {
	GtkMenuButton parent_instance;
	GnonogramsViewAppMenuPrivate * priv;
};

struct _GnonogramsViewAppMenuClass {
	GtkMenuButtonClass parent_class;
};

struct _GnonogramsViewAppMenuPrivate {
	GnonogramsController* _controller;
};

struct _GnonogramsViewAppMenuGradeChooser {
	GtkComboBoxText parent_instance;
	GnonogramsViewAppMenuGradeChooserPrivate * priv;
};

struct _GnonogramsViewAppMenuGradeChooserClass {
	GtkComboBoxTextClass parent_class;
};

struct _GnonogramsViewAppMenuDimensionSpinButton {
	GtkSpinButton parent_instance;
	GnonogramsViewAppMenuDimensionSpinButtonPrivate * priv;
};

struct _GnonogramsViewAppMenuDimensionSpinButtonClass {
	GtkSpinButtonClass parent_class;
};

struct _GnonogramsViewAppMenuAppPopover {
	GtkPopover parent_instance;
	GnonogramsViewAppMenuAppPopoverPrivate * priv;
};

struct _GnonogramsViewAppMenuAppPopoverClass {
	GtkPopoverClass parent_class;
};

struct _GnonogramsViewAppMenuAppPopoverPrivate {
	gboolean cancelled;
};

struct _GnonogramsViewAppMenuSettingLabel {
	GtkLabel parent_instance;
	GnonogramsViewAppMenuSettingLabelPrivate * priv;
};

struct _GnonogramsViewAppMenuSettingLabelClass {
	GtkLabelClass parent_class;
};

struct _Block5Data {
	int _ref_count_;
	GnonogramsViewAppMenu* self;
	GnonogramsViewAppMenuGradeChooser* grade_setting;
	GnonogramsViewAppMenuDimensionSpinButton* row_setting;
	GnonogramsViewAppMenuDimensionSpinButton* column_setting;
	GtkEntry* title_setting;
};

struct _Block6Data {
	int _ref_count_;
	GnonogramsView* self;
	GtkAllocation alloc;
};

static gint GnonogramsView_private_offset;
static gpointer gnonograms_view_parent_class = NULL;
VALA_EXTERN GeeMultiMap* gnonograms_view_action_accelerators;
GeeMultiMap* gnonograms_view_action_accelerators = NULL;
static GActionEntry* gnonograms_view_view_action_entries;
static gint gnonograms_view_view_action_entries_length1;
static GActionEntry* gnonograms_view_view_action_entries = NULL;
static gint gnonograms_view_view_action_entries_length1 = 0;
static gint _gnonograms_view_view_action_entries_size_ = 0;
VALA_EXTERN GtkApplication* gnonograms_view_app;
GtkApplication* gnonograms_view_app = NULL;
static gint GnonogramsViewProgressIndicator_private_offset;
static gpointer gnonograms_view_progress_indicator_parent_class = NULL;
static gpointer gnonograms_view_header_button_parent_class = NULL;
static gint GnonogramsViewRestartButton_private_offset;
static gpointer gnonograms_view_restart_button_parent_class = NULL;
static gint GnonogramsViewAppMenu_private_offset;
static gpointer gnonograms_view_app_menu_parent_class = NULL;
static gpointer gnonograms_view_app_menu_grade_chooser_parent_class = NULL;
static gpointer gnonograms_view_app_menu_dimension_spin_button_parent_class = NULL;
static gint GnonogramsViewAppMenuAppPopover_private_offset;
static gpointer gnonograms_view_app_menu_app_popover_parent_class = NULL;
static gpointer gnonograms_view_app_menu_setting_label_parent_class = NULL;

VALA_EXTERN GType gnonograms_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsView, g_object_unref)
VALA_EXTERN GType gnonograms_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
VALA_EXTERN GType gnonograms_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsController, g_object_unref)
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_label_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsLabelBox, g_object_unref)
VALA_EXTERN GType gnonograms_cell_grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGrid, g_object_unref)
static GType gnonograms_view_progress_indicator_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewProgressIndicator, g_object_unref)
static GType gnonograms_view_app_menu_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewAppMenu, g_object_unref)
static void gnonograms_view_action_undo (GnonogramsView* self);
static void _gnonograms_view_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_redo (GnonogramsView* self);
static void _gnonograms_view_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_zoom_in (GnonogramsView* self);
static void _gnonograms_view_action_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void gnonograms_view_action_zoom_out (GnonogramsView* self);
static void _gnonograms_view_action_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void gnonograms_view_action_cursor_up (GnonogramsView* self);
static void _gnonograms_view_action_cursor_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void gnonograms_view_action_cursor_down (GnonogramsView* self);
static void _gnonograms_view_action_cursor_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void gnonograms_view_action_cursor_left (GnonogramsView* self);
static void _gnonograms_view_action_cursor_left_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void gnonograms_view_action_cursor_right (GnonogramsView* self);
static void _gnonograms_view_action_cursor_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_setting_mode (GnonogramsView* self);
static void _gnonograms_view_action_setting_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_solving_mode (GnonogramsView* self);
static void _gnonograms_view_action_solving_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_generating_mode (GnonogramsView* self);
static void _gnonograms_view_action_generating_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void gnonograms_view_action_open (GnonogramsView* self);
static void _gnonograms_view_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_save (GnonogramsView* self);
static void _gnonograms_view_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_save_as (GnonogramsView* self);
static void _gnonograms_view_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void gnonograms_view_action_paint_filled (GnonogramsView* self);
static void _gnonograms_view_action_paint_filled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_paint_empty (GnonogramsView* self);
static void _gnonograms_view_action_paint_empty_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void gnonograms_view_action_paint_unknown (GnonogramsView* self);
static void _gnonograms_view_action_paint_unknown_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void gnonograms_view_action_check_errors (GnonogramsView* self);
static void _gnonograms_view_action_check_errors_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_restart (GnonogramsView* self);
static void _gnonograms_view_action_restart_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void gnonograms_view_action_solve (GnonogramsView* self);
static void _gnonograms_view_action_solve_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void gnonograms_view_action_hint (GnonogramsView* self);
static void _gnonograms_view_action_hint_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_options (GnonogramsView* self);
static void _gnonograms_view_action_options_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN GnonogramsView* gnonograms_view_new (GnonogramsModel* _model,
                                     GnonogramsController* controller);
VALA_EXTERN GnonogramsView* gnonograms_view_construct (GType object_type,
                                           GnonogramsModel* _model,
                                           GnonogramsController* controller);
VALA_EXTERN gchar** gnonograms_view_get_clues (GnonogramsView* self,
                                   gboolean is_column,
                                   gint* result_length1);
VALA_EXTERN gchar** gnonograms_label_box_get_clues (GnonogramsLabelBox* self,
                                        gint* result_length1);
VALA_EXTERN void gnonograms_view_update_labels_from_string_array (GnonogramsView* self,
                                                      gchar** clues,
                                                      gint clues_length1,
                                                      gboolean is_column);
VALA_EXTERN GnonogramsController* gnonograms_view_get_controller (GnonogramsView* self);
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_controller_get_dimensions (GnonogramsController* self,
                                           GnonogramsDimensions * result);
VALA_EXTERN void gnonograms_label_box_update_label_text (GnonogramsLabelBox* self,
                                             guint index,
                                             const gchar* txt);
VALA_EXTERN void gnonograms_view_update_labels_from_solution (GnonogramsView* self);
VALA_EXTERN GnonogramsModel* gnonograms_view_get_model (GnonogramsView* self);
VALA_EXTERN gchar* gnonograms_model_get_label_text_from_solution (GnonogramsModel* self,
                                                      guint idx,
                                                      gboolean is_column);
static void gnonograms_view_update_all_labels_completeness (GnonogramsView* self);
VALA_EXTERN gpointer gnonograms_move_ref (gpointer instance);
VALA_EXTERN void gnonograms_move_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
VALA_EXTERN void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_move (const GValue* value);
VALA_EXTERN GType gnonograms_move_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
VALA_EXTERN void gnonograms_view_make_move (GnonogramsView* self,
                                GnonogramsMove* m);
VALA_EXTERN gboolean gnonograms_move_is_null (GnonogramsMove* self);
static void gnonograms_view_update_current_and_model (GnonogramsView* self,
                                               GnonogramsCellState state,
                                               GnonogramsCell* target,
                                               GnonogramsCell* result);
VALA_EXTERN void gnonograms_view_send_notification (GnonogramsView* self,
                                        const gchar* text);
VALA_EXTERN void gnonograms_view_show_working (GnonogramsView* self,
                                   GCancellable* cancellable,
                                   const gchar* text);
VALA_EXTERN void gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                      gboolean value);
static void gnonograms_view_progress_indicator_set_text (GnonogramsViewProgressIndicator* self,
                                                  const gchar* value);
static void gnonograms_view_schedule_show_progress (GnonogramsView* self,
                                             GCancellable* cancellable);
VALA_EXTERN void gnonograms_view_end_working (GnonogramsView* self);
static void gnonograms_view_update_header_bar (GnonogramsView* self);
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsGameState gnonograms_controller_get_game_state (GnonogramsController* self);
static void gnonograms_view_set_buttons_sensitive (GnonogramsView* self,
                                            gboolean sensitive);
VALA_EXTERN void gnonograms_view_update_title (GnonogramsView* self);
VALA_EXTERN const gchar* gnonograms_view_get_game_name (GnonogramsView* self);
VALA_EXTERN const gchar* gnonograms_controller_get_current_game_path (GnonogramsController* self);
VALA_EXTERN GnonogramsDifficulty gnonograms_view_get_game_grade (GnonogramsView* self);
VALA_EXTERN gchar* gnonograms_difficulty_to_string (GnonogramsDifficulty self);
VALA_EXTERN gboolean gnonograms_model_is_blank (GnonogramsModel* self,
                                    GnonogramsGameState state);
VALA_EXTERN void gnonograms_view_set_restart_destructive (GnonogramsView* self,
                                              gboolean value);
VALA_EXTERN gboolean gnonograms_view_get_can_go_back (GnonogramsView* self);
VALA_EXTERN gboolean gnonograms_view_get_can_go_forward (GnonogramsView* self);
static void gnonograms_view_highlight_labels (GnonogramsView* self,
                                       GnonogramsCell* c,
                                       gboolean is_highlight);
VALA_EXTERN void gnonograms_label_box_highlight (GnonogramsLabelBox* self,
                                     guint index,
                                     gboolean is_highlight);
static void gnonograms_view_update_label_complete (GnonogramsView* self,
                                            guint idx,
                                            gboolean is_col);
VALA_EXTERN gboolean gnonograms_view_get_strikeout_complete (GnonogramsView* self);
VALA_EXTERN gpointer gnonograms_block_ref (gpointer instance);
VALA_EXTERN void gnonograms_block_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_block (const GValue* value);
VALA_EXTERN GType gnonograms_block_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
VALA_EXTERN GeeArrayList* gnonograms_model_get_complete_blocks_from_working (GnonogramsModel* self,
                                                                 guint index,
                                                                 gboolean is_column);
VALA_EXTERN void gnonograms_label_box_update_label_complete (GnonogramsLabelBox* self,
                                                 guint index,
                                                 GeeList* grid_blocks);
VALA_EXTERN void gnonograms_label_box_clear_formatting (GnonogramsLabelBox* self,
                                            guint index);
static void gnonograms_view_make_move_at_cell (GnonogramsView* self,
                                        GnonogramsCellState state,
                                        GnonogramsCell* target);
static gboolean _gnonograms_cell_equal (const GnonogramsCell * s1,
                                 const GnonogramsCell * s2);
VALA_EXTERN GnonogramsCellState gnonograms_model_get_data_for_cell (GnonogramsModel* self,
                                                        GnonogramsCell* cell);
VALA_EXTERN void gnonograms_controller_after_cell_changed (GnonogramsController* self,
                                               GnonogramsCell* cell,
                                               GnonogramsCellState previous_state);
VALA_EXTERN void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
VALA_EXTERN void gnonograms_model_set_data_from_cell (GnonogramsModel* self,
                                          GnonogramsCell* cell);
static void gnonograms_view_update_current_cell (GnonogramsView* self,
                                          GnonogramsCell* target);
VALA_EXTERN void gnonograms_view_get_current_cell (GnonogramsView* self,
                                       GnonogramsCell * result);
VALA_EXTERN void gnonograms_view_set_previous_cell (GnonogramsView* self,
                                        GnonogramsCell * value);
VALA_EXTERN void gnonograms_view_set_current_cell (GnonogramsView* self,
                                       GnonogramsCell * value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda22_ (Block4Data* _data4_);
static void gnonograms_view_progress_indicator_set_cancellable (GnonogramsViewProgressIndicator* self,
                                                         GCancellable* value);
static gboolean ___lambda22__gsource_func (gpointer self);
static gboolean gnonograms_view_stop_painting (GnonogramsView* self);
static gboolean gnonograms_view_on_grid_scroll_event (GnonogramsView* self,
                                               GdkEventScroll* event);
static void gnonograms_view_change_cell_size (GnonogramsView* self,
                                       gboolean increase);
VALA_EXTERN void gnonograms_controller_restart (GnonogramsController* self);
VALA_EXTERN void gnonograms_view_set_game_grade (GnonogramsView* self,
                                     GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_controller_computer_solve (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_hint (GnonogramsController* self);
VALA_EXTERN gboolean gnonograms_controller_previous_move (GnonogramsController* self);
VALA_EXTERN gboolean gnonograms_controller_next_move (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_open_game (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_save_game (GnonogramsController* self);
VALA_EXTERN void gnonograms_controller_save_game_as (GnonogramsController* self);
VALA_EXTERN gint gnonograms_view_get_cell_size (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_cell_size (GnonogramsView* self,
                                    gint value);
VALA_EXTERN gint gnonograms_controller_rewind_until_correct (GnonogramsController* self);
static void gnonograms_view_move_cursor (GnonogramsView* self,
                                  gint row_delta,
                                  gint col_delta);
VALA_EXTERN void gnonograms_controller_set_game_state (GnonogramsController* self,
                                           GnonogramsGameState value);
static void gnonograms_view_paint_cell_state (GnonogramsView* self,
                                       GnonogramsCellState cs);
static void _vala_GdkEvent_free (GdkEvent* self);
static void gnonograms_view_set_model (GnonogramsView* self,
                                GnonogramsModel* value);
static void gnonograms_view_set_controller (GnonogramsView* self,
                                     GnonogramsController* value);
VALA_EXTERN void gnonograms_view_get_previous_cell (GnonogramsView* self,
                                        GnonogramsCell * result);
VALA_EXTERN GnonogramsDifficulty gnonograms_view_get_generator_grade (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_generator_grade (GnonogramsView* self,
                                          GnonogramsDifficulty value);
VALA_EXTERN const gchar* gnonograms_controller_get_game_name (GnonogramsController* self);
VALA_EXTERN void gnonograms_view_set_strikeout_complete (GnonogramsView* self,
                                             gboolean value);
VALA_EXTERN gboolean gnonograms_view_get_readonly (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_readonly (GnonogramsView* self,
                                   gboolean value);
VALA_EXTERN void gnonograms_view_set_can_go_back (GnonogramsView* self,
                                      gboolean value);
VALA_EXTERN void gnonograms_view_set_can_go_forward (GnonogramsView* self,
                                         gboolean value);
VALA_EXTERN gboolean gnonograms_view_get_restart_destructive (GnonogramsView* self);
VALA_EXTERN GSimpleActionGroup* gnonograms_view_get_view_actions (GnonogramsView* self);
static void gnonograms_view_set_view_actions (GnonogramsView* self,
                                       GSimpleActionGroup* value);
static GnonogramsViewProgressIndicator* gnonograms_view_progress_indicator_new (void);
static GnonogramsViewProgressIndicator* gnonograms_view_progress_indicator_construct (GType object_type);
static GCancellable* gnonograms_view_progress_indicator_get_cancellable (GnonogramsViewProgressIndicator* self);
static GObject * gnonograms_view_progress_indicator_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void _gnonograms_view_progress_indicator___lambda19_ (GnonogramsViewProgressIndicator* self);
static void __gnonograms_view_progress_indicator___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
static void _gnonograms_view_progress_indicator___lambda20_ (GnonogramsViewProgressIndicator* self);
static void __gnonograms_view_progress_indicator___lambda20__gtk_widget_realize (GtkWidget* _sender,
                                                                          gpointer self);
static void _gnonograms_view_progress_indicator___lambda21_ (GnonogramsViewProgressIndicator* self);
static void __gnonograms_view_progress_indicator___lambda21__gtk_widget_unrealize (GtkWidget* _sender,
                                                                            gpointer self);
static void gnonograms_view_progress_indicator_finalize (GObject * obj);
static GType gnonograms_view_progress_indicator_get_type_once (void);
static void _vala_gnonograms_view_progress_indicator_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_gnonograms_view_progress_indicator_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static GType gnonograms_view_header_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewHeaderButton, g_object_unref)
static GnonogramsViewHeaderButton* gnonograms_view_header_button_new (const gchar* icon_name,
                                                               const gchar* action_name,
                                                               const gchar* text);
static GnonogramsViewHeaderButton* gnonograms_view_header_button_construct (GType object_type,
                                                                     const gchar* icon_name,
                                                                     const gchar* action_name,
                                                                     const gchar* text);
static GObject * gnonograms_view_header_button_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static GType gnonograms_view_header_button_get_type_once (void);
static GType gnonograms_view_restart_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewRestartButton, g_object_unref)
static GnonogramsViewRestartButton* gnonograms_view_restart_button_new (const gchar* icon_name,
                                                                 const gchar* action_name,
                                                                 const gchar* text);
static GnonogramsViewRestartButton* gnonograms_view_restart_button_construct (GType object_type,
                                                                       const gchar* icon_name,
                                                                       const gchar* action_name,
                                                                       const gchar* text);
static gboolean gnonograms_view_restart_button_get_restart_destructive (GnonogramsViewRestartButton* self);
static void gnonograms_view_restart_button_set_restart_destructive (GnonogramsViewRestartButton* self,
                                                             gboolean value);
static GObject * gnonograms_view_restart_button_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _gnonograms_view_restart_button___lambda27_ (GnonogramsViewRestartButton* self);
static void __gnonograms_view_restart_button___lambda27__g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void gnonograms_view_restart_button_finalize (GObject * obj);
static GType gnonograms_view_restart_button_get_type_once (void);
static void _vala_gnonograms_view_restart_button_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_gnonograms_view_restart_button_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static GnonogramsViewAppMenu* gnonograms_view_app_menu_new (GnonogramsController* controller);
static GnonogramsViewAppMenu* gnonograms_view_app_menu_construct (GType object_type,
                                                           GnonogramsController* controller);
static GnonogramsController* gnonograms_view_app_menu_get_controller (GnonogramsViewAppMenu* self);
static void gnonograms_view_app_menu_set_controller (GnonogramsViewAppMenu* self,
                                              GnonogramsController* value);
static GType gnonograms_view_app_menu_grade_chooser_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewAppMenuGradeChooser, g_object_unref)
static GnonogramsViewAppMenuGradeChooser* gnonograms_view_app_menu_grade_chooser_new (void);
static GnonogramsViewAppMenuGradeChooser* gnonograms_view_app_menu_grade_chooser_construct (GType object_type);
VALA_EXTERN GnonogramsDifficulty* gnonograms_difficulty_all_human (gint* result_length1);
static GnonogramsDifficulty gnonograms_view_app_menu_grade_chooser_get_grade (GnonogramsViewAppMenuGradeChooser* self);
static void gnonograms_view_app_menu_grade_chooser_set_grade (GnonogramsViewAppMenuGradeChooser* self,
                                                       GnonogramsDifficulty value);
static GType gnonograms_view_app_menu_grade_chooser_get_type_once (void);
static void _vala_gnonograms_view_app_menu_grade_chooser_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_gnonograms_view_app_menu_grade_chooser_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static GType gnonograms_view_app_menu_dimension_spin_button_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewAppMenuDimensionSpinButton, g_object_unref)
static GnonogramsViewAppMenuDimensionSpinButton* gnonograms_view_app_menu_dimension_spin_button_new (void);
static GnonogramsViewAppMenuDimensionSpinButton* gnonograms_view_app_menu_dimension_spin_button_construct (GType object_type);
static GType gnonograms_view_app_menu_dimension_spin_button_get_type_once (void);
static GType gnonograms_view_app_menu_app_popover_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewAppMenuAppPopover, g_object_unref)
static GnonogramsViewAppMenuAppPopover* gnonograms_view_app_menu_app_popover_new (void);
static GnonogramsViewAppMenuAppPopover* gnonograms_view_app_menu_app_popover_construct (GType object_type);
static GObject * gnonograms_view_app_menu_app_popover_constructor (GType type,
                                                            guint n_construct_properties,
                                                            GObjectConstructParam * construct_properties);
static void _gnonograms_view_app_menu_app_popover___lambda23_ (GnonogramsViewAppMenuAppPopover* self);
static void __gnonograms_view_app_menu_app_popover___lambda23__gtk_popover_closed (GtkPopover* _sender,
                                                                            gpointer self);
static gboolean _gnonograms_view_app_menu_app_popover___lambda24_ (GnonogramsViewAppMenuAppPopover* self,
                                                            GdkEventKey* event);
static gboolean __gnonograms_view_app_menu_app_popover___lambda24__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                        GdkEventKey* event,
                                                                                        gpointer self);
static void gnonograms_view_app_menu_app_popover_finalize (GObject * obj);
static GType gnonograms_view_app_menu_app_popover_get_type_once (void);
static GType gnonograms_view_app_menu_setting_label_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewAppMenuSettingLabel, g_object_unref)
static GnonogramsViewAppMenuSettingLabel* gnonograms_view_app_menu_setting_label_new (const gchar* text);
static GnonogramsViewAppMenuSettingLabel* gnonograms_view_app_menu_setting_label_construct (GType object_type,
                                                                                     const gchar* text);
static GType gnonograms_view_app_menu_setting_label_get_type_once (void);
static GObject * gnonograms_view_app_menu_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _gnonograms_view_app_menu___lambda25_ (Block5Data* _data5_);
VALA_EXTERN void gnonograms_controller_set_generator_grade (GnonogramsController* self,
                                                GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_controller_set_dimensions (GnonogramsController* self,
                                           GnonogramsDimensions * value);
VALA_EXTERN void gnonograms_controller_set_game_name (GnonogramsController* self,
                                          const gchar* value);
static void __gnonograms_view_app_menu___lambda25__gnonograms_view_app_menu_app_popover_apply_settings (GnonogramsViewAppMenuAppPopover* _sender,
                                                                                                 gpointer self);
static void _gnonograms_view_app_menu___lambda26_ (Block5Data* _data5_);
VALA_EXTERN GnonogramsDifficulty gnonograms_controller_get_generator_grade (GnonogramsController* self);
static void __gnonograms_view_app_menu___lambda26__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void gnonograms_view_app_menu_finalize (GObject * obj);
static GType gnonograms_view_app_menu_get_type_once (void);
static void _vala_gnonograms_view_app_menu_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gnonograms_view_app_menu_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static GObject * gnonograms_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_new (GtkOrientation _orientation,
                                              GnonogramsView* view);
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_construct (GType object_type,
                                                    GtkOrientation _orientation,
                                                    GnonogramsView* view);
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_new (GnonogramsView* view);
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_construct (GType object_type,
                                                    GnonogramsView* view);
static gboolean _gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                        GdkEventScroll* event,
                                                                        gpointer self);
static void _gnonograms_view___lambda28_ (GnonogramsView* self);
static void __gnonograms_view___lambda28__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda29_ (GnonogramsView* self);
static void __gnonograms_view___lambda29__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda30_ (GnonogramsView* self);
static void __gnonograms_view___lambda30__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda31_ (GnonogramsView* self);
static void __gnonograms_view___lambda31__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda32_ (GnonogramsView* self);
static void __gnonograms_view___lambda32__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda33_ (GnonogramsView* self);
static void __gnonograms_view___lambda33__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda34_ (GnonogramsView* self);
static void __gnonograms_view___lambda34__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda35_ (GnonogramsView* self);
static void __gnonograms_view___lambda35__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda36_ (GnonogramsView* self);
static void __gnonograms_view___lambda36__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda37_ (GnonogramsView* self);
VALA_EXTERN void gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                        GdkWindow* window,
                                        GdkRectangle* result);
static void __gnonograms_view___lambda37__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static gboolean _gnonograms_view___lambda38_ (GnonogramsView* self);
VALA_EXTERN void gnonograms_label_box_unhighlight_all (GnonogramsLabelBox* self);
static gboolean __gnonograms_view___lambda38__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                      GdkEventCrossing* event,
                                                                      gpointer self);
static gboolean _gnonograms_view___lambda39_ (GnonogramsView* self,
                                       GdkEventButton* event);
static gboolean __gnonograms_view___lambda39__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self);
static gboolean _gnonograms_view___lambda40_ (GnonogramsView* self,
                                       GdkEventKey* event);
static gboolean __gnonograms_view___lambda40__gtk_widget_key_release_event (GtkWidget* _sender,
                                                                     GdkEventKey* event,
                                                                     gpointer self);
static gboolean _gnonograms_view_stop_painting_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static void _gnonograms_view___lambda41_ (GnonogramsView* self,
                                   GtkAllocation* alloc);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda42_ (Block6Data* _data6_);
static gboolean ___lambda42__gsource_func (gpointer self);
static void __gnonograms_view___lambda41__gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static void gnonograms_view_finalize (GObject * obj);
static GType gnonograms_view_get_type_once (void);
static void _vala_gnonograms_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_gnonograms_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const GnonogramsCell GNONOGRAMS_NULL_CELL;

static inline gpointer
gnonograms_view_get_instance_private (GnonogramsView* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsView_private_offset);
}

static void
_gnonograms_view_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_undo ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_redo ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_zoom_in ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
	gnonograms_view_action_zoom_out ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_cursor_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
	gnonograms_view_action_cursor_up ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_cursor_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	gnonograms_view_action_cursor_down ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_cursor_left_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	gnonograms_view_action_cursor_left ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_cursor_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_cursor_right ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_setting_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_setting_mode ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_solving_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_solving_mode ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_generating_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
	gnonograms_view_action_generating_mode ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_open ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_save ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_save_as ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_paint_filled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_paint_filled ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_paint_empty_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	gnonograms_view_action_paint_empty ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_paint_unknown_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
	gnonograms_view_action_paint_unknown ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_check_errors_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_check_errors ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_restart_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_restart ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_solve_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	gnonograms_view_action_solve ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_hint_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_hint ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_options_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_options ((GnonogramsView*) self);
}

GnonogramsView*
gnonograms_view_construct (GType object_type,
                           GnonogramsModel* _model,
                           GnonogramsController* controller)
{
	GnonogramsView * self = NULL;
	g_return_val_if_fail (_model != NULL, NULL);
	g_return_val_if_fail (controller != NULL, NULL);
	self = (GnonogramsView*) g_object_new (object_type, "model", _model, "controller", controller, "resizable", FALSE, "title", _ ("Gnonograms"), NULL);
	return self;
}

GnonogramsView*
gnonograms_view_new (GnonogramsModel* _model,
                     GnonogramsController* controller)
{
	return gnonograms_view_construct (GNONOGRAMS_TYPE_VIEW, _model, controller);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gchar**
gnonograms_view_get_clues (GnonogramsView* self,
                           gboolean is_column,
                           gint* result_length1)
{
	GnonogramsLabelBox* _tmp0_ = NULL;
	GnonogramsLabelBox* label_box = NULL;
	GnonogramsLabelBox* _tmp3_;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	if (is_column) {
		GnonogramsLabelBox* _tmp1_;
		_tmp1_ = self->priv->column_clue_box;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsLabelBox* _tmp2_;
		_tmp2_ = self->priv->row_clue_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	label_box = _tmp3_;
	_tmp5_ = gnonograms_label_box_get_clues (label_box, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	_g_object_unref0 (label_box);
	return result;
}

void
gnonograms_view_update_labels_from_string_array (GnonogramsView* self,
                                                 gchar** clues,
                                                 gint clues_length1,
                                                 gboolean is_column)
{
	GnonogramsLabelBox* _tmp0_ = NULL;
	GnonogramsLabelBox* clue_box = NULL;
	GnonogramsLabelBox* _tmp3_;
	guint _tmp4_ = 0U;
	guint lim = 0U;
	g_return_if_fail (self != NULL);
	if (is_column) {
		GnonogramsLabelBox* _tmp1_;
		_tmp1_ = self->priv->column_clue_box;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsLabelBox* _tmp2_;
		_tmp2_ = self->priv->row_clue_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	clue_box = _tmp3_;
	if (is_column) {
		GnonogramsController* _tmp5_;
		GnonogramsDimensions _tmp6_ = {0};
		GnonogramsDimensions _tmp7_;
		_tmp5_ = self->priv->_controller;
		gnonograms_controller_get_dimensions (_tmp5_, &_tmp6_);
		_tmp7_ = _tmp6_;
		_tmp4_ = _tmp7_.width;
	} else {
		GnonogramsController* _tmp8_;
		GnonogramsDimensions _tmp9_ = {0};
		GnonogramsDimensions _tmp10_;
		_tmp8_ = self->priv->_controller;
		gnonograms_controller_get_dimensions (_tmp8_, &_tmp9_);
		_tmp10_ = _tmp9_;
		_tmp4_ = _tmp10_.height;
	}
	lim = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				GnonogramsLabelBox* _tmp13_;
				const gchar* _tmp14_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = i;
					i = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				if (!(((guint) i) < lim)) {
					break;
				}
				_tmp13_ = clue_box;
				_tmp14_ = clues[i];
				gnonograms_label_box_update_label_text (_tmp13_, (guint) i, _tmp14_);
			}
		}
	}
	_g_object_unref0 (clue_box);
}

void
gnonograms_view_update_labels_from_solution (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsController* _tmp2_;
				GnonogramsDimensions _tmp3_ = {0};
				GnonogramsDimensions _tmp4_;
				GnonogramsLabelBox* _tmp5_;
				GnonogramsModel* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_controller;
				gnonograms_controller_get_dimensions (_tmp2_, &_tmp3_);
				_tmp4_ = _tmp3_;
				if (!(((guint) r) < _tmp4_.height)) {
					break;
				}
				_tmp5_ = self->priv->row_clue_box;
				_tmp6_ = self->priv->_model;
				_tmp7_ = gnonograms_model_get_label_text_from_solution (_tmp6_, (guint) r, FALSE);
				_tmp8_ = _tmp7_;
				gnonograms_label_box_update_label_text (_tmp5_, (guint) r, _tmp8_);
				_g_free0 (_tmp8_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				GnonogramsController* _tmp11_;
				GnonogramsDimensions _tmp12_ = {0};
				GnonogramsDimensions _tmp13_;
				GnonogramsLabelBox* _tmp14_;
				GnonogramsModel* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = c;
					c = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = self->priv->_controller;
				gnonograms_controller_get_dimensions (_tmp11_, &_tmp12_);
				_tmp13_ = _tmp12_;
				if (!(((guint) c) < _tmp13_.width)) {
					break;
				}
				_tmp14_ = self->priv->column_clue_box;
				_tmp15_ = self->priv->_model;
				_tmp16_ = gnonograms_model_get_label_text_from_solution (_tmp15_, (guint) c, TRUE);
				_tmp17_ = _tmp16_;
				gnonograms_label_box_update_label_text (_tmp14_, (guint) c, _tmp17_);
				_g_free0 (_tmp17_);
			}
		}
	}
	gnonograms_view_update_all_labels_completeness (self);
}

void
gnonograms_view_make_move (GnonogramsView* self,
                           GnonogramsMove* m)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	if (!gnonograms_move_is_null (m)) {
		GnonogramsCell _tmp0_;
		GnonogramsCell _tmp1_;
		GnonogramsCell _tmp2_ = {0};
		_tmp0_ = m->cell;
		_tmp1_ = m->cell;
		gnonograms_view_update_current_and_model (self, _tmp0_.state, &_tmp1_, &_tmp2_);
	}
}

void
gnonograms_view_send_notification (GnonogramsView* self,
                                   const gchar* text)
{
	GraniteWidgetsToast* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GraniteWidgetsToast* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->toast;
	_tmp1_ = g_strdup (text);
	_tmp2_ = _tmp1_;
	granite_widgets_toast_set_title (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->toast;
	granite_widgets_toast_send_notification (_tmp3_);
}

void
gnonograms_view_show_working (GnonogramsView* self,
                              GCancellable* cancellable,
                              const gchar* text)
{
	GnonogramsCellGrid* _tmp0_;
	GnonogramsViewProgressIndicator* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cancellable != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->cell_grid;
	gnonograms_cell_grid_set_frozen (_tmp0_, TRUE);
	_tmp1_ = self->priv->progress_indicator;
	gnonograms_view_progress_indicator_set_text (_tmp1_, text);
	gnonograms_view_schedule_show_progress (self, cancellable);
}

void
gnonograms_view_end_working (GnonogramsView* self)
{
	GnonogramsCellGrid* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cell_grid;
	gnonograms_cell_grid_set_frozen (_tmp0_, FALSE);
	if (self->priv->progress_timeout_id > ((guint) 0)) {
		g_source_remove (self->priv->progress_timeout_id);
		self->priv->progress_timeout_id = (guint) 0;
	} else {
		GtkStack* _tmp1_;
		_tmp1_ = self->priv->progress_stack;
		gtk_stack_set_visible_child_name (_tmp1_, "Title");
	}
	gnonograms_view_update_all_labels_completeness (self);
	gnonograms_view_update_header_bar (self);
}

static void
gnonograms_view_update_header_bar (GnonogramsView* self)
{
	GraniteModeSwitch* _tmp0_;
	GnonogramsController* _tmp1_;
	GnonogramsGameState _tmp2_;
	GnonogramsGameState _tmp3_;
	GnonogramsController* _tmp4_;
	GnonogramsGameState _tmp5_;
	GnonogramsGameState _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mode_switch;
	_tmp1_ = self->priv->_controller;
	_tmp2_ = gnonograms_controller_get_game_state (_tmp1_);
	_tmp3_ = _tmp2_;
	granite_mode_switch_set_active (_tmp0_, _tmp3_ != GNONOGRAMS_GAME_STATE_SETTING);
	_tmp4_ = self->priv->_controller;
	_tmp5_ = gnonograms_controller_get_game_state (_tmp4_);
	_tmp6_ = _tmp5_;
	switch (_tmp6_) {
		case GNONOGRAMS_GAME_STATE_SETTING:
		{
			gnonograms_view_set_buttons_sensitive (self, TRUE);
			break;
		}
		case GNONOGRAMS_GAME_STATE_SOLVING:
		{
			gnonograms_view_set_buttons_sensitive (self, TRUE);
			break;
		}
		case GNONOGRAMS_GAME_STATE_GENERATING:
		{
			gnonograms_view_set_buttons_sensitive (self, FALSE);
			break;
		}
		default:
		{
			break;
		}
	}
}

void
gnonograms_view_update_title (GnonogramsView* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GnonogramsController* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GnonogramsDifficulty _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gnonograms_view_get_game_name (self);
	_tmp2_ = _tmp1_;
	gtk_label_set_label (_tmp0_, _tmp2_);
	_tmp3_ = self->priv->title_label;
	_tmp4_ = self->priv->_controller;
	_tmp5_ = gnonograms_controller_get_current_game_path (_tmp4_);
	_tmp6_ = _tmp5_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp6_);
	_tmp7_ = self->priv->grade_label;
	_tmp8_ = self->priv->_game_grade;
	_tmp9_ = gnonograms_difficulty_to_string (_tmp8_);
	_tmp10_ = _tmp9_;
	gtk_label_set_label (_tmp7_, _tmp10_);
	_g_free0 (_tmp10_);
}

static void
gnonograms_view_set_buttons_sensitive (GnonogramsView* self,
                                       gboolean sensitive)
{
	GtkButton* _tmp0_;
	GnonogramsController* _tmp1_;
	GnonogramsGameState _tmp2_;
	GnonogramsGameState _tmp3_;
	GraniteModeSwitch* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GtkButton* _tmp15_;
	gboolean _tmp16_ = FALSE;
	GtkButton* _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	GtkButton* _tmp25_;
	gboolean _tmp26_ = FALSE;
	GtkButton* _tmp30_;
	GtkButton* _tmp31_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->generate_button;
	_tmp1_ = self->priv->_controller;
	_tmp2_ = gnonograms_controller_get_game_state (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp3_ != GNONOGRAMS_GAME_STATE_GENERATING);
	_tmp4_ = self->priv->mode_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, sensitive);
	_tmp5_ = self->priv->load_game_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
	_tmp6_ = self->priv->save_game_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, sensitive);
	_tmp7_ = self->priv->save_game_as_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, sensitive);
	if (sensitive) {
		GnonogramsModel* _tmp9_;
		GnonogramsController* _tmp10_;
		GnonogramsGameState _tmp11_;
		GnonogramsGameState _tmp12_;
		_tmp9_ = self->priv->_model;
		_tmp10_ = self->priv->_controller;
		_tmp11_ = gnonograms_controller_get_game_state (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp8_ = !gnonograms_model_is_blank (_tmp9_, _tmp12_);
	} else {
		_tmp8_ = FALSE;
	}
	gnonograms_view_set_restart_destructive (self, _tmp8_);
	if (sensitive) {
		gboolean _tmp14_;
		_tmp14_ = self->priv->_can_go_back;
		_tmp13_ = _tmp14_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp15_ = self->priv->undo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, _tmp13_);
	if (sensitive) {
		gboolean _tmp17_;
		_tmp17_ = self->priv->_can_go_forward;
		_tmp16_ = _tmp17_;
	} else {
		_tmp16_ = FALSE;
	}
	_tmp18_ = self->priv->redo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, _tmp16_);
	if (sensitive) {
		GnonogramsController* _tmp21_;
		GnonogramsGameState _tmp22_;
		GnonogramsGameState _tmp23_;
		_tmp21_ = self->priv->_controller;
		_tmp22_ = gnonograms_controller_get_game_state (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp20_ = _tmp23_ == GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		gboolean _tmp24_;
		_tmp24_ = self->priv->_can_go_back;
		_tmp19_ = _tmp24_;
	} else {
		_tmp19_ = FALSE;
	}
	_tmp25_ = self->priv->check_correct_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, _tmp19_);
	if (sensitive) {
		GnonogramsController* _tmp27_;
		GnonogramsGameState _tmp28_;
		GnonogramsGameState _tmp29_;
		_tmp27_ = self->priv->_controller;
		_tmp28_ = gnonograms_controller_get_game_state (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp26_ = _tmp29_ == GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp26_ = FALSE;
	}
	_tmp30_ = self->priv->hint_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp30_, _tmp26_);
	_tmp31_ = self->priv->auto_solve_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, sensitive);
}

static void
gnonograms_view_highlight_labels (GnonogramsView* self,
                                  GnonogramsCell* c,
                                  gboolean is_highlight)
{
	GnonogramsLabelBox* _tmp0_;
	GnonogramsCell _tmp1_;
	GnonogramsLabelBox* _tmp2_;
	GnonogramsCell _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->row_clue_box;
	_tmp1_ = *c;
	gnonograms_label_box_highlight (_tmp0_, _tmp1_.row, is_highlight);
	_tmp2_ = self->priv->column_clue_box;
	_tmp3_ = *c;
	gnonograms_label_box_highlight (_tmp2_, _tmp3_.col, is_highlight);
}

static void
gnonograms_view_update_all_labels_completeness (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsController* _tmp2_;
				GnonogramsDimensions _tmp3_ = {0};
				GnonogramsDimensions _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_controller;
				gnonograms_controller_get_dimensions (_tmp2_, &_tmp3_);
				_tmp4_ = _tmp3_;
				if (!(((guint) r) < _tmp4_.height)) {
					break;
				}
				gnonograms_view_update_label_complete (self, (guint) r, FALSE);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				GnonogramsController* _tmp7_;
				GnonogramsDimensions _tmp8_ = {0};
				GnonogramsDimensions _tmp9_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = c;
					c = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->priv->_controller;
				gnonograms_controller_get_dimensions (_tmp7_, &_tmp8_);
				_tmp9_ = _tmp8_;
				if (!(((guint) c) < _tmp9_.width)) {
					break;
				}
				gnonograms_view_update_label_complete (self, (guint) c, TRUE);
			}
		}
	}
}

static void
gnonograms_view_update_label_complete (GnonogramsView* self,
                                       guint idx,
                                       gboolean is_col)
{
	GnonogramsLabelBox* _tmp0_ = NULL;
	GnonogramsLabelBox* lbox = NULL;
	GnonogramsLabelBox* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GnonogramsController* _tmp5_;
	GnonogramsGameState _tmp6_;
	GnonogramsGameState _tmp7_;
	g_return_if_fail (self != NULL);
	if (is_col) {
		GnonogramsLabelBox* _tmp1_;
		_tmp1_ = self->priv->column_clue_box;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsLabelBox* _tmp2_;
		_tmp2_ = self->priv->row_clue_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	lbox = _tmp3_;
	_tmp5_ = self->priv->_controller;
	_tmp6_ = gnonograms_controller_get_game_state (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ == GNONOGRAMS_GAME_STATE_SOLVING) {
		gboolean _tmp8_;
		_tmp8_ = self->priv->_strikeout_complete;
		_tmp4_ = _tmp8_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GeeList* blocks = NULL;
		GeeList* _tmp9_;
		GnonogramsModel* _tmp10_;
		GeeArrayList* _tmp11_;
		GnonogramsLabelBox* _tmp12_;
		GeeList* _tmp13_;
		_tmp9_ = gee_list_empty (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref);
		blocks = _tmp9_;
		_tmp10_ = self->priv->_model;
		_tmp11_ = gnonograms_model_get_complete_blocks_from_working (_tmp10_, idx, is_col);
		_g_object_unref0 (blocks);
		blocks = (GeeList*) _tmp11_;
		_tmp12_ = lbox;
		_tmp13_ = blocks;
		gnonograms_label_box_update_label_complete (_tmp12_, idx, _tmp13_);
		_g_object_unref0 (blocks);
	} else {
		GnonogramsLabelBox* _tmp14_;
		_tmp14_ = lbox;
		gnonograms_label_box_clear_formatting (_tmp14_, idx);
	}
	_g_object_unref0 (lbox);
}

static gboolean
_gnonograms_cell_equal (const GnonogramsCell * s1,
                        const GnonogramsCell * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->row != s2->row) {
		return FALSE;
	}
	if (s1->col != s2->col) {
		return FALSE;
	}
	if (s1->state != s2->state) {
		return FALSE;
	}
	return TRUE;
}

static void
gnonograms_view_make_move_at_cell (GnonogramsView* self,
                                   GnonogramsCellState state,
                                   GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCellState prev_state = 0;
	GnonogramsModel* _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell cell = {0};
	GnonogramsCell _tmp3_;
	GnonogramsCell _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = *target;
	if (_gnonograms_cell_equal (&_tmp0_, &GNONOGRAMS_NULL_CELL) == TRUE) {
		return;
	}
	_tmp1_ = self->priv->_model;
	_tmp2_ = *target;
	prev_state = gnonograms_model_get_data_for_cell (_tmp1_, &_tmp2_);
	_tmp3_ = *target;
	gnonograms_view_update_current_and_model (self, state, &_tmp3_, &_tmp4_);
	cell = _tmp4_;
	if (prev_state != state) {
		GnonogramsController* _tmp5_;
		GnonogramsCell _tmp6_;
		_tmp5_ = self->priv->_controller;
		_tmp6_ = cell;
		gnonograms_controller_after_cell_changed (_tmp5_, &_tmp6_, prev_state);
	}
}

static void
gnonograms_view_update_current_and_model (GnonogramsView* self,
                                          GnonogramsCellState state,
                                          GnonogramsCell* target,
                                          GnonogramsCell* result)
{
	GnonogramsCell cell = {0};
	GnonogramsCell _tmp0_ = {0};
	GnonogramsModel* _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell _tmp3_;
	guint row = 0U;
	GnonogramsCell _tmp4_;
	guint col = 0U;
	GnonogramsCell _tmp5_;
	GnonogramsController* _tmp6_;
	GnonogramsGameState _tmp7_;
	GnonogramsGameState _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	gnonograms_cell_clone (target, &_tmp0_);
	cell = _tmp0_;
	cell.state = state;
	_tmp1_ = self->priv->_model;
	_tmp2_ = cell;
	gnonograms_model_set_data_from_cell (_tmp1_, &_tmp2_);
	_tmp3_ = cell;
	gnonograms_view_update_current_cell (self, &_tmp3_);
	_tmp4_ = self->priv->_current_cell;
	row = _tmp4_.row;
	_tmp5_ = self->priv->_current_cell;
	col = _tmp5_.col;
	_tmp6_ = self->priv->_controller;
	_tmp7_ = gnonograms_controller_get_game_state (_tmp6_);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == GNONOGRAMS_GAME_STATE_SETTING) {
		GnonogramsLabelBox* _tmp9_;
		GnonogramsModel* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GnonogramsLabelBox* _tmp13_;
		GnonogramsModel* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp9_ = self->priv->row_clue_box;
		_tmp10_ = self->priv->_model;
		_tmp11_ = gnonograms_model_get_label_text_from_solution (_tmp10_, row, FALSE);
		_tmp12_ = _tmp11_;
		gnonograms_label_box_update_label_text (_tmp9_, row, _tmp12_);
		_g_free0 (_tmp12_);
		_tmp13_ = self->priv->column_clue_box;
		_tmp14_ = self->priv->_model;
		_tmp15_ = gnonograms_model_get_label_text_from_solution (_tmp14_, col, TRUE);
		_tmp16_ = _tmp15_;
		gnonograms_label_box_update_label_text (_tmp13_, col, _tmp16_);
		_g_free0 (_tmp16_);
	} else {
		gnonograms_view_update_label_complete (self, row, FALSE);
		gnonograms_view_update_label_complete (self, col, TRUE);
	}
	*result = cell;
	return;
}

static void
gnonograms_view_update_current_cell (GnonogramsView* self,
                                     GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = self->priv->_current_cell;
	gnonograms_view_set_previous_cell (self, &_tmp0_);
	_tmp1_ = *target;
	gnonograms_view_set_current_cell (self, &_tmp1_);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		GnonogramsView* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gboolean
__lambda22_ (Block4Data* _data4_)
{
	GnonogramsView* self;
	GnonogramsViewProgressIndicator* _tmp0_;
	GtkStack* _tmp1_;
	gboolean result;
	self = _data4_->self;
	_tmp0_ = self->priv->progress_indicator;
	gnonograms_view_progress_indicator_set_cancellable (_tmp0_, _data4_->cancellable);
	_tmp1_ = self->priv->progress_stack;
	gtk_stack_set_visible_child_name (_tmp1_, "Progress");
	self->priv->progress_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}

static gboolean
___lambda22__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda22_ (self);
	return result;
}

static void
gnonograms_view_schedule_show_progress (GnonogramsView* self,
                                        GCancellable* cancellable)
{
	Block4Data* _data4_;
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cancellable != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data4_->cancellable);
	_data4_->cancellable = _tmp0_;
	self->priv->progress_timeout_id = g_timeout_add_full (G_PRIORITY_HIGH_IDLE, GNONOGRAMS_VIEW_PROGRESS_DELAY_MSEC, ___lambda22__gsource_func, block4_data_ref (_data4_), block4_data_unref);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static gboolean
gnonograms_view_stop_painting (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->drawing_with_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	self->priv->drawing_with_key = (guint) 0;
	result = FALSE;
	return result;
}

/** With Control pressed, zoom using the fontsize. **/
static gboolean
gnonograms_view_on_grid_scroll_event (GnonogramsView* self,
                                      GdkEventScroll* event)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if ((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		switch (event->direction) {
			case GDK_SCROLL_UP:
			{
				gnonograms_view_change_cell_size (self, FALSE);
				break;
			}
			case GDK_SCROLL_DOWN:
			{
				gnonograms_view_change_cell_size (self, TRUE);
				break;
			}
			default:
			{
				break;
			}
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

/** Action callbacks **/
static void
gnonograms_view_action_restart (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	GnonogramsController* _tmp1_;
	GnonogramsGameState _tmp2_;
	GnonogramsGameState _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_restart (_tmp0_);
	_tmp1_ = self->priv->_controller;
	_tmp2_ = gnonograms_controller_get_game_state (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == GNONOGRAMS_GAME_STATE_SETTING) {
		gnonograms_view_set_game_grade (self, GNONOGRAMS_DIFFICULTY_UNDEFINED);
	}
}

static void
gnonograms_view_action_solve (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_computer_solve (_tmp0_);
}

static void
gnonograms_view_action_hint (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_hint (_tmp0_);
}

static void
gnonograms_view_action_options (GnonogramsView* self)
{
	GnonogramsViewAppMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->app_menu;
	g_signal_emit_by_name ((GtkButton*) _tmp0_, "activate");
}

static void
gnonograms_view_action_undo (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_previous_move (_tmp0_);
}

static void
gnonograms_view_action_redo (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_next_move (_tmp0_);
}

static void
gnonograms_view_action_open (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_open_game (_tmp0_);
}

static void
gnonograms_view_action_save (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_save_game (_tmp0_);
}

static void
gnonograms_view_action_save_as (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_save_game_as (_tmp0_);
}

static void
gnonograms_view_action_zoom_in (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_change_cell_size (self, TRUE);
}

static void
gnonograms_view_action_zoom_out (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_change_cell_size (self, FALSE);
}

static void
gnonograms_view_change_cell_size (GnonogramsView* self,
                                  gboolean increase)
{
	gdouble delta = 0.0;
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_cell_size;
	delta = MAX (GNONOGRAMS_VIEW_ZOOM_RATIO * _tmp0_, 1.0);
	if (increase) {
		gint _tmp1_;
		_tmp1_ = self->priv->_cell_size;
		gnonograms_view_set_cell_size (self, _tmp1_ + ((gint) delta));
	} else {
		gint _tmp2_;
		_tmp2_ = self->priv->_cell_size;
		gnonograms_view_set_cell_size (self, _tmp2_ - ((gint) delta));
	}
}

static void
gnonograms_view_action_check_errors (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	if (gnonograms_controller_rewind_until_correct (_tmp0_) == 0) {
		gnonograms_view_send_notification (self, _ ("No errors"));
	}
}

static void
gnonograms_view_action_cursor_up (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_move_cursor (self, -1, 0);
}

static void
gnonograms_view_action_cursor_down (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_move_cursor (self, 1, 0);
}

static void
gnonograms_view_action_cursor_left (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_move_cursor (self, 0, -1);
}

static void
gnonograms_view_action_cursor_right (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_move_cursor (self, 0, 1);
}

static void
gnonograms_view_move_cursor (GnonogramsView* self,
                             gint row_delta,
                             gint col_delta)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell target = {0};
	GnonogramsCell _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	GnonogramsCell _tmp5_;
	GnonogramsController* _tmp6_;
	GnonogramsDimensions _tmp7_ = {0};
	GnonogramsDimensions _tmp8_;
	GnonogramsCell _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	if (_gnonograms_cell_equal (&_tmp0_, &GNONOGRAMS_NULL_CELL) == TRUE) {
		return;
	}
	_tmp1_ = self->priv->_current_cell;
	_tmp2_ = self->priv->_current_cell;
	_tmp3_.row = _tmp1_.row + row_delta;
	_tmp3_.col = _tmp2_.col + col_delta;
	_tmp3_.state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	target = _tmp3_;
	_tmp5_ = target;
	_tmp6_ = self->priv->_controller;
	gnonograms_controller_get_dimensions (_tmp6_, &_tmp7_);
	_tmp8_ = _tmp7_;
	if (_tmp5_.row >= _tmp8_.height) {
		_tmp4_ = TRUE;
	} else {
		GnonogramsCell _tmp9_;
		GnonogramsController* _tmp10_;
		GnonogramsDimensions _tmp11_ = {0};
		GnonogramsDimensions _tmp12_;
		_tmp9_ = target;
		_tmp10_ = self->priv->_controller;
		gnonograms_controller_get_dimensions (_tmp10_, &_tmp11_);
		_tmp12_ = _tmp11_;
		_tmp4_ = _tmp9_.col >= _tmp12_.width;
	}
	if (_tmp4_) {
		return;
	}
	_tmp13_ = target;
	gnonograms_view_update_current_cell (self, &_tmp13_);
}

static void
gnonograms_view_action_setting_mode (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_set_game_state (_tmp0_, GNONOGRAMS_GAME_STATE_SETTING);
}

static void
gnonograms_view_action_solving_mode (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_set_game_state (_tmp0_, GNONOGRAMS_GAME_STATE_SOLVING);
}

static void
gnonograms_view_action_generating_mode (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_controller;
	gnonograms_controller_set_game_state (_tmp0_, GNONOGRAMS_GAME_STATE_GENERATING);
}

static void
gnonograms_view_action_paint_filled (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_paint_cell_state (self, GNONOGRAMS_CELL_STATE_FILLED);
}

static void
gnonograms_view_action_paint_empty (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_paint_cell_state (self, GNONOGRAMS_CELL_STATE_EMPTY);
}

static void
gnonograms_view_action_paint_unknown (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	gnonograms_view_paint_cell_state (self, GNONOGRAMS_CELL_STATE_UNKNOWN);
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

static void
gnonograms_view_paint_cell_state (GnonogramsView* self,
                                  GnonogramsCellState cs)
{
	gboolean _tmp0_ = FALSE;
	GdkEvent* current_event = NULL;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	GnonogramsCell _tmp7_;
	g_return_if_fail (self != NULL);
	if (cs == GNONOGRAMS_CELL_STATE_UNKNOWN) {
		GnonogramsController* _tmp1_;
		GnonogramsGameState _tmp2_;
		GnonogramsGameState _tmp3_;
		_tmp1_ = self->priv->_controller;
		_tmp2_ = gnonograms_controller_get_game_state (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_ != GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->priv->drawing_with_state = cs;
	_tmp4_ = gtk_get_current_event ();
	current_event = _tmp4_;
	_tmp5_ = current_event;
	if (_tmp5_->type == GDK_KEY_PRESS) {
		GdkEvent* _tmp6_;
		_tmp6_ = current_event;
		self->priv->drawing_with_key = ((GdkEventKey*) _tmp6_)->keyval;
	}
	_tmp7_ = self->priv->_current_cell;
	gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp7_);
	__vala_GdkEvent_free0 (current_event);
}

GnonogramsModel*
gnonograms_view_get_model (GnonogramsView* self)
{
	GnonogramsModel* result;
	GnonogramsModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_set_model (GnonogramsView* self,
                           GnonogramsModel* value)
{
	GnonogramsModel* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_model (self);
	if (old_value != value) {
		GnonogramsModel* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_model);
		self->priv->_model = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_MODEL_PROPERTY]);
	}
}

GnonogramsController*
gnonograms_view_get_controller (GnonogramsView* self)
{
	GnonogramsController* result;
	GnonogramsController* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_controller;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_set_controller (GnonogramsView* self,
                                GnonogramsController* value)
{
	GnonogramsController* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_controller (self);
	if (old_value != value) {
		GnonogramsController* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_controller);
		self->priv->_controller = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CONTROLLER_PROPERTY]);
	}
}

void
gnonograms_view_get_current_cell (GnonogramsView* self,
                                  GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_view_set_current_cell (GnonogramsView* self,
                                  GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_view_get_current_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_current_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY]);
	}
}

void
gnonograms_view_get_previous_cell (GnonogramsView* self,
                                   GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_previous_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_view_set_previous_cell (GnonogramsView* self,
                                   GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_view_get_previous_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_previous_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_view_get_generator_grade (GnonogramsView* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_generator_grade;
	return result;
}

void
gnonograms_view_set_generator_grade (GnonogramsView* self,
                                     GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_generator_grade (self);
	if (old_value != value) {
		self->priv->_generator_grade = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_view_get_game_grade (GnonogramsView* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_game_grade;
	return result;
}

void
gnonograms_view_set_game_grade (GnonogramsView* self,
                                GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_game_grade (self);
	if (old_value != value) {
		self->priv->_game_grade = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY]);
	}
}

gint
gnonograms_view_get_cell_size (GnonogramsView* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_cell_size;
	return result;
}

void
gnonograms_view_set_cell_size (GnonogramsView* self,
                               gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_cell_size (self);
	if (old_value != value) {
		self->priv->_cell_size = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY]);
	}
}

const gchar*
gnonograms_view_get_game_name (GnonogramsView* self)
{
	const gchar* result;
	GnonogramsController* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_controller;
	_tmp1_ = gnonograms_controller_get_game_name (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gboolean
gnonograms_view_get_strikeout_complete (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_strikeout_complete;
	return result;
}

void
gnonograms_view_set_strikeout_complete (GnonogramsView* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_strikeout_complete (self);
	if (old_value != value) {
		self->priv->_strikeout_complete = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_readonly (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_readonly;
	return result;
}

void
gnonograms_view_set_readonly (GnonogramsView* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_readonly (self);
	if (old_value != value) {
		self->priv->_readonly = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_READONLY_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_can_go_back (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_back;
	return result;
}

void
gnonograms_view_set_can_go_back (GnonogramsView* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_can_go_back (self);
	if (old_value != value) {
		self->priv->_can_go_back = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_can_go_forward (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_forward;
	return result;
}

void
gnonograms_view_set_can_go_forward (GnonogramsView* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_can_go_forward (self);
	if (old_value != value) {
		self->priv->_can_go_forward = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_restart_destructive (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_restart_destructive;
	return result;
}

void
gnonograms_view_set_restart_destructive (GnonogramsView* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_restart_destructive (self);
	if (old_value != value) {
		self->priv->_restart_destructive = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY]);
	}
}

GSimpleActionGroup*
gnonograms_view_get_view_actions (GnonogramsView* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view_actions;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_set_view_actions (GnonogramsView* self,
                                  GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_view_actions (self);
	if (old_value != value) {
		GSimpleActionGroup* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view_actions);
		self->priv->_view_actions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY]);
	}
}

static inline gpointer
gnonograms_view_progress_indicator_get_instance_private (GnonogramsViewProgressIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsViewProgressIndicator_private_offset);
}

static GnonogramsViewProgressIndicator*
gnonograms_view_progress_indicator_construct (GType object_type)
{
	GnonogramsViewProgressIndicator * self = NULL;
	self = (GnonogramsViewProgressIndicator*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, "column-homogeneous", FALSE, "column-spacing", 6, "valign", GTK_ALIGN_CENTER, NULL);
	return self;
}

static GnonogramsViewProgressIndicator*
gnonograms_view_progress_indicator_new (void)
{
	return gnonograms_view_progress_indicator_construct (GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR);
}

static void
gnonograms_view_progress_indicator_set_text (GnonogramsViewProgressIndicator* self,
                                             const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	gtk_label_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_view_progress_indicator_properties[GNONOGRAMS_VIEW_PROGRESS_INDICATOR_TEXT_PROPERTY]);
}

static GCancellable*
gnonograms_view_progress_indicator_get_cancellable (GnonogramsViewProgressIndicator* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cancellable;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_progress_indicator_set_cancellable (GnonogramsViewProgressIndicator* self,
                                                    GCancellable* value)
{
	GCancellable* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_progress_indicator_get_cancellable (self);
	if (old_value != value) {
		GCancellable* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_cancellable);
		self->priv->_cancellable = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_progress_indicator_properties[GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY]);
	}
}

static void
_gnonograms_view_progress_indicator___lambda19_ (GnonogramsViewProgressIndicator* self)
{
	GCancellable* _tmp0_;
	_tmp0_ = self->priv->_cancellable;
	if (_tmp0_ != NULL) {
		GCancellable* _tmp1_;
		_tmp1_ = self->priv->_cancellable;
		g_cancellable_cancel (_tmp1_);
	}
}

static void
__gnonograms_view_progress_indicator___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
	_gnonograms_view_progress_indicator___lambda19_ ((GnonogramsViewProgressIndicator*) self);
}

static void
_gnonograms_view_progress_indicator___lambda20_ (GnonogramsViewProgressIndicator* self)
{
	GCancellable* _tmp0_;
	GtkSpinner* _tmp2_;
	_tmp0_ = self->priv->_cancellable;
	if (_tmp0_ != NULL) {
		GtkButton* _tmp1_;
		_tmp1_ = self->priv->cancel_button;
		gtk_widget_show ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = self->priv->spinner;
	gtk_spinner_start (_tmp2_);
}

static void
__gnonograms_view_progress_indicator___lambda20__gtk_widget_realize (GtkWidget* _sender,
                                                                     gpointer self)
{
	_gnonograms_view_progress_indicator___lambda20_ ((GnonogramsViewProgressIndicator*) self);
}

static void
_gnonograms_view_progress_indicator___lambda21_ (GnonogramsViewProgressIndicator* self)
{
	GCancellable* _tmp0_;
	GtkSpinner* _tmp2_;
	_tmp0_ = self->priv->_cancellable;
	if (_tmp0_ != NULL) {
		GtkButton* _tmp1_;
		gnonograms_view_progress_indicator_set_cancellable (self, NULL);
		_tmp1_ = self->priv->cancel_button;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = self->priv->spinner;
	gtk_spinner_stop (_tmp2_);
}

static void
__gnonograms_view_progress_indicator___lambda21__gtk_widget_unrealize (GtkWidget* _sender,
                                                                       gpointer self)
{
	_gnonograms_view_progress_indicator___lambda21_ ((GnonogramsViewProgressIndicator*) self);
}

static GObject *
gnonograms_view_progress_indicator_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewProgressIndicator * self;
	GtkSpinner* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkButton* _tmp6_;
	GtkImage* img = NULL;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkButton* _tmp9_;
	GtkImage* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkImage* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
	parent_class = G_OBJECT_CLASS (gnonograms_view_progress_indicator_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicator);
	_tmp0_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->label);
	self->priv->label = _tmp1_;
	_tmp2_ = self->priv->label;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp4_ = self->priv->label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
	_tmp5_ = self->priv->spinner;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
	_tmp6_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->cancel_button);
	self->priv->cancel_button = _tmp6_;
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("process-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp7_);
	img = _tmp7_;
	_tmp8_ = img;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _ ("Cancel solving"));
	_tmp9_ = self->priv->cancel_button;
	_tmp10_ = img;
	gtk_button_set_image (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->cancel_button;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp11_, TRUE);
	_tmp12_ = self->priv->cancel_button;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "warn");
	_tmp14_ = img;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, "warn");
	_tmp16_ = self->priv->cancel_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp16_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp17_ = self->priv->cancel_button;
	g_signal_connect_object (_tmp17_, "clicked", (GCallback) __gnonograms_view_progress_indicator___lambda19__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __gnonograms_view_progress_indicator___lambda20__gtk_widget_realize, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "unrealize", (GCallback) __gnonograms_view_progress_indicator___lambda21__gtk_widget_unrealize, self, 0);
	_g_object_unref0 (img);
	return obj;
}

static void
gnonograms_view_progress_indicator_class_init (GnonogramsViewProgressIndicatorClass * klass,
                                               gpointer klass_data)
{
	gnonograms_view_progress_indicator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsViewProgressIndicator_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_progress_indicator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_progress_indicator_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_progress_indicator_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_progress_indicator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_PROGRESS_INDICATOR_TEXT_PROPERTY, gnonograms_view_progress_indicator_properties[GNONOGRAMS_VIEW_PROGRESS_INDICATOR_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY, gnonograms_view_progress_indicator_properties[GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY] = g_param_spec_object ("cancellable", "cancellable", "cancellable", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_view_progress_indicator_instance_init (GnonogramsViewProgressIndicator * self,
                                                  gpointer klass)
{
	self->priv = gnonograms_view_progress_indicator_get_instance_private (self);
}

static void
gnonograms_view_progress_indicator_finalize (GObject * obj)
{
	GnonogramsViewProgressIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicator);
	_g_object_unref0 (self->priv->spinner);
	_g_object_unref0 (self->priv->cancel_button);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->_cancellable);
	G_OBJECT_CLASS (gnonograms_view_progress_indicator_parent_class)->finalize (obj);
}

static GType
gnonograms_view_progress_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewProgressIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_progress_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewProgressIndicator), 0, (GInstanceInitFunc) gnonograms_view_progress_indicator_instance_init, NULL };
	GType gnonograms_view_progress_indicator_type_id;
	gnonograms_view_progress_indicator_type_id = g_type_register_static (gtk_grid_get_type (), "GnonogramsViewProgressIndicator", &g_define_type_info, 0);
	GnonogramsViewProgressIndicator_private_offset = g_type_add_instance_private (gnonograms_view_progress_indicator_type_id, sizeof (GnonogramsViewProgressIndicatorPrivate));
	return gnonograms_view_progress_indicator_type_id;
}

static GType
gnonograms_view_progress_indicator_get_type (void)
{
	static volatile gsize gnonograms_view_progress_indicator_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_progress_indicator_type_id__once)) {
		GType gnonograms_view_progress_indicator_type_id;
		gnonograms_view_progress_indicator_type_id = gnonograms_view_progress_indicator_get_type_once ();
		g_once_init_leave (&gnonograms_view_progress_indicator_type_id__once, gnonograms_view_progress_indicator_type_id);
	}
	return gnonograms_view_progress_indicator_type_id__once;
}

static void
_vala_gnonograms_view_progress_indicator_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	GnonogramsViewProgressIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicator);
	switch (property_id) {
		case GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY:
		g_value_set_object (value, gnonograms_view_progress_indicator_get_cancellable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_progress_indicator_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	GnonogramsViewProgressIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_PROGRESS_INDICATOR, GnonogramsViewProgressIndicator);
	switch (property_id) {
		case GNONOGRAMS_VIEW_PROGRESS_INDICATOR_TEXT_PROPERTY:
		gnonograms_view_progress_indicator_set_text (self, g_value_get_string (value));
		break;
		case GNONOGRAMS_VIEW_PROGRESS_INDICATOR_CANCELLABLE_PROPERTY:
		gnonograms_view_progress_indicator_set_cancellable (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static GnonogramsViewHeaderButton*
gnonograms_view_header_button_construct (GType object_type,
                                         const gchar* icon_name,
                                         const gchar* action_name,
                                         const gchar* text)
{
	GnonogramsViewHeaderButton * self = NULL;
	GtkApplication* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (action_name != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = gnonograms_view_app;
	_tmp2_ = _tmp1_ = gtk_application_get_accels_for_action (_tmp0_, action_name);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	_tmp4_ = granite_markup_accel_tooltip (_tmp3_, (gint) _vala_array_length (_tmp1_), text);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	self = (GnonogramsViewHeaderButton*) g_object_new (object_type, "action-name", action_name, "tooltip-markup", _tmp5_, "image", _tmp7_, NULL);
	_g_object_unref0 (_tmp7_);
	_g_free0 (_tmp5_);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	return self;
}

static GnonogramsViewHeaderButton*
gnonograms_view_header_button_new (const gchar* icon_name,
                                   const gchar* action_name,
                                   const gchar* text)
{
	return gnonograms_view_header_button_construct (GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, icon_name, action_name, text);
}

static GObject *
gnonograms_view_header_button_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewHeaderButton * self;
	parent_class = G_OBJECT_CLASS (gnonograms_view_header_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, GnonogramsViewHeaderButton);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	return obj;
}

static void
gnonograms_view_header_button_class_init (GnonogramsViewHeaderButtonClass * klass,
                                          gpointer klass_data)
{
	gnonograms_view_header_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_header_button_constructor;
}

static void
gnonograms_view_header_button_instance_init (GnonogramsViewHeaderButton * self,
                                             gpointer klass)
{
}

static GType
gnonograms_view_header_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewHeaderButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_header_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewHeaderButton), 0, (GInstanceInitFunc) gnonograms_view_header_button_instance_init, NULL };
	GType gnonograms_view_header_button_type_id;
	gnonograms_view_header_button_type_id = g_type_register_static (gtk_button_get_type (), "GnonogramsViewHeaderButton", &g_define_type_info, 0);
	return gnonograms_view_header_button_type_id;
}

static GType
gnonograms_view_header_button_get_type (void)
{
	static volatile gsize gnonograms_view_header_button_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_header_button_type_id__once)) {
		GType gnonograms_view_header_button_type_id;
		gnonograms_view_header_button_type_id = gnonograms_view_header_button_get_type_once ();
		g_once_init_leave (&gnonograms_view_header_button_type_id__once, gnonograms_view_header_button_type_id);
	}
	return gnonograms_view_header_button_type_id__once;
}

static inline gpointer
gnonograms_view_restart_button_get_instance_private (GnonogramsViewRestartButton* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsViewRestartButton_private_offset);
}

static GnonogramsViewRestartButton*
gnonograms_view_restart_button_construct (GType object_type,
                                          const gchar* icon_name,
                                          const gchar* action_name,
                                          const gchar* text)
{
	GnonogramsViewRestartButton * self = NULL;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (action_name != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	self = (GnonogramsViewRestartButton*) gnonograms_view_header_button_construct (object_type, icon_name, action_name, text);
	return self;
}

static GnonogramsViewRestartButton*
gnonograms_view_restart_button_new (const gchar* icon_name,
                                    const gchar* action_name,
                                    const gchar* text)
{
	return gnonograms_view_restart_button_construct (GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, icon_name, action_name, text);
}

static gboolean
gnonograms_view_restart_button_get_restart_destructive (GnonogramsViewRestartButton* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_restart_destructive;
	return result;
}

static void
gnonograms_view_restart_button_set_restart_destructive (GnonogramsViewRestartButton* self,
                                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_restart_button_get_restart_destructive (self);
	if (old_value != value) {
		self->priv->_restart_destructive = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_restart_button_properties[GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY]);
	}
}

static void
_gnonograms_view_restart_button___lambda27_ (GnonogramsViewRestartButton* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->_restart_destructive;
	if (_tmp0_) {
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkStyleContext* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		GtkStyleContext* _tmp6_;
		_tmp1_ = gtk_button_get_image ((GtkButton*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = gtk_widget_get_style_context (_tmp2_);
		gtk_style_context_add_class (_tmp3_, "warn");
		_tmp4_ = gtk_button_get_image ((GtkButton*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_widget_get_style_context (_tmp5_);
		gtk_style_context_remove_class (_tmp6_, "dim");
	} else {
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkStyleContext* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		GtkStyleContext* _tmp12_;
		_tmp7_ = gtk_button_get_image ((GtkButton*) self);
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_widget_get_style_context (_tmp8_);
		gtk_style_context_remove_class (_tmp9_, "warn");
		_tmp10_ = gtk_button_get_image ((GtkButton*) self);
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_widget_get_style_context (_tmp11_);
		gtk_style_context_add_class (_tmp12_, "dim");
	}
}

static void
__gnonograms_view_restart_button___lambda27__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
	_gnonograms_view_restart_button___lambda27_ ((GnonogramsViewRestartButton*) self);
}

static GObject *
gnonograms_view_restart_button_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewRestartButton * self;
	parent_class = G_OBJECT_CLASS (gnonograms_view_restart_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButton);
	gnonograms_view_restart_button_set_restart_destructive (self, FALSE);
	g_signal_connect_object ((GObject*) self, "notify::restart-destructive", (GCallback) __gnonograms_view_restart_button___lambda27__g_object_notify, self, 0);
	g_object_bind_property_with_closures ((GObject*) self, "sensitive", (GObject*) self, "restart-destructive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	return obj;
}

static void
gnonograms_view_restart_button_class_init (GnonogramsViewRestartButtonClass * klass,
                                           gpointer klass_data)
{
	gnonograms_view_restart_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsViewRestartButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_restart_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_restart_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_restart_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_restart_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY, gnonograms_view_restart_button_properties[GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY] = g_param_spec_boolean ("restart-destructive", "restart-destructive", "restart-destructive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_view_restart_button_instance_init (GnonogramsViewRestartButton * self,
                                              gpointer klass)
{
	self->priv = gnonograms_view_restart_button_get_instance_private (self);
}

static void
gnonograms_view_restart_button_finalize (GObject * obj)
{
	GnonogramsViewRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButton);
	G_OBJECT_CLASS (gnonograms_view_restart_button_parent_class)->finalize (obj);
}

static GType
gnonograms_view_restart_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewRestartButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_restart_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewRestartButton), 0, (GInstanceInitFunc) gnonograms_view_restart_button_instance_init, NULL };
	GType gnonograms_view_restart_button_type_id;
	gnonograms_view_restart_button_type_id = g_type_register_static (GNONOGRAMS_VIEW_TYPE_HEADER_BUTTON, "GnonogramsViewRestartButton", &g_define_type_info, 0);
	GnonogramsViewRestartButton_private_offset = g_type_add_instance_private (gnonograms_view_restart_button_type_id, sizeof (GnonogramsViewRestartButtonPrivate));
	return gnonograms_view_restart_button_type_id;
}

static GType
gnonograms_view_restart_button_get_type (void)
{
	static volatile gsize gnonograms_view_restart_button_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_restart_button_type_id__once)) {
		GType gnonograms_view_restart_button_type_id;
		gnonograms_view_restart_button_type_id = gnonograms_view_restart_button_get_type_once ();
		g_once_init_leave (&gnonograms_view_restart_button_type_id__once, gnonograms_view_restart_button_type_id);
	}
	return gnonograms_view_restart_button_type_id__once;
}

static void
_vala_gnonograms_view_restart_button_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GnonogramsViewRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButton);
	switch (property_id) {
		case GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_restart_button_get_restart_destructive (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_restart_button_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GnonogramsViewRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_RESTART_BUTTON, GnonogramsViewRestartButton);
	switch (property_id) {
		case GNONOGRAMS_VIEW_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY:
		gnonograms_view_restart_button_set_restart_destructive (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
gnonograms_view_app_menu_get_instance_private (GnonogramsViewAppMenu* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsViewAppMenu_private_offset);
}

static GnonogramsViewAppMenu*
gnonograms_view_app_menu_construct (GType object_type,
                                    GnonogramsController* controller)
{
	GnonogramsViewAppMenu * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	g_return_val_if_fail (controller != NULL, NULL);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	self = (GnonogramsViewAppMenu*) g_object_new (object_type, "image", _tmp1_, "tooltip-text", _ ("Options"), "controller", controller, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

static GnonogramsViewAppMenu*
gnonograms_view_app_menu_new (GnonogramsController* controller)
{
	return gnonograms_view_app_menu_construct (GNONOGRAMS_VIEW_TYPE_APP_MENU, controller);
}

static GnonogramsController*
gnonograms_view_app_menu_get_controller (GnonogramsViewAppMenu* self)
{
	GnonogramsController* result;
	GnonogramsController* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_controller;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_app_menu_set_controller (GnonogramsViewAppMenu* self,
                                         GnonogramsController* value)
{
	GnonogramsController* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_app_menu_get_controller (self);
	if (old_value != value) {
		self->priv->_controller = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_app_menu_properties[GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY]);
	}
}

static GnonogramsViewAppMenuGradeChooser*
gnonograms_view_app_menu_grade_chooser_construct (GType object_type)
{
	GnonogramsViewAppMenuGradeChooser * self = NULL;
	gint _tmp0_ = 0;
	GnonogramsDifficulty* _tmp1_;
	self = (GnonogramsViewAppMenuGradeChooser*) g_object_new (object_type, "expand", FALSE, NULL);
	_tmp1_ = gnonograms_difficulty_all_human (&_tmp0_);
	{
		GnonogramsDifficulty* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
		d_collection = _tmp1_;
		d_collection_length1 = _tmp0_;
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
			GnonogramsDifficulty d = 0;
			d = d_collection[d_it];
			{
				gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp2_ = g_strdup_printf ("%u", (guint) d);
				_tmp3_ = _tmp2_;
				_tmp4_ = gnonograms_difficulty_to_string (d);
				_tmp5_ = _tmp4_;
				gtk_combo_box_text_append ((GtkComboBoxText*) self, _tmp3_, _tmp5_);
				_g_free0 (_tmp5_);
				_g_free0 (_tmp3_);
			}
		}
		d_collection = (g_free (d_collection), NULL);
	}
	return self;
}

static GnonogramsViewAppMenuGradeChooser*
gnonograms_view_app_menu_grade_chooser_new (void)
{
	return gnonograms_view_app_menu_grade_chooser_construct (GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER);
}

static GnonogramsDifficulty
gnonograms_view_app_menu_grade_chooser_get_grade (GnonogramsViewAppMenuGradeChooser* self)
{
	GnonogramsDifficulty result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gtk_combo_box_get_active_id ((GtkComboBox*) self);
	_tmp1_ = _tmp0_;
	result = (GnonogramsDifficulty) atoi (_tmp1_);
	return result;
}

static void
gnonograms_view_app_menu_grade_chooser_set_grade (GnonogramsViewAppMenuGradeChooser* self,
                                                  GnonogramsDifficulty value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf ("%u", CLAMP ((guint) value, (guint) GNONOGRAMS_MIN_GRADE, (guint) GNONOGRAMS_DIFFICULTY_MAXIMUM));
	_tmp1_ = _tmp0_;
	gtk_combo_box_set_active_id ((GtkComboBox*) self, _tmp1_);
	_g_free0 (_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, gnonograms_view_app_menu_grade_chooser_properties[GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY]);
}

static void
gnonograms_view_app_menu_grade_chooser_class_init (GnonogramsViewAppMenuGradeChooserClass * klass,
                                                   gpointer klass_data)
{
	gnonograms_view_app_menu_grade_chooser_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_app_menu_grade_chooser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_app_menu_grade_chooser_set_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY, gnonograms_view_app_menu_grade_chooser_properties[GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY] = g_param_spec_enum ("grade", "grade", "grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_view_app_menu_grade_chooser_instance_init (GnonogramsViewAppMenuGradeChooser * self,
                                                      gpointer klass)
{
}

static GType
gnonograms_view_app_menu_grade_chooser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewAppMenuGradeChooserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_app_menu_grade_chooser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewAppMenuGradeChooser), 0, (GInstanceInitFunc) gnonograms_view_app_menu_grade_chooser_instance_init, NULL };
	GType gnonograms_view_app_menu_grade_chooser_type_id;
	gnonograms_view_app_menu_grade_chooser_type_id = g_type_register_static (gtk_combo_box_text_get_type (), "GnonogramsViewAppMenuGradeChooser", &g_define_type_info, 0);
	return gnonograms_view_app_menu_grade_chooser_type_id;
}

static GType
gnonograms_view_app_menu_grade_chooser_get_type (void)
{
	static volatile gsize gnonograms_view_app_menu_grade_chooser_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_app_menu_grade_chooser_type_id__once)) {
		GType gnonograms_view_app_menu_grade_chooser_type_id;
		gnonograms_view_app_menu_grade_chooser_type_id = gnonograms_view_app_menu_grade_chooser_get_type_once ();
		g_once_init_leave (&gnonograms_view_app_menu_grade_chooser_type_id__once, gnonograms_view_app_menu_grade_chooser_type_id);
	}
	return gnonograms_view_app_menu_grade_chooser_type_id__once;
}

static void
_vala_gnonograms_view_app_menu_grade_chooser_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	GnonogramsViewAppMenuGradeChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER, GnonogramsViewAppMenuGradeChooser);
	switch (property_id) {
		case GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_app_menu_grade_chooser_get_grade (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_app_menu_grade_chooser_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	GnonogramsViewAppMenuGradeChooser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_APP_MENU_TYPE_GRADE_CHOOSER, GnonogramsViewAppMenuGradeChooser);
	switch (property_id) {
		case GNONOGRAMS_VIEW_APP_MENU_GRADE_CHOOSER_GRADE_PROPERTY:
		gnonograms_view_app_menu_grade_chooser_set_grade (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static GnonogramsViewAppMenuDimensionSpinButton*
gnonograms_view_app_menu_dimension_spin_button_construct (GType object_type)
{
	GnonogramsViewAppMenuDimensionSpinButton * self = NULL;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	_tmp0_ = gtk_adjustment_new (5.0, 5.0, 50.0, 5.0, 5.0, 5.0);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	self = (GnonogramsViewAppMenuDimensionSpinButton*) g_object_new (object_type, "adjustment", _tmp1_, "climb-rate", 5.0, "digits", 0, "snap-to-ticks", TRUE, "orientation", GTK_ORIENTATION_HORIZONTAL, "margin-top", 3, "margin-bottom", 3, "width-chars", 3, "can-focus", TRUE, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

static GnonogramsViewAppMenuDimensionSpinButton*
gnonograms_view_app_menu_dimension_spin_button_new (void)
{
	return gnonograms_view_app_menu_dimension_spin_button_construct (GNONOGRAMS_VIEW_APP_MENU_TYPE_DIMENSION_SPIN_BUTTON);
}

static void
gnonograms_view_app_menu_dimension_spin_button_class_init (GnonogramsViewAppMenuDimensionSpinButtonClass * klass,
                                                           gpointer klass_data)
{
	gnonograms_view_app_menu_dimension_spin_button_parent_class = g_type_class_peek_parent (klass);
}

static void
gnonograms_view_app_menu_dimension_spin_button_instance_init (GnonogramsViewAppMenuDimensionSpinButton * self,
                                                              gpointer klass)
{
}

static GType
gnonograms_view_app_menu_dimension_spin_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewAppMenuDimensionSpinButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_app_menu_dimension_spin_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewAppMenuDimensionSpinButton), 0, (GInstanceInitFunc) gnonograms_view_app_menu_dimension_spin_button_instance_init, NULL };
	GType gnonograms_view_app_menu_dimension_spin_button_type_id;
	gnonograms_view_app_menu_dimension_spin_button_type_id = g_type_register_static (gtk_spin_button_get_type (), "GnonogramsViewAppMenuDimensionSpinButton", &g_define_type_info, 0);
	return gnonograms_view_app_menu_dimension_spin_button_type_id;
}

static GType
gnonograms_view_app_menu_dimension_spin_button_get_type (void)
{
	static volatile gsize gnonograms_view_app_menu_dimension_spin_button_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_app_menu_dimension_spin_button_type_id__once)) {
		GType gnonograms_view_app_menu_dimension_spin_button_type_id;
		gnonograms_view_app_menu_dimension_spin_button_type_id = gnonograms_view_app_menu_dimension_spin_button_get_type_once ();
		g_once_init_leave (&gnonograms_view_app_menu_dimension_spin_button_type_id__once, gnonograms_view_app_menu_dimension_spin_button_type_id);
	}
	return gnonograms_view_app_menu_dimension_spin_button_type_id__once;
}

static inline gpointer
gnonograms_view_app_menu_app_popover_get_instance_private (GnonogramsViewAppMenuAppPopover* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsViewAppMenuAppPopover_private_offset);
}

static GnonogramsViewAppMenuAppPopover*
gnonograms_view_app_menu_app_popover_construct (GType object_type)
{
	GnonogramsViewAppMenuAppPopover * self = NULL;
	self = (GnonogramsViewAppMenuAppPopover*) g_object_new (object_type, NULL);
	return self;
}

static GnonogramsViewAppMenuAppPopover*
gnonograms_view_app_menu_app_popover_new (void)
{
	return gnonograms_view_app_menu_app_popover_construct (GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER);
}

static void
_gnonograms_view_app_menu_app_popover___lambda23_ (GnonogramsViewAppMenuAppPopover* self)
{
	if (!self->priv->cancelled) {
		g_signal_emit (self, gnonograms_view_app_menu_app_popover_signals[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_APPLY_SETTINGS_SIGNAL], 0);
	} else {
		g_signal_emit (self, gnonograms_view_app_menu_app_popover_signals[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_CANCEL_SIGNAL], 0);
	}
	self->priv->cancelled = FALSE;
}

static void
__gnonograms_view_app_menu_app_popover___lambda23__gtk_popover_closed (GtkPopover* _sender,
                                                                       gpointer self)
{
	_gnonograms_view_app_menu_app_popover___lambda23_ ((GnonogramsViewAppMenuAppPopover*) self);
}

static gboolean
_gnonograms_view_app_menu_app_popover___lambda24_ (GnonogramsViewAppMenuAppPopover* self,
                                                   GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	self->priv->cancelled = event->keyval == GDK_KEY_Escape;
	if (event->keyval == GDK_KEY_KP_Enter) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->keyval == GDK_KEY_Return;
	}
	if (_tmp0_) {
		gtk_widget_hide ((GtkWidget*) self);
	}
}

static gboolean
__gnonograms_view_app_menu_app_popover___lambda24__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                               GdkEventKey* event,
                                                                               gpointer self)
{
	gboolean result;
	result = _gnonograms_view_app_menu_app_popover___lambda24_ ((GnonogramsViewAppMenuAppPopover*) self, event);
	return result;
}

static GObject *
gnonograms_view_app_menu_app_popover_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewAppMenuAppPopover * self;
	parent_class = G_OBJECT_CLASS (gnonograms_view_app_menu_app_popover_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, GnonogramsViewAppMenuAppPopover);
	g_signal_connect_object ((GtkPopover*) self, "closed", (GCallback) __gnonograms_view_app_menu_app_popover___lambda23__gtk_popover_closed, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __gnonograms_view_app_menu_app_popover___lambda24__gtk_widget_key_press_event, self, 0);
	return obj;
}

static void
gnonograms_view_app_menu_app_popover_class_init (GnonogramsViewAppMenuAppPopoverClass * klass,
                                                 gpointer klass_data)
{
	gnonograms_view_app_menu_app_popover_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsViewAppMenuAppPopover_private_offset);
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_app_menu_app_popover_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_app_menu_app_popover_finalize;
	gnonograms_view_app_menu_app_popover_signals[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_APPLY_SETTINGS_SIGNAL] = g_signal_new ("apply-settings", GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_app_menu_app_popover_signals[GNONOGRAMS_VIEW_APP_MENU_APP_POPOVER_CANCEL_SIGNAL] = g_signal_new ("cancel", GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
gnonograms_view_app_menu_app_popover_instance_init (GnonogramsViewAppMenuAppPopover * self,
                                                    gpointer klass)
{
	self->priv = gnonograms_view_app_menu_app_popover_get_instance_private (self);
	self->priv->cancelled = FALSE;
}

static void
gnonograms_view_app_menu_app_popover_finalize (GObject * obj)
{
	GnonogramsViewAppMenuAppPopover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_APP_MENU_TYPE_APP_POPOVER, GnonogramsViewAppMenuAppPopover);
	G_OBJECT_CLASS (gnonograms_view_app_menu_app_popover_parent_class)->finalize (obj);
}

/** Popover that can be cancelled with Escape and closed by Enter **/
static GType
gnonograms_view_app_menu_app_popover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewAppMenuAppPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_app_menu_app_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewAppMenuAppPopover), 0, (GInstanceInitFunc) gnonograms_view_app_menu_app_popover_instance_init, NULL };
	GType gnonograms_view_app_menu_app_popover_type_id;
	gnonograms_view_app_menu_app_popover_type_id = g_type_register_static (gtk_popover_get_type (), "GnonogramsViewAppMenuAppPopover", &g_define_type_info, 0);
	GnonogramsViewAppMenuAppPopover_private_offset = g_type_add_instance_private (gnonograms_view_app_menu_app_popover_type_id, sizeof (GnonogramsViewAppMenuAppPopoverPrivate));
	return gnonograms_view_app_menu_app_popover_type_id;
}

static GType
gnonograms_view_app_menu_app_popover_get_type (void)
{
	static volatile gsize gnonograms_view_app_menu_app_popover_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_app_menu_app_popover_type_id__once)) {
		GType gnonograms_view_app_menu_app_popover_type_id;
		gnonograms_view_app_menu_app_popover_type_id = gnonograms_view_app_menu_app_popover_get_type_once ();
		g_once_init_leave (&gnonograms_view_app_menu_app_popover_type_id__once, gnonograms_view_app_menu_app_popover_type_id);
	}
	return gnonograms_view_app_menu_app_popover_type_id__once;
}

static GnonogramsViewAppMenuSettingLabel*
gnonograms_view_app_menu_setting_label_construct (GType object_type,
                                                  const gchar* text)
{
	GnonogramsViewAppMenuSettingLabel * self = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	self = (GnonogramsViewAppMenuSettingLabel*) g_object_new (object_type, "label", text, "xalign", 1.0f, "margin-end", 6, NULL);
	return self;
}

static GnonogramsViewAppMenuSettingLabel*
gnonograms_view_app_menu_setting_label_new (const gchar* text)
{
	return gnonograms_view_app_menu_setting_label_construct (GNONOGRAMS_VIEW_APP_MENU_TYPE_SETTING_LABEL, text);
}

static void
gnonograms_view_app_menu_setting_label_class_init (GnonogramsViewAppMenuSettingLabelClass * klass,
                                                   gpointer klass_data)
{
	gnonograms_view_app_menu_setting_label_parent_class = g_type_class_peek_parent (klass);
}

static void
gnonograms_view_app_menu_setting_label_instance_init (GnonogramsViewAppMenuSettingLabel * self,
                                                      gpointer klass)
{
}

static GType
gnonograms_view_app_menu_setting_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewAppMenuSettingLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_app_menu_setting_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewAppMenuSettingLabel), 0, (GInstanceInitFunc) gnonograms_view_app_menu_setting_label_instance_init, NULL };
	GType gnonograms_view_app_menu_setting_label_type_id;
	gnonograms_view_app_menu_setting_label_type_id = g_type_register_static (gtk_label_get_type (), "GnonogramsViewAppMenuSettingLabel", &g_define_type_info, 0);
	return gnonograms_view_app_menu_setting_label_type_id;
}

static GType
gnonograms_view_app_menu_setting_label_get_type (void)
{
	static volatile gsize gnonograms_view_app_menu_setting_label_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_app_menu_setting_label_type_id__once)) {
		GType gnonograms_view_app_menu_setting_label_type_id;
		gnonograms_view_app_menu_setting_label_type_id = gnonograms_view_app_menu_setting_label_get_type_once ();
		g_once_init_leave (&gnonograms_view_app_menu_setting_label_type_id__once, gnonograms_view_app_menu_setting_label_type_id);
	}
	return gnonograms_view_app_menu_setting_label_type_id__once;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		GnonogramsViewAppMenu* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->title_setting);
		_g_object_unref0 (_data5_->column_setting);
		_g_object_unref0 (_data5_->row_setting);
		_g_object_unref0 (_data5_->grade_setting);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
_gnonograms_view_app_menu___lambda25_ (Block5Data* _data5_)
{
	GnonogramsViewAppMenu* self;
	GnonogramsController* _tmp0_;
	GnonogramsViewAppMenuGradeChooser* _tmp1_;
	GnonogramsDifficulty _tmp2_;
	GnonogramsDifficulty _tmp3_;
	GnonogramsController* _tmp4_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	GnonogramsDimensions _tmp11_ = {0};
	GnonogramsController* _tmp12_;
	GtkEntry* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	self = _data5_->self;
	_tmp0_ = self->priv->_controller;
	_tmp1_ = _data5_->grade_setting;
	_tmp2_ = gnonograms_view_app_menu_grade_chooser_get_grade (_tmp1_);
	_tmp3_ = _tmp2_;
	gnonograms_controller_set_generator_grade (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->_controller;
	_tmp5_ = _data5_->column_setting;
	_tmp6_ = gtk_spin_button_get_value ((GtkSpinButton*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _data5_->row_setting;
	_tmp9_ = gtk_spin_button_get_value ((GtkSpinButton*) _tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_.width = (guint) _tmp7_;
	_tmp11_.height = (guint) _tmp10_;
	gnonograms_controller_set_dimensions (_tmp4_, &_tmp11_);
	_tmp12_ = self->priv->_controller;
	_tmp13_ = _data5_->title_setting;
	_tmp14_ = gtk_entry_get_text (_tmp13_);
	_tmp15_ = _tmp14_;
	gnonograms_controller_set_game_name (_tmp12_, _tmp15_);
}

static void
__gnonograms_view_app_menu___lambda25__gnonograms_view_app_menu_app_popover_apply_settings (GnonogramsViewAppMenuAppPopover* _sender,
                                                                                            gpointer self)
{
	_gnonograms_view_app_menu___lambda25_ (self);
}

static void
_gnonograms_view_app_menu___lambda26_ (Block5Data* _data5_)
{
	GnonogramsViewAppMenu* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data5_->self;
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GnonogramsViewAppMenuGradeChooser* _tmp2_;
		GnonogramsController* _tmp3_;
		GnonogramsDifficulty _tmp4_;
		GnonogramsDifficulty _tmp5_;
		GnonogramsViewAppMenuDimensionSpinButton* _tmp6_;
		GnonogramsController* _tmp7_;
		GnonogramsDimensions _tmp8_ = {0};
		GnonogramsDimensions _tmp9_;
		GnonogramsViewAppMenuDimensionSpinButton* _tmp10_;
		GnonogramsController* _tmp11_;
		GnonogramsDimensions _tmp12_ = {0};
		GnonogramsDimensions _tmp13_;
		GtkEntry* _tmp14_;
		GnonogramsController* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GtkPopover* _tmp18_;
		GtkPopover* _tmp19_;
		_tmp2_ = _data5_->grade_setting;
		_tmp3_ = self->priv->_controller;
		_tmp4_ = gnonograms_controller_get_generator_grade (_tmp3_);
		_tmp5_ = _tmp4_;
		gnonograms_view_app_menu_grade_chooser_set_grade (_tmp2_, _tmp5_);
		_tmp6_ = _data5_->row_setting;
		_tmp7_ = self->priv->_controller;
		gnonograms_controller_get_dimensions (_tmp7_, &_tmp8_);
		_tmp9_ = _tmp8_;
		gtk_spin_button_set_value ((GtkSpinButton*) _tmp6_, (gdouble) _tmp9_.height);
		_tmp10_ = _data5_->column_setting;
		_tmp11_ = self->priv->_controller;
		gnonograms_controller_get_dimensions (_tmp11_, &_tmp12_);
		_tmp13_ = _tmp12_;
		gtk_spin_button_set_value ((GtkSpinButton*) _tmp10_, (gdouble) _tmp13_.width);
		_tmp14_ = _data5_->title_setting;
		_tmp15_ = self->priv->_controller;
		_tmp16_ = gnonograms_controller_get_game_name (_tmp15_);
		_tmp17_ = _tmp16_;
		gtk_entry_set_text (_tmp14_, _tmp17_);
		_tmp18_ = gtk_menu_button_get_popover ((GtkMenuButton*) self);
		_tmp19_ = _tmp18_;
		gtk_widget_show_all ((GtkWidget*) _tmp19_);
	}
}

static void
__gnonograms_view_app_menu___lambda26__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_gnonograms_view_app_menu___lambda26_ (self);
}

static GObject *
gnonograms_view_app_menu_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsViewAppMenu * self;
	Block5Data* _data5_;
	GtkButton* zoom_out_button = NULL;
	gchar* _tmp0_;
	GtkApplication* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	GtkButton* _tmp6_ = NULL;
	GtkButton* _tmp7_;
	GtkButton* zoom_in_button = NULL;
	gchar* _tmp8_;
	GtkApplication* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkGrid* size_grid = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkGrid* _tmp19_;
	GtkButton* _tmp20_;
	GtkGrid* _tmp21_;
	GtkButton* _tmp22_;
	GnonogramsViewAppMenuGradeChooser* _tmp23_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp24_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp25_;
	gchar* _tmp26_;
	GtkEntry* _tmp27_ = NULL;
	GtkGrid* settings_grid = NULL;
	GtkGrid* _tmp28_ = NULL;
	GtkGrid* _tmp29_;
	GnonogramsViewAppMenuSettingLabel* _tmp30_;
	GnonogramsViewAppMenuSettingLabel* _tmp31_;
	GtkGrid* _tmp32_;
	GtkEntry* _tmp33_;
	GtkGrid* _tmp34_;
	GnonogramsViewAppMenuSettingLabel* _tmp35_;
	GnonogramsViewAppMenuSettingLabel* _tmp36_;
	GtkGrid* _tmp37_;
	GnonogramsViewAppMenuGradeChooser* _tmp38_;
	GtkGrid* _tmp39_;
	GnonogramsViewAppMenuSettingLabel* _tmp40_;
	GnonogramsViewAppMenuSettingLabel* _tmp41_;
	GtkGrid* _tmp42_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp43_;
	GtkGrid* _tmp44_;
	GnonogramsViewAppMenuSettingLabel* _tmp45_;
	GnonogramsViewAppMenuSettingLabel* _tmp46_;
	GtkGrid* _tmp47_;
	GnonogramsViewAppMenuDimensionSpinButton* _tmp48_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp49_ = NULL;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GnonogramsViewAppMenuAppPopover* app_popover = NULL;
	GnonogramsViewAppMenuAppPopover* _tmp54_;
	GnonogramsViewAppMenuAppPopover* _tmp55_;
	GtkGrid* _tmp56_;
	GnonogramsViewAppMenuAppPopover* _tmp57_;
	GnonogramsViewAppMenuAppPopover* _tmp58_;
	parent_class = G_OBJECT_CLASS (gnonograms_view_app_menu_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenu);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = g_strdup (GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_ZOOM_OUT);
	_tmp1_ = gnonograms_view_app;
	_tmp3_ = _tmp2_ = gtk_application_get_accels_for_action (_tmp1_, GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_ZOOM_OUT);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _vala_array_length (_tmp2_);
	_tmp5_ = granite_markup_accel_tooltip (_tmp4_, (gint) _vala_array_length (_tmp2_), _ ("Zoom out"));
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-out-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, _tmp0_);
	_g_free0 (_tmp0_);
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp6_, _tmp5_);
	_g_free0 (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
	zoom_out_button = _tmp7_;
	_tmp8_ = g_strdup (GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_ZOOM_IN);
	_tmp9_ = gnonograms_view_app;
	_tmp11_ = _tmp10_ = gtk_application_get_accels_for_action (_tmp9_, GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_ZOOM_IN);
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _vala_array_length (_tmp10_);
	_tmp13_ = granite_markup_accel_tooltip (_tmp12_, (gint) _vala_array_length (_tmp10_), _ ("Zoom in"));
	_tmp14_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-in-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_actionable_set_action_name ((GtkActionable*) _tmp14_, _tmp8_);
	_g_free0 (_tmp8_);
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp14_, _tmp13_);
	_g_free0 (_tmp13_);
	g_object_ref_sink (_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
	zoom_in_button = _tmp15_;
	_tmp16_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_homogeneous (_tmp16_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
	g_object_set ((GtkWidget*) _tmp16_, "margin", 12, NULL);
	g_object_ref_sink (_tmp16_);
	size_grid = _tmp16_;
	_tmp17_ = size_grid;
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_LINKED);
	_tmp19_ = size_grid;
	_tmp20_ = zoom_out_button;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = size_grid;
	_tmp22_ = zoom_in_button;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = gnonograms_view_app_menu_grade_chooser_new ();
	g_object_ref_sink (_tmp23_);
	_data5_->grade_setting = _tmp23_;
	_tmp24_ = gnonograms_view_app_menu_dimension_spin_button_new ();
	g_object_ref_sink (_tmp24_);
	_data5_->row_setting = _tmp24_;
	_tmp25_ = gnonograms_view_app_menu_dimension_spin_button_new ();
	g_object_ref_sink (_tmp25_);
	_data5_->column_setting = _tmp25_;
	_tmp26_ = g_strdup (_ ("Enter title of game here"));
	_tmp27_ = (GtkEntry*) gtk_entry_new ();
	gtk_entry_set_placeholder_text (_tmp27_, _tmp26_);
	_g_free0 (_tmp26_);
	g_object_ref_sink (_tmp27_);
	_data5_->title_setting = _tmp27_;
	_tmp28_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp28_, GTK_ORIENTATION_VERTICAL);
	g_object_set ((GtkWidget*) _tmp28_, "margin", 12, NULL);
	gtk_grid_set_row_spacing (_tmp28_, 6);
	gtk_grid_set_column_homogeneous (_tmp28_, FALSE);
	g_object_ref_sink (_tmp28_);
	settings_grid = _tmp28_;
	_tmp29_ = settings_grid;
	_tmp30_ = gnonograms_view_app_menu_setting_label_new (_ ("Name:"));
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp31_, 0, 0, 1, 1);
	_g_object_unref0 (_tmp31_);
	_tmp32_ = settings_grid;
	_tmp33_ = _data5_->title_setting;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 1, 0, 3, 1);
	_tmp34_ = settings_grid;
	_tmp35_ = gnonograms_view_app_menu_setting_label_new (_ ("Difficulty:"));
	g_object_ref_sink (_tmp35_);
	_tmp36_ = _tmp35_;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp36_, 0, 1, 1, 1);
	_g_object_unref0 (_tmp36_);
	_tmp37_ = settings_grid;
	_tmp38_ = _data5_->grade_setting;
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 1, 1, 3, 1);
	_tmp39_ = settings_grid;
	_tmp40_ = gnonograms_view_app_menu_setting_label_new (_ ("Rows:"));
	g_object_ref_sink (_tmp40_);
	_tmp41_ = _tmp40_;
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp41_, 0, 2, 1, 1);
	_g_object_unref0 (_tmp41_);
	_tmp42_ = settings_grid;
	_tmp43_ = _data5_->row_setting;
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 1, 2, 1, 1);
	_tmp44_ = settings_grid;
	_tmp45_ = gnonograms_view_app_menu_setting_label_new (_ ("Columns:"));
	g_object_ref_sink (_tmp45_);
	_tmp46_ = _tmp45_;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp46_, 0, 3, 1, 1);
	_g_object_unref0 (_tmp46_);
	_tmp47_ = settings_grid;
	_tmp48_ = _data5_->column_setting;
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 1, 3, 1, 1);
	_tmp49_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp49_, GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp49_);
	main_grid = _tmp49_;
	_tmp50_ = main_grid;
	_tmp51_ = size_grid;
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
	_tmp52_ = main_grid;
	_tmp53_ = settings_grid;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = gnonograms_view_app_menu_app_popover_new ();
	g_object_ref_sink (_tmp54_);
	app_popover = _tmp54_;
	_tmp55_ = app_popover;
	_tmp56_ = main_grid;
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = app_popover;
	gtk_menu_button_set_popover ((GtkMenuButton*) self, (GtkWidget*) _tmp57_);
	_tmp58_ = app_popover;
	g_signal_connect_data (_tmp58_, "apply-settings", (GCallback) __gnonograms_view_app_menu___lambda25__gnonograms_view_app_menu_app_popover_apply_settings, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	g_signal_connect_data ((GtkToggleButton*) self, "toggled", (GCallback) __gnonograms_view_app_menu___lambda26__gtk_toggle_button_toggled, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_g_object_unref0 (app_popover);
	_g_object_unref0 (main_grid);
	_g_object_unref0 (settings_grid);
	_g_object_unref0 (size_grid);
	_g_object_unref0 (zoom_in_button);
	_g_object_unref0 (zoom_out_button);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return obj;
}

static void
gnonograms_view_app_menu_class_init (GnonogramsViewAppMenuClass * klass,
                                     gpointer klass_data)
{
	gnonograms_view_app_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsViewAppMenu_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_app_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_app_menu_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_app_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_app_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY, gnonograms_view_app_menu_properties[GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", GNONOGRAMS_TYPE_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
gnonograms_view_app_menu_instance_init (GnonogramsViewAppMenu * self,
                                        gpointer klass)
{
	self->priv = gnonograms_view_app_menu_get_instance_private (self);
}

static void
gnonograms_view_app_menu_finalize (GObject * obj)
{
	GnonogramsViewAppMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenu);
	G_OBJECT_CLASS (gnonograms_view_app_menu_parent_class)->finalize (obj);
}

static GType
gnonograms_view_app_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewAppMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_app_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsViewAppMenu), 0, (GInstanceInitFunc) gnonograms_view_app_menu_instance_init, NULL };
	GType gnonograms_view_app_menu_type_id;
	gnonograms_view_app_menu_type_id = g_type_register_static (gtk_menu_button_get_type (), "GnonogramsViewAppMenu", &g_define_type_info, 0);
	GnonogramsViewAppMenu_private_offset = g_type_add_instance_private (gnonograms_view_app_menu_type_id, sizeof (GnonogramsViewAppMenuPrivate));
	return gnonograms_view_app_menu_type_id;
}

static GType
gnonograms_view_app_menu_get_type (void)
{
	static volatile gsize gnonograms_view_app_menu_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_app_menu_type_id__once)) {
		GType gnonograms_view_app_menu_type_id;
		gnonograms_view_app_menu_type_id = gnonograms_view_app_menu_get_type_once ();
		g_once_init_leave (&gnonograms_view_app_menu_type_id__once, gnonograms_view_app_menu_type_id);
	}
	return gnonograms_view_app_menu_type_id__once;
}

static void
_vala_gnonograms_view_app_menu_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GnonogramsViewAppMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenu);
	switch (property_id) {
		case GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY:
		g_value_set_object (value, gnonograms_view_app_menu_get_controller (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_app_menu_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GnonogramsViewAppMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_VIEW_TYPE_APP_MENU, GnonogramsViewAppMenu);
	switch (property_id) {
		case GNONOGRAMS_VIEW_APP_MENU_CONTROLLER_PROPERTY:
		gnonograms_view_app_menu_set_controller (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
_gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                               GdkEventScroll* event,
                                                               gpointer self)
{
	gboolean result;
	result = gnonograms_view_on_grid_scroll_event ((GnonogramsView*) self, event);
	return result;
}

static void
_gnonograms_view___lambda28_ (GnonogramsView* self)
{
	GnonogramsGameState _tmp0_ = 0;
	GraniteModeSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GnonogramsController* _tmp4_;
	_tmp1_ = self->priv->mode_switch;
	_tmp2_ = granite_mode_switch_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp0_ = GNONOGRAMS_GAME_STATE_SETTING;
	}
	_tmp4_ = self->priv->_controller;
	gnonograms_controller_set_game_state (_tmp4_, _tmp0_);
}

static void
__gnonograms_view___lambda28__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda28_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda29_ (GnonogramsView* self)
{
	GnonogramsController* _tmp0_;
	GnonogramsGameState _tmp1_;
	GnonogramsGameState _tmp2_;
	_tmp0_ = self->priv->_controller;
	_tmp1_ = gnonograms_controller_get_game_state (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != GNONOGRAMS_GAME_STATE_UNDEFINED) {
		gnonograms_view_update_all_labels_completeness (self);
	}
	gnonograms_view_update_header_bar (self);
}

static void
__gnonograms_view___lambda29__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda29_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda30_ (GnonogramsView* self)
{
	gnonograms_view_update_title (self);
}

static void
__gnonograms_view___lambda30__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda30_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda31_ (GnonogramsView* self)
{
	gnonograms_view_update_title (self);
}

static void
__gnonograms_view___lambda31__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda31_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda32_ (GnonogramsView* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->save_game_button;
	_tmp1_ = self->priv->_readonly;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_);
}

static void
__gnonograms_view___lambda32__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda32_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda33_ (GnonogramsView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	_tmp1_ = self->priv->_can_go_back;
	if (_tmp1_) {
		GnonogramsController* _tmp2_;
		GnonogramsGameState _tmp3_;
		GnonogramsGameState _tmp4_;
		_tmp2_ = self->priv->_controller;
		_tmp3_ = gnonograms_controller_get_game_state (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = self->priv->check_correct_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, _tmp0_);
	_tmp6_ = self->priv->undo_button;
	_tmp7_ = self->priv->_can_go_back;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp7_);
	_tmp8_ = self->priv->_restart_destructive;
	_tmp9_ = self->priv->_can_go_back;
	gnonograms_view_set_restart_destructive (self, _tmp8_ | _tmp9_);
}

static void
__gnonograms_view___lambda33__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda33_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda34_ (GnonogramsView* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->redo_button;
	_tmp1_ = self->priv->_can_go_forward;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_);
}

static void
__gnonograms_view___lambda34__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda34_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda35_ (GnonogramsView* self)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_;
	_tmp0_ = self->priv->_previous_cell;
	gnonograms_view_highlight_labels (self, &_tmp0_, FALSE);
	_tmp1_ = self->priv->_current_cell;
	gnonograms_view_highlight_labels (self, &_tmp1_, TRUE);
	if (self->priv->drawing_with_state != GNONOGRAMS_CELL_STATE_UNDEFINED) {
		GnonogramsCell _tmp2_;
		_tmp2_ = self->priv->_current_cell;
		gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp2_);
	}
}

static void
__gnonograms_view___lambda35__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda35_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda36_ (GnonogramsView* self)
{
	gnonograms_view_update_all_labels_completeness (self);
}

static void
__gnonograms_view___lambda36__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda36_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda37_ (GnonogramsView* self)
{
	GdkRectangle monitor_area = {0};
	GdkRectangle _tmp0_ = {0};
	GdkWindow* window = NULL;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	gdouble available_screen_width = 0.0;
	GdkRectangle _tmp8_;
	gdouble max_cell_width = 0.0;
	GnonogramsController* _tmp9_;
	GnonogramsDimensions _tmp10_ = {0};
	GnonogramsDimensions _tmp11_;
	gint available_grid_height = 0;
	GdkWindow* _tmp12_;
	HdyHeaderBar* _tmp13_;
	gint opt_cell_height = 0;
	GnonogramsController* _tmp14_;
	GnonogramsDimensions _tmp15_ = {0};
	GnonogramsDimensions _tmp16_;
	gdouble available_screen_height = 0.0;
	GdkRectangle _tmp17_;
	HdyHeaderBar* _tmp18_;
	gdouble max_cell_height = 0.0;
	GnonogramsController* _tmp19_;
	GnonogramsDimensions _tmp20_ = {0};
	GnonogramsDimensions _tmp21_;
	gint max_cell_size = 0;
	gint _tmp22_;
	memset (&_tmp0_, 0, sizeof (GdkRectangle));
	_tmp0_.width = 1024;
	_tmp0_.height = 768;
	monitor_area = _tmp0_;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	window = _tmp2_;
	_tmp3_ = window;
	if (_tmp3_ != NULL) {
		GdkScreen* _tmp4_;
		GdkScreen* _tmp5_;
		GdkWindow* _tmp6_;
		GdkRectangle _tmp7_ = {0};
		_tmp4_ = gtk_window_get_screen ((GtkWindow*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = window;
		gnonograms_utils_get_monitor_area (_tmp5_, _tmp6_, &_tmp7_);
		monitor_area = _tmp7_;
	}
	_tmp8_ = monitor_area;
	available_screen_width = ((_tmp8_.width * 0.9) - (2 * GNONOGRAMS_VIEW_GRID_BORDER)) - GNONOGRAMS_VIEW_GRID_COLUMN_SPACING;
	_tmp9_ = self->priv->_controller;
	gnonograms_controller_get_dimensions (_tmp9_, &_tmp10_);
	_tmp11_ = _tmp10_;
	max_cell_width = available_screen_width / (_tmp11_.width * (1.0 + GNONOGRAMS_GRID_LABELBOX_RATIO));
	_tmp12_ = window;
	_tmp13_ = self->priv->header_bar;
	available_grid_height = (gint) ((gdk_window_get_height (_tmp12_) - gtk_widget_get_allocated_height ((GtkWidget*) _tmp13_)) - (2 * GNONOGRAMS_VIEW_GRID_BORDER));
	_tmp14_ = self->priv->_controller;
	gnonograms_controller_get_dimensions (_tmp14_, &_tmp15_);
	_tmp16_ = _tmp15_;
	opt_cell_height = (gint) (available_grid_height / (_tmp16_.height * (1.0 + GNONOGRAMS_GRID_LABELBOX_RATIO)));
	_tmp17_ = monitor_area;
	_tmp18_ = self->priv->header_bar;
	available_screen_height = ((_tmp17_.height * 0.9) - gtk_widget_get_allocated_height ((GtkWidget*) _tmp18_)) - (2 * GNONOGRAMS_VIEW_GRID_BORDER);
	_tmp19_ = self->priv->_controller;
	gnonograms_controller_get_dimensions (_tmp19_, &_tmp20_);
	_tmp21_ = _tmp20_;
	max_cell_height = available_screen_height / (_tmp21_.height * (1.0 + GNONOGRAMS_GRID_LABELBOX_RATIO));
	max_cell_size = (gint) MIN (max_cell_width, max_cell_height);
	_tmp22_ = self->priv->_cell_size;
	if (max_cell_size < _tmp22_) {
		gnonograms_view_set_cell_size (self, max_cell_size);
	} else {
		gint _tmp23_;
		_tmp23_ = self->priv->_cell_size;
		if (_tmp23_ < opt_cell_height) {
			gnonograms_view_set_cell_size (self, MIN (max_cell_size, opt_cell_height));
		}
	}
	_g_object_unref0 (window);
}

static void
__gnonograms_view___lambda37__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda37_ ((GnonogramsView*) self);
}

static gboolean
_gnonograms_view___lambda38_ (GnonogramsView* self)
{
	GnonogramsLabelBox* _tmp0_;
	GnonogramsLabelBox* _tmp1_;
	gboolean result;
	_tmp0_ = self->priv->row_clue_box;
	gnonograms_label_box_unhighlight_all (_tmp0_);
	_tmp1_ = self->priv->column_clue_box;
	gnonograms_label_box_unhighlight_all (_tmp1_);
	result = FALSE;
	return result;
}

static gboolean
__gnonograms_view___lambda38__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                             GdkEventCrossing* event,
                                                             gpointer self)
{
	gboolean result;
	result = _gnonograms_view___lambda38_ ((GnonogramsView*) self);
	return result;
}

static gboolean
_gnonograms_view___lambda39_ (GnonogramsView* self,
                              GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsCell _tmp6_;
	gboolean result;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->type == GDK_2BUTTON_PRESS) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->button == ((guint) GDK_BUTTON_MIDDLE);
	}
	if (_tmp0_) {
		GnonogramsCellState _tmp1_ = 0;
		GnonogramsController* _tmp2_;
		GnonogramsGameState _tmp3_;
		GnonogramsGameState _tmp4_;
		_tmp2_ = self->priv->_controller;
		_tmp3_ = gnonograms_controller_get_game_state (_tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == GNONOGRAMS_GAME_STATE_SOLVING) {
			_tmp1_ = GNONOGRAMS_CELL_STATE_UNKNOWN;
		} else {
			_tmp1_ = GNONOGRAMS_CELL_STATE_EMPTY;
		}
		self->priv->drawing_with_state = _tmp1_;
	} else {
		GnonogramsCellState _tmp5_ = 0;
		if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
			_tmp5_ = GNONOGRAMS_CELL_STATE_FILLED;
		} else {
			_tmp5_ = GNONOGRAMS_CELL_STATE_EMPTY;
		}
		self->priv->drawing_with_state = _tmp5_;
	}
	_tmp6_ = self->priv->_current_cell;
	gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp6_);
	result = TRUE;
	return result;
}

static gboolean
__gnonograms_view___lambda39__gtk_widget_button_press_event (GtkWidget* _sender,
                                                             GdkEventButton* event,
                                                             gpointer self)
{
	gboolean result;
	result = _gnonograms_view___lambda39_ ((GnonogramsView*) self, event);
	return result;
}

static gboolean
_gnonograms_view___lambda40_ (GnonogramsView* self,
                              GdkEventKey* event)
{
	gboolean result;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == self->priv->drawing_with_key) {
		gnonograms_view_stop_painting (self);
	}
	result = FALSE;
	return result;
}

static gboolean
__gnonograms_view___lambda40__gtk_widget_key_release_event (GtkWidget* _sender,
                                                            GdkEventKey* event,
                                                            gpointer self)
{
	gboolean result;
	result = _gnonograms_view___lambda40_ ((GnonogramsView*) self, event);
	return result;
}

static gboolean
_gnonograms_view_stop_painting_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = gnonograms_view_stop_painting ((GnonogramsView*) self);
	return result;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		GnonogramsView* self;
		self = _data6_->self;
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
__lambda42_ (Block6Data* _data6_)
{
	GnonogramsView* self;
	gdouble width = 0.0;
	GtkAllocation _tmp0_;
	gdouble height = 0.0;
	GtkAllocation _tmp1_;
	gboolean result;
	self = _data6_->self;
	_tmp0_ = _data6_->alloc;
	width = _tmp0_.width * (1 + GNONOGRAMS_GRID_LABELBOX_RATIO);
	_tmp1_ = _data6_->alloc;
	height = _tmp1_.height * (1 + GNONOGRAMS_GRID_LABELBOX_RATIO);
	gtk_window_resize ((GtkWindow*) self, (gint) width, (gint) height);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda42__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda42_ (self);
	return result;
}

static void
_gnonograms_view___lambda41_ (GnonogramsView* self,
                              GtkAllocation* alloc)
{
	Block6Data* _data6_;
	GtkAllocation _tmp0_;
	g_return_if_fail (alloc != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = *alloc;
	_data6_->alloc = _tmp0_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda42__gsource_func, block6_data_ref (_data6_), block6_data_unref);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}

static void
__gnonograms_view___lambda41__gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
	_gnonograms_view___lambda41_ ((GnonogramsView*) self, allocation);
}

static GObject *
gnonograms_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsView * self;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GSimpleActionGroup* view_actions = NULL;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GActionEntry* _tmp4_;
	gint _tmp4__length1;
	GSimpleActionGroup* _tmp5_;
	GnonogramsViewHeaderButton* _tmp26_;
	GnonogramsViewHeaderButton* _tmp27_;
	GnonogramsViewHeaderButton* _tmp28_;
	GnonogramsViewHeaderButton* _tmp29_;
	GnonogramsViewHeaderButton* _tmp30_;
	GnonogramsViewHeaderButton* _tmp31_;
	GnonogramsViewRestartButton* _tmp32_ = NULL;
	GnonogramsViewHeaderButton* _tmp33_;
	GnonogramsViewHeaderButton* _tmp34_;
	GnonogramsViewHeaderButton* _tmp35_;
	GnonogramsController* _tmp36_;
	GtkApplication* _tmp37_;
	gchar** _tmp38_;
	gchar** _tmp39_;
	gchar** _tmp40_;
	gint _tmp40__length1;
	gchar* _tmp41_;
	GnonogramsViewAppMenu* _tmp42_ = NULL;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GraniteModeSwitch* _tmp45_ = NULL;
	GnonogramsViewProgressIndicator* _tmp46_;
	GtkLabel* _tmp47_ = NULL;
	GtkLabel* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_ = NULL;
	GtkLabel* _tmp52_;
	GtkStyleContext* _tmp53_;
	GtkGrid* title_grid = NULL;
	GtkGrid* _tmp54_ = NULL;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLabel* _tmp58_;
	GtkGrid* _tmp59_;
	GtkStack* _tmp60_;
	GtkStack* _tmp61_;
	GnonogramsViewProgressIndicator* _tmp62_;
	GtkStack* _tmp63_;
	GtkGrid* _tmp64_;
	GtkStack* _tmp65_;
	GtkStack* _tmp66_;
	GtkWidget* _tmp67_;
	HdyHeaderBar* _tmp68_ = NULL;
	HdyHeaderBar* _tmp69_;
	GtkStyleContext* _tmp70_;
	HdyHeaderBar* _tmp71_;
	GtkButton* _tmp72_;
	HdyHeaderBar* _tmp73_;
	GtkButton* _tmp74_;
	HdyHeaderBar* _tmp75_;
	GtkButton* _tmp76_;
	HdyHeaderBar* _tmp77_;
	GtkButton* _tmp78_;
	HdyHeaderBar* _tmp79_;
	GtkButton* _tmp80_;
	HdyHeaderBar* _tmp81_;
	GtkButton* _tmp82_;
	HdyHeaderBar* _tmp83_;
	GtkButton* _tmp84_;
	HdyHeaderBar* _tmp85_;
	GnonogramsViewAppMenu* _tmp86_;
	HdyHeaderBar* _tmp87_;
	GtkButton* _tmp88_;
	HdyHeaderBar* _tmp89_;
	GraniteModeSwitch* _tmp90_;
	HdyHeaderBar* _tmp91_;
	GtkButton* _tmp92_;
	HdyHeaderBar* _tmp93_;
	GtkButton* _tmp94_;
	GraniteWidgetsToast* _tmp95_ = NULL;
	GraniteWidgetsToast* _tmp96_;
	GnonogramsLabelBox* _tmp97_;
	GnonogramsLabelBox* _tmp98_;
	GnonogramsCellGrid* _tmp99_;
	GtkGrid* _tmp100_ = NULL;
	GtkGrid* _tmp101_;
	GnonogramsLabelBox* _tmp102_;
	GtkGrid* _tmp103_;
	GnonogramsLabelBox* _tmp104_;
	GtkGrid* _tmp105_;
	GnonogramsCellGrid* _tmp106_;
	GtkEventBox* ev = NULL;
	GtkEventBox* _tmp107_ = NULL;
	GtkEventBox* _tmp108_;
	GtkEventBox* _tmp109_;
	GtkEventBox* _tmp110_;
	GtkGrid* _tmp111_;
	GtkOverlay* _tmp112_ = NULL;
	GtkOverlay* _tmp113_;
	GraniteWidgetsToast* _tmp114_;
	GtkOverlay* _tmp115_;
	GtkEventBox* _tmp116_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp117_ = NULL;
	GtkGrid* _tmp118_;
	HdyHeaderBar* _tmp119_;
	GtkGrid* _tmp120_;
	GtkOverlay* _tmp121_;
	GtkGrid* _tmp122_;
	GBindingFlags flags = 0U;
	GtkButton* _tmp123_;
	GnonogramsCellGrid* _tmp124_;
	GnonogramsCellGrid* _tmp125_;
	GraniteModeSwitch* _tmp126_;
	GnonogramsController* _tmp127_;
	GnonogramsController* _tmp128_;
	GnonogramsController* _tmp129_;
	GnonogramsCellGrid* _tmp130_;
	GnonogramsCellGrid* _tmp131_;
	GnonogramsCellGrid* _tmp132_;
	GnonogramsCellGrid* _tmp133_;
	parent_class = G_OBJECT_CLASS (gnonograms_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	_tmp0_ = gtk_icon_theme_get_default ();
	default_theme = _tmp0_;
	_tmp1_ = default_theme;
	gtk_icon_theme_add_resource_path (_tmp1_, "/com/github/jeremypw/gnonograms");
	_tmp2_ = g_simple_action_group_new ();
	view_actions = _tmp2_;
	_tmp3_ = view_actions;
	_tmp4_ = gnonograms_view_view_action_entries;
	_tmp4__length1 = gnonograms_view_view_action_entries_length1;
	g_action_map_add_action_entries ((GActionMap*) _tmp3_, _tmp4_, (gint) _tmp4__length1, self);
	_tmp5_ = view_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, GNONOGRAMS_VIEW_ACTION_GROUP, (GActionGroup*) _tmp5_);
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
		_tmp6_ = gnonograms_view_action_accelerators;
		_tmp7_ = gee_multi_map_get_keys (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp8_);
		_action_it = _tmp10_;
		while (TRUE) {
			GeeIterator* _tmp11_;
			gchar* action = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			gchar** accels_array = NULL;
			GeeMultiMap* _tmp14_;
			const gchar* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gint _tmp18_ = 0;
			gpointer* _tmp19_;
			gchar** _tmp20_;
			gint _tmp20__length1;
			gint accels_array_length1;
			gint _accels_array_size_;
			GtkApplication* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar** _tmp25_;
			gint _tmp25__length1;
			_tmp11_ = _action_it;
			if (!gee_iterator_next (_tmp11_)) {
				break;
			}
			_tmp12_ = _action_it;
			_tmp13_ = gee_iterator_get (_tmp12_);
			action = (gchar*) _tmp13_;
			_tmp14_ = gnonograms_view_action_accelerators;
			_tmp15_ = action;
			_tmp16_ = gee_multi_map_get (_tmp14_, _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp19_ = gee_collection_to_array (_tmp17_, &_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp20__length1 = _tmp18_;
			_g_object_unref0 (_tmp17_);
			accels_array = _tmp20_;
			accels_array_length1 = _tmp20__length1;
			_accels_array_size_ = accels_array_length1;
			_vala_array_add1 (&accels_array, &accels_array_length1, &_accels_array_size_, NULL);
			_tmp21_ = gnonograms_view_app;
			_tmp22_ = action;
			_tmp23_ = g_strconcat (GNONOGRAMS_VIEW_ACTION_PREFIX, _tmp22_, NULL);
			_tmp24_ = _tmp23_;
			_tmp25_ = accels_array;
			_tmp25__length1 = accels_array_length1;
			gtk_application_set_accels_for_action (_tmp21_, _tmp24_, _tmp25_);
			_g_free0 (_tmp24_);
			accels_array = (_vala_array_free (accels_array, accels_array_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (action);
		}
		_g_object_unref0 (_action_it);
	}
	_tmp26_ = gnonograms_view_header_button_new ("document-open", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_OPEN, _ ("Load Game"));
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->load_game_button);
	self->priv->load_game_button = (GtkButton*) _tmp26_;
	_tmp27_ = gnonograms_view_header_button_new ("document-save", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_SAVE, _ ("Save Game"));
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->save_game_button);
	self->priv->save_game_button = (GtkButton*) _tmp27_;
	_tmp28_ = gnonograms_view_header_button_new ("document-save-as", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_SAVE_AS, _ ("Save Game to Different File"));
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->save_game_as_button);
	self->priv->save_game_as_button = (GtkButton*) _tmp28_;
	_tmp29_ = gnonograms_view_header_button_new ("edit-undo", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_UNDO, _ ("Undo Last Move"));
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (self->priv->undo_button);
	self->priv->undo_button = (GtkButton*) _tmp29_;
	_tmp30_ = gnonograms_view_header_button_new ("edit-redo", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_REDO, _ ("Redo Last Move"));
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->priv->redo_button);
	self->priv->redo_button = (GtkButton*) _tmp30_;
	_tmp31_ = gnonograms_view_header_button_new ("media-seek-backward", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_CHECK_ERRORS, _ ("Check for Errors"));
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (self->priv->check_correct_button);
	self->priv->check_correct_button = (GtkButton*) _tmp31_;
	_tmp32_ = gnonograms_view_restart_button_new ("view-refresh", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_RESTART, _ ("Start again"));
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 12);
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->restart_button);
	self->priv->restart_button = (GtkButton*) _tmp32_;
	_tmp33_ = gnonograms_view_header_button_new ("help-contents", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_HINT, _ ("Suggest next move"));
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->hint_button);
	self->priv->hint_button = (GtkButton*) _tmp33_;
	_tmp34_ = gnonograms_view_header_button_new ("system", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_SOLVE, _ ("Solve by Computer"));
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->auto_solve_button);
	self->priv->auto_solve_button = (GtkButton*) _tmp34_;
	_tmp35_ = gnonograms_view_header_button_new ("list-add", GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_GENERATING_MODE, _ ("Generate New Puzzle"));
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->generate_button);
	self->priv->generate_button = (GtkButton*) _tmp35_;
	_tmp36_ = self->priv->_controller;
	_tmp37_ = gnonograms_view_app;
	_tmp39_ = _tmp38_ = gtk_application_get_accels_for_action (_tmp37_, GNONOGRAMS_VIEW_ACTION_PREFIX GNONOGRAMS_VIEW_ACTION_OPTIONS);
	_tmp40_ = _tmp39_;
	_tmp40__length1 = _vala_array_length (_tmp38_);
	_tmp41_ = granite_markup_accel_tooltip (_tmp40_, (gint) _vala_array_length (_tmp38_), _ ("Options"));
	_tmp42_ = gnonograms_view_app_menu_new (_tmp36_);
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp42_, _tmp41_);
	_g_free0 (_tmp41_);
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->app_menu);
	self->priv->app_menu = _tmp42_;
	_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
	_tmp43_ = g_strdup_printf ("%s\n%s", _ ("Edit a Game"), "Ctrl + 1");
	_tmp44_ = g_strdup_printf ("%s\n%s", _ ("Manually Solve"), "Ctrl + 2");
	_tmp45_ = granite_mode_switch_new_from_icon_name ("edit-symbolic", "head-thinking-symbolic");
	gtk_widget_set_margin_end ((GtkWidget*) _tmp45_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp45_, 12);
	gtk_widget_set_valign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
	granite_mode_switch_set_primary_icon_tooltip_text (_tmp45_, _tmp43_);
	_g_free0 (_tmp43_);
	granite_mode_switch_set_secondary_icon_tooltip_text (_tmp45_, _tmp44_);
	_g_free0 (_tmp44_);
	g_object_ref_sink (_tmp45_);
	_g_object_unref0 (self->priv->mode_switch);
	self->priv->mode_switch = _tmp45_;
	_tmp46_ = gnonograms_view_progress_indicator_new ();
	g_object_ref_sink (_tmp46_);
	_g_object_unref0 (self->priv->progress_indicator);
	self->priv->progress_indicator = _tmp46_;
	_tmp47_ = (GtkLabel*) gtk_label_new ("Gnonograms");
	gtk_label_set_use_markup (_tmp47_, TRUE);
	gtk_label_set_xalign (_tmp47_, 0.5f);
	g_object_ref_sink (_tmp47_);
	_g_object_unref0 (self->priv->title_label);
	self->priv->title_label = _tmp47_;
	_tmp48_ = self->priv->title_label;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_add_class (_tmp49_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp50_ = self->priv->title_label;
	gtk_widget_show ((GtkWidget*) _tmp50_);
	_tmp51_ = (GtkLabel*) gtk_label_new ("Easy");
	gtk_label_set_use_markup (_tmp51_, TRUE);
	gtk_label_set_xalign (_tmp51_, 0.5f);
	g_object_ref_sink (_tmp51_);
	_g_object_unref0 (self->priv->grade_label);
	self->priv->grade_label = _tmp51_;
	_tmp52_ = self->priv->grade_label;
	_tmp53_ = gtk_widget_get_style_context ((GtkWidget*) _tmp52_);
	gtk_style_context_add_class (_tmp53_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp54_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp54_, GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp54_);
	title_grid = _tmp54_;
	_tmp55_ = title_grid;
	_tmp56_ = self->priv->title_label;
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = title_grid;
	_tmp58_ = self->priv->grade_label;
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
	_tmp59_ = title_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp59_);
	_tmp60_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp60_);
	_g_object_unref0 (self->priv->progress_stack);
	self->priv->progress_stack = _tmp60_;
	_tmp61_ = self->priv->progress_stack;
	_tmp62_ = self->priv->progress_indicator;
	gtk_stack_add_named (_tmp61_, (GtkWidget*) _tmp62_, "Progress");
	_tmp63_ = self->priv->progress_stack;
	_tmp64_ = title_grid;
	gtk_stack_add_named (_tmp63_, (GtkWidget*) _tmp64_, "Title");
	_tmp65_ = self->priv->progress_stack;
	gtk_stack_set_visible_child_name (_tmp65_, "Title");
	_tmp66_ = self->priv->progress_stack;
	_tmp67_ = _g_object_ref0 ((GtkWidget*) _tmp66_);
	_tmp68_ = (HdyHeaderBar*) hdy_header_bar_new ();
	hdy_header_bar_set_has_subtitle (_tmp68_, FALSE);
	hdy_header_bar_set_show_close_button (_tmp68_, TRUE);
	hdy_header_bar_set_custom_title (_tmp68_, _tmp67_);
	_g_object_unref0 (_tmp67_);
	g_object_ref_sink (_tmp68_);
	_g_object_unref0 (self->priv->header_bar);
	self->priv->header_bar = _tmp68_;
	_tmp69_ = self->priv->header_bar;
	_tmp70_ = gtk_widget_get_style_context ((GtkWidget*) _tmp69_);
	gtk_style_context_add_class (_tmp70_, "gnonograms-header");
	_tmp71_ = self->priv->header_bar;
	_tmp72_ = self->priv->load_game_button;
	hdy_header_bar_pack_start (_tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = self->priv->header_bar;
	_tmp74_ = self->priv->save_game_button;
	hdy_header_bar_pack_start (_tmp73_, (GtkWidget*) _tmp74_);
	_tmp75_ = self->priv->header_bar;
	_tmp76_ = self->priv->save_game_as_button;
	hdy_header_bar_pack_start (_tmp75_, (GtkWidget*) _tmp76_);
	_tmp77_ = self->priv->header_bar;
	_tmp78_ = self->priv->restart_button;
	hdy_header_bar_pack_start (_tmp77_, (GtkWidget*) _tmp78_);
	_tmp79_ = self->priv->header_bar;
	_tmp80_ = self->priv->undo_button;
	hdy_header_bar_pack_start (_tmp79_, (GtkWidget*) _tmp80_);
	_tmp81_ = self->priv->header_bar;
	_tmp82_ = self->priv->redo_button;
	hdy_header_bar_pack_start (_tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = self->priv->header_bar;
	_tmp84_ = self->priv->check_correct_button;
	hdy_header_bar_pack_start (_tmp83_, (GtkWidget*) _tmp84_);
	_tmp85_ = self->priv->header_bar;
	_tmp86_ = self->priv->app_menu;
	hdy_header_bar_pack_end (_tmp85_, (GtkWidget*) _tmp86_);
	_tmp87_ = self->priv->header_bar;
	_tmp88_ = self->priv->generate_button;
	hdy_header_bar_pack_end (_tmp87_, (GtkWidget*) _tmp88_);
	_tmp89_ = self->priv->header_bar;
	_tmp90_ = self->priv->mode_switch;
	hdy_header_bar_pack_end (_tmp89_, (GtkWidget*) _tmp90_);
	_tmp91_ = self->priv->header_bar;
	_tmp92_ = self->priv->auto_solve_button;
	hdy_header_bar_pack_end (_tmp91_, (GtkWidget*) _tmp92_);
	_tmp93_ = self->priv->header_bar;
	_tmp94_ = self->priv->hint_button;
	hdy_header_bar_pack_end (_tmp93_, (GtkWidget*) _tmp94_);
	_tmp95_ = granite_widgets_toast_new ("");
	gtk_widget_set_halign ((GtkWidget*) _tmp95_, GTK_ALIGN_START);
	gtk_widget_set_valign ((GtkWidget*) _tmp95_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp95_);
	_g_object_unref0 (self->priv->toast);
	self->priv->toast = _tmp95_;
	_tmp96_ = self->priv->toast;
	granite_widgets_toast_set_default_action (_tmp96_, NULL);
	_tmp97_ = gnonograms_label_box_new (GTK_ORIENTATION_VERTICAL, self);
	g_object_ref_sink (_tmp97_);
	_g_object_unref0 (self->priv->row_clue_box);
	self->priv->row_clue_box = _tmp97_;
	_tmp98_ = gnonograms_label_box_new (GTK_ORIENTATION_HORIZONTAL, self);
	g_object_ref_sink (_tmp98_);
	_g_object_unref0 (self->priv->column_clue_box);
	self->priv->column_clue_box = _tmp98_;
	_tmp99_ = gnonograms_cell_grid_new (self);
	g_object_ref_sink (_tmp99_);
	_g_object_unref0 (self->priv->cell_grid);
	self->priv->cell_grid = _tmp99_;
	_tmp100_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_row_spacing (_tmp100_, 0);
	gtk_grid_set_column_spacing (_tmp100_, GNONOGRAMS_VIEW_GRID_COLUMN_SPACING);
	gtk_container_set_border_width ((GtkContainer*) _tmp100_, (guint) GNONOGRAMS_VIEW_GRID_BORDER);
	g_object_set ((GtkWidget*) _tmp100_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp100_);
	_g_object_unref0 (self->priv->main_grid);
	self->priv->main_grid = _tmp100_;
	_tmp101_ = self->priv->main_grid;
	_tmp102_ = self->priv->row_clue_box;
	gtk_grid_attach (_tmp101_, (GtkWidget*) _tmp102_, 0, 1, 1, 1);
	_tmp103_ = self->priv->main_grid;
	_tmp104_ = self->priv->column_clue_box;
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp104_, 1, 0, 1, 1);
	_tmp105_ = self->priv->main_grid;
	_tmp106_ = self->priv->cell_grid;
	gtk_grid_attach (_tmp105_, (GtkWidget*) _tmp106_, 1, 1, 1, 1);
	_tmp107_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_set ((GtkWidget*) _tmp107_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp107_);
	ev = _tmp107_;
	_tmp108_ = ev;
	gtk_widget_add_events ((GtkWidget*) _tmp108_, (gint) GDK_SCROLL_MASK);
	_tmp109_ = ev;
	g_signal_connect_object ((GtkWidget*) _tmp109_, "scroll-event", (GCallback) _gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp110_ = ev;
	_tmp111_ = self->priv->main_grid;
	gtk_container_add ((GtkContainer*) _tmp110_, (GtkWidget*) _tmp111_);
	_tmp112_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_set ((GtkWidget*) _tmp112_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp112_);
	_g_object_unref0 (self->priv->overlay);
	self->priv->overlay = _tmp112_;
	_tmp113_ = self->priv->overlay;
	_tmp114_ = self->priv->toast;
	gtk_overlay_add_overlay (_tmp113_, (GtkWidget*) _tmp114_);
	_tmp115_ = self->priv->overlay;
	_tmp116_ = ev;
	gtk_container_add ((GtkContainer*) _tmp115_, (GtkWidget*) _tmp116_);
	_tmp117_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp117_, GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp117_);
	grid = _tmp117_;
	_tmp118_ = grid;
	_tmp119_ = self->priv->header_bar;
	gtk_container_add ((GtkContainer*) _tmp118_, (GtkWidget*) _tmp119_);
	_tmp120_ = grid;
	_tmp121_ = self->priv->overlay;
	gtk_container_add ((GtkContainer*) _tmp120_, (GtkWidget*) _tmp121_);
	_tmp122_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp122_);
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
	_tmp123_ = self->priv->restart_button;
	g_object_bind_property_with_closures ((GObject*) self, "restart-destructive", (GObject*) _tmp123_, "restart-destructive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp124_ = self->priv->cell_grid;
	g_object_bind_property_with_closures ((GObject*) self, "current-cell", (GObject*) _tmp124_, "current-cell", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp125_ = self->priv->cell_grid;
	g_object_bind_property_with_closures ((GObject*) self, "previous-cell", (GObject*) _tmp125_, "previous-cell", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp126_ = self->priv->mode_switch;
	g_signal_connect_object ((GObject*) _tmp126_, "notify::active", (GCallback) __gnonograms_view___lambda28__g_object_notify, self, 0);
	_tmp127_ = self->priv->_controller;
	g_signal_connect_object ((GObject*) _tmp127_, "notify::game-state", (GCallback) __gnonograms_view___lambda29__g_object_notify, self, 0);
	_tmp128_ = self->priv->_controller;
	g_signal_connect_object ((GObject*) _tmp128_, "notify::game-name", (GCallback) __gnonograms_view___lambda30__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::game-grade", (GCallback) __gnonograms_view___lambda31__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::readonly", (GCallback) __gnonograms_view___lambda32__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::can-go-back", (GCallback) __gnonograms_view___lambda33__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::can-go-forward", (GCallback) __gnonograms_view___lambda34__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::current-cell", (GCallback) __gnonograms_view___lambda35__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::strikeout-complete", (GCallback) __gnonograms_view___lambda36__g_object_notify, self, 0);
	_tmp129_ = self->priv->_controller;
	g_signal_connect_object ((GObject*) _tmp129_, "notify::dimensions", (GCallback) __gnonograms_view___lambda37__g_object_notify, self, 0);
	_tmp130_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp130_, "leave-notify-event", (GCallback) __gnonograms_view___lambda38__gtk_widget_leave_notify_event, self, 0);
	_tmp131_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp131_, "button-press-event", (GCallback) __gnonograms_view___lambda39__gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) __gnonograms_view___lambda40__gtk_widget_key_release_event, self, 0);
	_tmp132_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp132_, "button-release-event", (GCallback) _gnonograms_view_stop_painting_gtk_widget_button_release_event, self, 0);
	_tmp133_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp133_, "size-allocate", (GCallback) __gnonograms_view___lambda41__gtk_widget_size_allocate, self, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (grid);
	_g_object_unref0 (ev);
	_g_object_unref0 (title_grid);
	_g_object_unref0 (view_actions);
	return obj;
}

static void
gnonograms_view_class_init (GnonogramsViewClass * klass,
                            gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GActionEntry _tmp1_ = {0};
	GActionEntry _tmp2_ = {0};
	GActionEntry _tmp3_ = {0};
	GActionEntry _tmp4_ = {0};
	GActionEntry _tmp5_ = {0};
	GActionEntry _tmp6_ = {0};
	GActionEntry _tmp7_ = {0};
	GActionEntry _tmp8_ = {0};
	GActionEntry _tmp9_ = {0};
	GActionEntry _tmp10_ = {0};
	GActionEntry _tmp11_ = {0};
	GActionEntry _tmp12_ = {0};
	GActionEntry _tmp13_ = {0};
	GActionEntry _tmp14_ = {0};
	GActionEntry _tmp15_ = {0};
	GActionEntry _tmp16_ = {0};
	GActionEntry _tmp17_ = {0};
	GActionEntry _tmp18_ = {0};
	GActionEntry _tmp19_ = {0};
	GActionEntry _tmp20_ = {0};
	GActionEntry _tmp21_ = {0};
	GActionEntry _tmp22_ = {0};
	GActionEntry* _tmp23_;
	GApplication* _tmp24_;
	GtkApplication* _tmp25_;
	GeeMultiMap* _tmp26_;
	GeeMultiMap* _tmp27_;
	GeeMultiMap* _tmp28_;
	GeeMultiMap* _tmp29_;
	GeeMultiMap* _tmp30_;
	GeeMultiMap* _tmp31_;
	GeeMultiMap* _tmp32_;
	GeeMultiMap* _tmp33_;
	GeeMultiMap* _tmp34_;
	GeeMultiMap* _tmp35_;
	GeeMultiMap* _tmp36_;
	GeeMultiMap* _tmp37_;
	GeeMultiMap* _tmp38_;
	GeeMultiMap* _tmp39_;
	GeeMultiMap* _tmp40_;
	GeeMultiMap* _tmp41_;
	GeeMultiMap* _tmp42_;
	GeeMultiMap* _tmp43_;
	GeeMultiMap* _tmp44_;
	GeeMultiMap* _tmp45_;
	GeeMultiMap* _tmp46_;
	GeeMultiMap* _tmp47_;
	GeeMultiMap* _tmp48_;
	GeeMultiMap* _tmp49_;
	GeeMultiMap* _tmp50_;
	GeeMultiMap* _tmp51_;
	GeeMultiMap* _tmp52_;
	GeeMultiMap* _tmp53_;
	GeeMultiMap* _tmp54_;
	GError* _inner_error0_ = NULL;
	gnonograms_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_MODEL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", GNONOGRAMS_TYPE_MODEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CONTROLLER_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", GNONOGRAMS_TYPE_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY] = g_param_spec_boxed ("current-cell", "current-cell", "current-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY] = g_param_spec_boxed ("previous-cell", "previous-cell", "previous-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY] = g_param_spec_enum ("generator-grade", "generator-grade", "generator-grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY] = g_param_spec_enum ("game-grade", "game-grade", "game-grade", GNONOGRAMS_TYPE_DIFFICULTY, GNONOGRAMS_DIFFICULTY_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY] = g_param_spec_int ("cell-size", "cell-size", "cell-size", G_MININT, G_MAXINT, 32, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GAME_NAME_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_NAME_PROPERTY] = g_param_spec_string ("game-name", "game-name", "game-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY] = g_param_spec_boolean ("strikeout-complete", "strikeout-complete", "strikeout-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_READONLY_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_READONLY_PROPERTY] = g_param_spec_boolean ("readonly", "readonly", "readonly", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY] = g_param_spec_boolean ("can-go-back", "can-go-back", "can-go-back", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY] = g_param_spec_boolean ("can-go-forward", "can-go-forward", "can-go-forward", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY] = g_param_spec_boolean ("restart-destructive", "restart-destructive", "restart-destructive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY] = g_param_spec_object ("view-actions", "view-actions", "view-actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	gnonograms_view_action_accelerators = (GeeMultiMap*) _tmp0_;
	memset (&_tmp1_, 0, sizeof (GActionEntry));
	_tmp1_.name = GNONOGRAMS_VIEW_ACTION_UNDO;
	_tmp1_.activate = _gnonograms_view_action_undo_gsimple_action_activate_callback;
	memset (&_tmp2_, 0, sizeof (GActionEntry));
	_tmp2_.name = GNONOGRAMS_VIEW_ACTION_REDO;
	_tmp2_.activate = _gnonograms_view_action_redo_gsimple_action_activate_callback;
	memset (&_tmp3_, 0, sizeof (GActionEntry));
	_tmp3_.name = GNONOGRAMS_VIEW_ACTION_ZOOM_IN;
	_tmp3_.activate = _gnonograms_view_action_zoom_in_gsimple_action_activate_callback;
	memset (&_tmp4_, 0, sizeof (GActionEntry));
	_tmp4_.name = GNONOGRAMS_VIEW_ACTION_ZOOM_OUT;
	_tmp4_.activate = _gnonograms_view_action_zoom_out_gsimple_action_activate_callback;
	memset (&_tmp5_, 0, sizeof (GActionEntry));
	_tmp5_.name = GNONOGRAMS_VIEW_ACTION_CURSOR_UP;
	_tmp5_.activate = _gnonograms_view_action_cursor_up_gsimple_action_activate_callback;
	memset (&_tmp6_, 0, sizeof (GActionEntry));
	_tmp6_.name = GNONOGRAMS_VIEW_ACTION_CURSOR_DOWN;
	_tmp6_.activate = _gnonograms_view_action_cursor_down_gsimple_action_activate_callback;
	memset (&_tmp7_, 0, sizeof (GActionEntry));
	_tmp7_.name = GNONOGRAMS_VIEW_ACTION_CURSOR_LEFT;
	_tmp7_.activate = _gnonograms_view_action_cursor_left_gsimple_action_activate_callback;
	memset (&_tmp8_, 0, sizeof (GActionEntry));
	_tmp8_.name = GNONOGRAMS_VIEW_ACTION_CURSOR_RIGHT;
	_tmp8_.activate = _gnonograms_view_action_cursor_right_gsimple_action_activate_callback;
	memset (&_tmp9_, 0, sizeof (GActionEntry));
	_tmp9_.name = GNONOGRAMS_VIEW_ACTION_SETTING_MODE;
	_tmp9_.activate = _gnonograms_view_action_setting_mode_gsimple_action_activate_callback;
	memset (&_tmp10_, 0, sizeof (GActionEntry));
	_tmp10_.name = GNONOGRAMS_VIEW_ACTION_SOLVING_MODE;
	_tmp10_.activate = _gnonograms_view_action_solving_mode_gsimple_action_activate_callback;
	memset (&_tmp11_, 0, sizeof (GActionEntry));
	_tmp11_.name = GNONOGRAMS_VIEW_ACTION_GENERATING_MODE;
	_tmp11_.activate = _gnonograms_view_action_generating_mode_gsimple_action_activate_callback;
	memset (&_tmp12_, 0, sizeof (GActionEntry));
	_tmp12_.name = GNONOGRAMS_VIEW_ACTION_OPEN;
	_tmp12_.activate = _gnonograms_view_action_open_gsimple_action_activate_callback;
	memset (&_tmp13_, 0, sizeof (GActionEntry));
	_tmp13_.name = GNONOGRAMS_VIEW_ACTION_SAVE;
	_tmp13_.activate = _gnonograms_view_action_save_gsimple_action_activate_callback;
	memset (&_tmp14_, 0, sizeof (GActionEntry));
	_tmp14_.name = GNONOGRAMS_VIEW_ACTION_SAVE_AS;
	_tmp14_.activate = _gnonograms_view_action_save_as_gsimple_action_activate_callback;
	memset (&_tmp15_, 0, sizeof (GActionEntry));
	_tmp15_.name = GNONOGRAMS_VIEW_ACTION_PAINT_FILLED;
	_tmp15_.activate = _gnonograms_view_action_paint_filled_gsimple_action_activate_callback;
	memset (&_tmp16_, 0, sizeof (GActionEntry));
	_tmp16_.name = GNONOGRAMS_VIEW_ACTION_PAINT_EMPTY;
	_tmp16_.activate = _gnonograms_view_action_paint_empty_gsimple_action_activate_callback;
	memset (&_tmp17_, 0, sizeof (GActionEntry));
	_tmp17_.name = GNONOGRAMS_VIEW_ACTION_PAINT_UNKNOWN;
	_tmp17_.activate = _gnonograms_view_action_paint_unknown_gsimple_action_activate_callback;
	memset (&_tmp18_, 0, sizeof (GActionEntry));
	_tmp18_.name = GNONOGRAMS_VIEW_ACTION_CHECK_ERRORS;
	_tmp18_.activate = _gnonograms_view_action_check_errors_gsimple_action_activate_callback;
	memset (&_tmp19_, 0, sizeof (GActionEntry));
	_tmp19_.name = GNONOGRAMS_VIEW_ACTION_RESTART;
	_tmp19_.activate = _gnonograms_view_action_restart_gsimple_action_activate_callback;
	memset (&_tmp20_, 0, sizeof (GActionEntry));
	_tmp20_.name = GNONOGRAMS_VIEW_ACTION_SOLVE;
	_tmp20_.activate = _gnonograms_view_action_solve_gsimple_action_activate_callback;
	memset (&_tmp21_, 0, sizeof (GActionEntry));
	_tmp21_.name = GNONOGRAMS_VIEW_ACTION_HINT;
	_tmp21_.activate = _gnonograms_view_action_hint_gsimple_action_activate_callback;
	memset (&_tmp22_, 0, sizeof (GActionEntry));
	_tmp22_.name = GNONOGRAMS_VIEW_ACTION_OPTIONS;
	_tmp22_.activate = _gnonograms_view_action_options_gsimple_action_activate_callback;
	_tmp23_ = g_new0 (GActionEntry, 22);
	_tmp23_[0] = _tmp1_;
	_tmp23_[1] = _tmp2_;
	_tmp23_[2] = _tmp3_;
	_tmp23_[3] = _tmp4_;
	_tmp23_[4] = _tmp5_;
	_tmp23_[5] = _tmp6_;
	_tmp23_[6] = _tmp7_;
	_tmp23_[7] = _tmp8_;
	_tmp23_[8] = _tmp9_;
	_tmp23_[9] = _tmp10_;
	_tmp23_[10] = _tmp11_;
	_tmp23_[11] = _tmp12_;
	_tmp23_[12] = _tmp13_;
	_tmp23_[13] = _tmp14_;
	_tmp23_[14] = _tmp15_;
	_tmp23_[15] = _tmp16_;
	_tmp23_[16] = _tmp17_;
	_tmp23_[17] = _tmp18_;
	_tmp23_[18] = _tmp19_;
	_tmp23_[19] = _tmp20_;
	_tmp23_[20] = _tmp21_;
	_tmp23_[21] = _tmp22_;
	gnonograms_view_view_action_entries = _tmp23_;
	gnonograms_view_view_action_entries_length1 = 22;
	_gnonograms_view_view_action_entries_size_ = gnonograms_view_view_action_entries_length1;
	_tmp24_ = g_application_get_default ();
	_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_application_get_type (), GtkApplication));
	_g_object_unref0 (gnonograms_view_app);
	gnonograms_view_app = _tmp25_;
	_tmp26_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp26_, GNONOGRAMS_VIEW_ACTION_UNDO, "<Ctrl>Z");
	_tmp27_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp27_, GNONOGRAMS_VIEW_ACTION_REDO, "<Ctrl><Shift>Z");
	_tmp28_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp28_, GNONOGRAMS_VIEW_ACTION_CURSOR_UP, "Up");
	_tmp29_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp29_, GNONOGRAMS_VIEW_ACTION_CURSOR_DOWN, "Down");
	_tmp30_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp30_, GNONOGRAMS_VIEW_ACTION_CURSOR_LEFT, "Left");
	_tmp31_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp31_, GNONOGRAMS_VIEW_ACTION_CURSOR_RIGHT, "Right");
	_tmp32_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp32_, GNONOGRAMS_VIEW_ACTION_ZOOM_IN, "<Ctrl>plus");
	_tmp33_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp33_, GNONOGRAMS_VIEW_ACTION_ZOOM_IN, "<Ctrl>equal");
	_tmp34_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp34_, GNONOGRAMS_VIEW_ACTION_ZOOM_IN, "<Ctrl>KP_Add");
	_tmp35_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp35_, GNONOGRAMS_VIEW_ACTION_ZOOM_OUT, "<Ctrl>minus");
	_tmp36_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp36_, GNONOGRAMS_VIEW_ACTION_ZOOM_OUT, "<Ctrl>KP_Subtract");
	_tmp37_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp37_, GNONOGRAMS_VIEW_ACTION_SETTING_MODE, "<Ctrl>1");
	_tmp38_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp38_, GNONOGRAMS_VIEW_ACTION_SOLVING_MODE, "<Ctrl>2");
	_tmp39_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp39_, GNONOGRAMS_VIEW_ACTION_GENERATING_MODE, "<Ctrl>3");
	_tmp40_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp40_, GNONOGRAMS_VIEW_ACTION_GENERATING_MODE, "<Ctrl>N");
	_tmp41_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp41_, GNONOGRAMS_VIEW_ACTION_OPEN, "<Ctrl>O");
	_tmp42_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp42_, GNONOGRAMS_VIEW_ACTION_SAVE, "<Ctrl>S");
	_tmp43_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp43_, GNONOGRAMS_VIEW_ACTION_SAVE_AS, "<Ctrl><Shift>S");
	_tmp44_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp44_, GNONOGRAMS_VIEW_ACTION_PAINT_FILLED, "F");
	_tmp45_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp45_, GNONOGRAMS_VIEW_ACTION_PAINT_EMPTY, "E");
	_tmp46_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp46_, GNONOGRAMS_VIEW_ACTION_PAINT_UNKNOWN, "X");
	_tmp47_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp47_, GNONOGRAMS_VIEW_ACTION_CHECK_ERRORS, "F7");
	_tmp48_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp48_, GNONOGRAMS_VIEW_ACTION_RESTART, "F5");
	_tmp49_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp49_, GNONOGRAMS_VIEW_ACTION_RESTART, "<Ctrl>R");
	_tmp50_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp50_, GNONOGRAMS_VIEW_ACTION_HINT, "F9");
	_tmp51_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp51_, GNONOGRAMS_VIEW_ACTION_HINT, "<Ctrl>H");
	_tmp52_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp52_, GNONOGRAMS_VIEW_ACTION_SOLVE, "<Alt>S");
	_tmp53_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp53_, GNONOGRAMS_VIEW_ACTION_OPTIONS, "F10");
	_tmp54_ = gnonograms_view_action_accelerators;
	gee_multi_map_set (_tmp54_, GNONOGRAMS_VIEW_ACTION_OPTIONS, "Menu");
	{
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp55_;
		GtkCssProvider* _tmp56_;
		GdkScreen* _tmp57_;
		GtkCssProvider* _tmp58_;
		_tmp55_ = gtk_css_provider_new ();
		css_provider = _tmp55_;
		_tmp56_ = css_provider;
		gtk_css_provider_load_from_resource (_tmp56_, "com/github/jeremypw/gnonograms/Application.css");
		_tmp57_ = gdk_screen_get_default ();
		_tmp58_ = css_provider;
		gtk_style_context_add_provider_for_screen (_tmp57_, (GtkStyleProvider*) _tmp58_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_g_object_unref0 (css_provider);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp59_;
		const gchar* _tmp60_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp59_ = e;
		_tmp60_ = _tmp59_->message;
		g_warning ("View.vala:452: Error adding css provider: %s", _tmp60_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	hdy_init ();
}

static void
gnonograms_view_instance_init (GnonogramsView * self,
                               gpointer klass)
{
	self->priv = gnonograms_view_get_instance_private (self);
	self->priv->_game_grade = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	self->priv->_cell_size = 32;
	self->priv->_readonly = FALSE;
	self->priv->_restart_destructive = FALSE;
	self->priv->drawing_with_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	self->priv->progress_timeout_id = (guint) 0;
}

static void
gnonograms_view_finalize (GObject * obj)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	_g_object_unref0 (self->priv->_model);
	_g_object_unref0 (self->priv->_controller);
	_g_object_unref0 (self->priv->_view_actions);
	_g_object_unref0 (self->priv->row_clue_box);
	_g_object_unref0 (self->priv->column_clue_box);
	_g_object_unref0 (self->priv->cell_grid);
	_g_object_unref0 (self->priv->progress_indicator);
	_g_object_unref0 (self->priv->app_menu);
	_g_object_unref0 (self->priv->header_bar);
	_g_object_unref0 (self->priv->toast);
	_g_object_unref0 (self->priv->mode_switch);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->overlay);
	_g_object_unref0 (self->priv->progress_stack);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->grade_label);
	_g_object_unref0 (self->priv->generate_button);
	_g_object_unref0 (self->priv->load_game_button);
	_g_object_unref0 (self->priv->save_game_button);
	_g_object_unref0 (self->priv->save_game_as_button);
	_g_object_unref0 (self->priv->undo_button);
	_g_object_unref0 (self->priv->redo_button);
	_g_object_unref0 (self->priv->check_correct_button);
	_g_object_unref0 (self->priv->hint_button);
	_g_object_unref0 (self->priv->auto_solve_button);
	_g_object_unref0 (self->priv->restart_button);
	G_OBJECT_CLASS (gnonograms_view_parent_class)->finalize (obj);
}

static GType
gnonograms_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsView), 0, (GInstanceInitFunc) gnonograms_view_instance_init, NULL };
	GType gnonograms_view_type_id;
	gnonograms_view_type_id = g_type_register_static (hdy_application_window_get_type (), "GnonogramsView", &g_define_type_info, 0);
	GnonogramsView_private_offset = g_type_add_instance_private (gnonograms_view_type_id, sizeof (GnonogramsViewPrivate));
	return gnonograms_view_type_id;
}

GType
gnonograms_view_get_type (void)
{
	static volatile gsize gnonograms_view_type_id__once = 0;
	if (g_once_init_enter (&gnonograms_view_type_id__once)) {
		GType gnonograms_view_type_id;
		gnonograms_view_type_id = gnonograms_view_get_type_once ();
		g_once_init_leave (&gnonograms_view_type_id__once, gnonograms_view_type_id);
	}
	return gnonograms_view_type_id__once;
}

static void
_vala_gnonograms_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODEL_PROPERTY:
		g_value_set_object (value, gnonograms_view_get_model (self));
		break;
		case GNONOGRAMS_VIEW_CONTROLLER_PROPERTY:
		g_value_set_object (value, gnonograms_view_get_controller (self));
		break;
		case GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_view_get_current_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_view_get_previous_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_get_generator_grade (self));
		break;
		case GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_get_game_grade (self));
		break;
		case GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY:
		g_value_set_int (value, gnonograms_view_get_cell_size (self));
		break;
		case GNONOGRAMS_VIEW_GAME_NAME_PROPERTY:
		g_value_set_string (value, gnonograms_view_get_game_name (self));
		break;
		case GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_strikeout_complete (self));
		break;
		case GNONOGRAMS_VIEW_READONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_readonly (self));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_can_go_back (self));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_can_go_forward (self));
		break;
		case GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_restart_destructive (self));
		break;
		case GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY:
		g_value_set_object (value, gnonograms_view_get_view_actions (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODEL_PROPERTY:
		gnonograms_view_set_model (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_VIEW_CONTROLLER_PROPERTY:
		gnonograms_view_set_controller (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY:
		gnonograms_view_set_current_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY:
		gnonograms_view_set_previous_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY:
		gnonograms_view_set_generator_grade (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY:
		gnonograms_view_set_game_grade (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_CELL_SIZE_PROPERTY:
		gnonograms_view_set_cell_size (self, g_value_get_int (value));
		break;
		case GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY:
		gnonograms_view_set_strikeout_complete (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_READONLY_PROPERTY:
		gnonograms_view_set_readonly (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY:
		gnonograms_view_set_can_go_back (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY:
		gnonograms_view_set_can_go_forward (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY:
		gnonograms_view_set_restart_destructive (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_VIEW_ACTIONS_PROPERTY:
		gnonograms_view_set_view_actions (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

